SystemOrganization addCategory: #Exupery!
SystemOrganization addCategory: #'Exupery-Intermediate'!
SystemOrganization addCategory: #'Exupery-Plugin'!
SystemOrganization addCategory: #'Exupery-Customer Tests'!
SystemOrganization addCategory: #'Exupery-Programmer Tests'!
SystemOrganization addCategory: #'Exupery-Tools'!

Object subclass: #AssembleInstruction
	instanceVariableNames: 'stream assembler instruction name encodingRules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

AssembleInstruction subclass: #AssembleArithmatic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!AssembleArithmatic methodsFor: 'misc' stamp: 'wbk 3/16/2003 21:07'!
arg1
	^ instruction arg1! !

!AssembleArithmatic methodsFor: 'misc' stamp: 'wbk 3/16/2003 21:07'!
arg2
	^ instruction arg2! !

!AssembleInstruction class methodsFor: 'instance creation' stamp: 'wbk 4/7/2003 14:25'!
instruction: aMedMov assembler: anAssembler
	|assembler|
	assembler := self new 
		initialiseInstruction: aMedMov
		assembler: anAssembler.
	assembler run.! !

!AssembleInstruction class methodsFor: 'instance creation' stamp: 'wbk 4/7/2003 14:25'!
name: aSymbol assembler: anAssemblerExupery 
	^ self new
		initializeName: aSymbol 
		assembler: anAssemblerExupery! !

!AssembleInstruction methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:06'!
addEncoding: anEncoder
	encodingRules add: anEncoder.
	anEncoder registerInstruction: self.! !

!AssembleInstruction methodsFor: 'misc' stamp: 'wbk 3/16/2003 21:08'!
arg1
	^ instruction from! !

!AssembleInstruction methodsFor: 'misc' stamp: 'wbk 3/16/2003 21:08'!
arg2
	^ instruction to! !

!AssembleInstruction methodsFor: 'misc' stamp: 'wbk 4/4/2003 17:30'!
assembler
	^ assembler! !

!AssembleInstruction methodsFor: 'Assembling' stamp: 'wbk 4/4/2003 17:10'!
encode: aMedAssembly 
	instruction := aMedAssembly.
	self run.! !

!AssembleInstruction methodsFor: 'misc' stamp: 'wbk 4/18/2003 16:17'!
initializeName: aSymbol assembler: anAssemblerExupery
	name := aSymbol.
	assembler := anAssemblerExupery.
	stream := assembler stream.
	encodingRules := OrderedCollection new.
	anAssemblerExupery 
		addInstruction: self
		named: name.! !

!AssembleInstruction methodsFor: 'Assembling' stamp: 'wbk 4/7/2003 14:21'!
run
	| rule |
	rule := encodingRules detect: [:each| each isFirable].
	rule fire.! !

AssembleInstruction subclass: #AssembleJump
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!AssembleJump methodsFor: 'Assembling' stamp: 'wbk 3/30/2005 21:06'!
encodeOpcode
	instruction type = #jz | (instruction type = #je) ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 132].
	instruction type = #jg ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r8F].
	instruction type = #jo ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r80].
	instruction type = #jmp ifTrue:
		[^ stream nextPut: 16rE9].
	instruction type = #jnz | (instruction type = #jne) ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r85].
	instruction type = #jl ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r8C].
	instruction type = #jle ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r8E].
	instruction type = #jge ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r8D].
	instruction type = #jnc ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r83].
	instruction type = #jc ifTrue:
		[stream nextPut: 15.
		^ stream nextPut: 16r82].

	self error: 'Unknown jump type'.! !

!AssembleJump methodsFor: 'Assembling' stamp: 'wbk 4/11/2003 15:58'!
encodeTarget
	stream nextPut: 0.
	stream nextPut: 0.
	stream nextPut: 0.
	stream nextPut: 0.
	assembler patchJumpTo: instruction target! !

!AssembleJump methodsFor: 'misc' stamp: 'wbk 4/18/2003 16:16'!
initialiseInstruction: aMedMov assembler: anAssembler 
	instruction := aMedMov.
	assembler := anAssembler.
	stream := assembler stream.
	encodingRules := OrderedCollection new.! !

!AssembleJump methodsFor: 'Assembling' stamp: 'wbk 2/6/2005 19:12'!
run
	instruction target isMedBlock
		ifTrue:
			[self encodeOpcode.
			self encodeTarget]
		ifFalse:
			[assembler stream nextPut: 16rFF.
			assembler
				encodeModRm: instruction target
				registerOpcode: 4]! !

Object subclass: #AssemblerExupery
	instanceVariableNames: 'stream blockAddresses jumpOffsets bytecodes instructionEncoders plugin relocator picEntries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!AssemblerExupery class methodsFor: 'as yet unclassified' stamp: 'wbk 1/21/2005 22:30'!
assemble: aMedMethod withPlugin: aPlugin relocator: aRelocator
	| assembler |
	assembler := self new 
		initializePlugin: aPlugin
		relocator: aRelocator.
	aMedMethod visitWith: assembler.
	^assembler ! !

!AssemblerExupery class methodsFor: 'as yet unclassified' stamp: 'wbk 1/21/2005 22:30'!
basicAssemble: aMedMethod withPlugin: aPlugin relocator: aRelocator
	| assembler |
	assembler := self new 
		initializePlugin: aPlugin
		relocator: aRelocator.
	aMedMethod visitWith: assembler.
	^assembler! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 4/18/2003 16:19'!
addInstruction: anInstruction named: aSymbol
	instructionEncoders 
		at: aSymbol 
		put: anInstruction.! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 2/4/2006 12:28'!
addRelocationFor: aMedBlock byteCodeAddress: anInteger
	relocator 
		addRelocationAt: stream position
		for: aMedBlock
		byteCodeAddress: anInteger! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 2/4/2006 23:09'!
addRelocationFor: aMedBlock byteCodeAddress: addressInteger argumentCount: argumentsInteger 
	
	relocator 
		addRelocationAt: stream position
		for: aMedBlock
		byteCodeAddress: addressInteger
		argumentCount: argumentsInteger! !

!AssemblerExupery methodsFor: 'Encoding' stamp: 'wbk 2/26/2005 20:22'!
addressFor: aMedBlock 
	^ blockAddresses at: aMedBlock blockNumber! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 2/27/2005 10:05'!
addressOfLiteral: aLiteral 
	^ plugin addressOf: aLiteral! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 1/21/2005 22:28'!
blockPositions
	^ blockAddresses! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 4/3/2003 20:53'!
byteCodes
	^ bytecodes! !

!AssemblerExupery methodsFor: 'Encoding' stamp: 'wbk 3/28/2005 19:06'!
encodeImmediate: aLiteral
	| value |
	value := aLiteral valueUsing: self.
	stream nextPut: (value bitAnd: 255).
	stream nextPut: ((value bitShift: -8) bitAnd: 255).
	stream nextPut: ((value bitShift: -16) bitAnd: 255).
	stream nextPut: ((value bitShift: -24) bitAnd: 255).! !

!AssemblerExupery methodsFor: 'Addressing Modes' stamp: 'wbk 6/2/2004 22:07'!
encodeModRm: modRmMed registerOpcode: anInteger 
	| mod rm result |
	modRmMed isLiteral 
		ifTrue: 
			[mod := 0.
			rm := 2r101]
		ifFalse:
			[modRmMed isAddressingMode 
				ifTrue: 
					[modRmMed hasOffset 
						ifTrue: [modRmMed offset <= 127
							ifTrue: [mod := 1]
							ifFalse: [mod := 2r10]] 
				ifFalse: [mod := 0].
			rm := self registerEncoding: modRmMed base]
		ifFalse: 
			[mod := 3.
			rm := self registerEncoding: modRmMed]].
	result := (mod bitShift: 6) + (anInteger bitShift: 3) + rm.
	stream nextPut: result.
	modRmMed isLiteral ifTrue: [^ self encodeImmediate: modRmMed.].
	modRmMed hasOffset ifTrue: 
		[modRmMed offset >= 0
			ifTrue:
				[modRmMed offset <= 127
					ifTrue: [stream nextPut: modRmMed offset]
					ifFalse: [self encodeImmediate: (MedLiteral literal: modRmMed offset)]]
			ifFalse:
				[modRmMed offset >= -128
					ifTrue: [stream nextPut: 256 + modRmMed offset]
					ifFalse: [Error signal: 'NOT YET IMPLEMENTED']]].! !

!AssemblerExupery methodsFor: 'Addressing Modes' stamp: 'wbk 3/16/2003 21:05'!
encodeModRm: modRmMed register: registerMed 
	^ self 
		encodeModRm: modRmMed 
		registerOpcode: (self registerEncoding: registerMed)! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 4/18/2003 18:34'!
initializeArithmaticInstructionNamed: nameSymbol toAddressingCode: toInteger fromAddressingCode: fromInteger fromImmediateCode: fromImmediateInteger fromImmediateModRmCode: fromImmediateToModRmInteger 
	| instruction |
	instruction := AssembleArithmatic 
		name: nameSymbol 
		assembler: self.
	instruction addEncoding: (EncodeToAddressingMode opcode: toInteger).
	instruction addEncoding: (EncodeFromAddressingMode opcode: fromInteger).
	instruction addEncoding: (EncodeFromLiteral 
				opcode: fromImmediateInteger
				modRmOpcode: fromImmediateToModRmInteger).! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 3/28/2005 19:18'!
initializeBitTestInstruction
	| instruction |
	instruction := (AssembleArithmatic
			name: #bitTest
			assembler: self).
	instruction addEncoding: (EncodeToAddressingMode opcodes: #(16r0F 16rA3)).
	instruction addEncoding: (EncodeFromByteLiteral
		opcode: #(16r0F 16rBA)
		modRmOpcode: 4).! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 3/28/2005 19:13'!
initializeEncodingRules
	self 
		initializeShiftInstructionName: #sar
		firstByte: 193
		modRmOpcode: 7
		fixedRegiser: #ecx
		fixedOpcode: 16rD3
		fixedModRm: 7.
	self 
		initializeShiftInstructionName: #sal
		firstByte: 193
		modRmOpcode: 4
		fixedRegiser: #ecx
		fixedOpcode: 16rD3
		fixedModRm: 4.
	self 
		initializeArithmaticInstructionNamed: #add
		toAddressingCode: 1
		fromAddressingCode: 3
		fromImmediateCode: #(129)
		fromImmediateModRmCode: 0.
	self 
		initializeArithmaticInstructionNamed: #and
		toAddressingCode: 33
		fromAddressingCode: 35
		fromImmediateCode: #(129)
		fromImmediateModRmCode: 4.
	self initializeMoveInstruction.
	self 
		initializeArithmaticInstructionNamed: #sub
		toAddressingCode: 41
		fromAddressingCode: 43
		fromImmediateCode: #(129)
		fromImmediateModRmCode: 5.
	self initializeMulInstruction.
	self 
		initializeArithmaticInstructionNamed: #or
		toAddressingCode: 9
		fromAddressingCode: 11
		fromImmediateCode: #(129)
		fromImmediateModRmCode: 1.
	self 
		initializeArithmaticInstructionNamed: #cmp
		toAddressingCode: 16r39
		fromAddressingCode: 16r3B
		fromImmediateCode: #(16r81)
		fromImmediateModRmCode: 7.
	self initializeBitTestInstruction.! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 3/28/2005 18:19'!
initializeMoveInstruction
	| instruction |
	instruction := (AssembleInstruction
			name: #mov
			assembler: self).
	instruction addEncoding: (EncodeToAddressingMode opcode: 137).
	instruction addEncoding: (EncodeFromAddressingMode opcode: 139).
	instruction addEncoding: (EncodeFromLiteralToRegister opcode: 184).
	instruction addEncoding: (EncodeFromLiteral
		opcode: #(199)
		modRmOpcode: 0).! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 12/25/2004 22:30'!
initializeMulInstruction
	| instruction aSymbol |
	aSymbol := #mul.
	instruction := (AssembleArithmatic
			name: aSymbol
			assembler: self).
	instruction addEncoding: (EncodeFromAddressingMode opcodes: #(16r0F 16rAF)).! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 2/27/2005 15:02'!
initializePlugin: aPlugin relocator: aRelocator 
	plugin := aPlugin.
	relocator := aRelocator.
	stream := WriteStream on: ByteArray new.
	blockAddresses := Dictionary new.
	jumpOffsets := OrderedCollection new.
	instructionEncoders := Dictionary new.
	picEntries := OrderedCollection new.
	self initializeEncodingRules.
	^ self! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 2/8/2004 21:35'!
initializeShiftInstructionName: aSymbol firstByte: firstByte modRmOpcode: modRmInteger fixedRegiser: registerSymbol fixedOpcode: fixedOpcodeInteger fixedModRm: fixedModRmInteger 
	| instruction |
	instruction := AssembleArithmatic 
				name: aSymbol
				assembler: self.
	instruction addEncoding: (EncodeImm8Rm32 
				firstByte: firstByte
				modRmValue: modRmInteger).
	instruction addEncoding: (EncodeFixedRegRm32
		fixedRegister: registerSymbol
		fixedOpcode: fixedOpcodeInteger
		fixedModRm: fixedModRmInteger).! !

!AssemblerExupery methodsFor: 'Encoding' stamp: 'wbk 4/3/2003 23:17'!
patchByteAt: locationInteger with: valueInteger 
	bytecodes
		at: locationInteger
		put: valueInteger! !

!AssemblerExupery methodsFor: 'Encoding' stamp: 'wbk 2/26/2005 19:35'!
patchJumpTo: aMedBlock 
	jumpOffsets add: (OffsetPatcher
		target: aMedBlock
		location: stream position
		assembler: self)! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 2/27/2005 15:01'!
picEntries
	^ picEntries! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 1/21/2005 21:56'!
position
	^ stream position! !

!AssemblerExupery methodsFor: 'Addressing Modes' stamp: 'wbk 4/18/2003 16:10'!
registerEncoding: aRegister
	aRegister name = #eax ifTrue: [^ 2r000].
	aRegister name = #ebx ifTrue: [^ 2r011].
	aRegister name = #ecx ifTrue: [^ 2r001].
	aRegister name = #edx ifTrue: [^ 2r010].

	aRegister name = #esi ifTrue: [^ 2r110].
	aRegister name = #edi ifTrue: [^ 2r111].

	aRegister name = #esp ifTrue: [^ 2r100].
	aRegister name = #ebp ifTrue: [^ 2r101].

	self error: ' Unrecognised register'.! !

!AssemblerExupery methodsFor: 'Misc' stamp: 'wbk 3/16/2003 18:34'!
stream
	^ stream! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 4/6/2003 21:24'!
visitAssembly: aMed 
	| encoder |
	encoder := instructionEncoders at: aMed name.
	encoder encode: aMed
! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 1/17/2005 20:06'!
visitBlock: aMedBlock 
	[aMedBlock isAligned & (stream position \\ 2 ~= 0)] whileTrue: [stream nextPut: 0].
	blockAddresses 
		at: aMedBlock blockNumber
		put: stream position.
	aMedBlock instructionsDo: [:each | each visitWith: self]! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 6/30/2003 20:28'!
visitCall: aMedCall 
	stream nextPut: 16rFF.
	self 
		encodeModRm: aMedCall function
		registerOpcode: 2.! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 3/26/2005 21:38'!
visitComparision: aMedComparision 
	^ self visitAssembly: aMedComparision! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 1/31/2004 18:32'!
visitDivide: aMedDivide 
		stream nextPut: 16rF7.
	self 
		encodeModRm: aMedDivide argument
		registerOpcode: 7.! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 3/31/2003 21:33'!
visitJump: aMedJump 
	AssembleJump
		instruction: aMedJump
		assembler: self! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 2/27/2005 10:07'!
visitMethod: aMedMethod 
	aMedMethod blocksDo: [:each | each visitWith: self].
	bytecodes _ stream contents.
	jumpOffsets do: [:each | each patch].! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 4/7/2003 14:55'!
visitMov: aMedMov 
	self visitAssembly: aMedMov! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 2/9/2004 21:13'!
visitNegate: aMedNegate 
	stream nextPut: 16rF7.
	self
		encodeModRm: aMedNegate argument
		registerOpcode: 3
	! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 3/12/2005 22:01'!
visitPic: aMedPic.
	aMedPic picEntry picMethodLocation: stream position.
	picEntries add: aMedPic picEntry.
	1 
		to: 33
		do: [:each| stream nextPut: 16r90]! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 3/4/2005 16:18'!
visitPop: aMedPop 
	stream nextPut: 16r58 + (self registerEncoding: aMedPop argument).! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 6/25/2003 16:36'!
visitPush: aMedPush 
	"This will probably need to be refactored. Possilby adding a class AssembleUnaryInstruction that assembles
	instructions with just one argument, it should be possible to stub out the other argument for mod/rm 
 	instructions. Single register instructions may be a little harder, the encoder for single registers also
	adds a literal, see EncodeFromLiteralToRegister."
	stream nextPut: 16r50 + (self registerEncoding: aMedPush argument).! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 3/4/2005 17:36'!
visitRet: aMedRet 
	"The postamble. This is the C return sequence"
	stream nextPutAll: #( "16r83 16rC4 64 16r5F 16r5E 16r5B 16r89 16rEC 16r5D" 16rC3)! !

!AssemblerExupery methodsFor: 'Visiting' stamp: 'wbk 2/2/2004 21:25'!
visitX86Cdq: aMedX86CDQ 
	stream nextPut: 16r99! !

Object subclass: #BlockFinder
	instanceVariableNames: 'method workQueue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!BlockFinder class methodsFor: 'instance creation' stamp: 'wbk 1/3/2006 22:29'!
findBlocksIn: aMedMethod 
	(self new initializeMethod: aMedMethod) runBasic! !

!BlockFinder class methodsFor: 'instance creation' stamp: 'wbk 1/3/2006 20:52'!
from: aMedMethod emitter: anIntermediateEmitter 
	^ self new initializeMethod: aMedMethod! !

!BlockFinder methodsFor: 'Misc' stamp: 'wbk 1/3/2006 22:21'!
initializeMethod: aMedMethod 
	workQueue := OrderedCollection new.
	method := aMedMethod! !

!BlockFinder methodsFor: 'analysis' stamp: 'wbk 1/5/2006 19:01'!
processElement
	| element target |
	element := workQueue removeLast.
	element jumpsDo: 
		[:each| target := each target.
			 target isBlockElement ifFalse:
			[target makeBlockElement.
			workQueue add: target]]! !

!BlockFinder methodsFor: 'analysis' stamp: 'wbk 1/5/2006 18:56'!
runBasic
	method blocksDo:
		[:each| each ifCreatesBlockContext: 
			[each makeBlockElement.
			workQueue add: each]].
	[workQueue isEmpty] whileFalse: [self processElement].! !

Object subclass: #ByteCodeReader
	instanceVariableNames: 'method generator stack stackHeights jumpTargets inlinedCalls nextBlock nextBlockArgumentCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!ByteCodeReader class methodsFor: 'reading' stamp: 'wbk 1/20/2006 23:13'!
newMethod: aMethod using: aGenerator jumpTargets: jumpArray stackHeights: stackArray 
	^(self new 
		initialiseMethod: aMethod
		using: aGenerator
		stack: (ExuperyStack 
				newPC: aMethod initialPC
				emitter: aGenerator emitter)
		jumpTargets: jumpArray
		stackHeights: stackArray) run! !

!ByteCodeReader class methodsFor: 'reading' stamp: 'wbk 1/20/2006 23:12'!
newMethod: aMethod using: aGenerator stack: aStack 
	^(self new 
		initialiseMethod: aMethod
		using: aGenerator
		stack: aStack
		jumpTargets: #()
		stackHeights: #()) run! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:23'!
add
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				add: second)! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 1/16/2006 19:55'!
binarySendWithSpecialSelector: anObject 
	| sendResult receiver argument |
	argument := stack pop.
	receiver := stack pop.	"Remove the two arguments"
	sendResult := generator 
				generateBinarySelector: anObject
				receiver: receiver
				argument: argument.
	stack push: sendResult! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:17'!
bitAnd
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				bitAnd: second)! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/7/2004 20:39'!
bitOr
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				bitOr: second)! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 19:08'!
bitShift
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator
		generate: first
		bitShift: second)! !

!ByteCodeReader methodsFor: 'Misc' stamp: 'wbk 2/1/2006 20:44'!
blockCopy
	| argumentCount context |
	argumentCount := stack pop.
	context := stack pop.
	nextBlock := stack pc + 3.
	nextBlockArgumentCount := (argumentCount literal - 1) / 2.
	^stack push: (generator 
				blockCopyArgumentCount: argumentCount
				context: context
				block: (generator emitter blockForBytecode: stack pc + 3)
				byteCodeAddress: stack pc + 3)! !

!ByteCodeReader methodsFor: 'Scanning' stamp: 'wbk 1/16/2006 19:56'!
byteCodeActionFor: anInteger 
	anInteger = 118 ifTrue: [^self pushConstant: 1 slot: -1].
	anInteger = 119 ifTrue: [^self pushConstant: 2 slot: -1].
	anInteger = 176 ifTrue: [^self add].
	anInteger = 124 ifTrue: [^self returnTop].
	anInteger >= 32 & (anInteger <= 63) ifTrue: [^self pushLiteralConstant].
	anInteger >= 104 & (anInteger <= 111) ifTrue: [^self popIntoTemp].
	anInteger = 120 ifTrue: [^self returnSelf].
	anInteger >= 16 & (anInteger <= 31) ifTrue: [^self pushTemp].
	anInteger = 180 ifTrue: [^self lessThanEquals].
	anInteger >= 152 & (anInteger <= 159) ifTrue: [^self shortConditionalJump].
	anInteger >= 172 & (anInteger <= 175) ifTrue: [^self longJumpIfFalse].
	anInteger = 184 ifTrue: [^self multiply].
	anInteger >= 160 & (anInteger <= 167) 
		ifTrue: [^self longUnconditionalJump].
	anInteger = 177 ifTrue: [^self subtract].
	anInteger = 112 ifTrue: [^self pushSelf].
	anInteger >= 208 & (anInteger <= 255) ifTrue: [^self sendLiteralSelector].
	anInteger = 117 ifTrue: [^self pushConstant: 0 slot: -1].
	anInteger >= 64 & (anInteger <= 95) ifTrue: [^self pushConstantVariable].
	anInteger = 205 ifTrue: [^self binarySendWithSpecialSelector: 29].
	anInteger = 113 ifTrue: [^self pushTrue].
	anInteger = 192 ifTrue: [^self sendAt].
	anInteger = 114 ifTrue: [^self pushFalse].
	anInteger = 193 ifTrue: [^self sendAtPut].
	anInteger = 135 ifTrue: [^self popStack].
	anInteger >= 0 & (anInteger <= 15) ifTrue: [^self pushInstanceVariable].
	anInteger >= 96 & (anInteger <= 103) 
		ifTrue: [^self storeAndPopReceiverVariable].
	anInteger = 116 ifTrue: [^self pushConstant: -1 slot: -1].
	anInteger = 115 ifTrue: [^self pushNil].
	anInteger = 123 ifTrue: [^self returnNil].
	anInteger = 121 ifTrue: [^self returnTrue].
	anInteger = 122 ifTrue: [^self returnFalse].
	anInteger = 178 ifTrue: [^self lessThan].
	anInteger = 179 ifTrue: [^self greaterThan].
	anInteger = 181 ifTrue: [^self greaterThanEqual].
	anInteger = 182 ifTrue: [^self equals].
	anInteger = 183 ifTrue: [^self notEquals].
	anInteger = 185 ifTrue: [^self divide].
	anInteger = 190 ifTrue: [^self bitAnd].
	anInteger = 191 ifTrue: [^self bitOr].
	anInteger = 189 ifTrue: [^self div].
	anInteger = 186 ifTrue: [^self mod].
	anInteger = 188 ifTrue: [^self bitShift].
	anInteger = 187 ifTrue: [^self makePoint].
	anInteger >= 168 & (anInteger <= 171) ifTrue: [^self longJumpIfTrue].
	anInteger = 204 ifTrue: [^self unarySendWithSelector: 28].
	anInteger = 194 ifTrue: [^self unarySendWithSelector: 18].
	anInteger = 195 ifTrue: [^self unarySendWithSelector: 19].
	anInteger = 196 ifTrue: [^self binarySendWithSpecialSelector: 20].
	anInteger = 197 ifTrue: [^self unarySendWithSelector: 21].
	anInteger = 198 ifTrue: [^self equivilent].
	anInteger >= 144 & (anInteger <= 151) 
		ifTrue: [^self shortUnconditionalJump].
	anInteger = 206 ifTrue: [^self unarySendWithSelector: 30].
	anInteger = 207 ifTrue: [^self unarySendWithSelector: 31].
	anInteger = 199 ifTrue: [^self sendClass].
	anInteger = 130 ifTrue: [^self extendedPopAndStore].
	anInteger = 128 ifTrue: [^self extendedPushBytecode].
	anInteger = 129 ifTrue: [^self extendedStore].
	anInteger = 131 ifTrue: [^self extendedSend].
	anInteger = 201 ifTrue: [^ self unarySendWithSelector: 25].
	anInteger = 202 ifTrue: [^ self binarySendWithSpecialSelector: 26].
	anInteger = 137 ifTrue: [^ self pushActiveContext].
	anInteger = 200 ifTrue: [^ self blockCopy].
	anInteger = 125 ifTrue: [^ self returnTopFromBlock].
	anInteger = 203 ifTrue: [^ self binarySendWithSpecialSelector: 27].
	
	Exupery log: '  Failed to compile bytecode ', anInteger asString.
	generator addUnknownByteCode! !

!ByteCodeReader methodsFor: 'Scanning' stamp: 'wbk 1/21/2006 14:50'!
byteCodeAddressing: anInteger 
	| jumpIndex | 
	generator byteCodeAddress: anInteger.
	(jumpTargets includes: anInteger) ifTrue: [self createTargetAt: anInteger].
	(nextBlock = anInteger) ifTrue: 
			[self createTargetAt: anInteger.
			stack heightTo: nextBlockArgumentCount.
			generator emitter setInitialStackHeight: stack stackHeight.
			generator emitter createBlockContextWithArguments: 
				nextBlockArgumentCount.].
	jumpIndex := jumpTargets 
				indexOf: anInteger
				ifAbsent: [^self].
	stack heightTo: (stackHeights at: jumpIndex).
	generator emitter setInitialStackHeight: stack stackHeight! !

!ByteCodeReader methodsFor: 'Scanning' stamp: 'wbk 11/27/2005 14:47'!
createTargetAt: anInteger 
	generator emitter materialiseStack.
	generator emitter jumpTarget: anInteger! !

!ByteCodeReader methodsFor: 'Scanning' stamp: 'wbk 7/28/2003 13:03'!
currentByteCode
	^method at: stack pc! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/7/2004 20:39'!
div
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				div: second)! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:18'!
divide
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				divide: second)! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 2/7/2004 20:39'!
equals
	| secondMed firstMed |
	secondMed := stack pop.
	firstMed := stack pop.
	stack push: (generator 
				prim: firstMed
				equals: secondMed)! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/27/2004 21:25'!
equivilent
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator
		generate: first
		equivilent: second).! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 12/8/2004 20:35'!
extendedPopAndStore
	| answer |
	answer := self extendedStoreBody.
	generator addExpression: answer.
	^ answer

	! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 6/13/2004 12:36'!
extendedPushBytecode
	| argument variableType variableIndex answer |
	argument := self fetchByte.
	variableType := (argument >> 6) bitAnd: 16r3.
	variableIndex := argument bitAnd: 16r3F.
	
	variableType = 0 ifTrue: 
		[answer := generator pushInstanceVariable: variableIndex.
		^ stack push: answer].
	variableType = 1 ifTrue:
		[answer := generator pushTempAt: variableIndex.
		^ stack push: answer].
	
	Error signal: 'Not Yet Handled'.! !

!ByteCodeReader methodsFor: 'Sends' stamp: 'wbk 6/16/2004 22:38'!
extendedSend
	| argument selectorIndex argumentCount sendResult |
	argument := self fetchByte.
	selectorIndex := argument bitAnd: 16r1F.
	argumentCount := argument >> 5.
	sendResult := generator
		sendSelector: (method literalAt: selectorIndex +1)
		inSlot: selectorIndex
		arguments: (stack pop: argumentCount + 1).
	stack push: sendResult! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 12/8/2004 20:32'!
extendedStore
	^ stack push: self extendedStoreBody! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 12/8/2004 20:33'!
extendedStoreBody
	| argument variableType variableIndex |
	argument := self fetchByte.
	variableType := (argument >> 6) bitAnd: 16r3.
	variableIndex := argument bitAnd: 16r3F.
	variableType = 0 ifTrue:
		[^ generator
			storeAndPopReceiverVariableIndex: variableIndex
			value: stack pop]. 
	variableType = 1 ifTrue:
		[^ generator
			popIntoTemp: stack pop
			slot: variableIndex].
	
	Error signal: 'Not Handled Yet'.
	! !

!ByteCodeReader methodsFor: 'Scanning' stamp: 'wbk 7/28/2003 13:03'!
fetchByte
	stack incrementPC.
	^method at: stack pc! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 2/7/2004 20:39'!
greaterThan
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				prim: first
				greaterThan: second)! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 2/7/2004 20:39'!
greaterThanEqual
	| secondMed firstMed |
	secondMed := stack pop.
	firstMed := stack pop.
	stack push: (generator 
				prim: firstMed
				greaterThanEqual: secondMed)! !

!ByteCodeReader methodsFor: 'Misc' stamp: 'wbk 1/20/2006 23:12'!
initialiseMethod: aMethod using: aGenerator stack: aStack jumpTargets: jumpArray stackHeights: heightArray 
	method := aMethod.
	generator := aGenerator.
	stack := aStack.
	generator state: stack.
	stackHeights := heightArray.
	jumpTargets := jumpArray! !

!ByteCodeReader methodsFor: 'Unit Testing' stamp: 'wbk 11/23/2005 20:12'!
intermediateGenerator
	^ generator! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 2/7/2004 20:39'!
lessThan
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				prim: first
				lessThan: second)! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 9/22/2004 21:40'!
lessThanEquals
	| first second |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
		prim: first
		lessThanEquals: second)! !

!ByteCodeReader methodsFor: 'Jumps' stamp: 'wbk 2/7/2004 20:38'!
longJumpIfFalse
	| boolean target |
	boolean := stack pop.
	target := stack pc + ((self currentByteCode bitAnd: 3) * 256) + self fetchByte + 2.
	generator 
		jumpIfFalse: boolean
		to: target! !

!ByteCodeReader methodsFor: 'Jumps' stamp: 'wbk 2/14/2004 11:50'!
longJumpIfTrue
	| boolean target |
	boolean := stack pop.
	target := stack pc + ((self currentByteCode bitAnd: 3) * 256) + self fetchByte + 2.
	generator 
		jumpIfTrue: boolean
		to: target! !

!ByteCodeReader methodsFor: 'Jumps' stamp: 'wbk 2/13/2005 12:46'!
longUnconditionalJump
	| target |
	target _ stack pc + (((self currentByteCode bitAnd: 7) - 4) * 256) + self fetchByte + 2.
	generator jumpTo: target! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/13/2004 20:30'!
makePoint
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: 
		(generator 
			generate: first
			makePoint: second).! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/7/2004 20:39'!
mod
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				mod: second)! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:27'!
multiply
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				multiply: second)! !

!ByteCodeReader methodsFor: 'Comparision' stamp: 'wbk 2/7/2004 20:39'!
notEquals
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				prim: first
				notEquals: second)! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 10/23/2004 20:29'!
popIntoTemp
	generator addExpression: (generator 
		popIntoTemp: stack pop
		slot: self currentByteCode - 104)! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:38'!
popStack
	^generator popStack: stack pop! !

!ByteCodeReader methodsFor: 'Scanning' stamp: 'wbk 10/21/2005 21:10'!
processByteCode: anInteger
	self byteCodeAddressing: stack pc.
	^self byteCodeActionFor: anInteger! !

!ByteCodeReader methodsFor: 'Misc' stamp: 'wbk 11/22/2005 22:09'!
pushActiveContext
	^ stack push: MedActiveContext new.! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 7/12/2003 10:05'!
pushConstantVariable
	|position|
	position := self currentByteCode bitAnd: 16r1F.
	self 
		pushLiteralVariable: (method literalAt: position + 1)
		slot: position! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 1/18/2006 21:23'!
pushConstant: aLiteral slot: aNumber 
	| answer |
	answer := generator 
				pushConstant: aLiteral
				slot: aNumber.
	stack push: answer.
	^answer! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushFalse
	stack push: generator pushFalse! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushInstanceVariable
	| position answer |
	position := self currentByteCode bitAnd: 15.
	answer := generator pushInstanceVariable: position.
	stack push: answer! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 9/18/2002 22:18'!
pushLiteralConstant
	|position|
	position := self currentByteCode bitAnd: 16r1F.
	self 
		pushConstant: (method literalAt: position + 1)
		slot: position
	! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushLiteralVariable: aLiteral slot: aSmallInteger 
	| answer |
	answer := generator 
				pushLiteralVariable: aLiteral
				slot: aSmallInteger.
	stack push: answer.
	^answer! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushNil
	stack push: generator pushNil! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushSelf
	| answer |
	answer := generator pushSelf.
	stack push: answer.
	^answer! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushTemp
	| answer |
	answer := generator pushTempAt: (self currentByteCode bitAnd: 15).
	stack push: answer.
	^answer! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 2/7/2004 20:39'!
pushTrue
	| answer |
	answer := generator pushTrue.
	stack push: answer! !

!ByteCodeReader methodsFor: 'Returns' stamp: 'wbk 11/27/2003 21:17'!
returnFalse
	generator returnFalse! !

!ByteCodeReader methodsFor: 'Returns' stamp: 'wbk 10/18/2003 12:53'!
returnNil
	generator returnNil! !

!ByteCodeReader methodsFor: 'Returns' stamp: 'wbk 10/4/2003 00:04'!
returnSelf
	generator returnSelf.! !

!ByteCodeReader methodsFor: 'Returns' stamp: 'wbk 9/28/2004 22:45'!
returnTop
	generator returnTop: stack pop.
	"self assert: [stack isEmpty]" "This isn't always true, the problem is demonstrated with the
									shortUnconditionalJumpTests. There they push a return value
									onto the stack to be used if the block is not evaluated."! !

!ByteCodeReader methodsFor: 'Returns' stamp: 'wbk 11/22/2005 22:39'!
returnTopFromBlock
	^ generator addExpression: (MedBlockReturn value: stack pop)! !

!ByteCodeReader methodsFor: 'Returns' stamp: 'wbk 11/27/2003 19:38'!
returnTrue
	generator returnTrue! !

!ByteCodeReader methodsFor: 'Scanning' stamp: 'wbk 10/24/2005 21:28'!
run
	generator numberOfTemporaries: method numTemps.
	generator numberOfArguments: method numArgs.
	generator needsLargeContext: method needsLargeContext.
	method primitive ~= 0 ifTrue: [generator setPrimitive: method primitive].
	generator createContext.
	[stack pc <= method endPC] whileTrue: 
			[self processByteCode: (method at: stack pc).
			stack incrementPC].
	generator finish! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/7/2004 20:39'!
sendAt
	| argument receiver sendResult |
	argument := stack pop.
	receiver := stack pop.
	sendResult := generator 
				sendAtTo: receiver
				with: argument.
	stack push: sendResult! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/7/2004 20:39'!
sendAtPut
	| value location receiver sendResult |
	value := stack pop.
	location := stack pop.
	receiver := stack pop.
	sendResult := generator 
				sendAtPutTo: receiver
				location: location
				value: value.
	stack push: sendResult! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 3/1/2004 19:47'!
sendClass
	stack push: (generator generateClass: stack pop)! !

!ByteCodeReader methodsFor: 'Sends' stamp: 'wbk 2/7/2004 20:39'!
sendLiteralSelector
	| selectorPosition argumentCount sendResult arguments |
	selectorPosition := self currentByteCode bitAnd: 15.
	argumentCount := (self currentByteCode >> 4 bitAnd: 3) - 1.
	arguments := stack pop: argumentCount + 1.
	sendResult := generator 
				sendSelector: (method literalAt: selectorPosition + 1)
				inSlot: selectorPosition
				arguments: arguments.
	stack push: sendResult! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/14/2004 15:19'!
sendNew
	| argument |
	argument := stack pop.
	stack push: (generator generateNew: argument)! !

!ByteCodeReader methodsFor: 'Jumps' stamp: 'wbk 2/7/2004 20:38'!
shortConditionalJump
	| boolean destination |
	boolean := stack pop.
	destination := stack pc + (self currentByteCode bitAnd: 7) + 1 + 1.
	generator 
		jumpIfFalse: boolean
		to: destination! !

!ByteCodeReader methodsFor: 'Jumps' stamp: 'wbk 2/13/2005 12:46'!
shortUnconditionalJump
	| target |
	target _ stack pc + (self currentByteCode bitAnd: 7) + 2.
	generator jumpTo: target! !

!ByteCodeReader methodsFor: 'Misc' stamp: 'wbk 5/31/2004 20:20'!
stackHeight
	^ stack stackSize! !

!ByteCodeReader methodsFor: 'Misc' stamp: 'wbk 5/30/2004 23:09'!
stackHeights
	^ stackHeights! !

!ByteCodeReader methodsFor: 'Stack' stamp: 'wbk 12/2/2004 19:42'!
storeAndPopReceiverVariable
	generator addExpression: (generator 
		storeAndPopReceiverVariableIndex: (self currentByteCode bitAnd: 7)
		value: stack pop)! !

!ByteCodeReader methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:24'!
subtract
	| second first |
	second := stack pop.
	first := stack pop.
	stack push: (generator 
				generate: first
				subtract: second)! !

!ByteCodeReader methodsFor: 'Common Sends' stamp: 'wbk 2/22/2004 13:27'!
unarySendWithSelector: aSmallInteger 
	| argument |
	argument := stack pop.
	stack push: (generator 
		generateUnarySelector: aSmallInteger
		receiver: argument)! !

Object subclass: #ColouringRegisterAllocator
	instanceVariableNames: 'source result machine interferenceGraph registerStack registerFile registerTable spiltRegisters hasSpilt coloursUsed simplifyWorklist spillWorklist moveWorklist coalescedMoves isValidating'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!ColouringRegisterAllocator class methodsFor: 'instance creation' stamp: 'wbk 8/17/2005 22:47'!
on: aMethod for: aMachine
	| allocator |
	allocator := self new
		initialiseSource: aMethod
		machine: aMachine
		isValidating: true.
	allocator run.
	^ allocator! !

!ColouringRegisterAllocator methodsFor: 'Interference Graph' stamp: 'wbk 11/2/2002 16:15'!
addInterferenceEdge: firstRegister to: secondRegister
	| firstNode secondNode |
	firstRegister = secondRegister ifTrue: [^ self]. "Arcs to ourself are meaningless, they also allow 
													collections to be modified inside iterations"
	(machine isSpecialRegister: firstRegister) | (machine isSpecialRegister: secondRegister)
		ifTrue: [^ self]. "Special registers do not interfere with colourable registers"
	firstNode := interferenceGraph at: firstRegister.
	secondNode := interferenceGraph at: secondRegister.
	firstNode addEdgeTo: secondNode.
	secondNode addEdgeTo: firstNode! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 8/17/2005 22:44'!
analyseLiveness
	LivenessAnalyser 
		on: source
		isValidating: isValidating.! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 5/22/2004 22:15'!
assert: aBoolean
	aBoolean ifFalse: [TestResult failure sunitSignalWith: 'Verification failed'].! !

!ColouringRegisterAllocator methodsFor: 'Select Registers' stamp: 'wbk 6/2/2004 22:48'!
assignColourTo: aNode 
	| colour |
	self clearRegisterTable.
	coloursUsed := 0.
	aNode neighboursDo: [:each | self markRegisterUsedFor: each].
	colour := self 
				firstFreeRegisterFor: aNode
				ifAbsent: [^self spillFor: aNode].
	aNode colour: colour.! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 6/2/2004 22:53'!
assignmentDictionary
	| assignments |
	assignments := Dictionary new.
	interferenceGraph do: 
			[:each | 
			assignments 
				at: each register
				put: each currentVersion colour].
	^assignments! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 6/2/2004 22:53'!
assignRegisters
	"coalescedMoves
		do: [:t1 | (registerAssignments includesKey: t1 from)
				ifFalse: [registerAssignments 
					at: t1 from 
					put: (interferenceGraph at: t1 from) currentVersion colour]]."

	| assignments |
	assignments := self assignmentDictionary.
	self assignRegisters: assignments! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 4/20/2005 20:24'!
assignRegisters: assignments 
	result := RegisterReassigner 
				assignments: assignments
				method: source
				for: machine! !

!ColouringRegisterAllocator methodsFor: 'Interference Graph' stamp: 'wbk 1/11/2006 20:04'!
buildInterferenceGraph
	interferenceGraph := Dictionary new.
	source registersDo: 
			[:each | 
			(machine isSpecialRegister: each) not ifTrue: 
					[interferenceGraph 
						at: each
						ifAbsentPut: 
							[InterferenceNode 
								for: each
								with: machine
								interferenceGraph: interferenceGraph]]].
	self installRegisterInInteferenceGraph: #eax.
	self installRegisterInInteferenceGraph: #ecx.
	self installRegisterInInteferenceGraph: #edx.
	source instructionsDo: [:each | each buildInterferenceWith: self]! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 8/2/2004 21:29'!
calculateStatistics
	source registersDo: 
		[:each| (machine isSpecialRegister: each) ifFalse: 
			[(interferenceGraph at: each) incrementRegisterCount]].! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 10/23/2002 18:08'!
clearRegisterTable
	registerTable := registerFile collect: [:each| false].! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 6/20/2004 10:53'!
coalesce
	| toCoalesce |
	toCoalesce := moveWorklist 
		detect: [:each | each isCoalescable]
		ifNone: [^false].
	self coalesceNode: toCoalesce.
	moveWorklist copy do: 
		[:each | (each doesInterfere) ifTrue: [self freezeMove: each]].
	^true! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/5/2002 13:16'!
coalescedMoves
	^ coalescedMoves! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 7/25/2004 18:11'!
coalesceNode: node 
	| fromNode toNode temporaryNode |
	fromNode := node fromCurrentNode.
	toNode := node toCurrentNode.
	fromNode register isMachineRegister ifTrue:
		[temporaryNode := fromNode.
		fromNode := toNode.
		toNode := temporaryNode].
	fromNode decrementCurrentMoves.
	toNode addInterferenceEdgesFrom: fromNode.
	toNode = fromNode ifFalse:
		[toNode incrementCurrentMovesBy: fromNode currentMoves.
		fromNode simplify].
	fromNode currentVersion: toNode.
	self queueNode: toNode.
	coalescedMoves add: node.
	moveWorklist remove: node.! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 10/23/2002 17:18'!
createWorkingEdges
	interferenceGraph do: [:each| each createWorkingEdges]! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 3/4/2005 16:56'!
createWorklists
	source instructionsDo: 
			[:each | 
			(self isCoalescableMove: each) ifTrue: 
					[moveWorklist add: (MoveNode 
								move: each
								withGraph: interferenceGraph
								maxColours: machine numberOfColours)]].
	interferenceGraph do: 
			[:each | 
			each isMoveRelated | each register isMachineRegister ifFalse: 
					[each currentSize < machine numberOfColours & each isSelected not 
						ifTrue: [simplifyWorklist add: each]
						ifFalse: [spillWorklist add: each]]]! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 10/17/2005 21:11'!
findNodeToSpill
	| spillable |
	"This is just a basic heuristic, spill the register that interferes with the most
	other registers. It is possible to do a lot better. 
	The heuristic should concider how much each register is used while it is alive"
	spillable := spillWorklist select: 
		[:each | ((self hasSpill: each register) not) and: [each register isMachineRegister not]].
	spillable := spillable asSortedCollection: [:a :b| a spillWeight > b spillWeight].
	^ spillable first! !

!ColouringRegisterAllocator methodsFor: 'Select Registers' stamp: 'wbk 11/4/2002 16:56'!
firstFreeRegisterFor: aNode ifAbsent: aBlock
	| index |
	coloursUsed >= registerFile size & aNode isSpilled ifTrue: aBlock.
	index := registerTable indexOf: false.
	^ registerFile at: index! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 8/2/2004 22:24'!
freeze
	| moves |
	moveWorklist isEmpty ifTrue: [^false].
	moves := moveWorklist 
		select: 
			[:each |  each fromNode currentSize < machine numberOfColours |
	 			( each toNode currentSize < machine numberOfColours)].
	moves ifEmpty: [^ false].
	moves := moves asSortedCollection: [:a :b| a freezeWeight > b freezeWeight].
	"self halt."
	self freezeMove: moves first.
	^true! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 6/21/2004 22:11'!
freezeMove: move 
	| fromNode toNode |
	moveWorklist remove: move.
	fromNode := move fromCurrentNode.
	toNode :=  move toCurrentNode.
	self queueNode: fromNode.
	self queueNode: toNode! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 5/29/2004 15:22'!
gatherSimplifyableNodes
	| toSimplify |
	toSimplify := spillWorklist select: [:each | each currentSize < machine numberOfColours].
	spillWorklist removeAll: toSimplify.
	simplifyWorklist addAll: toSimplify! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 6/21/2004 22:16'!
getMoveFrom: aSymbol to: aSymbol2 
	^ moveWorklist detect: 
		[:each| each fromNode register name = aSymbol & (each toNode register name = aSymbol2)]! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 8/2/2004 21:24'!
hasNoTemporaries
	result registersDo: [:each| each isMachineRegister ifFalse: [^false]].
	^ true.! !

!ColouringRegisterAllocator methodsFor: 'Misc' stamp: 'wbk 5/26/2004 22:28'!
hasSpill: aMedTemporaryRegister 
	^ hasSpilt includes: aMedTemporaryRegister! !

!ColouringRegisterAllocator methodsFor: 'Misc' stamp: 'wbk 8/17/2005 22:46'!
initialiseSource: aMethod machine: aMachine
self removeMe.
	source := aMethod.
	machine := aMachine.
	interferenceGraph := Dictionary new.
	registerStack := OrderedCollection new.
	registerFile := aMachine useableRegisters.
	spiltRegisters := OrderedCollection new.
	hasSpilt := Set new.
	simplifyWorklist := OrderedCollection new.
	spillWorklist := OrderedCollection new.
	moveWorklist := OrderedCollection new.
	coalescedMoves := OrderedCollection new.
	^ self! !

!ColouringRegisterAllocator methodsFor: 'Misc' stamp: 'wbk 8/17/2005 22:46'!
initialiseSource: aMethod machine: aMachine isValidating: aBoolean
	source := aMethod.
	machine := aMachine.
	isValidating := aBoolean.
	interferenceGraph := Dictionary new.
	registerStack := OrderedCollection new.
	registerFile := aMachine useableRegisters.
	spiltRegisters := OrderedCollection new.
	hasSpilt := Set new.
	simplifyWorklist := OrderedCollection new.
	spillWorklist := OrderedCollection new.
	moveWorklist := OrderedCollection new.
	coalescedMoves := OrderedCollection new.
	^ self! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 5/29/2004 14:03'!
insertSpills
	source := SpillInserter
		spiltRegisters: spiltRegisters
		method: source
		for: machine
		allocator: self! !

!ColouringRegisterAllocator methodsFor: 'Interference Graph' stamp: 'wbk 1/11/2006 20:04'!
installRegisterInInteferenceGraph: aSymbol
	interferenceGraph
		at: (machine registerNamed: aSymbol)
		put: (InterferenceNode
			for: (machine registerNamed: aSymbol)
			with: machine
			interferenceGraph: interferenceGraph).! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/2/2002 15:50'!
interferenceGraph
	^ interferenceGraph! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/23/2002 21:59'!
interferenceNode: aRegister
	^ interferenceGraph
		at: aRegister ! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/7/2002 15:35'!
interferes: firstRegister with: secondRegister 
	^(interferenceGraph at: firstRegister) 
		interferesWith: (interferenceGraph at: secondRegister)! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/23/2002 22:12'!
intermediateForm
	^ self result intermediateForm! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 6/24/2003 13:28'!
isCoalescableMove: aMove 
	(aMove isMov and: [aMove to isRegister & aMove from isRegister]) ifFalse: [^ false].
	(machine isSpecialRegister: aMove from) | (machine isSpecialRegister: aMove to)
		ifTrue: [^ false]. "Copied from ColouringRegisterAllocator>>addInterferenceEdge:to:"
	^ (self
		interferes: aMove to
		with: aMove from) not! !

!ColouringRegisterAllocator methodsFor: 'Select Registers' stamp: 'wbk 11/4/2002 17:04'!
markRegisterUsedFor: aNode 
	aNode isSpilled ifTrue: [^ self].
	coloursUsed := coloursUsed + 1.
	aNode hasColour ifFalse: [^ self].
	registerTable 
		at: (registerFile indexOf: aNode colour) 
		put: true! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/5/2002 10:34'!
moveWorklist
	^ moveWorklist! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 11/7/2002 15:38'!
processWorkLists
	simplifyWorklist isEmpty ifFalse: [^ self simplify].
	self coalesce ifTrue: [^ self].
	self freeze ifTrue: [^ self].
	spillWorklist isEmpty ifFalse: [^ self spillRegister].
	self spillMove! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 10/17/2005 21:10'!
queueNode: aNode 
	aNode decrementCurrentMoves.
	aNode isCurrentlyInvolvedInMoves ifTrue: [^self].
	aNode currentSize < machine numberOfColours 
		ifTrue: [simplifyWorklist add: aNode.]
		ifFalse: [spillWorklist add: aNode]! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 6/2/2004 22:54'!
registerAssignments
	^ self assignmentDictionary! !

!ColouringRegisterAllocator methodsFor: 'Misc' stamp: 'wbk 5/26/2004 23:56'!
registerIsSpilled: aMedTemporaryRegister 
	hasSpilt add: aMedTemporaryRegister! !

!ColouringRegisterAllocator methodsFor: 'Misc' stamp: 'wbk 1/11/2006 19:52'!
registerNamed: aByteSymbol 
	^ machine registerNamed: aByteSymbol! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/3/2002 12:20'!
registerStack
	^ registerStack! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/1/2002 23:09'!
registerStack: aCollection
	registerStack := aCollection collect: [:each| interferenceGraph at: (machine registerNamed: each)] ! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 11/5/2002 13:30'!
registersToSimplify
	^ spillWorklist isEmpty not | simplifyWorklist isEmpty not | moveWorklist isEmpty not! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/2/2002 17:02'!
result
	^ result! !

!ColouringRegisterAllocator methodsFor: 'Allocation' stamp: 'wbk 4/1/2006 23:05'!
run
	| hadSpills |
	hadSpills := true.
	[hadSpills] whileTrue: 
			[self setUp.
			self simplifyAndSpill.
			self select.
			hadSpills := spiltRegisters size ~= 0.
			hadSpills 
				ifTrue: [self insertSpills]
				ifFalse: [self assignRegisters]].! !

!ColouringRegisterAllocator methodsFor: 'Select Registers' stamp: 'wbk 6/2/2004 22:48'!
select
	spiltRegisters := OrderedCollection new.
	registerStack reverseDo: [:each | self assignColourTo: each]! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 8/2/2004 21:18'!
setUp
	self analyseLiveness.
	self buildInterferenceGraph.
	registerStack := OrderedCollection new.
	self createWorkingEdges.
	self createWorklists.
	self calculateStatistics.! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 5/29/2004 16:03'!
simplify
	simplifyWorklist do: 
			[:each | 
			registerStack addLast: each.
			each simplify].
	simplifyWorklist := OrderedCollection new.
	self gatherSimplifyableNodes! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 8/2/2004 21:13'!
simplifyAndSpill
	[self registersToSimplify] whileTrue: [self processWorkLists]! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/5/2002 10:40'!
simplifyWorklist
	^ simplifyWorklist! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/28/2002 21:36'!
source
	^ source! !

!ColouringRegisterAllocator methodsFor: 'Select Registers' stamp: 'wbk 11/3/2002 14:52'!
spillFor: aNode 
	spiltRegisters add: aNode register.
	hasSpilt add: aNode register! !

!ColouringRegisterAllocator methodsFor: 'Move Coalescing' stamp: 'wbk 11/7/2002 15:52'!
spillMove
	self freezeMove: moveWorklist first! !

!ColouringRegisterAllocator methodsFor: 'Simplify Graph' stamp: 'wbk 10/15/2005 21:26'!
spillRegister
	| toSpill |
	toSpill := self findNodeToSpill.
	toSpill register isMachineRegister ifTrue:
		[Exupery log: '  ERROR spilling a machine register'.
		Error signal: 'Spilling a machine register'].
	registerStack addLast: toSpill.
	toSpill simplify.
	toSpill markAsSpilled.
	spillWorklist remove: toSpill.
	self gatherSimplifyableNodes.
	! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 11/5/2002 11:04'!
spillWorklist
	^ spillWorklist! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/28/2002 17:58'!
spiltRegisters
	^ spiltRegisters! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/28/2002 19:29'!
spiltRegisters: aCollection
	spiltRegisters := aCollection! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/23/2002 22:35'!
stackIncludes: aRegister
	^ registerStack includes: (interferenceGraph at: aRegister).! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 10/28/2002 10:25'!
stackSize
	^ registerStack size! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 3/4/2005 16:57'!
unallocated
	| answer |
	answer := OrderedCollection new.
	interferenceGraph do: [:each| each isSelected | each register isMachineRegister ifFalse: [answer add: each]].
	^ answer! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 7/25/2004 16:26'!
verify
	"Copied from ColouringRegisterAllocatorTests>>verifyAllocationCounts. 	verifyAllocationMoveCounds should be modified to use this in the future."

	self verifyMoveCounts.
	self verifyInterferenceGraph.
	self verifyCoalescableNodesNotSimplified.! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 7/25/2004 16:34'!
verifyCoalescableNodesNotSimplified
	moveWorklist do:
		[:each| self assert: each fromNode currentVersion isSimplified not.
		self assert: each toNode currentVersion isSimplified not]! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 7/25/2004 16:00'!
verifyInterferenceGraph
	"Check that all machine registers are at the top of the merge trees"
	interferenceGraph do:
		[:each| each register isMachineRegister ifTrue:
			[self assert: each = each  currentVersion]].! !

!ColouringRegisterAllocator methodsFor: 'Unit Testing' stamp: 'wbk 7/25/2004 15:54'!
verifyMoveCounts
	| moveCount |
	moveCount := Dictionary new.
	moveWorklist do: 
			[:each | 
			moveCount 
				at: each fromCurrentNode
				put: (moveCount 
						at: each fromCurrentNode
						ifAbsent: [0]) + 1.
			moveCount 
				at: each toCurrentNode
				put: (moveCount 
						at: each toCurrentNode
						ifAbsent: [0]) + 1].
	interferenceGraph do: 
			[:each | 
			self assert: each currentVersion currentMoves = (moveCount 
								at: each currentVersion
								ifAbsent: [0])]! !

Object subclass: #CompilerToys
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!CompilerToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/6/2004 20:10'!
minus! !

!CompilerToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/4/2004 21:36'!
sal! !

!CompilerToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/4/2004 20:50'!
sar! !

!CompilerToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/6/2004 20:10'!
sub! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'wbk 3/13/2005 21:25'!
basicTarget
	^ 7! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'wbk 10/14/2002 19:06'!
conditionalJumps
	^ 1 <= 2
		ifTrue: [^ 3]
		ifFalse: [^ 4]! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/29/2002 18:36'!
iterativeFactorial: n
	|acc|
	acc := 1.
	1
		to: n
		do: [:each| acc := acc * each].
	^ acc! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'wbk 10/13/2002 19:02'!
lessThanEquals
	^ 1<=2! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'wbk 10/13/2002 19:04'!
nestedConditionals
	^ 1 + (1 <= 3)! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'wbk 9/3/2002 12:09'!
return42
	^ 42! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 16:15'!
simpleMethod
	^ 1! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 16:17'!
simpleMethod2
	^ 1 + 2! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 16:18'!
simpleMethod3
	^ 1 + 100! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 16:20'!
simpleMethod4
	^ 100 + 101! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 16:32'!
simpleMethod5
	^ 1 + 2 + 3 + 4 + 5 + 6! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'WBK 8/26/2002 18:43'!
simpleMethod6
	^ 100 times: 2 * 3! !

!CompilerToys methodsFor: 'as yet unclassified' stamp: 'wbk 10/2/2002 18:04'!
stringConcatenate
	^ 'abc', 'def'! !

Object subclass: #EncodeFixedRegRm32
	instanceVariableNames: 'registerName opcode rmOpcode instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!EncodeFixedRegRm32 class methodsFor: 'as yet unclassified' stamp: 'wbk 2/8/2004 21:36'!
fixedRegister: aSymbol fixedOpcode: anUndefinedObject fixedModRm: anUndefinedObject3 
	^ self new
		initialiseFixedRegister: aSymbol 
		fixedOpcode: anUndefinedObject 
		fixedModRm: anUndefinedObject3 ! !

!EncodeFixedRegRm32 methodsFor: 'as yet unclassified' stamp: 'wbk 2/8/2004 21:53'!
fire
	instruction assembler stream nextPut: opcode.
	instruction assembler 
		encodeModRm: instruction arg2
		registerOpcode: rmOpcode! !

!EncodeFixedRegRm32 methodsFor: 'as yet unclassified' stamp: 'wbk 2/8/2004 21:39'!
initialiseFixedRegister: aSymbol fixedOpcode: opcodeInteger fixedModRm: rmInteger 
	registerName := aSymbol.
	opcode := opcodeInteger.
	rmOpcode := rmInteger! !

!EncodeFixedRegRm32 methodsFor: 'as yet unclassified' stamp: 'wbk 2/8/2004 21:53'!
isFirable
	instruction arg1 isRegister ifFalse: [^false].
	^instruction arg1 name = registerName! !

!EncodeFixedRegRm32 methodsFor: 'as yet unclassified' stamp: 'wbk 2/8/2004 21:53'!
registerInstruction: anAssembleArithmatic 
	instruction := anAssembleArithmatic! !

Object subclass: #EncodeFromLiteral
	instanceVariableNames: 'opcode modRmOpcode assembler instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

EncodeFromLiteral subclass: #EncodeFromByteLiteral
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!EncodeFromByteLiteral methodsFor: 'Encoding' stamp: 'wbk 3/28/2005 19:26'!
encodeImmediate
	assembler stream nextPut: instruction arg1 literal! !

!EncodeFromLiteral class methodsFor: 'as yet unclassified' stamp: 'wbk 4/18/2003 18:19'!
opcode: aSmallInteger modRmOpcode: aSmallInteger2
	^ self new
		initializeOpcode: aSmallInteger 
		modRmOpcode: aSmallInteger2 ! !

!EncodeFromLiteral methodsFor: 'Encoding' stamp: 'wbk 3/28/2005 19:24'!
encodeImmediate
	assembler encodeImmediate: instruction arg1! !

!EncodeFromLiteral methodsFor: 'Encoding' stamp: 'wbk 3/28/2005 19:24'!
fire
	assembler stream nextPutAll: opcode.
	assembler 
		encodeModRm: instruction arg2
		registerOpcode: modRmOpcode.
	self encodeImmediate! !

!EncodeFromLiteral methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:18'!
initializeOpcode: aSmallInteger modRmOpcode: aSmallInteger2
	opcode := aSmallInteger.
	modRmOpcode := aSmallInteger2.	
	^ self.! !

!EncodeFromLiteral methodsFor: 'Encoding' stamp: 'wbk 4/6/2003 21:17'!
isFirable
	^ instruction arg1 isLiteral! !

!EncodeFromLiteral methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:17'!
registerInstruction: anAssembleArithmatic 
	instruction := anAssembleArithmatic.
	assembler := instruction assembler.! !

Object subclass: #EncodeFromLiteralToRegister
	instanceVariableNames: 'opcode assembler instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!EncodeFromLiteralToRegister class methodsFor: 'as yet unclassified' stamp: 'wbk 4/18/2003 18:21'!
opcode: aSmallInteger
	^ self new
		initializeOpcode: aSmallInteger ! !

!EncodeFromLiteralToRegister methodsFor: 'Encoding' stamp: 'wbk 4/7/2003 14:18'!
fire
	assembler stream nextPut: opcode + (assembler registerEncoding: instruction arg2).
	assembler encodeImmediate: instruction arg1.! !

!EncodeFromLiteralToRegister methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:21'!
initializeOpcode: aSmallInteger
	opcode := aSmallInteger.
	^ self! !

!EncodeFromLiteralToRegister methodsFor: 'Encoding' stamp: 'wbk 4/7/2003 14:15'!
isFirable
	^ instruction arg2 isRegister & instruction arg1 isLiteral! !

!EncodeFromLiteralToRegister methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:20'!
registerInstruction: anAssembleInstruction 
	instruction := anAssembleInstruction.
	assembler := instruction assembler.! !

Object subclass: #EncodeImm8Rm32
	instanceVariableNames: 'instructionByte modRmValue assembler instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!EncodeImm8Rm32 class methodsFor: 'as yet unclassified' stamp: 'wbk 4/18/2003 18:24'!
firstByte: aSmallInteger modRmValue: aSmallInteger2
	^ self new
		initializeFirstByte: aSmallInteger 
		modRmValue: aSmallInteger2! !

!EncodeImm8Rm32 methodsFor: 'Encoding' stamp: 'wbk 2/8/2004 21:52'!
fire
	assembler stream nextPut: instructionByte.
	assembler 
		encodeModRm: instruction arg2 
		registerOpcode: modRmValue.
	assembler stream nextPut: instruction arg1 literal! !

!EncodeImm8Rm32 methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:23'!
initializeFirstByte: aSmallInteger modRmValue: aSmallInteger2
	instructionByte :=  aSmallInteger.
	modRmValue := aSmallInteger2.
	^ self! !

!EncodeImm8Rm32 methodsFor: 'Encoding' stamp: 'wbk 4/4/2003 17:28'!
isFirable
	^ instruction arg1 isLiteral & instruction arg2 isRegister! !

!EncodeImm8Rm32 methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:23'!
registerInstruction: anAssembleArithmatic 
	instruction := anAssembleArithmatic .
	assembler := instruction assembler.! !

Object subclass: #EncodeToAddressingMode
	instanceVariableNames: 'opcode assembler instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

EncodeToAddressingMode subclass: #EncodeFromAddressingMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!EncodeFromAddressingMode methodsFor: 'Encoding' stamp: 'wbk 4/11/2003 18:07'!
fire
	assembler stream nextPutAll: opcode.
	assembler 
		encodeModRm: instruction arg1
		register: instruction arg2	! !

!EncodeFromAddressingMode methodsFor: 'Encoding' stamp: 'wbk 4/6/2003 21:03'!
isFirable
	^ instruction arg2 isRegister & (instruction arg1 isAddressingMode | instruction arg1 isRegister)! !

!EncodeToAddressingMode class methodsFor: 'as yet unclassified' stamp: 'wbk 4/18/2003 18:16'!
opcodes: aSmallInteger
	^ self new
		initializeOpcodes: aSmallInteger! !

!EncodeToAddressingMode class methodsFor: 'as yet unclassified' stamp: 'wbk 3/28/2005 18:31'!
opcode: aSmallInteger
	aSmallInteger isCollection ifTrue: [^ self new initializeOpcodes: aSmallInteger].
	^ self new
		initializeOpcodes: (Array with: aSmallInteger)! !

!EncodeToAddressingMode methodsFor: 'Encoding' stamp: 'wbk 4/11/2003 18:08'!
fire
	assembler stream nextPutAll: opcode.
	assembler 
		encodeModRm: instruction arg2 
		register: instruction arg1	! !

!EncodeToAddressingMode methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:12'!
initializeOpcodes: aSmallInteger
	opcode := aSmallInteger.
	^ self! !

!EncodeToAddressingMode methodsFor: 'Encoding' stamp: 'wbk 4/6/2003 20:57'!
isFirable
	^ instruction arg1 isRegister & (instruction arg2 isAddressingMode | instruction arg2 isRegister)! !

!EncodeToAddressingMode methodsFor: 'misc' stamp: 'wbk 4/18/2003 18:11'!
registerInstruction: anAssembleArithmatic 
	instruction := anAssembleArithmatic.
	assembler := instruction assembler.! !

Object subclass: #Exupery
	instanceVariableNames: 'method assembly machine instructions allocated generator byteCodes lowLevel optimised relocations blockPositions lowLevelOptimised picEntries jumpsRemoved pics inlinedCalls receiver'
	classVariableNames: 'PICs CompiledMethods ArgumentCountForBlock BlockPositions Methods'
	poolDictionaries: ''
	category: 'Exupery'!

!Exupery class methodsFor: 'code cache' stamp: 'wbk 2/5/2006 11:51'!
argumentCountFor: anInteger
	^ ArgumentCountForBlock at: anInteger! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 2/5/2006 10:38'!
byteCodeAddressFor: anInteger
	^ BlockPositions at: anInteger! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 2/5/2006 10:10'!
clearMethodCacheAndContexts
	Object flushCache.
	MethodContext allInstancesDo: [:each| each clearExuperyReturnAddress].
	ExuperyBlockContext allInstancesDo: [:each| each convertToInterpretedContext].! !

!Exupery class methodsFor: 'compiling' stamp: 'wbk 10/25/2005 22:01'!
compileMethod: aSymbol class: aClass 
	Exupery log: 'Compiling ', aClass printString, '>>', aSymbol.
	self 
		compileMethod: aSymbol
		class: aClass
		inlining: #()! !

!Exupery class methodsFor: 'compiling' stamp: 'wbk 10/25/2005 22:01'!
compileMethod: aSymbol class: aClass inlining: anArray 
	self 
		compileMethod: aSymbol
		into: aSymbol
		forClass: aClass
		inlining: anArray! !

!Exupery class methodsFor: 'instance creation' stamp: 'wbk 11/6/2005 18:47'!
compileMethod: aCompiledMethod inlining: anObject receiver: aClass 
	| compiler |
	compiler := self new 
				initializeMethod: aCompiledMethod
				inlining: anObject
				receiver: aClass.
	compiler run.
	^compiler! !

!Exupery class methodsFor: 'compiling' stamp: 'wbk 11/6/2005 18:48'!
compileMethod: aSymbol into: aSymbol2 forClass: aClass inlining: anObject 
	| method code compiler |
	method := (self 
				definingClass: aClass
				forSelector: aSymbol) compiledMethodAt: aSymbol.
	compiler := self 
				compileMethod: method
				inlining: anObject
				receiver: aClass.
	"Load the compiled method into the code cache"
	code := self loadCode: compiler byteCodes.
	compiler relocateMethodAt: code.
	(PICs 
		at: aClass
		ifAbsentPut: [Dictionary new]) 
			at: aSymbol2
			put: compiler pics.
	self 
		register: code
		forClass: aClass
		selector: aSymbol2.
	aSymbol2 flushCache! !

!Exupery class methodsFor: 'compiling' stamp: 'wbk 4/17/2005 12:06'!
definingClass: aClass forSelector: aSymbol
	(aClass canUnderstand: aSymbol) ifFalse: [self error: 'Class does not understand selector'].
	(aClass includesSelector: aSymbol) ifTrue: [^ aClass].
	^ self
		definingClass: aClass superclass
		forSelector: aSymbol! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 2/5/2006 10:07'!
initialiseExupery
	"This dictionary must be of size zero, this allows us to replace a divsion with a
	bit mask. This is also true for classes method dictionaries."

	self log: 'Initializing the Code Cache'.
	self initializeMethodDictionary.
	self clearMethodCacheAndContexts.
	self initializeCompileMethodArray.
	PICs := Dictionary new.
	BlockPositions := Dictionary new.
	ArgumentCountForBlock := Dictionary new.! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 4/15/2004 22:02'!
initialiseExupery: aDictionary
	"Don't call this method directly, use initialiseExupery. The argument is just to pass
	a dictionary into the VM. The dictionary will then be used to find compiled code for
	methods"
	<primitive: 'initialiseExupery' module: 'ExuperyPlugin'>
	TestFailure signal! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 9/8/2005 18:30'!
initializeCompileMethodArray
	" The registered compiled array must NEVER be garbage collected, this will lead
	to a dangling pointer in the VM."

	| newArray |
	newArray := Array new.
	self registerCompiledMethodArray: newArray.
	CompiledMethods := newArray! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 9/8/2005 18:31'!
initializeMethodDictionary
	Methods := ExuperyMethodDictionary new.
	self initialiseExupery: Methods! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 10/15/2005 23:23'!
loadCode: anArray
	<primitive: 'loadCode' module: 'ExuperyPlugin'>
	Exupery log: '  loadCode failed'.
	TestFailure signal! !

!Exupery class methodsFor: 'logging' stamp: 'wbk 8/27/2005 22:23'!
log: aString
	| file |
	file := CrLfFileStream fileNamed: 'Exupery.log'.
	file position: file size.
	file nextPutAll: Time now printString.
	file nextPutAll: ': '.
	file nextPutAll: aString.
	file cr.
	file close.! !

!Exupery class methodsFor: 'pics' stamp: 'wbk 5/18/2005 19:56'!
picsInMethod: aByteSymbol class: aClass 
	^ (PICs at: aClass) at: aByteSymbol! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 5/31/2005 20:04'!
registerCompiledMethodArray: anArray 
	<primitive: 'setMethodArray' module: 'ExuperyPlugin'>
	TestFailure signal! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 6/2/2005 18:14'!
registerCompiledMethod: aMethod 
	| answer |
	answer := CompiledMethods size.
	CompiledMethods := CompiledMethods copyGrownBy: 1.
	CompiledMethods at: CompiledMethods size put: aMethod.
	self registerCompiledMethodArray: CompiledMethods.
	^ answer! !

!Exupery class methodsFor: 'code cache' stamp: 'wbk 4/17/2005 11:36'!
register: code forClass: aClass selector: aSymbol2
	"<primitive: 'registerCompiledMethod' module: 'ExuperyPlugin'>
	TestFailure signal"
	(Methods
		at: aClass
		ifAbsentPut: ExuperyMethodDictionary new)
			at: aSymbol2
			put: code.! !

!Exupery methodsFor: 'Relocation' stamp: 'wbk 2/4/2006 23:27'!
addRelocationAt: aSmallInteger for: aMedBlock byteCodeAddress: anInteger
	relocations add: {aSmallInteger. aMedBlock. anInteger}! !

!Exupery methodsFor: 'Relocation' stamp: 'wbk 2/4/2006 23:23'!
addRelocationAt: aSmallInteger for: aMedBlock byteCodeAddress: byteCodeInteger argumentCount: argumentsInteger 
	
	relocations add: {aSmallInteger. aMedBlock. byteCodeInteger. argumentsInteger}! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 10/24/2002 13:42'!
allocateRegisters
	| withRegisters |
	withRegisters := ColouringRegisterAllocator 
		on: instructions
		for: machine.
	allocated := withRegisters result.! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 7/20/2005 23:53'!
assemble
	| assembler |
	assembler := AssemblerExupery 
		assemble: jumpsRemoved" allocated"
		withPlugin: machine
		relocator: self.
	blockPositions := assembler blockPositions.
	byteCodes := assembler byteCodes.
	picEntries := assembler picEntries.! !

!Exupery methodsFor: 'Misc' stamp: 'wbk 9/16/2002 15:54'!
assembly
	^ assembly! !

!Exupery methodsFor: 'Misc' stamp: 'wbk 3/17/2003 14:32'!
byteCodes
	^ byteCodes! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 8/17/2005 14:52'!
convertIntermediate
	| simplifer |
	simplifer:= IntermediateSimplifier 
				from: optimised
				machine: machine.
	lowLevel := simplifer run.! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 1/3/2006 22:28'!
findBlocks
	BlockFinder findBlocksIn: optimised! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 1/20/2006 23:13'!
generateIntermediate
	| jumpFinder reader |
	jumpFinder := JumpTargetRecorder new.
	ByteCodeReader 
		newMethod: method
		using: jumpFinder
		jumpTargets: #()
		stackHeights: #().
	generator := IntermediateGenerator 
				for: machine
				jumpTargets: jumpFinder targets , jumpFinder blocks
				inlining: inlinedCalls
				receiver: receiver.
	reader := ByteCodeReader 
				newMethod: method
				using: generator
				jumpTargets: jumpFinder targets
				stackHeights: jumpFinder stackTrace.
	method := generator result.
	^reader! !

!Exupery methodsFor: 'Misc' stamp: 'wbk 10/15/2002 18:39'!
generator
	^ generator! !

!Exupery methodsFor: 'Misc' stamp: 'wbk 10/25/2005 22:04'!
getMethod
	^ method! !

!Exupery methodsFor: 'Misc' stamp: 'wbk 11/6/2005 18:45'!
initializeMethod: aCompiledMethod inlining: anObject receiver: aClass 
	method := aCompiledMethod.
	assembly := ''.
	machine := MachineX86 new.
	relocations := OrderedCollection new.
	pics := OrderedCollection new.
	inlinedCalls := anObject.
	receiver := aClass.
	anObject isNil ifTrue: [0 halt].
	^self! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 1/22/2005 14:45'!
lowLevelOptimiser
	| optimiser |
	optimiser := LowLevelOptimiser 
				from: lowLevel
				machine: machine.
	lowLevelOptimised := optimiser run.! !

!Exupery methodsFor: 'Misc' stamp: 'wbk 5/18/2005 20:00'!
pics
	^ pics! !

!Exupery methodsFor: 'Misc' stamp: 'wbk 5/31/2005 19:53'!
registerCompiledMethod: aMethod 
	| answer |
self removeMe.
	answer := CompiledMethods size.
	CompiledMethods := CompiledMethods copyGrownBy: 1.
	CompiledMethods at: CompiledMethods size put: aMethod.
	self registerCompiledMethodArray: CompiledMethods.
	^ answer! !

!Exupery methodsFor: 'Relocation' stamp: 'wbk 4/18/2006 20:26'!
relocateMethodAt: anInteger
	| position |
	relocations do:
		[:each| machine 
			machineWordIn: anInteger
			at: each first
			put: (blockPositions at: each second blockNumber).
		position := anInteger + ((blockPositions at: each second blockNumber) / 2).
		BlockPositions
			at: position
			put: each third.
		each size = 4 ifTrue: 
			[ArgumentCountForBlock
				at: position
				put: ((each at: 4) bitShift: -1)]].
	pics := picEntries collect: [:each| each relocateInMethodAt: anInteger].
	(blockPositions associations asSortedCollection: [:a :b| a key < b key]) do:
		[:each| Exupery log: '  block ', each key printString, ' at 0x', 
			(each value + (1 << 31 + anInteger * 2)) printStringHex].! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 4/1/2005 21:50'!
removeJumps
	jumpsRemoved := JumpRemover 
				removeJumpsFrom: allocated
				machine: machine! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 4/18/2006 20:27'!
run
	machine compiledMethodNumber: (Exupery registerCompiledMethod: method ).
	self generateIntermediate.
	self treeOptimiser.
	self findBlocks.
	self convertIntermediate.
	self lowLevelOptimiser.
	self selectInstructions.
	self allocateRegisters.
	self removeJumps.
	self assemble.! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 1/22/2005 14:44'!
selectInstructions
	| selector |
	selector := InstructionSelector 
		on: lowLevelOptimised
		for: machine.
	instructions := selector result.! !

!Exupery methodsFor: 'Misc' stamp: 'wbk 3/24/2005 18:46'!
setMethodArray: ansArray
	<primitive: 'setMethodArray' module: 'ExuperyPlugin'>
	TestFailure signal! !

!Exupery methodsFor: 'Compilation' stamp: 'wbk 12/21/2004 11:52'!
treeOptimiser
	| optimiser |
	optimiser := TreeOptimiser 
				from: method
				machine: machine.
	optimised := optimiser run.! !

Object subclass: #ExuperyBenchmarks
	instanceVariableNames: 'time compiledTime cumulativeTime cumulativeCompiledTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 20:20'!
arithmaticLoopBenchmark
	^ Time millisecondsToRun: [self arithmeticLoop].! !

!ExuperyBenchmarks methodsFor: 'benchmark methods' stamp: 'wbk 8/2/2004 22:31'!
arithmeticLoop
	| acc |
	acc := 0.
	1
		to: 20000000
		do: [:each| acc := acc + 1].
	^ acc! !

!ExuperyBenchmarks methodsFor: 'test example methods' stamp: 'wbk 3/13/2005 21:28'!
basicTarget
	^ 8! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 20:05'!
bytecodeBenchmark
	^ Time millisecondsToRun: [1000 benchmark].! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 20:20'!
compileArithmaticLoop
	Exupery
		compileMethod: #arithmeticLoop
		class: ExuperyBenchmarks! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 6/3/2005 18:17'!
compileBytecodeBenchmark
	Exupery
		compileMethod: #benchmark
		class: SmallInteger
		inlining: {{43. Array}. {62. Array}}.
	Exupery
		compileMethod: #at:
		class: Array.
	Exupery
		compileMethod: #at:put:
		class: Array.! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 6/23/2005 18:44'!
compileCompilerBenchmark
	"Requires the value bytecode"
	Exupery
		compileMethod: #at:ifAbsent:
		class: Array
		inlining: {{17. Array}}.
	Exupery
		compileMethod: #at:
		class: Array.
	Exupery
		compileMethod: #between:and:
		class: SmallInteger.
	Exupery
		compileMethod: #max:
		class: SmallInteger.
	Exupery
		compileMethod: #growSize
		class: Dictionary.
	Exupery
		compileMethod: #reset
		class: WriteStream.

	Exupery
		compileMethod: #step
		class: Parser.
	"Exupery
		compileMethod: #at:ifAbsent:
		class: Dictionary."
! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 1/21/2006 10:25'!
compileDoLoops
	Exupery
		compileMethod: #doLoops
		class: ExuperyBenchmarks.
	Exupery
		compileMethod: #do:
		class: Interval! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 19:51'!
compileGifConversion
	Exupery 
		compileMethod: #writeBitData:
		class: GIFReadWriter. ! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 5/15/2005 20:43'!
compilerBenchmark
	^ Time millisecondsToRun:
		[1
			to: 100
			do:
				[:each| ExuperyBenchmarks 
					basicCompile:
'beRootIfNessisary: parentObject exitingTo: nextBlock 
	| header rootTableCount emitter |
	emitter addExpression: (emitter 
				jumpType: #jge
				to: nextBlock
				dependingOn: (emitter 
						emit: parentObject
						cmp: (emitter mem: emitter youngStartAddress))).
	header := emitter createTemporaryRegister.
	emitter 
		moveFrom: (emitter mem: parentObject)
		to: header.
	emitter addExpression: (emitter 
				jumpType: #jnz
				to: nextBlock
				dependingOn: (emitter 
						emit: header
						and: (MedLiteral literal: 1073741824))).	"root flag in header"
	rootTableCount := emitter createTemporaryRegister.
	emitter 
		moveFrom: (emitter 
				emit: (MedLiteral literal: 1)
				add: (emitter mem: emitter rootTableCountAddress))
		to: rootTableCount.
	emitter 
		moveFrom: rootTableCount
		to: (emitter mem: emitter rootTableCountAddress).
	emitter 
		moveFrom: parentObject
		to: (emitter mem: (emitter 
						emit: emitter rootTableAddress
						add: (emitter 
								emit: rootTableCount
								sal: (MedLiteral literal: 2)))).
	emitter 
		moveFrom: (emitter 
				emit: header
				or: (MedLiteral literal: 1073741824))
		to: (emitter mem: parentObject).
	emitter jumpTo: nextBlock.
	emitter currentBlock: nextBlock'
				notifying: nil
				trailer: #(0 0 0 0)
				ifFail: [nil]]]! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 4/17/2005 15:28'!
compileSendBenchmark
	Exupery
		compileMethod: #benchFib
		class: SmallInteger.! !

!ExuperyBenchmarks methodsFor: 'benchmarks profiled' stamp: 'wbk 1/15/2006 19:27'!
doLoops
	| answer |
	1
		to: 10
		do: 
			[:count|
				answer := 0.
				(1 to: 600000) do: [:each| answer := answer + 1]]! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 1/21/2006 10:23'!
doLoopsBenchmark
	^ Time millisecondsToRun: [ExuperyBenchmarks new doLoops].! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 8/2/2004 22:43'!
gifConversion
	"Smalltalk garbageCollect." "To stabilise the benchmark. It generates a lot of garbage
								and so does compiling"
	^ Time millisecondsToRun:
		[GIFReadWriter
			putForm: (Form
				extent: 1000@1000
				depth: 32)
			onStream: (WriteStream on: (ByteArray new: 10000))].! !

!ExuperyBenchmarks methodsFor: 'execution' stamp: 'wbk 8/1/2004 11:44'!
initialize
	cumulativeTime := 1.
	cumulativeCompiledTime := 1.! !

!ExuperyBenchmarks methodsFor: 'benchmarks profiled' stamp: 'wbk 11/12/2005 12:40'!
largeExplorers
	| explorer |
	explorer := (Array new: 4000) explore.
	explorer dependents do:
		[:each| each class = SystemWindow ifTrue: [each delete]]! !

!ExuperyBenchmarks methodsFor: 'execution' stamp: 'wbk 1/21/2006 10:26'!
run
	#((arithmaticLoopBenchmark compileArithmaticLoop)
		(bytecodeBenchmark compileBytecodeBenchmark)
		(sendBenchmark compileSendBenchmark)
		(doLoopsBenchmark compileDoLoops)) do:
			[:each| self
				runBenchmark: (each at: 1)
				compilingWith: (each at: 2)].
	#(largeExplorers compilerBenchmark) do:
		[:each| self runProfiledBenchmark: each].
			
	Transcript cr.
	time := (cumulativeTime ln / 5) exp. "Calculate the root of 4"
	compiledTime := (cumulativeCompiledTime ln / 5) exp.
	Transcript show: 'Cumulative Time '.
	Transcript show: (time printShowingDecimalPlaces: 3).
	Transcript show: ' compiled '.
	Transcript show: (compiledTime printShowingDecimalPlaces: 3).
	Transcript show: ' ratio '.
	Transcript show: ((time / compiledTime) asFloat printShowingDecimalPlaces: 3).
	Transcript cr.! !

!ExuperyBenchmarks methodsFor: 'execution' stamp: 'wbk 2/6/2005 21:50'!
runBenchmark: benchmarkSymbol compilingWith: compilingSymbol 
	Exupery initialiseExupery.
	Transcript cr.
	Transcript show: benchmarkSymbol.
	Transcript space.
	time := self perform: benchmarkSymbol.
	Transcript show: time.
	Transcript show: ' compiled '.
	self perform: compilingSymbol.
	compiledTime := self perform: benchmarkSymbol.
	Transcript show: compiledTime.
	Transcript show: ' ratio: '.
	Transcript show: ((time / compiledTime) asFloat printShowingDecimalPlaces: 3).
	cumulativeTime := cumulativeTime * time.
	cumulativeCompiledTime := cumulativeCompiledTime * compiledTime.! !

!ExuperyBenchmarks methodsFor: 'execution' stamp: 'wbk 11/12/2005 12:47'!
runProfiledBenchmark: benchmarkSymbol 
	| profiler |
	Exupery initialiseExupery.
	Transcript cr.
	Transcript show: benchmarkSymbol.
	Transcript space.
	time := Time millisecondsToRun:
		[profiler := ExuperyProfiler spyOn: [self perform: benchmarkSymbol]].
	Transcript show: time.
	Transcript show: ' comp'.
	profiler compileFirst: 10.
	Transcript show: 'iled '.
	compiledTime :=  Time millisecondsToRun:
		[profiler := ExuperyProfiler spyOn: [self perform: benchmarkSymbol]].
	Transcript show: compiledTime.
	Transcript show: ' ratio: '.
	Transcript show: ((time / compiledTime) asFloat printShowingDecimalPlaces: 3).
	cumulativeTime := cumulativeTime * time.
	cumulativeCompiledTime := cumulativeCompiledTime * compiledTime.! !

!ExuperyBenchmarks methodsFor: 'benchmarks' stamp: 'wbk 7/21/2004 20:05'!
sendBenchmark
	^ Time millisecondsToRun: [33 benchFib].! !

Object variableSubclass: #ExuperyBlockContext
	instanceVariableNames: 'caller unusedIP unusedSP homeContext compiledIP initialCompiledBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Plugin'!

!ExuperyBlockContext class methodsFor: 'class initialization' stamp: 'wbk 12/26/2005 17:11'!
initialize
	self becomeCompactAt: 15! !

!ExuperyBlockContext methodsFor: 'Copied From BlockContext' stamp: 'wbk 1/25/2006 20:17'!
aboutToReturn: anObject through: aContext
	self home return: anObject! !

!ExuperyBlockContext methodsFor: 'Debugging' stamp: 'wbk 1/24/2006 20:20'!
cachesStack

	^false! !

!ExuperyBlockContext methodsFor: 'Deoptimisation' stamp: 'wbk 2/18/2006 18:07'!
convertToInterpretedContext
	| byteCodeIP argumentCount initialIP tmpHomeContext |
	compiledIP isNil ifFalse: 
		[byteCodeIP := Exupery byteCodeAddressFor: compiledIP].
	argumentCount := Exupery argumentCountFor: initialCompiledBlock.
	initialIP := Exupery byteCodeAddressFor: initialCompiledBlock.
	tmpHomeContext := homeContext.
	unusedSP isNil ifFalse: [unusedIP := byteCodeIP].
	homeContext := argumentCount.
	compiledIP :=  initialIP.
	initialCompiledBlock := tmpHomeContext.
	self primitiveChangeClassTo: BlockContext basicNew.! !

!ExuperyBlockContext methodsFor: 'Copied From BlockContext' stamp: 'wbk 1/23/2006 21:04'!
ensure: aBlock
	"Copied from BlockContext"
	"Evaluate a termination block after evaluating the receiver, regardless of whether the receiver's evaluation completes."

	| returnValue b |
	<primitive: 198>
	returnValue := self value.
	"aBlock wasn't nil when execution of this method began; it is nil'd out by the unwind machinery, and that's how we know it's already been evaluated ... otherwise, obviously, it needs to be evaluated"
	aBlock == nil ifFalse: [
		"nil out aBlock temp before evaluating aBlock so it is not executed again if aBlock remote returns"
		b := aBlock.
		thisContext tempAt: 1 put: nil.  "aBlock _ nil"
		b value.
	].
	^ returnValue! !

!ExuperyBlockContext methodsFor: 'Debugging' stamp: 'wbk 1/24/2006 20:18'!
hideFromDebugger 
	^ false! !

!ExuperyBlockContext methodsFor: 'Exceptions' stamp: 'wbk 1/24/2006 19:50'!
home
	^ homeContext! !

!ExuperyBlockContext methodsFor: 'Misc' stamp: 'wbk 2/11/2006 19:03'!
interpretedProgramCounter
	^ unusedIP! !

!ExuperyBlockContext methodsFor: 'Misc' stamp: 'wbk 2/11/2006 19:03'!
interpretedStackPointer
	^ unusedSP! !

!ExuperyBlockContext methodsFor: 'Exceptions' stamp: 'wbk 4/18/2006 20:31'!
numArgs
	^ Exupery argumentCountFor: initialCompiledBlock! !

!ExuperyBlockContext methodsFor: 'Exceptions' stamp: 'wbk 4/16/2006 17:29'!
on: exception do: handlerAction
	"Evaluate the receiver in the scope of an exception handler."
	| handlerActive |
	<primitive: 199>
	handlerActive := true.
	^self value! !

!ExuperyBlockContext methodsFor: 'Debugging' stamp: 'wbk 1/24/2006 20:27'!
printDetails: aStream
	aStream nextPutAll: 'ExuperyBlockContext details'! !

!ExuperyBlockContext methodsFor: 'Debugging' stamp: 'wbk 4/16/2006 17:24'!
receiver
	^ homeContext receiver! !

!ExuperyBlockContext methodsFor: 'Misc' stamp: 'wbk 4/19/2006 20:55'!
selector
	^ homeContext selector! !

!ExuperyBlockContext methodsFor: 'Debugging' stamp: 'wbk 1/24/2006 20:21'!
sender
	^ caller! !

!ExuperyBlockContext methodsFor: 'Copied From BlockContext' stamp: 'wbk 4/19/2006 21:17'!
sunitEnsure: aBlock
 
        ^self ensure: aBlock! !

!ExuperyBlockContext methodsFor: 'Copied From BlockContext' stamp: 'wbk 4/19/2006 21:17'!
sunitOn: anException do: aHandlerBlock
 
        ^self on: anException do: aHandlerBlock! !

!ExuperyBlockContext methodsFor: 'Block Execution' stamp: 'wbk 12/27/2005 12:14'!
value
	<primitive: 'blockValue' module: 'ExuperyPlugin'>
	TestFailure signal! !

!ExuperyBlockContext methodsFor: 'Copied From BlockContext' stamp: 'wbk 4/19/2006 19:33'!
valueWithPossibleArgs: anArray 

     "Evaluate the block represented by the receiver. 
     If the block requires arguments, take them from anArray. If anArray is too
     large, the rest is ignored, if it is too small, use nil for the other arguments"
 
	self numArgs = 0 ifTrue: [^self value].
	self numArgs = anArray size ifTrue: [^self valueWithArguments: anArray].
	self numArgs > anArray size ifTrue: [
		^self valueWithArguments: anArray,
				(Array new: (self numArgs - anArray size))
	].
	^self valueWithArguments: (anArray copyFrom: 1 to: self numArgs)
! !

!ExuperyBlockContext methodsFor: 'Block Execution' stamp: 'wbk 1/19/2006 21:01'!
value: anObject
	<primitive: 'blockValue1Argument' module: 'ExuperyPlugin'>
	TestFailure signal! !

!ExuperyBlockContext methodsFor: 'Block Execution' stamp: 'wbk 1/22/2006 16:05'!
value: anObject value: secondObject
	<primitive: 'blockValue2Argument' module: 'ExuperyPlugin'>
	TestFailure signal! !

!ExuperyBlockContext methodsFor: 'Block Execution' stamp: 'wbk 1/22/2006 16:24'!
value: anObject value: secondObject value: thirdObject
	<primitive: 'blockValue3Argument' module: 'ExuperyPlugin'>
	TestFailure signal! !

Object subclass: #ExuperyInstanceVariables
	instanceVariableNames: 'a b i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15 i16 i17 i18 count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 8/30/2003 20:29'!
a
	"Adding zero to avoid a primitive shortcut"
	^ a + 0! !

!ExuperyInstanceVariables methodsFor: 'Misc' stamp: 'wbk 6/8/2005 21:45'!
array
	count := count + 1.
	^ #(a b c)! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 10/3/2003 23:56'!
a: firstObject
	a := firstObject.! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 11/16/2003 17:51'!
a: firstObject b: secondObject
	a := firstObject.
	b := secondObject.
	^ 5 "Because Exupery doesn't handle returnSelf yet"! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 8/30/2003 20:28'!
b
	"Adding zero to avoid a primitive short-cut"
	^ b + 0! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 3/12/2005 22:38'!
basicTarget
	^ 6! !

!ExuperyInstanceVariables methodsFor: 'Temporary Variables' stamp: 'wbk 6/13/2004 12:16'!
basicTemps
	|t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18|
	t7 := 7.
	t8 := 8.
	t17 := 17.
	t18 := 18.
	^ t17 + t18.! !

!ExuperyInstanceVariables methodsFor: 'Blocks' stamp: 'wbk 1/26/2006 21:22'!
blockSetA
	[a := 42] value! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/8/2005 21:12'!
count
	^ count! !

!ExuperyInstanceVariables methodsFor: 'Blocks' stamp: 'wbk 1/26/2006 19:47'!
ensureUnwinding
	[[^ #answer] ensure: [a := 42]] value! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 11/22/2003 16:47'!
getA
	^ a! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 11/22/2003 16:48'!
getB
	^ b! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:00'!
i16
	^ i16 + 0! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:01'!
i16: anObject
	i16 := anObject! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:00'!
i17
	^ i17 + 0! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:01'!
i17: anObject
	i17 := anObject! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:01'!
i18
	^ i18 + 0! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:02'!
i18: anObject
	i18 := anObject! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:18'!
i8
	^ i8 + 0! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/12/2004 18:18'!
i8: anObject
	i8 := anObject.! !

!ExuperyInstanceVariables methodsFor: 'Experiments' stamp: 'wbk 6/12/2004 18:17'!
iNNN: anObject
	i9 := anObject
	! !

!ExuperyInstanceVariables methodsFor: 'Misc' stamp: 'wbk 6/8/2005 21:10'!
initialize
	count := 0! !

!ExuperyInstanceVariables methodsFor: 'Temporary Variables' stamp: 'wbk 6/13/2004 12:24'!
loadExtendedTemp
	|t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18|
	^ t17! !

!ExuperyInstanceVariables methodsFor: 'Temporary Variables' stamp: 'wbk 10/21/2004 20:28'!
sideEffects
	a := 2.
	^ (a := a +1) + (a := a + 1)! !

!ExuperyInstanceVariables methodsFor: 'Temporary Variables' stamp: 'wbk 6/13/2004 12:23'!
storeExtendedTemp
	|t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18|
	t17 := 17.! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/13/2004 13:43'!
storeInstanceExtended
 ^ true ifTrue: [i16:= 10].! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/13/2004 13:53'!
storeInstanceExtended2
 ^ (true ifTrue: [i16:= 10]) + i16.! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/14/2004 22:31'!
storeTempExtended
	|t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18|	
 	^ (true ifTrue: [t16:= 15]) + t16.! !

!ExuperyInstanceVariables methodsFor: 'accessing' stamp: 'wbk 6/14/2004 22:36'!
storeTempExtended2
	|t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t13 t14 t15 t16 t17 t18|	
 	^ true ifTrue: [t16:= 15].! !

Object subclass: #ExuperyProfiler
	instanceVariableNames: 'samples'
	classVariableNames: 'Timer ObservedProcess'
	poolDictionaries: ''
	category: 'Exupery-Tools'!

!ExuperyProfiler class methodsFor: 'compiling' stamp: 'wbk 10/15/2005 23:20'!
profileAndCompile: aBlock
	(self spyOn: aBlock) compileFirst: 10! !

!ExuperyProfiler class methodsFor: 'profiling' stamp: 'wbk 6/17/2005 22:33'!
spyOn: aBlock	
	^ self new spyOn: aBlock! !

!ExuperyProfiler class methodsFor: 'compiling' stamp: 'wbk 8/27/2005 12:10'!
stressTest
	TestCase allSubclasses do: [:each | self stressTestClass: each]! !

!ExuperyProfiler class methodsFor: 'compiling' stamp: 'wbk 4/19/2006 21:37'!
stressTestClass: each 
	each = MCInitializationTest ifTrue: [^ self].
	each = MCOrganizationTest ifTrue: [^ self].
	each = VariableEnvironmentTest ifTrue: [^ self].
	each = BrowserEnvironmentTest ifTrue: [^ self].
	each = ChildrenToSiblingsTest ifTrue: [^ self]. "This test is failing"
	each = UnixProcessTestCase ifTrue: [^ self]. "This test crashes without Exupery"
	Exupery log: 'Testing class ', each printString.
	Exupery initialiseExupery.
	Transcript
		show: each class printString;
		cr.
	self profileAndCompile: [each buildSuite run].
	^each buildSuite run! !

!ExuperyProfiler methodsFor: 'analysis' stamp: 'wbk 8/24/2005 21:08'!
callsByFrequency
	| flattened |
	flattened := OrderedCollection new.
	samples do: [:classes| classes do: [:methods| flattened add: methods]].
	^ flattened asOrderedCollection asSortedCollection: [:a :b| a numberOfSenders > b numberOfSenders]! !

!ExuperyProfiler methodsFor: 'compiling' stamp: 'wbk 11/9/2005 20:50'!
compileEntry: each 
	[Exupery 
		compileMethod: each method
		class: each methodClass]
		on: Error
		do: [:ex| ]! !

!ExuperyProfiler methodsFor: 'compiling' stamp: 'wbk 10/10/2005 23:03'!
compileFirst: anInteger 
	|calls|
	calls := self callsByFrequency.
	(calls first: (anInteger min: calls size)) do: [:each | self compileEntry: each]! !

!ExuperyProfiler methodsFor: 'profiling' stamp: 'wbk 6/22/2005 22:36'!
getSampleFor: aContext
	^ (samples 
		at: aContext receiver class
		ifAbsentPut: [Dictionary new]) 
			at: aContext selector
			ifAbsentPut: [ProfileSample
				class: aContext receiver class
				selector: aContext selector]


"add: aContext receiver class -> aContext selector -> aContext sender receiver class -> aContext sender selector -> aContext sender pc"! !

!ExuperyProfiler methodsFor: 'misc' stamp: 'wbk 6/22/2005 22:31'!
initialize
	samples := Dictionary new.! !

!ExuperyProfiler methodsFor: 'misc' stamp: 'wbk 6/22/2005 22:53'!
samples
	| answer |
	answer := OrderedCollection new.
	self samplesDo: [:sample| answer add: sample].
	^ answer! !

!ExuperyProfiler methodsFor: 'misc' stamp: 'wbk 6/22/2005 22:53'!
samplesDo: aBlock
	samples do: [:dictionary| dictionary do: [:sample| aBlock value: sample]].! !

!ExuperyProfiler methodsFor: 'profiling' stamp: 'wbk 6/22/2005 22:31'!
spyOn: aBlock 
	| myDelay millisecs |
	millisecs := 1.
	(aBlock isMemberOf: BlockContext) ifFalse: [self error: 'spy needs a block here'].
	"set up the probe"
	ObservedProcess := Processor activeProcess.
	myDelay := Delay forMilliseconds: millisecs.
	Timer := [[true] whileTrue: 
					[myDelay wait.
					self tally: ObservedProcess suspendedContext
					"tally can be > 1 if ran a long primitive"].
			 nil] newProcess.
	Timer priority: Processor userInterruptPriority.
	"activate the probe and evaluate the block"
	Timer resume.
	aBlock ensure: [Timer terminate].
	^ self! !

!ExuperyProfiler methodsFor: 'profiling' stamp: 'wbk 6/22/2005 22:32'!
tally: aContext
	(self getSampleFor: aContext) addSender: (self getSampleFor: aContext sender)


"add: aContext receiver class -> aContext selector -> aContext sender receiver class -> aContext sender selector -> aContext sender pc"! !

Object subclass: #ExuperyStack
	instanceVariableNames: 'PC emitter concreteStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!ExuperyStack class methodsFor: 'as yet unclassified' stamp: 'wbk 4/26/2004 22:30'!
newPC: aSmallInteger emitter: anEmitter
	^ self new 
		initializePC: aSmallInteger
		emitter: anEmitter.! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 10/25/2005 22:21'!
heightTo: aSmallInteger 
	aSmallInteger > self stackHeight
		ifTrue: 
			[concreteStack addAll: ((self stackHeight + 1 to: aSmallInteger)
				collect: [:each| emitter stackRegister: each])]
		ifFalse:
			[concreteStack removeLast:  self stackHeight - aSmallInteger]! !

!ExuperyStack methodsFor: 'Program Counter' stamp: 'wbk 7/28/2003 12:34'!
incrementPC
	PC := PC + 1.! !

!ExuperyStack methodsFor: 'Misc' stamp: 'wbk 9/24/2004 23:10'!
initializePC: aSmallInteger emitter: anEmitter 
	PC := aSmallInteger.
	emitter := anEmitter.
	concreteStack := OrderedCollection new.! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 9/24/2004 21:26'!
isEmpty
	^ concreteStack isEmpty! !

!ExuperyStack methodsFor: 'Misc' stamp: 'wbk 10/31/2005 21:05'!
materialiseStack
	concreteStack := ((1 to: concreteStack size) collect: 
					[:each | 
					(concreteStack at: each) isStackRegister ifFalse:
						[emitter 
							stackPush: (concreteStack at: each)
							to: (emitter stackRegister: each)].
					emitter stackRegister: each]) asOrderedCollection! !

!ExuperyStack methodsFor: 'Program Counter' stamp: 'wbk 7/28/2003 12:39'!
pc
	^ PC! !

!ExuperyStack methodsFor: 'Program Counter' stamp: 'wbk 7/28/2003 21:38'!
pc: aSmallInteger 
	PC := aSmallInteger! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 10/4/2004 21:42'!
peek
	^ concreteStack last! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 9/25/2004 08:54'!
pop
	| answer |
	answer := concreteStack removeLast.
	"answer := emitter stackRegister: self stackHeight + 1."
	^answer! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 5/31/2004 23:49'!
pop: aSmallInteger 
	| answer |
	answer := OrderedCollection new.
	1 to: aSmallInteger do: [:each | answer addFirst: self pop].	"Remove arguments from the stack"
	^ answer! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 8/18/2005 23:48'!
push: aMed 
	| stackVariable storedValue |
	aMed isStackable 
		ifTrue: [storedValue := aMed]
		ifFalse: 
			[stackVariable := emitter stackRegister: self stackHeight + 1.
			emitter 
				moveFrom: aMed
				to: stackVariable.
			storedValue := stackVariable].
	concreteStack addLast: storedValue! !

!ExuperyStack methodsFor: 'Misc' stamp: 'wbk 9/24/2004 21:12'!
stackHeight
	^ concreteStack size! !

!ExuperyStack methodsFor: 'Stack Manipulation' stamp: 'wbk 9/24/2004 20:27'!
stackSize
	^ self stackHeight! !

ExuperyStack subclass: #TestExuperyStack
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!TestExuperyStack methodsFor: 'stubbed methods' stamp: 'wbk 8/21/2004 21:44'!
initializePC: aSmallInteger emitter: anEmitter 
	super
		initializePC: aSmallInteger
		emitter: anEmitter.
	stack := OrderedCollection new.! !

!TestExuperyStack methodsFor: 'stubbed methods' stamp: 'wbk 6/13/2004 15:08'!
peek
	^ stack last! !

!TestExuperyStack methodsFor: 'stubbed methods' stamp: 'wbk 4/26/2004 23:29'!
pop
	^stack removeLast! !

!TestExuperyStack methodsFor: 'stubbed methods' stamp: 'wbk 4/26/2004 23:29'!
push: anArray
	stack addLast: anArray! !

Object subclass: #InstructionSelector
	instanceVariableNames: 'source result machine currentBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!InstructionSelector class methodsFor: 'instance creation' stamp: 'WBK 8/28/2002 20:13'!
on: aMed for: aMachine
	|selector|
	selector := self new 
		initializeMed: aMed
		for: aMachine.
	selector run.
	^ selector! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 14:57'!
buildArithmaticOperator: operator arg1: arg1 arg2: arg2 
	| destReg |
	destReg := machine createTemporaryRegister.
	currentBlock add: (MedMov 
		from: arg2 
		to: destReg).
	currentBlock add: (MedAssembly 
		name: operator
		arguments: {arg1. destReg}).
	^destReg! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 15:02'!
buildMoveFrom: from to: to 
	| instr |
	instr := MedMov 
		from: from 
		to: to.
	currentBlock add: instr.
	^ to! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 4/11/2003 13:33'!
getAddressingModeFor: aNode	
	| answer address |
	(aNode address isAdd and: [aNode address arg2 isMachineInteger])
		ifTrue: 
			[answer := MedAddressingMode
				offset: aNode address arg2 literal
				base: (self getRegFor: aNode address arg1)]
		ifFalse: 
			[address := self getRegFor: aNode address.
			answer := MedAddressingMode indirectRegister: address].
	^ answer! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/5/2002 14:38'!
getRegFor: aMed
	|reg|
	aMed isRegister ifTrue: [^ aMed].
	aMed isLiteral ifTrue:
		[reg := machine createTemporaryRegister.
		currentBlock add: (MedMov
			from: aMed
			to: reg).
		^ reg].
	^ aMed visitWith: self
		! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 10/6/2002 17:15'!
getRegOrLiteralFor: aMed
	aMed isLiteral ifTrue: [^ aMed].
	^ self getRegFor: aMed! !

!InstructionSelector methodsFor: 'Misc' stamp: 'wbk 3/17/2003 18:24'!
initializeMed: aMed for: aMachine
	source := aMed.
 	machine := aMachine.
	result := OrderedCollection new.
	^ self	! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 14:59'!
matchArithmaticArg1Address: anArithmatic 
	^ self 
		buildArithmaticOperator: anArithmatic operator
		arg1: (self getAddressingModeFor: anArithmatic arg1)
		arg2: (self getRegFor: anArithmatic arg2)! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 3/6/2004 21:15'!
matchArithmatic: anArithmatic 
	anArithmatic arg1 isMem ifTrue: [^self matchArithmaticArg1Address: anArithmatic].
	^self matchBasicArithmatic: anArithmatic! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 14:58'!
matchBasicArithmatic: anArithmatic 
	^ self 
		buildArithmaticOperator: anArithmatic operator
		arg1: (self getRegOrLiteralFor: anArithmatic arg1)
		arg2: (self getRegFor: anArithmatic arg2)! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 15:03'!
matchBasicMove: aMed 
	^ self 
		buildMoveFrom: (self getRegOrLiteralFor: aMed from)
		to: (self getRegFor: aMed to)! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 15:04'!
matchMoveFromAddress: aMed
	^ self
		buildMoveFrom: (self getAddressingModeFor: aMed from)
		to: (self getRegFor: aMed to)! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 11/9/2002 15:05'!
matchMoveToAddress: aMed
	^ self
		buildMoveFrom: (self getRegOrLiteralFor: aMed from)
		to: (self getAddressingModeFor: aMed to)! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 3/6/2004 19:01'!
matchShift: anArithmatic 
	| shiftAmnt shiftAmount |
	shiftAmnt := self getRegOrLiteralFor: anArithmatic arg2.
	shiftAmount := shiftAmnt isRegister 
				ifTrue: 
					[currentBlock add: (MedMov 
								from: shiftAmnt
								to: (machine registerNamed: #ecx)).
					machine registerNamed: #ecx]
				ifFalse: [shiftAmnt].
	^self 
		buildArithmaticOperator: anArithmatic operator
		arg1: shiftAmount
		arg2: (self getRegFor: anArithmatic arg1)! !

!InstructionSelector methodsFor: 'Misc' stamp: 'wbk 9/11/2002 21:25'!
result
	^ result! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 10/6/2002 16:57'!
run
	result := MedMethod from: source.
	source blocksDo: [:each| each visitWith: self].
	^ result! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 1/20/2005 21:29'!
visitAddress: aMedAddress 
	self shouldBeImplemented! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 12/25/2004 22:48'!
visitArithmatic: anArithmatic 
	| instruction |
	(#(#sal #sar) includes: anArithmatic operator) ifTrue: [^self matchShift: anArithmatic].
	anArithmatic operator = #mul ifTrue:
		[^ self 
		buildArithmaticOperator: anArithmatic operator
			arg1: (self getRegFor: anArithmatic arg1)
			arg2: (self getRegFor: anArithmatic arg2)].
	instruction := anArithmatic operator = #sub
		ifTrue:
			[MedArithmatic
				operator: #sub
				arg1: anArithmatic arg2
				arg2: anArithmatic arg1]
		ifFalse: [anArithmatic].
	^self matchArithmatic: instruction! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 1/16/2005 19:27'!
visitBlock: aBlock
	|block|
	block := result blockNumbered: aBlock blockNumber.
	aBlock isAligned ifTrue: [block makeAligned].
	currentBlock := block.
	aBlock do: [:each| each visitWith: self].
	currentBlock := nil.
	^ block! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 2/9/2005 22:32'!
visitCall: aMedCall 
	currentBlock add: (MedCall 
				function: aMedCall function
				machine: machine)! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 3/28/2005 17:41'!
visitComparision: aMedComparision 
	aMedComparision arg2 isMem ifTrue:
		[^ currentBlock add: (MedComparision
			operator: aMedComparision operator
			arg1: (self getAddressingModeFor: aMedComparision arg2)
			arg2: (self getRegFor: aMedComparision arg1))].
	aMedComparision arg1 isMem ifTrue:
		[^ currentBlock add: (MedComparision
			operator: aMedComparision operator
			arg1: (self getRegFor: aMedComparision arg2)
			arg2: (self getAddressingModeFor: aMedComparision arg1))].
	currentBlock add: (MedComparision
		operator: aMedComparision operator
		arg1: (self getRegOrLiteralFor: aMedComparision arg2)
		arg2: (self getRegFor: aMedComparision arg1))
	! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 2/1/2004 22:16'!
visitDivide: aMedDivide 
	|answer arg1 arg2 |
	answer := machine createTemporaryRegister.
	arg1 := self getRegFor: aMedDivide arg1.
	arg2 := self getRegFor: aMedDivide arg2.
	currentBlock add: (MedMov
		from: arg1
		to: (machine registerNamed: #eax)).
	currentBlock add: (MedX86CDQ 
		eax: (machine registerNamed: #eax)
		edx: (machine registerNamed: #edx)).
	currentBlock add: (MedX86Divide 
		register: arg2
		eax: (machine registerNamed: #eax)
		edx: (machine registerNamed: #edx)).
	currentBlock add: (MedMov
		from: (machine registerNamed: #eax)
		to: answer).
	currentBlock add: (MedMov
		from: (machine registerNamed: #edx)
		to: aMedDivide remainder).
	^ answer
		! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 2/4/2005 21:29'!
visitJump: aJump 
	| instructionReg target |
	instructionReg := aJump instruction isNil 
				ifTrue: [nil]
				ifFalse: [self getRegFor: aJump instruction].
	target := aJump target isMedBlock
		ifTrue: [result newBlockFor: aJump target]
		ifFalse: [self getRegFor: aJump target].
	currentBlock add: (MedJump 
				type: aJump type
				target: target).
	^ instructionReg! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 11/9/2002 15:17'!
visitMem: aMem
	^ self 
		buildMoveFrom: (self getAddressingModeFor: aMem)
		to: (machine createTemporaryRegister)! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 3/5/2005 00:01'!
visitMov: aMov
	(aMov from isArithmatic and: [aMov from arg1 = aMov to]) ifTrue: 
		[^ currentBlock add: (MedAssembly 
			name: aMov from operator
			arguments: {self getRegOrLiteralFor: aMov from arg2. self getRegFor: aMov from arg1})].
	aMov to isMem ifTrue: [^ self matchMoveToAddress: aMov].
	aMov from isMem ifTrue: [ ^ self matchMoveFromAddress: aMov].
	^ self matchBasicMove: aMov! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 2/9/2004 20:56'!
visitNegate: aMedNegate 
	| destReg |
	destReg := machine createTemporaryRegister.
	currentBlock add: (MedMov 
		from: (self getRegFor: aMedNegate argument) 
		to: destReg).
	currentBlock add: (MedNegate argument: destReg).
	^ destReg! !

!InstructionSelector methodsFor: 'Instruction Selection' stamp: 'wbk 2/27/2005 14:47'!
visitPic: aMedPic 
	currentBlock add: (MedPic 
				selectionRegister: aMedPic location
				picEntry: aMedPic picEntry)! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 3/4/2005 15:57'!
visitPop: aMedPop 
	currentBlock add: (MedPop argument: (self getRegFor: aMedPop argument))! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 6/21/2003 17:19'!
visitPush: aMedPush 
	currentBlock add: (MedPush argument: (self getRegFor: aMedPush argument))! !

!InstructionSelector methodsFor: 'Selection Visiting' stamp: 'wbk 3/4/2005 16:29'!
visitRet: aRet
	currentBlock add: (MedRet resultRegister: (machine registerNamed: #eax)).
	^ nil.! !

!InstructionSelector methodsFor: 'Unit testing' stamp: 'wbk 2/9/2004 20:59'!
writtenResult
	^ result intermediateForm! !

Object subclass: #InterferenceNode
	instanceVariableNames: 'register edges currentEdges colour isSelected isSpilled isMoveRelated currentMoves currentVersion registerCount'
	classVariableNames: 'CountCurrentEdges CountEdges'
	poolDictionaries: ''
	category: 'Exupery'!

!InterferenceNode class methodsFor: 'instance creation' stamp: 'wbk 7/1/2004 21:12'!
for: aRegister with: aMachine interferenceGraph: aGraph
	^self new 
		initializeFor: aRegister
		with: aMachine
		interferenceGraph: aGraph! !

!InterferenceNode class methodsFor: 'as yet unclassified' stamp: 'wbk 6/22/2004 23:15'!
initialize
	CountCurrentEdges := Dictionary new.
	CountEdges := Dictionary new.! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/5/2002 18:48'!
addBackCurrentInterferenceEdge: aNode
	currentEdges add: aNode.! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/25/2004 23:47'!
addBackInterferenceEdge: aNode
	edges addNode: aNode.! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/25/2004 23:30'!
addEdgeTo: aRegister
	edges addNode: aRegister! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/28/2004 22:36'!
addInterferenceEdgesFrom: aNode
	aNode currentEdgesDo:
		[:each| currentEdges add: each.
		each addBackCurrentInterferenceEdge: self].
	edges := edges + aNode edges.
	aNode neighboursDo: 
		[:each| each addBackInterferenceEdge: self].! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/26/2004 00:31'!
basicInterferesWith: aRegister 
	^ edges includesNode: aRegister! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 5/2/2004 18:12'!
colour
	register isMachineRegister ifTrue: [^ register].
	^ colour! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 10/23/2002 18:14'!
colour: aRegister
	colour := aRegister! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/23/2004 22:16'!
createWorkingEdges
	currentEdges := edges asSet! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/6/2002 13:36'!
currentEdges
	^ currentEdges ! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/5/2002 16:54'!
currentEdgesDo: aBlock
	currentEdges do: aBlock! !

!InterferenceNode methodsFor: 'Move Coalescing' stamp: 'wbk 11/6/2002 17:09'!
currentMoves
	^ currentMoves! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 10/23/2002 22:39'!
currentSize
	^ currentEdges size! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 5/16/2004 17:26'!
currentVersion
	currentVersion ifNotNil: [^ currentVersion currentVersion].
	^ self! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 5/17/2004 21:28'!
currentVersion: anInterferenceNode 
	anInterferenceNode = self currentVersion ifTrue: [^ self].
	currentVersion := anInterferenceNode! !

!InterferenceNode methodsFor: 'Move Coalescing' stamp: 'wbk 5/22/2004 21:51'!
decrementCurrentMoves
	currentMoves := currentMoves - 1! !

!InterferenceNode methodsFor: 'as yet unclassified' stamp: 'wbk 6/25/2004 23:36'!
edges
	^ edges! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 5/2/2004 18:18'!
hasColour
	register isMachineRegister ifTrue: [^ true].
	^ colour isNil not! !

!InterferenceNode methodsFor: 'Move Coalescing' stamp: 'wbk 11/6/2002 17:13'!
incrementCurrentMoves
	currentMoves := currentMoves + 1! !

!InterferenceNode methodsFor: 'Move Coalescing' stamp: 'wbk 5/22/2004 21:59'!
incrementCurrentMovesBy: aSmallInteger 
	currentMoves := currentMoves + aSmallInteger! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 8/2/2004 21:22'!
incrementRegisterCount
	registerCount := registerCount + 1! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/27/2004 22:08'!
index
	^ register index! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 8/2/2004 21:07'!
initializeFor: aRegister with: aMachine interferenceGraph: aGraph 
	register := aRegister.
	"edges := NodeLattice 
				newWith: aMachine
				interferenceGraph: aGraph.	"
	edges := NodeLattice new.
	isSelected := false.
	isSpilled := false.
	isMoveRelated := false.
	currentMoves := 0.
	registerCount := 0.
	^self! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 5/15/2004 15:20'!
interferesWith: aRegister 
	^ self currentVersion basicInterferesWith: aRegister currentVersion! !

!InterferenceNode methodsFor: 'Move Coalescing' stamp: 'wbk 11/6/2002 17:24'!
isCurrentlyInvolvedInMoves
	^ currentMoves > 0! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/5/2002 11:03'!
isMoveRelated
	^ isMoveRelated! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 10/23/2002 20:43'!
isSelected
	^ isSelected! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 7/25/2004 16:34'!
isSimplified
	^ currentEdges class = Array! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/2/2002 18:44'!
isSpilled
	^ isSpilled! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/5/2002 10:59'!
markAsMoveRelated
	isMoveRelated := true! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 11/3/2002 12:25'!
markAsSpilled
	isSpilled := true.! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 6/26/2004 00:26'!
neighboursDo: aBlock
	"Could be obselete soon"
	edges nodesDo: aBlock! !

!InterferenceNode methodsFor: 'Unit Testing' stamp: 'wbk 10/23/2002 17:32'!
printOn: aStream
	aStream nextPutAll: 'Node ['.
	register printOn: aStream.
	aStream nextPut: $].! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 10/23/2002 18:14'!
register
	^ register! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 8/2/2004 21:07'!
registerCount
	^ registerCount! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 10/23/2002 17:37'!
removeEdgeTo: aNode
	currentEdges remove: aNode! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 3/5/2005 22:41'!
simplify
	self register isMachineRegister ifFalse:
		[currentEdges do: [:each | each removeEdgeTo: self].
		currentEdges := #()].
	isSelected := true! !

!InterferenceNode methodsFor: 'misc' stamp: 'wbk 3/5/2005 23:33'!
spillWeight
	^ self currentSize - (registerCount / 100)! !

Object subclass: #IntermediateCopier
	instanceVariableNames: 'source result emitter currentBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

IntermediateCopier subclass: #AssemblyCopier
	instanceVariableNames: 'newBlock machine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!AssemblyCopier methodsFor: 'Misc' stamp: 'wbk 4/7/2005 21:14'!
afterInstruction! !

!AssemblyCopier methodsFor: 'misc' stamp: 'wbk 3/31/2005 22:07'!
result
	^ result! !

!AssemblyCopier methodsFor: 'misc' stamp: 'wbk 3/31/2005 22:06'!
run
	source blocksDo: [:each| each visitWith: self]! !

!AssemblyCopier methodsFor: 'Assignment Visiting' stamp: 'wbk 4/1/2005 22:00'!
visitAddressingMode: anAddressingMode
	^ MedAddressingMode
		offset: anAddressingMode offset 
		base: (anAddressingMode address visitWith: self).! !

!AssemblyCopier methodsFor: 'Assignment Visiting' stamp: 'wbk 4/1/2005 22:12'!
visitAddress: aMedAddress 
	^ aMedAddress! !

!AssemblyCopier methodsFor: 'Assignment Visiting' stamp: 'wbk 4/1/2005 21:35'!
visitAssembly: anAssembly
	| newArgs |
	newArgs := OrderedCollection new.
	anAssembly argumentsDo: [:each| newArgs add: (each visitWith: self)].
	 ^ MedAssembly
		name: anAssembly name
		arguments: newArgs! !

!AssemblyCopier methodsFor: 'Assignment Visiting' stamp: 'wbk 4/7/2005 21:13'!
visitBlock: aMedBlock 
	newBlock := result blockNumbered: aMedBlock blockNumber.
	aMedBlock isAligned ifTrue: [newBlock makeAligned].
	aMedBlock instructionsDo: 
		[:each | newBlock add: (each visitWith: self).
		self afterInstruction].
	^newBlock! !

!AssemblyCopier methodsFor: 'Assignment Visiting' stamp: 'wbk 4/1/2005 21:48'!
visitCall: aMedCall 
	^ MedCall 
		function: (aMedCall function visitWith: self)
		machine: machine! !

!AssemblyCopier methodsFor: 'Assignment Visiting' stamp: 'wbk 4/1/2005 22:21'!
visitDivide: aDivide 
	^ MedX86Divide
		register: (aDivide register visitWith: self)
		eax: (machine registerNamed: #eax)
		edx: (machine registerNamed: #edx)! !

!AssemblyCopier methodsFor: 'Assignment Visiting' stamp: 'wbk 4/1/2005 21:35'!
visitJump: aJump 
	| target |
	target := aJump target isMedBlock
		ifTrue: [result blockNumbered: aJump target blockNumber]
		ifFalse: [aJump target visitWith: self].
	^ MedJump 
		type: aJump type
		target: target! !

!AssemblyCopier methodsFor: 'Assignment Visiting' stamp: 'wbk 4/1/2005 21:37'!
visitMov: anAssembly
	| fromRegister toRegister |
	fromRegister :=(anAssembly from visitWith: self).
	toRegister := (anAssembly to visitWith: self).
	fromRegister = toRegister ifTrue: [^ nil]. "This move has been coalesced"
	 ^ MedMov
		from: fromRegister
		to: toRegister! !

!AssemblyCopier methodsFor: 'Assignment Visiting' stamp: 'wbk 4/1/2005 22:20'!
visitX86Cdq: aMedX86CDQ 
	^ aMedX86CDQ! !

AssemblyCopier subclass: #JumpRemover
	instanceVariableNames: 'reordered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!JumpRemover class methodsFor: 'Actions' stamp: 'wbk 4/1/2005 21:53'!
removeJumpsFrom: anArray machine: anObject 
	| assigner |
	assigner := self new 
				initializeSource: anArray
				machine: anObject.
	assigner run.
	^assigner result! !

!JumpRemover methodsFor: 'Jump Removal' stamp: 'wbk 4/5/2005 22:08'!
addChildren: aMedBlock
	(( aMedBlock) isEmpty not and: 
		[((aMedBlock) lastExpression isJump) and:
			[(reordered includes: aMedBlock lastExpression target) not] and:
				[aMedBlock lastExpression target isMedBlock]]) ifTrue:
				[reordered add: (aMedBlock) lastExpression target.]! !

!JumpRemover methodsFor: 'Misc' stamp: 'wbk 4/1/2005 21:53'!
initializeSource: aMedMethod machine: anObject 
	source := aMedMethod.
	result := MedMethod from: source.
	machine := anObject.! !

!JumpRemover methodsFor: 'Jump Removal' stamp: 'wbk 4/5/2005 21:34'!
removeRedundantJumps
	1
		to: result numberOfBlocks - 1
		do: 
			[:each| ((result blockAt: each) isEmpty not and: [(result blockAt: each) lastExpression isJump and: 
				[(result blockAt: each) lastExpression target = (result blockAt: each + 1)]]) ifTrue:
					[(result blockAt: each) removeLast]]! !

!JumpRemover methodsFor: 'Jump Removal' stamp: 'wbk 4/5/2005 21:50'!
reorderBlocks
	reordered := OrderedCollection new.
	result blocksDo: 
		[:each| (reordered includes: each) ifFalse:
			[reordered add: each.
			self addChildren: each]].
	result blocks: reordered.! !

!JumpRemover methodsFor: 'Misc' stamp: 'wbk 4/5/2005 21:41'!
run
	super run.
	self reorderBlocks.
	self removeRedundantJumps.
	! !

AssemblyCopier subclass: #RegisterReassigner
	instanceVariableNames: 'assignments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!RegisterReassigner class methodsFor: 'instance creation' stamp: 'wbk 10/23/2002 19:09'!
assignments: aDictionary method: aMethod for: aMachine
	| assigner |
	assigner := self new
		initializeAssignments: aDictionary 
		method: aMethod 
		for: aMachine.
	assigner run.
	^ assigner result! !

!RegisterReassigner methodsFor: 'misc' stamp: 'wbk 7/6/2003 21:15'!
initializeAssignments: aDictionary method: aMethod for: aMachine
	assignments := aDictionary.
	source := aMethod.
	machine := aMachine.
	result _ MedMethod from: aMethod.
	^ self! !

!RegisterReassigner methodsFor: '-- all --' stamp: 'wbk 4/20/2005 18:17'!
visitTemporaryRegister: aReg
	| answer |
	answer := assignments at: aReg.
	^ answer! !

RegisterReassigner subclass: #SpillInserter
	instanceVariableNames: 'spiltRegisters spillMap spillVersions registerAllocator readCurrent readLast'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!SpillInserter class methodsFor: 'instance creation' stamp: 'wbk 5/26/2004 23:50'!
spiltRegisters: someRegisters method: aMethod for: aMachine allocator: anAllocator
	| assigner |
	assigner := self new
		initializeSpills: someRegisters 
		method: aMethod 
		for: aMachine
		allocator: anAllocator.
	assigner run.
	^ assigner result! !

!SpillInserter methodsFor: 'Misc' stamp: 'wbk 4/7/2005 21:15'!
afterInstruction
	readLast := readCurrent.
	readCurrent := Set new.! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 4/7/2005 21:30'!
createSpillMap: anAssembly 
	| spillRegisters oldSpillMap |
	oldSpillMap := spillMap.
	spillMap := Dictionary new.
	spillRegisters := (anAssembly registersIn: spiltRegisters).
	spillRegisters do: 
		[:each| (readLast includes: each) 
			ifTrue: 
				[spillMap
					at: each
					put: (oldSpillMap at: each)]
			ifFalse:
				[spillMap
					at: each
					put: (self newRegisterFor: each)]].
	^ spillRegisters! !

!SpillInserter methodsFor: 'Misc' stamp: 'wbk 4/7/2005 18:23'!
initialize
	readCurrent := Set new.
	readLast := Set new.! !

!SpillInserter methodsFor: 'Misc' stamp: 'wbk 5/26/2004 23:52'!
initializeSpills: someRegisters method: aMethod for: aMachine allocator: anAllocator.
	source := aMethod.
	machine := aMachine.
	registerAllocator := anAllocator.
	result := MedMethod from: aMethod.
	spillVersions := Dictionary new.
	spiltRegisters := someRegisters asSet.
	someRegisters do: [:each| machine spillSlotFor: each].
	^ self! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 4/20/2005 20:34'!
loadSpiltRegisters: spillRegs forInstruction: anAssembly 
	spillRegs do: 
			[:each | 
			(anAssembly isRegisterRead: each) ifTrue: 
				[readCurrent add: each.
				(readLast includes: each) not ifTrue: 
					[machine 
						reloadRegister: each
						usingMap: spillMap
						into: newBlock]]]! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 5/26/2004 23:54'!
newRegisterFor: aRegister
	| newVersion oldVersion answer |
	oldVersion := spillVersions
		at: aRegister
		ifAbsent: [0].
	newVersion := oldVersion + 1.
	spillVersions
		at: aRegister
		put: newVersion.
	answer := machine registerNamed: (aRegister name, 'v', newVersion asString) asSymbol.
	registerAllocator registerIsSpilled: answer.
	^ answer! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 7/31/2004 11:44'!
saveSpiltRegisters: spillRegs forInstruction: anAssembly 
	spillRegs do: 
			[:each | 
			(anAssembly isRegisterWritten: each) ifTrue: 
					[machine 
						saveRegister: each
						usingMap: spillMap
						into: newBlock]]! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 8/1/2004 14:47'!
visitAssembly: anAssembly 
	| spillRegs |
	spillRegs := self createSpillMap: anAssembly.
	self 
		loadSpiltRegisters: spillRegs
		forInstruction: anAssembly.
	newBlock add: (super visitAssembly: anAssembly).
	self 
		saveSpiltRegisters: spillRegs
		forInstruction: anAssembly.
	^nil! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 4/20/2005 20:41'!
visitBlock: aMedBlock
	readLast := Set new.
	super visitBlock: aMedBlock! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 3/28/2005 22:32'!
visitComparision: anAssembly 
	| spillRegs |
	spillRegs := self createSpillMap: anAssembly.
	self 
		loadSpiltRegisters: spillRegs
		forInstruction: anAssembly.
	newBlock add: (super visitComparision: anAssembly).
	self 
		saveSpiltRegisters: spillRegs
		forInstruction: anAssembly.
	^nil! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 4/20/2005 18:17'!
visitMov: anAssembly 
	| spillRegs |
	spillRegs := self createSpillMap: anAssembly.
	self 
		loadSpiltRegisters: spillRegs
		forInstruction: anAssembly.
	newBlock add: (super visitMov: anAssembly).
	self 
		saveSpiltRegisters: spillRegs
		forInstruction: anAssembly.
	^nil! !

!SpillInserter methodsFor: 'Visiting' stamp: 'wbk 11/2/2002 12:57'!
visitTemporaryRegister: aReg
	spillMap isNil ifTrue: [^ aReg].
	^ spillMap
		at: aReg
		ifAbsent: [aReg]! !

!IntermediateCopier class methodsFor: 'instance creation' stamp: 'wbk 12/21/2004 11:54'!
from: aMedMethod emitter: anEmitter
	^ self new 
		convertFrom: aMedMethod
		emitter: anEmitter! !

!IntermediateCopier class methodsFor: 'instance creation' stamp: 'wbk 5/28/2005 18:48'!
from: aMedMethod machine: aMachine 
	| emitter answer |
	emitter := IntermediateEmitter 
				machine: aMachine
				jumpTargets: #()
				result: (MedMethod from: aMedMethod)
				inlining: #().
	answer := self 
				from: aMedMethod
				emitter: emitter.
	^answer! !

!IntermediateCopier methodsFor: 'Misc' stamp: 'wbk 10/5/2005 22:36'!
convertFrom: aMedMethod emitter: anEmitter
	source := aMedMethod.
	emitter := anEmitter.
	result := emitter result.
	result nextBlockNumber: source numberOfBlocks + 1.
	result numberOfTemporaries: source numberOfTemporaries.
	result numberOfArguments: source numberOfArguments.
	result needsLargeContext: source needsLargeContext.
	source entryPoints do:
		[:each| result
			registerEntryPointWithPC: each address
			label: (self resultBlockFor: each label)].
	
! !

!IntermediateCopier methodsFor: 'Misc' stamp: 'wbk 1/3/2005 20:16'!
finishUp! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 2/11/2006 10:56'!
prepareBlockFrom: each 
	| newBlock |
	currentBlock := each.
	newBlock := self resultBlockFor: each.
	emitter currentBlock: newBlock.
	newBlock initialStackHeight: each initialStackHeight.
	self prepareStackFrom: each! !

!IntermediateCopier methodsFor: 'Misc' stamp: 'wbk 2/11/2006 10:55'!
prepareStackFrom: aMedBlock 
	! !

!IntermediateCopier methodsFor: 'Misc' stamp: 'wbk 10/26/2005 20:59'!
resultBlockFor: aBlock 
	| answer |
	answer :=  result blockNumbered: aBlock blockNumber.
	aBlock isAligned ifTrue: [answer makeAligned].
	^ answer! !

!IntermediateCopier methodsFor: 'Misc' stamp: 'wbk 10/25/2005 13:55'!
run	
	source visitWith: self.
	self finishUp.
	^emitter result! !

!IntermediateCopier methodsFor: 'Misc' stamp: 'wbk 12/21/2004 12:49'!
runBasic
	source visitWith: self.
	^emitter result! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 1/5/2006 20:21'!
simplifyBlock: aMedBlock 
	aMedBlock instructionsDo: [:each | emitter addExpression: (each visitWith: self)]! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:52'!
visitArithmatic: aMed 
	^ emitter 
		arithmaticOperator: aMed operator
		arg1: (aMed arg1 visitWith: self)
		arg2: (aMed arg2 visitWith: self)! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 1/22/2005 15:51'!
visitBlock: aMedBlock 
	^ result blockNumbered: aMedBlock blockNumber! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 2/9/2005 22:41'!
visitCall: aMedCall 
	^ MedCall 
		function: (aMedCall function visitWith: self)
		machine: emitter machine! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 3/26/2005 16:49'!
visitComparision: aMedComparision 
	^ MedComparision
		operator: aMedComparision operator
		arg1: (aMedComparision arg1 visitWith: self)
		arg2: (aMedComparision arg2 visitWith: self)! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 12/20/2004 22:37'!
visitDivide: aMedDivide 
	^ MedDivide
		emit: (aMedDivide arg1 visitWith: self)
		divide: (aMedDivide arg2 visitWith: self)
		remander: (aMedDivide remainder visitWith: self)! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 1/5/2006 22:22'!
visitJump: aJump 
	| target |
	aJump target isMedBlock 
		ifTrue: [target := self resultBlockFor: aJump target]
		ifFalse: [target := aJump target visitWith: self].
	aJump instruction ifNil: [^ emitter basicJumpTo: target].
	^ emitter 
		jumpType: aJump type
		to: target
		dependingOn: (aJump instruction visitWith: self)! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 12/20/2004 22:38'!
visitLiteral: aMedLiteral 
	^  aMedLiteral.! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 12/20/2004 22:38'!
visitMachineRegister: aMedMachineRegister 
	^ aMedMachineRegister
! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 12/20/2004 22:38'!
visitMem: aMedMem 
	^ MedMem address: (aMedMem address visitWith: self).! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 2/11/2006 10:56'!
visitMethod: aMedMethod 
	aMedMethod blocksDo: 
			[:each | 
			self prepareBlockFrom: each.
			self simplifyBlock: each]! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:44'!
visitMov: aMedMov 
	^ emitter 
		basicMoveFrom: (aMedMov from visitWith: self)
		to: (aMedMov to visitWith: self)! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 12/20/2004 22:40'!
visitNegate: aMedNegate 
	^ MedNegate argument: (aMedNegate argument visitWith: self)! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 2/27/2005 14:48'!
visitPic: aMedPic 
	^ MedPic 
		selectionRegister: aMedPic location
		picEntry: aMedPic picEntry! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 3/4/2005 15:38'!
visitPop: aMedPop 
	^ MedPop argument: (aMedPop argument visitWith: self)! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 12/20/2004 22:40'!
visitPush: aMedPush 
	^ MedPush argument: (aMedPush argument visitWith: self)! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 3/4/2005 17:40'!
visitRet: aMedRet 
	^ MedRet resultRegister: aMedRet resultRegister! !

!IntermediateCopier methodsFor: 'Visiting' stamp: 'wbk 12/20/2004 22:41'!
visitTemporaryRegister: aMedTemporaryRegister 
	^ aMedTemporaryRegister! !

IntermediateCopier subclass: #IntermediateSimplifier
	instanceVariableNames: 'stack simplifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

IntermediateSimplifier class
	instanceVariableNames: 'source'!

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 2/7/2006 20:43'!
callSendSelector: selector arguments: someArguments pc: nextPC stack: aStack 
	| returnToInterpreter compiledAddress label picPosition picEntry machine|
	machine := emitter machine.
	returnToInterpreter := emitter newBlock.
	label := emitter newBlock.
	simplifier 
		restoreContextWithPC: nextPC
		stack: (aStack, someArguments).
	emitter 
		moveFrom: (emitter 
			addressOf: label
			byteCodeAddress: nextPC)
		to: (emitter mem: (emitter 
						emit: emitter currentContextAddress
						add: (MedLiteral literal: 20))).
	emitter 
		moveFrom: (emitter classOf: someArguments first)
		to: (machine registerNamed: #eax).
	picPosition := machine registerNamed: #ecx.
	compiledAddress := machine registerNamed: #eax.
	picEntry := MedPicEntry byteCodeAddress: nextPC - 1.
	emitter 
		moveFrom: picEntry
		to: picPosition.
	emitter 
		moveFrom: selector
		to: (machine registerNamed: #edx).
	emitter restoreSendersFrame.
	emitter 
		picLocatedAt: (machine registerNamed: #eax)
		picEntry: picEntry.
	emitter 
		moveFrom: (emitter 
				callFunctionNamed: #exuperySetupMessageSend
				with: {
						(machine registerNamed: #edx).
						(MedLiteral literal: someArguments size - 1).
						picPosition
					})
		to: compiledAddress.
	emitter addExpression: (emitter 
				jumpType: #jz
				to: returnToInterpreter
				dependingOn: (emitter 
						emit: compiledAddress
						cmp: (MedLiteral literal: 0))).
	emitter jumpTo: compiledAddress.
	emitter currentBlock: returnToInterpreter.
	emitter 
		moveFrom: (MedLiteral literal: 1)
		to: (machine registerNamed: #eax).
	emitter ret.
	^label! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 3/27/2005 14:28'!
codeForLabel: aMedLabel
	emitter addExpression: (aMedLabel code visitWith: self)! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 3/27/2005 14:19'!
codeForLabel: aMedLabel answerIn: answer 
	emitter 
		moveFrom: (aMedLabel code visitWith: self)
		to: answer! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 2/7/2006 20:29'!
conditionalJumpTo: labelMed onBoolean: booleanMed ifBooleanIs: anObject pc: pcInteger stack: anObject1 
	| notBooleanBlock nextBlock failingBoolean |
	notBooleanBlock := emitter newBlock.
	nextBlock := emitter newBlock.
	failingBoolean := anObject = #trueObj 
				ifTrue: [#falseObj]
				ifFalse: [#trueObj].
	self 
		jumpTo: labelMed
		if: booleanMed
		equals: (emitter mem: (MedLiteral literal: anObject)).
	self 
		jumpTo: notBooleanBlock
		if: booleanMed
		notEquals: (emitter mem: (MedLiteral literal: failingBoolean)).
	emitter jumpTo: nextBlock.
	emitter currentBlock: notBooleanBlock.
	simplifier 
		expandedSendSelector: (emitter specialObject: 25)
		arguments: { booleanMed }
		pc: pcInteger
		stack: anObject1.
	emitter jumpTo: nextBlock.
	emitter currentBlock: nextBlock! !

!IntermediateSimplifier methodsFor: 'Misc' stamp: 'wbk 10/30/2005 21:25'!
convertArgument: aMed
	aMed isStackRegister ifTrue: [stack removeLast].
	^ aMed visitWith: self.
	! !

!IntermediateSimplifier methodsFor: 'Misc' stamp: 'wbk 1/27/2006 20:57'!
convertFrom: aMedMethod emitter: anEmitter
	super
		convertFrom: aMedMethod 
		emitter: anEmitter.
	stack := OrderedCollection new! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 8/22/2005 22:18'!
convertStackToRegisters
	| register |
	stack := stack collect: 
		[:each| each isRegister | each isMedLiteral
			ifTrue: [each]
			ifFalse:
				[register := emitter createTemporaryRegister.
				emitter
					moveFrom: (each visitWith: self)
					to: register.
				register]]! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 8/24/2005 18:09'!
copyArgumentsFor: aMedTypeSwitch 
	aMedTypeSwitch arguments 
		with: aMedTypeSwitch variables
		do: 
			[:argument :variable | 
			emitter 
				moveFrom: (argument visitWith: self)
				to: (variable visitWith: self)]! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 2/8/2006 22:36'!
expandedSendSelector: selector arguments: someArguments pc: pcInteger stack: anObject 
	| nextPC label |
	nextPC := pcInteger + 1.	"Set the PC to the next instruction"
	label := self 
				callSendSelector: selector
				arguments: someArguments
				pc: nextPC
				stack: anObject.
	nextPC := pcInteger + 1.
	^self 
		returnSendReturnBlock: label
		pc: nextPC
		stack: anObject! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 3/27/2005 14:29'!
failureCodeForLabel: aMedLabel 
	emitter addExpression: (aMedLabel failureCode visitWith: self).! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 3/27/2005 14:23'!
failureCodeForLabel: aMedLabel answerIn: answer 
	| failureCode |
	failureCode := aMedLabel failureCode visitWith: self.
	failureCode isNil ifFalse: 
			[emitter 
				moveFrom: failureCode
				to: answer]! !

!IntermediateSimplifier methodsFor: 'Misc' stamp: 'wbk 1/3/2005 20:16'!
finishUp
	emitter createProlog.! !

!IntermediateSimplifier methodsFor: 'Misc' stamp: 'wbk 1/27/2006 20:57'!
initialize
	simplifier := self! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 2/7/2006 20:30'!
jumpTo: labelMed if: booleanMed equals: anObject 
	emitter addExpression: (emitter 
				jumpType: #je
				to: labelMed
				dependingOn: (emitter 
						emit: booleanMed
						cmp: anObject))! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 2/7/2006 20:30'!
jumpTo: notBooleanBlock if: booleanMed notEquals: anObject1 
	emitter addExpression: (emitter 
				jumpType: #jne
				to: notBooleanBlock
				dependingOn: (emitter 
						emit: booleanMed
						cmp: anObject1))! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 1/14/2006 18:53'!
loadCompiledMethodAddress
	emitter 
		moveFrom: (emitter 
				fetchAddress: (MedLiteral literal: emitter machine compiledMethodNumber)
				ofObject: (emitter mem: (MedLiteral literal: #methodArray)))
		to: emitter initialCompiledMethodAddress! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 2/10/2006 18:32'!
numberOfTemporaries
	^currentBlock isBlockElement 
		ifTrue: 
			[" anObject"

			0]
		ifFalse: [emitter numberOfTemporaries]! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 10/30/2005 22:05'!
prepareArguments: aCollection for: aBlock
	| answer arguments arg |
	aCollection do: 
		[:each| arg := self convertArgument: each.
		stack add: arg].
	arguments := stack removeLast: aCollection size.
	answer := aBlock value: arguments.
	^ answer! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 8/23/2005 21:24'!
prepareLabelArguments: argumentsCollection into: registersCollection for: aBlock
	| answer arguments |

	argumentsCollection 
		with: registersCollection
		do: 
			[:argument :register | 
			emitter 
				moveFrom: (argument visitWith: self)
				to: register.
			stack add: register].
	arguments := stack removeLast: argumentsCollection size.
	answer := aBlock value: arguments.
	^ answer! !

!IntermediateSimplifier methodsFor: 'Misc' stamp: 'wbk 2/11/2006 10:55'!
prepareStackFrom: aMedBlock 
	aMedBlock initialStackHeight ifNil: [^self].
	stack := OrderedCollection new.
	1 
		to: aMedBlock initialStackHeight
		do: [:each | stack addLast: (emitter stackRegister: each)]! !

!IntermediateSimplifier methodsFor: 'Primitives' stamp: 'wbk 11/6/2005 20:43'!
primitiveAtPut: aMedPrimitive 
	| methodBytecodes index receiver value |
	aMedPrimitive receiver isBits ifTrue: [self error: '#at: to nonpointer storage is unsupported'].
	index := emitter createTemporaryRegister.
	receiver := emitter createTemporaryRegister.
	value := emitter createTemporaryRegister.
	methodBytecodes := self resultBlockFor: aMedPrimitive failureBlock.
	emitter moveFrom: (aMedPrimitive arguments at: 3) to: value.
	emitter moveFrom: (self 
		primitiveIndex: (aMedPrimitive arguments at: 2) 
		receiver: aMedPrimitive receiver) to: index.
	emitter moveFrom: (aMedPrimitive arguments at: 1) to: receiver.
	self
		primitive: receiver
		at: index
		put: value
		failTo: methodBytecodes.
	^ value! !

!IntermediateSimplifier methodsFor: 'Primitives' stamp: 'wbk 11/6/2005 20:42'!
primitiveAt: aMedPrimitive 
	| methodBytecodes index resultAddress receiver |
	aMedPrimitive receiver isBits ifTrue: [self error: '#at: to nonpointer storage is unsupported'].
	index := emitter createTemporaryRegister.
	receiver := emitter createTemporaryRegister.
	methodBytecodes := self resultBlockFor: aMedPrimitive failureBlock.
	emitter 
		moveFrom: (self 
			primitiveIndex: (aMedPrimitive arguments last)
			receiver: aMedPrimitive receiver)
		to: index.
	emitter 
		moveFrom: (aMedPrimitive arguments first visitWith: self)
		to: receiver.
	resultAddress := emitter 
				addressOfIndexedElementIn: receiver
				at: index
				failTo: methodBytecodes.
	^resultAddress! !

!IntermediateSimplifier methodsFor: 'Primitives' stamp: 'wbk 11/6/2005 20:49'!
primitiveIndex: aMed receiver: aClass
	| numberOfInstanceVariables index |
	index := (aMed visitWith: self).
	numberOfInstanceVariables := aClass allInstVarNames size.
	^ numberOfInstanceVariables = 0
		ifTrue: [index]
		ifFalse: 
			[emitter
				emit: (MedLiteral literal: 4 * numberOfInstanceVariables)
				add: index]! !

!IntermediateSimplifier methodsFor: 'Primitives' stamp: 'wbk 6/3/2005 16:09'!
primitive: receiver at: index put: value failTo: methodBytecodes 
	emitter moveFrom: value
		to: (emitter 
				addressOfIndexedElementIn: receiver
				at: index
				failTo: methodBytecodes).
	emitter beRoot: receiver ifNeededBy: value.
	^ value! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 2/11/2006 11:38'!
reloadStack: aStack 
	| currentContext stackPosition |
	currentContext := emitter currentContextRegister.
	stackPosition := 0.
	aStack do: 
			[:each | 
			emitter addExpression: (MedMov 
						from: (self 
								stackAddressAt: stackPosition
								context: currentContext)
						to: each).
			stackPosition := stackPosition + 1]! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 4/9/2006 10:17'!
restoreContextWithPC: aSmallInteger stack: aStack 
	emitter addExpression: (MedMov 
				from: (MedLiteral smallInteger: aSmallInteger)
				to: emitter currentContextsPC).
	self saveStackPointerIntoContext: aStack.
	self saveStackToContext: aStack! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 2/11/2006 11:38'!
returnSendReturnBlock: label pc: nextPC stack: aStack 
	| answer |
	answer := emitter createTemporaryRegister.
	emitter alignedLabel: label.
	emitter preamble.
	simplifier reloadStack: aStack , (Array with: answer).
	emitter 
		registerEntryPointWithPC: (MedLiteral smallInteger: nextPC)
		label: label.
	^answer! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 4/9/2006 13:21'!
saveRegistersAround: aBlockContext 
	| answer |
	answer := emitter createTemporaryRegister.
	simplifier convertStackToRegisters.
	simplifier saveStackPointerIntoContext: stack.
	simplifier saveStackToContext: stack.
	emitter
		moveFrom: aBlockContext value
		to: answer.
	emitter loadCurrentContext.
	simplifier reloadStack: stack.
	^ answer! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 4/9/2006 10:17'!
saveStackPointerIntoContext: aStack 
	emitter addExpression: (MedMov 
				from: (MedLiteral smallInteger: aStack size + simplifier numberOfTemporaries)
				to: emitter currentContextsStack)! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 3/28/2006 22:59'!
saveStackToContext: aStack 
	| stackPosition currentContext |
	currentContext := emitter currentContextRegister.
	stackPosition := 0.
	aStack do: 
			[:each | 
			emitter addExpression: (MedMov 
						from: each
						to: (simplifier 
								stackAddressAt: stackPosition
								context: currentContext)).
			stackPosition := stackPosition + 1]! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 1/27/2006 22:22'!
simplifiedHomeContext
	^emitter simplifiedHomeContext: currentBlock isBlockElement! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 1/27/2006 22:14'!
simplifiedInstanceVariableAddress: aSmallInteger 
	^emitter 
		fetchAddress: (MedLiteral literal: aSmallInteger)
		ofObject: simplifier simplifiedReceiverAddress! !

!IntermediateSimplifier methodsFor: 'Unit Testing' stamp: 'wbk 1/27/2006 22:31'!
simplifiedReceiverAddress
	^emitter mem: (emitter 
				emit: simplifier simplifiedHomeContext
				add: (MedLiteral literal: 24))! !

!IntermediateSimplifier methodsFor: 'Unit Testing' stamp: 'wbk 1/27/2006 21:00'!
simplifier: aMockIntermediateEmitter 
	simplifier := aMockIntermediateEmitter! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 6/16/2005 21:52'!
simplifyCompactClassTypeSwitch: aMedTypeSwitch ifClassIndex: classIndex 
	| failureBlock answer switchOn nextBlock |
	failureBlock := self resultBlockFor: aMedTypeSwitch failureBlock.
	nextBlock := emitter newBlock.
	answer := emitter createTemporaryRegister.
	switchOn := aMedTypeSwitch variables first.
	self copyArgumentsFor: aMedTypeSwitch.
	emitter 
		checkIsNotInteger: switchOn
		failTo: failureBlock.
	emitter addExpression: (emitter 
				jumpType: #jne
				to: failureBlock
				dependingOn: (emitter 
						emit: (MedLiteral literal: classIndex << 12)
						cmp: (emitter 
								emit: (emitter mem: switchOn)
								and: (MedLiteral literal: 126976)))).
	emitter 
		moveFrom: (aMedTypeSwitch code visitWith: self)
		to: answer.
	emitter jumpTo: nextBlock.
	emitter currentBlock: failureBlock.
	emitter 
		moveFrom: (aMedTypeSwitch failureCode visitWith: self)
		to: answer.
	emitter jumpTo: nextBlock.
	emitter currentBlock: nextBlock.
	^answer! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 6/16/2005 21:47'!
simplifyFullTypeSwitch: aMedTypeSwitch 
	| failureBlock nextBlock answer |
	nextBlock := emitter newBlock.
	answer := emitter createTemporaryRegister.
	failureBlock := self resultBlockFor: aMedTypeSwitch failureBlock.
	self copyArgumentsFor: aMedTypeSwitch.
	emitter addExpression: (emitter 
				jumpType: #jne
				to: failureBlock
				dependingOn: (emitter 
						emit: (emitter 
								fetchAddress: (MedLiteral literal: (Exupery registerCompiledMethod: aMedTypeSwitch ifType))
								ofObject: (emitter mem: (MedLiteral literal: #methodArray)))
						cmp: (emitter classOf: (aMedTypeSwitch variables first visitWith: self)))).
	emitter 
		moveFrom: (aMedTypeSwitch code visitWith: self)
		to: answer.
	emitter jumpTo: nextBlock.
	emitter currentBlock: failureBlock.
	emitter 
		moveFrom: (aMedTypeSwitch failureCode visitWith: self)
		to: answer.
	emitter jumpTo: nextBlock.
	emitter currentBlock: nextBlock.
	^answer! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 2/11/2006 11:37'!
stackAddressAt: stackPosition context: currentContext 
	| temporaries |
	temporaries := self numberOfTemporaries.
	^MedMem address: (MedArithmatic 
				operator: #add
				arg1: currentContext
				arg2: (MedLiteral literal: 28 + (stackPosition * 4) + (temporaries * 4)))! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:52'!
visitBitShift: aMedBitShift 
	^ emitter 
		expanded: (aMedBitShift firstArgument visitWith: self)
		bitShift: (aMedBitShift secondArgument visitWith: self)
		failingTo: (aMedBitShift failureBlock visitWith: self)! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 12/24/2005 15:05'!
visitBlockReturn: aMedBlockReturn 
	^ emitter expandedBlockReturnValue: (aMedBlockReturn value visitWith: self)! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 10/30/2005 21:11'!
visitConvertBoolean: aConvertBoolean 
	^ emitter 
		convertExpandedComparisionToBoolean: (self convertArgument: aConvertBoolean expression)
		jumpType: aConvertBoolean jumpType! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/11/2006 11:38'!
visitCreateBlockContext: aMedCreateBlockContext 
	emitter preamble.
	"self loadCompiledMethodAddress."
	simplifier reloadStack: ((1 to: aMedCreateBlockContext argumentCount) collect: [:each | emitter machine stackRegister: each]).
	^nil! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 3/29/2006 19:07'!
visitCreateBlock: aMedCreateBlock 
	^ simplifier saveRegistersAround: 
		[emitter
			callFunctionNamed: #createExuperyBlock
			with: {aMedCreateBlock argumentCount visitWith: self.
					emitter 
						addressOf: (aMedCreateBlock block visitWith: self)
						byteCodeAddress: aMedCreateBlock byteCodeAddress
						argumentCount: aMedCreateBlock argumentCount literal.
					MedLiteral literal: (currentBlock isBlockElement
						ifTrue: [1]
						ifFalse: [0])}]! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 12/24/2005 14:27'!
visitCreateContext: aMedCreateContext 
	emitter addExpression: (emitter 
				callFunctionNamed: #exuperyCreateContext
				with: {
						(MedLiteral literal: result numberOfArguments).
						(MedLiteral literal: result numberOfTemporaries).
						(MedLiteral literal: result needsLargeContext)
					}).
	emitter loadCurrentContext.
	self loadCompiledMethodAddress.
	^nil! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/7/2006 20:32'!
visitDeconvertBoolean: aMedDeconvertBoolean 
	simplifier 
		conditionalJumpTo: (aMedDeconvertBoolean target visitWith: self)
		onBoolean: (self convertArgument: aMedDeconvertBoolean boolean)
		ifBooleanIs: aMedDeconvertBoolean desiredBoolean
		pc: aMedDeconvertBoolean pc
		stack: stack.
	^nil! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 1/27/2006 22:22'!
visitHomeContext: aMed 
	^self simplifiedHomeContext! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 1/27/2006 22:14'!
visitInstanceVariableAddress: aSmallInteger 
	^self simplifiedInstanceVariableAddress: aSmallInteger! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:22'!
visitIntegerValueOf: aMedIntegerValueOf 
	^ emitter 
		expandedIntegerValueOf: (aMedIntegerValueOf argument visitWith: self)
		failTo: (aMedIntegerValueOf failureBlock visitWith: self)! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 8/23/2005 21:22'!
visitLabel: aMedLabel 
	| overflowBlock answer nextBlock |
	self 
		prepareLabelArguments: aMedLabel arguments
		into: aMedLabel argumentRegisters
		for:
			[:arguments|
			overflowBlock := self resultBlockFor: aMedLabel failureBlock.
			nextBlock := emitter newBlock.
			self convertStackToRegisters.
			"aMedLabel arguments 
				with: aMedLabel argumentRegisters
				do: 
					[:argument :register | 
					emitter 
						moveFrom: (argument visitWith: self)
						to: register]."
			answer := emitter machine createTemporaryRegister.
			aMedLabel 
				simplifyCodeUsing: self
				answerIn: answer.
			emitter jumpTo: nextBlock.
			emitter currentBlock: overflowBlock.
			aMedLabel 
				simplifyFailureCodeUsing: self
				answerIn: answer.
			emitter jumpTo: nextBlock.
			emitter currentBlock: nextBlock].
	^answer! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:52'!
visitMidDivide: aMedMidDivide 
	^ emitter 
		expanded: (aMedMidDivide firstArgument visitWith: self)
		divide: (aMedMidDivide secondArgument visitWith: self)
		failingTo: (aMedMidDivide failureBlock visitWith: self)! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:51'!
visitMidDiv: aMedMidDiv 
	^ emitter 
		expanded: (aMedMidDiv firstArgument visitWith: self)
		div: (aMedMidDiv secondArgument visitWith: self)
		failingTo: (aMedMidDiv failureBlock visitWith: self)! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:52'!
visitMidMod: aMedMidMod 
	^ emitter 
		expanded: (aMedMidMod firstArgument visitWith: self)
		mod: (aMedMidMod secondArgument visitWith: self)
		failingTo: (aMedMidMod failureBlock visitWith: self)! !

!IntermediateSimplifier methodsFor: 'Primitives' stamp: 'wbk 5/30/2005 18:08'!
visitPrimitiveReturn: aMedPrimitiveReturn 
	emitter 
		expandedPrimitiveReturn: (aMedPrimitiveReturn value visitWith: self)
		popping: aMedPrimitiveReturn poppingItems.
	^ nil! !

!IntermediateSimplifier methodsFor: 'Primitives' stamp: 'wbk 6/3/2005 16:04'!
visitPrimitive: aMedPrimitive 
	aMedPrimitive primitive = #at: ifTrue: 
		[^self primitiveAt: aMedPrimitive].
	aMedPrimitive primitive = #at:put: ifTrue: 
		[^self primitiveAtPut: aMedPrimitive].
	Error signal: 'NOT IMPLEMENTED'! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 1/27/2006 20:55'!
visitReceiverAddress
	^self simplifiedReceiverAddress! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 1/5/2006 20:20'!
visitReturn: aMedReturn 
	^ currentBlock isBlockElement
		ifTrue: [emitter expandedNonlocalReturnValue: (aMedReturn value visitWith: self)]
		ifFalse: [emitter expandedReturnValue: (aMedReturn value visitWith: self)]! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 2/7/2006 19:55'!
visitSend: aMedSend 
	self convertStackToRegisters.
	^self 
		prepareArguments: aMedSend arguments
		for: 
			[:arguments | 
			^simplifier 
				expandedSendSelector: (aMedSend selector visitWith: self)
				arguments: arguments
				pc: aMedSend programCounter
				stack: stack]! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 3/27/2005 14:49'!
visitSideEffectingLabel: aMedSideEffectingLabel 
	^ self visitLabel: aMedSideEffectingLabel.! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 11/3/2005 23:43'!
visitStackPush: aMedStackPush
	| answer |
	answer := self visitMov: aMedStackPush.
	stack addLast: aMedStackPush to.
	^ answer! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 1/27/2006 22:14'!
visitStoreInReceiver: aMedStoreInReceiver 
	| answer |
	answer := emitter createTemporaryRegister.
	emitter 
		moveFrom: (aMedStoreInReceiver value visitWith: self)
		to: answer.
	emitter 
		beRoot: simplifier simplifiedReceiverAddress
		ifNeededBy: answer.
	emitter 
		moveFrom: answer
		to: (simplifier simplifiedInstanceVariableAddress: aMedStoreInReceiver slot).
	^ answer! !

!IntermediateSimplifier methodsFor: 'Visiting' stamp: 'wbk 1/14/2006 22:56'!
visitStoreInTemp: aMedStoreInTemp 
	^emitter 
		expandedPopIntoTemp: (aMedStoreInTemp value visitWith: self)
		slot: aMedStoreInTemp slot
		isInBlock: currentBlock isBlockElement! !

!IntermediateSimplifier methodsFor: 'Sends and Returns' stamp: 'wbk 8/24/2005 18:10'!
visitTypeSwitch: aMedTypeSwitch
	| classIndex |
	classIndex := Smalltalk compactClassesArray
		indexOf: aMedTypeSwitch ifType
		ifAbsent: [^self simplifyFullTypeSwitch: aMedTypeSwitch].
	^ self 
		simplifyCompactClassTypeSwitch: aMedTypeSwitch
		ifClassIndex: classIndex! !

IntermediateCopier subclass: #LowLevelOptimiser
	instanceVariableNames: 'isAfterJump'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!LowLevelOptimiser methodsFor: 'Misc' stamp: 'wbk 1/22/2005 16:11'!
initialize
	isAfterJump := false.! !

!LowLevelOptimiser methodsFor: 'Testing' stamp: 'wbk 4/9/2005 22:21'!
isDetag: aMed
	^ aMed isArithmatic and: [aMed operator = #sub and: [aMed arg2 isLiteral and: [aMed arg2 literal = 1]]]! !

!LowLevelOptimiser methodsFor: 'Testing' stamp: 'wbk 4/9/2005 22:04'!
isRetag: aMed
	^ aMed operator = #or and: [aMed arg1 isLiteral and: [aMed arg1 literal = 1]]
	! !

!LowLevelOptimiser methodsFor: 'Visiting' stamp: 'wbk 1/22/2005 16:20'!
simplifyBlock: aMedBlock 
	isAfterJump := false.
	^ super simplifyBlock: aMedBlock! !

!LowLevelOptimiser methodsFor: 'Visiting' stamp: 'wbk 1/22/2005 15:25'!
visitAddress: aMedAddress 
	^ aMedAddress! !

!LowLevelOptimiser methodsFor: 'Visiting' stamp: 'wbk 4/9/2005 23:23'!
visitArithmatic: anArithmatic
	((self isRetag: anArithmatic) and: [anArithmatic arg2 isJump and: [anArithmatic arg2 type = #jo 
		and: [anArithmatic arg2 instruction isArithmatic and: 
			[(#(add sub) includes: anArithmatic arg2 instruction operator) and: [(self isDetag: anArithmatic arg2 instruction arg1)]]]]]) ifTrue: 
		[^ (emitter
			jumpType: #jo
			to: (anArithmatic arg2 target visitWith: self)
			dependingOn: (emitter
				arithmaticOperator: anArithmatic arg2 instruction operator
				arg1: (anArithmatic arg2 instruction arg1 arg1 visitWith: self)
				arg2: (anArithmatic arg2 instruction arg2 visitWith: self) ))].
	^ super visitArithmatic: anArithmatic! !

!LowLevelOptimiser methodsFor: 'Visiting' stamp: 'wbk 4/8/2005 22:18'!
visitComparision: aComparision
	(aComparision operator = #cmp and: [aComparision arg1 isSubtract and: [aComparision arg2 isSubtract and: [aComparision arg1 arg2 isLiteral and: [aComparision arg2 arg2 isLiteral and: [aComparision arg1 arg2 literal = 1 and: [aComparision arg2 arg2 literal = 1]]]]]]) ifTrue:
		[^ emitter
			emit: (aComparision arg1 arg1 visitWith: self)
			cmp: (aComparision arg2 arg1 visitWith: self)].
	^ super visitComparision: aComparision! !

!LowLevelOptimiser methodsFor: 'Visiting' stamp: 'wbk 1/22/2005 16:18'!
visitJump: aJump
	isAfterJump ifTrue: [^ nil.].
	aJump instruction ifNil: [isAfterJump := true].
	^ super visitJump: aJump! !

!LowLevelOptimiser methodsFor: 'Visiting' stamp: 'wbk 1/22/2005 17:53'!
visitRet: aMedRet 
	isAfterJump := true.
	^ super visitRet: aMedRet! !

IntermediateCopier subclass: #TreeOptimiser
	instanceVariableNames: 'literalRegisters isAfterJump'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!TreeOptimiser methodsFor: 'Misc' stamp: 'wbk 1/5/2006 21:13'!
initialize
	literalRegisters := Dictionary new.
	isAfterJump := false.! !

!TreeOptimiser methodsFor: 'Optimisation' stamp: 'wbk 12/25/2004 11:43'!
invertJumpType: aSymbol 
	aSymbol = #jg ifTrue: [^ #jle].
	aSymbol = #jne ifTrue: [^ #je].
	aSymbol = #jz ifTrue: [^ #jnz].
	aSymbol = #je ifTrue: [^ #jne].
	aSymbol = #jo ifTrue: [^ #jno].
	aSymbol = #jnz ifTrue: [^ #jz].
	aSymbol = #jne ifTrue: [^ #je].
	aSymbol = #jl ifTrue: [^ #jge].
	aSymbol = #jle ifTrue: [^ #jg].
	aSymbol = #jge ifTrue: [^ #jl].

	self error: 'UnrecognisedJump'! !

!TreeOptimiser methodsFor: 'Optimisation' stamp: 'wbk 2/1/2006 21:32'!
optimiseBlockCreation: aMedBlockCopy 
	^MedCreateBlock 
		argumentCount: aMedBlockCopy argumentCount
		block: aMedBlockCopy block
		byteCodeAddress: aMedBlockCopy byteCodeAddress! !

!TreeOptimiser methodsFor: 'Optimisation' stamp: 'wbk 10/25/2005 23:00'!
optimiseBooleanConversion: aMedDeconvertBoolean 
	| label jumpType |
	label := aMedDeconvertBoolean boolean.
	jumpType := aMedDeconvertBoolean desiredBoolean = #trueObj 
				ifTrue: [self invertJumpType: label code jumpType]
				ifFalse: [label code jumpType].
	^emitter 
		sideEffectingLabelArguments: (label arguments collect: [:each | each visitWith: self])
		registers: (label argumentRegisters collect: [:each | each visitWith: self])
		around: (emitter 
				jumpType: jumpType
				to: (aMedDeconvertBoolean target visitWith: self)
				dependingOn: (label code expression visitWith: self))
		failingTo: (emitter 
				deconvertBooleanJumpingTo: (aMedDeconvertBoolean target visitWith: self)
				if: (label failureCode visitWith: self)
				is: aMedDeconvertBoolean desiredBoolean
				pc: aMedDeconvertBoolean pc)
		failureBlock: (label failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 1/5/2006 21:16'!
simplifyBlock: aMedBlock 
	isAfterJump := false.
	^ super simplifyBlock: aMedBlock! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:26'!
visitAtElementAddress: aMedAtElementAddress 
	^ emitter 
		atElementAddressFor: (aMedAtElementAddress object visitWith: self)
		with: (aMedAtElementAddress index visitWith: self)
		failTo: (aMedAtElementAddress failureBlock visitWith: self)
		cacheOffset: aMedAtElementAddress cacheOffset! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 12/22/2004 20:50'!
visitAtPut: aMedAtPut 
	^ emitter
		atPutReceiver: (aMedAtPut object visitWith: self)
		index: (aMedAtPut index visitWith: self)
		value: (aMedAtPut value visitWith: self)
		failTo: (aMedAtPut failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 12/22/2004 21:23'!
visitBitShift: aMedBitShift 
	^ emitter
		emit: (aMedBitShift firstArgument visitWith: self)
		bitShift: (aMedBitShift secondArgument visitWith: self)
		failingTo: (aMedBitShift failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 12/8/2005 19:25'!
visitBlockCopy: aMedBlockCopy 
	aMedBlockCopy context isActiveContext ifTrue: [^ self optimiseBlockCreation: aMedBlockCopy].
	self error: 'Can''t compile block copies yet'.! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 1/5/2006 22:27'!
visitBlockReturn: aMedBlockReturn 
	| answer |
	answer := emitter blockReturn: (aMedBlockReturn value visitWith: self).
	isAfterJump := true.
	^ answer
! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:20'!
visitConvertBoolean: aMedConvertBoolean 
	^ emitter 
		convertComparisionToBoolean: (aMedConvertBoolean expression visitWith: self)
		jumpType: aMedConvertBoolean jumpType! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 12/8/2005 21:44'!
visitCreateBlockContext: aMedCreateBlockContext 
	^ aMedCreateBlockContext! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 4/22/2005 20:25'!
visitCreateContext: aMedCreateContext 
	^ MedCreateContext new! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 10/25/2005 23:00'!
visitDeconvertBoolean: aMedDeconvertBoolean 
	(aMedDeconvertBoolean boolean isLabel and: [aMedDeconvertBoolean boolean code isConvertBoolean]) ifTrue: [^self optimiseBooleanConversion: aMedDeconvertBoolean].
	^emitter 
		deconvertBooleanJumpingTo: (aMedDeconvertBoolean target visitWith: self)
		if: (aMedDeconvertBoolean boolean visitWith: self)
		is: aMedDeconvertBoolean desiredBoolean
		pc: aMedDeconvertBoolean pc! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 1/14/2006 17:41'!
visitHomeContext: aMedHomeContext 
	^ MedHomeContext new.! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 1/27/2006 22:13'!
visitInstanceVariableAddress: aSmallInteger 
	^emitter instanceVariableAddress: aSmallInteger! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 3/27/2005 21:24'!
visitIntegerValueOf: aMedIntegerValueOf 
	| value |
	value := aMedIntegerValueOf argument visitWith: self.
	(value isLiteral and: [value literal isInteger]) ifTrue: [^ MedLiteral literal: value literal - 1].
	^ emitter 
		integerValueOf: value
		failTo: (aMedIntegerValueOf failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 1/5/2006 22:17'!
visitJump: aJump
	isAfterJump ifTrue: [^ nil.].
	aJump instruction ifNil: [isAfterJump := true].
	^ super visitJump: aJump! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 3/27/2005 15:19'!
visitLabel: aMedLabel 
	| arguments argumentRegisters |
	arguments := OrderedCollection new.
	argumentRegisters := OrderedCollection new.
	aMedLabel arguments 
		with: aMedLabel argumentRegisters
		do: 
			[:eachArgument :eachRegister | 
			(eachArgument isLiteral and: [eachArgument literal isInteger]) 
				ifTrue: 
					[literalRegisters 
						at: eachRegister
						put: eachArgument]
				ifFalse: 
					[arguments add: (eachArgument visitWith: self).
					argumentRegisters add: (eachRegister visitWith: self)]].
	^ emitter 
		labelArguments: arguments
		registers: argumentRegisters
		around: (aMedLabel code visitWith: self)
		failingTo: (aMedLabel failureCode visitWith: self)
		failureBlock: (aMedLabel failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 12/22/2004 21:46'!
visitMidDivide: aMedDivide 
	^emitter 
		emit: (aMedDivide firstArgument visitWith: self)
		divide: (aMedDivide secondArgument visitWith: self)
		failingTo: (aMedDivide failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 12/22/2004 21:45'!
visitMidDiv: aMedMidDiv 
	^emitter 
		emit: (aMedMidDiv firstArgument visitWith: self)
		div: (aMedMidDiv secondArgument visitWith: self)
		failingTo: (aMedMidDiv failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 12/22/2004 21:47'!
visitMidMod: aMedMod 
	^emitter 
		emit: (aMedMod firstArgument visitWith: self)
		mod: (aMedMod secondArgument visitWith: self)
		failingTo: (aMedMod failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 11/6/2005 19:27'!
visitPrimitiveReturn: aMedPrimitiveReturn 
	emitter 
		primitiveReturn: (aMedPrimitiveReturn value visitWith: self)
		popping: aMedPrimitiveReturn poppingItems
		receiver: aMedPrimitiveReturn receiver.
	^nil! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 11/6/2005 19:23'!
visitPrimitive: aMedPrimitive 
	^emitter 
		primitive: aMedPrimitive primitive
		arguments: (aMedPrimitive arguments collect: [:each | each visitWith: self])
		failureBlock: (aMedPrimitive failureBlock visitWith: self)
		receiver: aMedPrimitive receiver! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 1/27/2006 20:37'!
visitReceiverAddress
	^ emitter receiverAddress! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 1/5/2006 22:18'!
visitReturn: aMedReturn 
	emitter returnValue: (aMedReturn value visitWith: self).
	isAfterJump := true.
	^ nil! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 10/25/2005 23:12'!
visitSend: aMedSend 
	^emitter 
		sendSelector: (aMedSend selector visitWith: self)
		arguments: (aMedSend arguments collect: [:each | each visitWith: self])
		pc: aMedSend programCounter
		selectorName: nil! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 3/27/2005 15:19'!
visitSideEffectingLabel: aMedLabel 
	| arguments argumentRegisters |
	arguments := OrderedCollection new.
	argumentRegisters := OrderedCollection new.
	aMedLabel arguments 
		with: aMedLabel argumentRegisters
		do: 
			[:eachArgument :eachRegister | 
			(eachArgument isLiteral and: [eachArgument literal isInteger]) 
				ifTrue: 
					[literalRegisters 
						at: eachRegister
						put: eachArgument]
				ifFalse: 
					[arguments add: (eachArgument visitWith: self).
					argumentRegisters add: (eachRegister visitWith: self)]].
	^ emitter 
		sideEffectingLabelArguments: arguments
		registers: argumentRegisters
		around: (aMedLabel code visitWith: self)
		failingTo: (aMedLabel failureCode visitWith: self)
		failureBlock: (aMedLabel failureBlock visitWith: self)! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 11/30/2005 22:40'!
visitStackPush: aMedStackPush 
	^ emitter
		basicStackPush: (aMedStackPush from visitWith: self)
		to: aMedStackPush to! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:29'!
visitStoreInReceiver: aMedStoreInReceiver 
	^ emitter 
		popIntoReceiver: (aMedStoreInReceiver value visitWith: self)
		slot: aMedStoreInReceiver slot! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 2/13/2005 12:29'!
visitStoreInTemp: aMedStoreInTemp 
	^ emitter 
		popIntoTemp: (aMedStoreInTemp value visitWith: self)
		slot: aMedStoreInTemp slot! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 12/25/2004 17:03'!
visitTemporaryRegister: aMed
	(literalRegisters includesKey: aMed) ifTrue: [^ literalRegisters at: aMed].
	^ super visitTemporaryRegister: aMed! !

!TreeOptimiser methodsFor: 'Visiting' stamp: 'wbk 6/16/2005 20:49'!
visitTypeSwitch: aMedTypeSwitch 
	^emitter 
		typeSwitchOn: (aMedTypeSwitch arguments collect: [:each| each visitWith: self])
		variables: (aMedTypeSwitch variables collect: [:each| each visitWith: self])
		ifType: aMedTypeSwitch ifType
		code: (aMedTypeSwitch code visitWith: self)
		failureCode: (aMedTypeSwitch failureCode visitWith: self)
		failureBlock: (aMedTypeSwitch failureBlock visitWith: self)! !

Object subclass: #IntermediateCreator
	instanceVariableNames: 'method machine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!IntermediateCreator class methodsFor: 'Intermediate Creation' stamp: 'wbk 10/5/2002 18:37'!
createAssembly: anArray for: aMachine
	^ self new
		createAssembly: anArray
		for: aMachine! !

!IntermediateCreator class methodsFor: 'instance creation' stamp: 'wbk 12/19/2004 14:18'!
createExpression: anArray for: aMachineX86 
	^ self new
		createExpression: anArray
		for: aMachineX86! !

!IntermediateCreator class methodsFor: 'Intermediate Creation' stamp: 'wbk 10/5/2002 18:36'!
createIntermediate: anArray for: aMachine
	^ self new
		createIntermediate: anArray
		for: aMachine! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 1/26/2004 22:49'!
createArithmatic: anArray
	|arg1 arg2|
	arg1 := self createExpression: (anArray at: 2).
	arg2 := self createExpression: (anArray at: 3).
	^ MedArithmatic
		operator: (anArray at: 1)
		arg1: arg1
		arg2: arg2! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/24/2002 11:36'!
createAssemblyBlock: anArray
	|blockNumber block|
	self assert: [(anArray at: 1) = #block].
	blockNumber := anArray at: 2.
	block := method blockNumbered: blockNumber.
	3 to: anArray size do: [:each| block add: (self 
		createAssemblyInstr: (anArray at: each))].
	^ block	! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 3/26/2005 20:57'!
createAssemblyInstr: anArray 
	| arguments instruction |
	instruction := anArray at: 1.
	(self isJump: anArray) ifTrue: [^ self createJump: anArray].
	instruction = #ret ifTrue: [^ MedRet resultRegister: (machine registerNamed: #eax)].
	arguments := OrderedCollection new.
	2 
		to: anArray size
		do: [:each | arguments add: (self createExpression: (anArray at: each))].
	instruction = #mov ifTrue: 
			[^ MedMov 
				from: (arguments at: 1)
				to: (arguments at: 2)].
	instruction = #call ifTrue: 
			[^ MedCall 
				function: (arguments at: 1)
				machine: machine].
	instruction = #push ifTrue: [^ MedPush argument: (arguments at: 1)].
	instruction = #div ifTrue: 
			[^ MedX86Divide 
				register: (arguments at: 1)
				eax: (machine registerNamed: #eax)
				edx: (machine registerNamed: #edx)].
	instruction = #cdq ifTrue: 
			[^ MedX86CDQ 
				eax: (machine registerNamed: #eax)
				edx: (machine registerNamed: #edx)].
	instruction = #neg ifTrue: [^ MedNegate argument: (arguments at: 1)].
	instruction = #pic ifTrue: 
			[^ MedPic 
				selectionRegister: arguments first
				picEntry: MedPicEntry new].
	instruction = #pop ifTrue: [^MedPop argument: arguments first].
	instruction = #cmp ifTrue:
		[^ MedComparision
			operator: #cmp
			arg1: arguments first
			arg2: arguments last].
	^ MedAssembly 
		name: instruction
		arguments: arguments! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 7/6/2003 21:30'!
createAssembly: anArray for: aMachine
	machine := aMachine.
	method := MedMethod new.
	anArray do: [:each| (self createJustTheBlocks: each)].
	anArray do: [:each|  (self createAssemblyBlock: each)].
	^ method


! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 6/4/2005 10:42'!
createBasicType: anObject 
	| operator |
	anObject isInteger ifTrue: [^MedLiteral literal: anObject].
	anObject isString 
		ifTrue: 
			[(self isMachineRegister: anObject) 
				ifTrue: [^machine machineRegister: anObject].
			(self isRegister: anObject) ifTrue: [^machine temporaryNamed: anObject].
			anObject = #Array ifTrue: [^Array].
			^MedLiteral literal: anObject].
	operator := anObject at: 1.
	anObject size = 2
		ifTrue: 
			[^MedAddressingMode 
				offset: operator
				base: (machine registerNamed: (anObject at: 2))].
	^MedAddressingMode address: (self createExpression: operator)! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/24/2002 11:32'!
createBlock: anArray
	|blockNumber block|
	self assert: [(anArray at: 1) = #block].
	blockNumber := anArray at: 2.
	block := method blockNumbered: blockNumber.
	3 to: anArray size do: [:each| block add: (self createExpression: (anArray at: each))].
	^ block	! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 2/4/2006 23:13'!
createExpression: anObject 
	| operator |
	(self isBasicType: anObject) ifTrue: [^self createBasicType: anObject].
	operator := anObject at: 1.
	operator = #ret ifTrue: [^MedRet new].
	operator = #mov ifTrue: [^self createMove: anObject].
	operator = #mem ifTrue: [^self createMem: anObject].
	operator = #push ifTrue: [^MedPush argument: (self createExpression: (anObject at: 2))].
	operator = #call ifTrue: 
			[^MedCall 
				function: (self createExpression: (anObject at: 2))
				machine: machine].
	operator = #deconvertBoolean ifTrue: 
			[^MedDeconvertBoolean 
				jumpTo: (self createTarget: (anObject at: 4))
				if: (self createExpression: (anObject at: 3))
				is: (anObject at: 2)
				pc: (anObject at: 5)].
	operator = #convertBoolean ifTrue: 
			[^MedConvertBoolean 
				jumpType: (anObject at: 2)
				expression: (self createExpression: (anObject at: 3))].
	operator = #div ifTrue: 
			[^MedDivide 
				emit: (self createExpression: (anObject at: 2))
				divide: (self createExpression: (anObject at: 3))
				remander: (self createExpression: (anObject at: 4))].
	operator = #label ifTrue: 
			[^MedLabel 
				arguments: ((anObject at: 2) collect: [:each | self createExpression: each])
				registers: ((anObject at: 3) collect: [:each | self createExpression: each])
				around: (self createExpression: (anObject at: 4))
				failingTo: (self createExpression: (anObject at: 5))
				failureBlock: (self createTarget: (anObject at: 6))].
	operator = #sideEffectsLabel ifTrue: 
			[^MedSideEffectingLabel 
				arguments: ((anObject at: 2) collect: [:each | self createExpression: each])
				registers: ((anObject at: 3) collect: [:each | self createExpression: each])
				around: (self createExpression: (anObject at: 4))
				failingTo: (self createExpression: (anObject at: 5))
				failureBlock: (self createTarget: (anObject at: 6))].
	operator = #send ifTrue: 
			[^MedSend 
				selector: (self createExpression: (anObject at: 2))
				arguments: ((anObject 
						copyFrom: 4
						to: anObject size) collect: [:each | self createExpression: each])
				programCounter: (anObject at: 3)].
	operator = #return ifTrue: [^MedReturn value: (self createExpression: (anObject at: 2))].
	operator = #integerValueOf ifTrue: 
			[^MedIntegerValueOf 
				argument: (self createExpression: (anObject at: 2))
				failureBlock: (self createTarget: (anObject at: 3))].
	operator = #storeInTemp ifTrue: 
			[^MedStoreInTemp 
				slot: (anObject at: 2)
				value: (self createExpression: (anObject at: 3))].
	operator = #storeInReceiver ifTrue: 
			[^MedStoreInReceiver 
				slot: (anObject at: 2)
				value: (self createExpression: (anObject at: 3))].
	operator = #bitShift ifTrue: 
			[^MedBitShift 
				new: (self createExpression: (anObject at: 2))
				with: (self createExpression: (anObject at: 3))
				failingTo: (self createTarget: (anObject at: 4))].
	operator = #midDiv ifTrue: 
			[^MedMidDiv 
				new: (self createExpression: (anObject at: 2))
				with: (self createExpression: (anObject at: 3))
				failingTo: (self createTarget: (anObject at: 4))].
	operator = #midDivide ifTrue: 
			[^MedMidDivide 
				new: (self createExpression: (anObject at: 2))
				with: (self createExpression: (anObject at: 3))
				failingTo: (self createTarget: (anObject at: 4))].
	operator = #atElementAddress ifTrue: 
			[^MedAtElementAddress 
				for: (self createExpression: (anObject at: 2))
				index: (self createExpression: (anObject at: 3))
				failTo: (self createTarget: (anObject at: 4))
				cacheOffset: (anObject at: 5)].
	operator = #atPut ifTrue: 
			[^MedAtPut 
				receiver: (self createExpression: (anObject at: 2))
				index: (self createExpression: (anObject at: 3))
				value: (self createExpression: (anObject at: 4))
				failTo: (self createTarget: (anObject at: 5))].
	operator = #midMod ifTrue: 
			[^MedMidMod 
				new: (self createExpression: (anObject at: 2))
				with: (self createExpression: (anObject at: 3))
				failingTo: (self createTarget: (anObject at: 4))].
	operator = #pic ifTrue: 
			[^MedPic 
				selectionRegister: (self createExpression: (anObject at: 2))
				picEntry: MedPicEntry new].
	operator = #picEntry ifTrue: [^MedPicEntry new].
	operator = #addressOf ifTrue: 
		[^MedAddress 
			addressOf: (self createTarget: (anObject at: 3))
			byteCodeAddress: (anObject at: 2)].
	operator = #blockAddress ifTrue: 
		[^MedBlockAddress 
			addressOf: (self createTarget: (anObject at: 3))
			byteCodeAddress: (anObject at: 2)
			argumentCount: (anObject at: 4)].
	(self isJump: anObject) ifTrue: [^self createJump: anObject].
	operator = #neg ifTrue: [^MedNegate argument: (self createExpression: (anObject at: 2))].
	operator = #pop ifTrue: [^MedPop argument: (self createExpression: (anObject at: 2))].
	operator = #cmp ifTrue: 
			[^MedComparision 
				operator: #cmp
				arg1: (self createExpression: (anObject at: 2))
				arg2: (self createExpression: (anObject at: 3))].
	operator = #bitTest ifTrue: 
			[^MedComparision 
				operator: #bitTest
				arg1: (self createExpression: (anObject at: 2))
				arg2: (self createExpression: (anObject at: 3))].
	operator = #createContext ifTrue: [^MedCreateContext new].
	operator = #typeSwitch ifTrue: 
			[^MedTypeSwitch 
				switchOn: ((anObject at: 2) collect: [:each | self createExpression: each])
				variables: ((anObject at: 3) collect: [:each | self createExpression: each])
				ifType: (self createExpression: (anObject at: 5) first first)
				code: (self createExpression: (anObject at: 5) first last)
				failureCode: (self createExpression: (anObject at: 6))
				failureBlock: (self createTarget: (anObject at: 4))].
	operator = #primitive ifTrue: 
			[^MedPrimitive 
				primitive: (anObject at: 2)
				arguments: ((anObject 
						copyFrom: 5
						to: anObject size) collect: [:each | self createExpression: each])
				failureBlock: (self createTarget: (anObject at: 4))
				receiver: (Smalltalk at: (anObject at: 3))].
	operator = #primitiveReturn ifTrue: 
			[^MedPrimitiveReturn 
				value: (self createExpression: (anObject at: 3))
				popping: (anObject at: 2)
				receiver: nil].
	operator = #stackPush ifTrue: 
			[^MedStackPush 
				from: (self createExpression: (anObject at: 2))
				to: (self createExpression: (anObject at: 3))].
	operator = #blockCopy ifTrue: 
			[^MedBlockCopy 
				arguments: (self createExpression: (anObject at: 2))
				context: (self createExpression: (anObject at: 4))
				block: (self createTarget: (anObject at: 5))
				byteCodeAddress: (anObject at: 3)].
	operator = #activeContext ifTrue: [^MedActiveContext new].
	operator = #createBlockContext ifTrue: [^MedCreateBlockContext arguments: (anObject at: 2)].
	operator = #blockReturn ifTrue: [^MedBlockReturn value: (self createExpression: (anObject at: 2))].
	operator = #createBlock ifTrue: 
			[^MedCreateBlock 
				argumentCount: (self createExpression: (anObject at: 2))
				block: (self createTarget: (anObject at: 4))
				byteCodeAddress: (anObject at: 3)].
	operator = #homeContext ifTrue: [^MedHomeContext new].
	operator = #receiverAddress ifTrue: [^MedReceiverAddress new].
	operator = #instanceVariableAddress ifTrue: [^MedInstanceVariableAddress slot: (anObject at: 2)].
	^self createArithmatic: anObject! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 12/19/2004 14:19'!
createExpression: anArray for: aMachineX86 
	machine := aMachineX86.
	^ self createExpression: anArray! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/5/2002 20:32'!
createIntermediate: anArray for: aMachine
	method := MedMethod new.
	machine := aMachine.
	anArray do: [:each| (self createBlock: each)].
	^ method! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 2/4/2005 23:25'!
createJump: anArray 
	| testInstruction target targetAddress |
	testInstruction := anArray size = 3 
				ifTrue: [self createExpression: (anArray at: 3)]
				ifFalse: [nil].
	targetAddress := anArray at: 2.
	(targetAddress isSymbol and: [(targetAddress size > 4)]) 
			ifTrue: [target := self createTarget: targetAddress]
			ifFalse: [target := self createExpression: targetAddress].
	^MedJump 
		type: (anArray at: 1)
		target: target
		instruction: testInstruction! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 7/6/2003 21:30'!
createJustTheBlocks: anArray
	|blockNumber block|
	self assert: [(anArray at: 1) = #block].
	blockNumber := anArray at: 2.
	block := method blockNumbered: blockNumber.
	^ block	! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/5/2002 20:32'!
createMem: anArray
	|address|
	address := self createExpression: (anArray at: 2).
	^ MedMem
		address: address! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 12/18/2004 00:04'!
createMove: anArray
	|arg1 arg2|
	arg1 := self createExpression: (anArray at: 2).
	arg2 := self createExpression: (anArray at: 3).
	^ MedMov
		from: arg1
		to: arg2! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 8/8/2004 11:40'!
createTarget: targetAddress 
	| blockNumber |
	blockNumber := (targetAddress 
				copyFrom: 6
				to: targetAddress size) asInteger.
	^method blockNumbered: blockNumber! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/22/2002 15:34'!
isBasicType: anObject 
	| operator |
	anObject isInteger | anObject isString ifTrue: [^true].
	operator := anObject at: 1.
	operator isNumber | (self isMachineRegister: operator) ifTrue: [^true].
	(anObject isCollection and: [self isRegister: (anObject at: 1)]) ifTrue: [^true].
	^false! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 3/30/2005 21:07'!
isJump: anObject
	anObject isCollection ifFalse: [^ false].
	^ #(jo jz jg jle jl jge je jmp jnz jne jnc jc) includes: (anObject at: 1)
! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 10/22/2002 15:22'!
isMachineRegister: anObject 
	(#(#eax #ebx #ecx #edx #esi #edi #ebp #esp) includes: anObject) 
		ifTrue: [^true].
	"(anObject isString and: [(anObject at: 1) = $t]) ifTrue: [^ true]."
	^false! !

!IntermediateCreator methodsFor: 'Intermediate Creation' stamp: 'wbk 12/18/2004 00:03'!
isRegister: anObject 
	^(self isMachineRegister: anObject) 
		| (anObject isString and: [(anObject at: 2) isDigit])
		| (anObject = #currentContext)! !

Object subclass: #IntermediateEmitter
	instanceVariableNames: 'currentBlock machine jumpTargets emitter stack result inliningSends'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!IntermediateEmitter class methodsFor: 'instance creation' stamp: 'wbk 5/26/2005 23:00'!
machine: aMachine jumpTargets: aCollection inlining: anObject 
	^self 
		machine: aMachine
		jumpTargets: aCollection
		result: MedMethod new
		inlining: anObject! !

!IntermediateEmitter class methodsFor: 'instance creation' stamp: 'wbk 5/26/2005 22:59'!
machine: aMachine jumpTargets: aCollection result: aMethod inlining: anObject 
	^self new 
		initializeMachine: aMachine
		jumpTargets: aCollection
		result: aMethod
		inlining: anObject! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 1/14/2006 17:19'!
activeCompiledMethodAddress
	^MedMem address: (MedArithmatic 
				operator: #add
				arg1: self homeContext
				arg2: (MedLiteral literal: 16))! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 10/23/2004 22:35'!
addExpression: aMed 
	aMed isNil ifTrue: [^ self].
	aMed isRegister ifTrue: [^ self].
	aMed isLiteral ifTrue: [^ self].
	currentBlock add: aMed! !

!IntermediateEmitter methodsFor: 'Emit - Primitives' stamp: 'wbk 5/8/2005 17:17'!
addressOfIndexedElementIn: receiver at: index failTo: methodBytecodes 
	emitter 
		checkIsInteger: index
		failTo: methodBytecodes.
	emitter addExpression: (emitter 
				jumpType: #jg
				to: methodBytecodes
				dependingOn: (emitter 
						emit: (MedLiteral literal: 3)
						cmp: index)).
	emitter addExpression: (emitter 
				jumpType: #jge
				to: methodBytecodes
				dependingOn: (emitter 
						emit: (emitter 
								emit: index
								sar: (MedLiteral literal: 1))
						cmp: (emitter sizeOfObject: receiver))).
	^emitter mem: (emitter 
				emit: receiver
				add: (emitter 
						emit: (emitter 
								emit: index
								minus: (MedLiteral literal: 1))
						sal: (MedLiteral literal: 1)))! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/1/2006 22:42'!
addressOf: aMedBlock 
self removeMe.
	^ MedAddress addressOf: aMedBlock! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/1/2006 22:42'!
addressOf: aMedBlock byteCodeAddress: anInteger
	^ MedAddress 
		addressOf: aMedBlock
		byteCodeAddress: anInteger! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/4/2006 19:37'!
addressOf: aMedBlock byteCodeAddress: aByteSymbol argumentCount: aByteSymbol3 
	^ MedBlockAddress
		addressOf: aMedBlock
		byteCodeAddress: aByteSymbol
		argumentCount: aByteSymbol3! !

!IntermediateEmitter methodsFor: 'Emit - Control Flow' stamp: 'wbk 8/17/2005 11:41'!
alignedLabel: aBlock 
	aBlock makeAligned.
	self jumpTo: aBlock.
	self currentBlock: aBlock.
	^ aBlock! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 2/13/2005 12:52'!
arithmaticOperator: aSymbol arg1: firstMed arg2: secondMed 
	^ MedArithmatic 
		operator: aSymbol
		arg1: firstMed
		arg2: secondMed! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 2/13/2005 12:46'!
basicJumpTo: aLabel 
	^ MedJump 
		type: #jmp
		target: aLabel! !

!IntermediateEmitter methodsFor: 'Emit - Low Level Moves' stamp: 'wbk 2/13/2005 12:44'!
basicMoveFrom: aMedMem to: aMedTemporaryRegister 
	^ MedMov 
		from: aMedMem
		to: aMedTemporaryRegister! !

!IntermediateEmitter methodsFor: 'Emit - Low Level Moves' stamp: 'wbk 11/3/2005 19:55'!
basicStackPush: aMedMem to: aMedTemporaryRegister 
	^MedStackPush 
		from: aMedMem
		to: aMedTemporaryRegister! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 3/27/2005 18:17'!
beRootIfNessisary: parentObject exitingTo: nextBlock 
	| header rootTableCount |
	emitter addExpression: (emitter 
				jumpType: #jge
				to: nextBlock
				dependingOn: (emitter 
						emit: parentObject
						cmp: (emitter mem: emitter youngStartAddress))).
	header := emitter createTemporaryRegister.
	emitter 
		moveFrom: (emitter mem: parentObject)
		to: header.
	emitter addExpression: (emitter 
				jumpType: #jnz
				to: nextBlock
				dependingOn: (emitter 
						emit: header
						and: (MedLiteral literal: 1073741824))).	"root flag in header"
	rootTableCount := emitter createTemporaryRegister.
	emitter 
		moveFrom: (emitter 
				emit: (MedLiteral literal: 1)
				add: (emitter mem: emitter rootTableCountAddress))
		to: rootTableCount.
	emitter 
		moveFrom: rootTableCount
		to: (emitter mem: emitter rootTableCountAddress).
	emitter 
		moveFrom: parentObject
		to: (emitter mem: (emitter 
						emit: emitter rootTableAddress
						add: (emitter 
								emit: rootTableCount
								sal: (MedLiteral literal: 2)))).
	emitter 
		moveFrom: (emitter 
				emit: header
				or: (MedLiteral literal: 1073741824))
		to: (emitter mem: parentObject).
	emitter jumpTo: nextBlock.
	emitter currentBlock: nextBlock! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:27'!
beRoot: parentObject ifNeededBy: childObject 
	| nextBlock |
	nextBlock _ emitter newBlock.
	self 
		ifInNewSpace: childObject
		jumpTo: nextBlock.
	self 
		beRootIfNessisary: parentObject
		exitingTo: nextBlock! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 11/27/2005 22:00'!
blockForBytecode: aSmallInteger 
	^ jumpTargets at: aSmallInteger! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 1/5/2006 22:08'!
blockReturn: aMed
	^ MedBlockReturn value: aMed! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/18/2005 21:54'!
callFunctionNamed: aSymbol with: someMeds 
	| functionAddress answer |
	someMeds reverseDo: [:each | emitter push: each].
	functionAddress := machine createTemporaryRegister.
	currentBlock add: (MedMov 
				from: (machine addressOf: (MedLiteral literal: aSymbol))
				to: functionAddress).
	currentBlock add: (MedCall 
				function: functionAddress
				machine: machine).
	answer := machine createTemporaryRegister.
	emitter 
		moveFrom: (machine registerNamed: #eax)
		to: answer.
	currentBlock add: (MedMov 
				from: (MedArithmatic 
						operator: #add
						arg1: (MedLiteral literal: someMeds size * 4)
						arg2: (machine registerNamed: #esp))
				to: (machine registerNamed: #esp)).
	^ answer! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 3/28/2005 18:44'!
checkIsInteger: aMed failTo: aLabel 
	| check |
	check := MedJump 
				type: #jnc
				target: aLabel
				instruction: (MedComparision
						operator: #bitTest
						arg1: aMed
						arg2: (MedLiteral literal: 0)).
	currentBlock add: check! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 3/30/2005 20:57'!
checkIsNotInteger: aMedMem failTo: aMedBlock 
	| check |
	check := MedJump 
				type: #jc
				target: aMedBlock
				instruction: (MedComparision 
						operator: #bitTest
						arg1: aMedMem
						arg2: (MedLiteral literal: 0)).
	currentBlock add: check! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 4/1/2006 17:07'!
checkRoundingNeedsAdjustingForSecondArgument: secondArgument remainder: remander failingTo: nextBlock adjustBy: aBlock
	| negativeBlock |
	negativeBlock := emitter newBlock.
	self addExpression: (self 
				jumpType: #jl
				to: negativeBlock
				dependingOn: (self 
						emit: secondArgument
						cmp: (MedLiteral literal: 0))).
	self addExpression: (self 
				jumpType: #jge
				to: nextBlock
				dependingOn: (self 
						emit: remander
						cmp: (MedLiteral literal: 0))).
	aBlock value.
	self jumpTo: nextBlock.

	self currentBlock: negativeBlock.
	self addExpression: (self
		jumpType: #jle
		to: nextBlock
		dependingOn: (self
			emit: remander
			cmp: (MedLiteral literal: 0))).
	aBlock value.
	self jumpTo: nextBlock.
	
	emitter currentBlock: nextBlock.
	! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 8/19/2005 22:05'!
classOf: aMedLiteral 
	| answer notInteger nextBlock classHeader classIndex argument |
	argument := emitter createTemporaryRegister.
	answer := emitter createTemporaryRegister.
	classIndex := emitter createTemporaryRegister.
	notInteger := emitter newBlock.
	classHeader := emitter newBlock.
	nextBlock := emitter newBlock.
	emitter
		moveFrom: aMedLiteral
		to: argument.
	emitter 
		checkIsInteger: argument
		failTo: notInteger.
	emitter 
		moveFrom: (emitter specialObject: 5)
		to: answer.
	emitter jumpTo: nextBlock.
	emitter currentBlock: notInteger.
	emitter 
		moveFrom: (emitter 
				emit: (MedLiteral literal: 31)
				and: (emitter 
						emit: (emitter mem: argument)
						sar: (MedLiteral literal: 12)))
		to: classIndex.
	self 
		ifZero: classIndex
		jumpTo: classHeader.
	emitter 
		moveFrom: (emitter 
				fetchVariableAddress: (emitter 
						emit: classIndex
						minus: (MedLiteral literal: 1))
				ofObject: (emitter specialObject: 28))
		to: answer.
	emitter jumpTo: nextBlock.
	emitter currentBlock: classHeader.
	emitter 
		moveFrom: (emitter 
				emit: (MedLiteral literal: 4294967292)
				and: (emitter mem: (emitter 
								emit: argument
								minus: (MedLiteral literal: 4))))
		to: answer.
	emitter jumpTo: nextBlock.
	emitter currentBlock: nextBlock.
	^ answer! !

!IntermediateEmitter methodsFor: 'Emit - Control Flow' stamp: 'wbk 3/27/2005 17:42'!
conditionalBytecodeArg1: firstMed arg2: secondMed withJump: aSymbol failureSelector: aNumber 
	| subtract |
	^ emitter 
		withFailTo: 
			[:arguments :overflowBlock | 
			subtract := emitter 
						emit: (emitter 
								integerValueOf: arguments first
								failTo: overflowBlock)
						cmp: (emitter 
								integerValueOf: arguments last
								failTo: overflowBlock).
			emitter 
				convertComparisionToBoolean: subtract
				jumpType: aSymbol]
		failureSpecialSelector: aNumber
		arguments: ({ 
				firstMed.
				secondMed})! !

!IntermediateEmitter methodsFor: 'Emit - Control Flow' stamp: 'wbk 2/8/2006 21:33'!
conditionalJumpTo: labelMed onBoolean: booleanMed ifBooleanIs: anObject 
self removeMe.
	self 
		conditionalJumpTo: labelMed
		onBoolean: booleanMed
		ifBooleanIs: anObject
		pc: stack pc
		stack: #()! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 2/13/2005 12:20'!
convertComparisionToBoolean: aMed jumpType: aSymbol 
	^ MedConvertBoolean 
		jumpType: aSymbol
		expression: aMed! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 2/13/2005 12:59'!
convertExpandedComparisionToBoolean: aMed jumpType: aSymbol 
	| answer falseLabel nextLabel |
	answer _ machine createTemporaryRegister.
	falseLabel _ result newBlock.
	nextLabel _ result newBlock.
	emitter addExpression: (emitter 
				jumpType: aSymbol
				to: falseLabel
				dependingOn: aMed).
	emitter 
		moveFrom: emitter trueAddress
		to: answer.
	emitter jumpTo: nextLabel.
	emitter currentBlock: falseLabel.
	emitter 
		moveFrom: emitter falseAddress
		to: answer.
	emitter jumpTo: nextLabel.
	currentBlock _ nextLabel.
	^ answer! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 3/27/2005 22:46'!
convertToSmallInteger: aMedObject failTo: aMedBlock 
	^ MedArithmatic 
		operator: #or
		arg1: (MedLiteral literal: 1)
		arg2: (MedJump 
				type: #jo
				target: aMedBlock
				instruction:  aMedObject)! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 1/18/2006 23:03'!
createBlockContextWithArguments: anObject 
	emitter addExpression: (MedCreateBlockContext arguments: anObject)! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 8/22/2005 20:59'!
createProlog
	| prolog |
	prolog := result prolog.
	self currentBlock: prolog.
	self setUpStackFrame.
	emitter jumpTo: (result blockAt: 2)	" Jump to the next block,"! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 11/20/2003 23:26'!
createTemporaryRegister
	^ machine createTemporaryRegister! !

!IntermediateEmitter methodsFor: 'Unit Testing' stamp: 'wbk 10/14/2002 14:17'!
currentBlock
	^ currentBlock! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 1/21/2006 14:39'!
currentBlock: aMedBlock 
	currentBlock := aMedBlock! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 1/29/2005 22:08'!
currentContextAddress
	^ MedMem address: (MedLiteral literal: #activeContext)! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/9/2006 21:38'!
currentContextRegister
	| currentContext |
	currentContext := machine createTemporaryRegister.
	currentBlock add: (MedMov 
				from: machine currentContext
				to: currentContext).
	^ currentContext! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:53'!
currentContextsPC
	^ MedMem address: (MedArithmatic 
				operator: #add
				arg1: machine currentContext
				arg2: (MedLiteral literal: 4 * 2))! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:28'!
currentContextsStack
	^ MedMem address: (MedArithmatic 
				operator: #add
				arg1: machine currentContext
				arg2: (MedLiteral literal: 4 * 3))! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 10/25/2005 23:00'!
deconvertBooleanJumpingTo: labelMed if: booleanMed is: aSymbol pc: pcInteger 
	^MedDeconvertBoolean 
		jumpTo: labelMed
		if: booleanMed
		is: aSymbol
		pc: pcInteger! !

!IntermediateEmitter methodsFor: 'Unit Testing' stamp: 'wbk 8/30/2004 16:17'!
emitter: aMockEmitter 
	emitter := aMockEmitter.
	aMockEmitter result: result.! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 8/8/2003 20:36'!
emit: aMedLiteral add: aMedMem 
	^ MedArithmatic
		operator: #add
		arg1: aMedLiteral
		arg2: aMedMem! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 2/4/2004 23:38'!
emit: aMedMem and: aSmallInteger 
	^ MedArithmatic
		operator: #and
		arg1: aMedMem
		arg2: aSmallInteger! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 12/22/2004 21:43'!
emit: firstMed bitShift: secondMed failingTo: aBlock 
	^MedBitShift 
		new: firstMed
		with: secondMed
		failingTo: aBlock! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 3/26/2005 15:39'!
emit: aMedLiteral cmp: aMedLiteral2 
	^ MedComparision 
		operator: #cmp
		arg1: aMedLiteral
		arg2: aMedLiteral2! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 3/28/2005 13:08'!
emit: firstMed divideForMod: secondMed into: aResult remainder: remander failingTo: aMedBlock 
	self 
		ifZero: secondMed
		jumpTo: aMedBlock.
	self 
		moveFrom: (MedArithmatic
			operator: #sal
			arg1: (MedDivide 
				emit: firstMed
				divide: secondMed
				remander: remander)
			arg2: (MedLiteral literal: 1))
		to: aResult
! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 12/22/2004 21:46'!
emit: firstMed divide: secondMed failingTo: aMedBlock 
	^MedMidDivide 
		new: firstMed
		with: secondMed
		failingTo: aMedBlock! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 3/28/2005 13:00'!
emit: firstMed divide: secondMed into: aResult remainder: remander failingTo: aMedBlock 
	self 
		ifZero: secondMed
		jumpTo: aMedBlock.
	self 
		moveFrom: (MedJump
			type: #jo
			target: aMedBlock
			instruction:(MedArithmatic
				operator: #sal
				arg1: (MedDivide  
					emit: (MedArithmatic
						operator: #sar
						arg1: firstMed
						arg2: (MedLiteral literal: 1))
					divide:  (MedArithmatic
						operator: #sar
						arg1: secondMed
						arg2: (MedLiteral literal: 1))
					remander: remander)
				arg2: (MedLiteral literal: 1)))
		to: aResult! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 12/22/2004 21:45'!
emit: firstMed div: secondMed failingTo: aMedBlock 
	^MedMidDiv 
		new: firstMed
		with: secondMed
		failingTo: aMedBlock! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 3/6/2004 21:09'!
emit: firstMed minus: secondMed
	^ MedArithmatic
		operator: #sub
		arg1: firstMed
		arg2: secondMed! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 12/22/2004 21:47'!
emit: firstMed mod: secondMed failingTo: aMedBlock 
	^MedMidMod 
		new: firstMed
		with: secondMed
		failingTo: aMedBlock! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 3/27/2005 23:11'!
emit: firstMed multiply: secondMed failingTo: aLabel 
	^ MedArithmatic 
		operator: #mul
		arg1: (MedArithmatic
			operator: #sar
			arg1: firstMed
			arg2: (MedLiteral literal: 1))
		arg2: secondMed! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 11/21/2003 00:03'!
emit: aMedTemporaryRegister or: aLargePositiveInteger 
	^ MedArithmatic
		operator: #or
		arg1: aMedTemporaryRegister
		arg2: aLargePositiveInteger! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 11/21/2003 00:01'!
emit: aSmallInteger sal: aMedTemporaryRegister 
	^ MedArithmatic
		operator: #sal
		arg1: aSmallInteger
		arg2: aMedTemporaryRegister! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 3/7/2004 23:33'!
emit: aMedLiteral sar: aMedLiteral2 
	^MedArithmatic 
		operator: #sar
		arg1: aMedLiteral
		arg2: aMedLiteral2! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/18/2006 17:20'!
expandedBlockReturnValue: aMed 
	| sendersContext |
	sendersContext := self sendersContext.
	emitter 
		moveFrom: emitter nilAddress
		to: (emitter mem: (emitter
			emit: machine currentContext
			add: (MedLiteral literal: 4))).
	self 
		storeResult: sendersContext
		inContext: aMed.
	self returnToContext: sendersContext.
	^aMed! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 3/27/2005 20:43'!
expandedIntegerValueOf: aMed failTo: aLabel 
	| temporary |
	temporary := emitter createTemporaryRegister.
	self 
		moveFrom: aMed
		to: temporary.
	self 
		checkIsInteger: temporary
		failTo: aLabel.
	^ MedArithmatic 
		operator: #sub
		arg1: temporary
		arg2: (MedLiteral literal: 1)! !

!IntermediateEmitter methodsFor: 'Emit - Control Flow' stamp: 'wbk 2/8/2006 21:33'!
expandedJumpIfFalseTo: labelMed onBoolean: booleanMed 
self removeMe.
	self 
		conditionalJumpTo: labelMed
		onBoolean: booleanMed
		ifBooleanIs: #falseObj! !

!IntermediateEmitter methodsFor: 'Emit - Control Flow' stamp: 'wbk 2/8/2006 21:33'!
expandedJumpIfTrueTo: labelMed onBoolean: booleanMed 
self removeMe.
	self 
		conditionalJumpTo: labelMed
		onBoolean: booleanMed
		ifBooleanIs: #trueObj! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 1/8/2006 11:20'!
expandedNonlocalReturnValue: aMedLiteral 
	| returnAddress exitToInterpreter |
	returnAddress := emitter createTemporaryRegister.
	exitToInterpreter := emitter newBlock.
	emitter
		moveFrom: (emitter
			callFunctionNamed: #exuperyNonlocalReturn
			with: {aMedLiteral})
		to: returnAddress.
   emitter addExpression: (emitter
		jumpType: #je
		to: exitToInterpreter
		dependingOn: (emitter
			emit: returnAddress
			cmp: (MedLiteral literal: 0))).
	emitter returnToCompiledMethod: (emitter 
				emit: returnAddress
				minus: (MedLiteral literal: 1)).
	emitter currentBlock: exitToInterpreter.
	self returnToInterpreter.
	^ aMedLiteral! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 1/14/2006 22:55'!
expandedPopIntoTemp: aMed slot: anInteger isInBlock: aBoolean
	| source |
	source := emitter createTemporaryRegister.
	emitter 
		moveFrom: aMed
		to: source.
	emitter 
		moveFrom: source
		to: (emitter 
				simplifiedTemporaryAddress: anInteger
				isInBlock: aBoolean).
	^source! !

!IntermediateEmitter methodsFor: 'Emit - Primitives' stamp: 'wbk 6/3/2005 18:09'!
expandedPrimitiveReturn: aMedMem popping: aSmallInteger 
	| stackPointer |
	stackPointer := machine createTemporaryRegister.
	emitter
		moveFrom: (emitter 
			emit: (emitter mem: (emitter
				emit: emitter currentContextAddress
				add: (MedLiteral literal: 12)))
			minus: (MedLiteral literal: (aSmallInteger - 1) *2))
		to: stackPointer.
	emitter 
		moveFrom: stackPointer
		to: (emitter mem: (emitter
			emit: emitter currentContextAddress
			add: (MedLiteral literal: 12))).
	emitter
		stackFor: emitter currentContextAddress
		at: stackPointer
		put: aMedMem.
	emitter return.! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/11/2006 12:46'!
expandedReturnValue: aMed 
	| sendersContext |
	sendersContext := self sendersContext.
	self 
		storeResult: sendersContext
		inContext: aMed.
	emitter recycleContextIfPossible: machine currentContext.
	self returnToContext: sendersContext.
	^aMed! !

!IntermediateEmitter methodsFor: 'Emit - Arithmatic' stamp: 'wbk 3/27/2005 22:10'!
expanded: firstMed bitShift: secondMed failingTo: aBlock 
	| answer negativeBlock nextBlock firstArgument secondArgument |
	answer := machine createTemporaryRegister.
	firstArgument := machine createTemporaryRegister.
	secondArgument := machine createTemporaryRegister.
	negativeBlock := emitter newBlock.
	nextBlock := emitter newBlock.
	emitter 
		moveFrom: firstMed
		to: firstArgument.
	emitter 
		moveFrom: (emitter 
			emit: secondMed
			sar: (MedLiteral literal: 1))
		to: secondArgument.
	self addExpression: (emitter 
				jumpType: #jl
				to: negativeBlock
				dependingOn: (self 
						emit: secondArgument
						cmp: (MedLiteral literal: 0))).
	self addExpression: (emitter 
				jumpType: #jl
				to: aBlock
				dependingOn: (self 
						emit: (MedLiteral literal: 31)
						cmp: secondArgument)).
	emitter 
		moveFrom: (emitter 
				emit: firstArgument
				sal: secondArgument)
		to: answer.
	self addExpression: (emitter 
				jumpType: #jnz
				to: aBlock
				dependingOn: (self 
						emit: firstArgument
						cmp: (emitter 
								emit: answer
								sar: secondArgument))).
	emitter jumpTo: nextBlock.
	emitter currentBlock: negativeBlock.
	self addExpression: (emitter 
				jumpType: #jl
				to: aBlock
				dependingOn: (emitter 
						emit: secondArgument
						cmp: (MedLiteral literal: -31))).
	self 
		moveFrom: (emitter 
				emit: firstArgument
				sar: (MedNegate argument: secondArgument))
		to: answer.
	emitter jumpTo: nextBlock.
	emitter currentBlock: nextBlock.
	^ answer! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 2/13/2005 12:52'!
expanded: firstMed divide: secondMed failingTo: aMedBlock 
	| answer remander |
	answer _ machine createTemporaryRegister.
	remander _ machine createTemporaryRegister.
	self 
		emit: firstMed
		divide: secondMed
		into: answer
		remainder: remander
		failingTo: aMedBlock.
	self 
		ifNotZero: remander
		jumpTo: aMedBlock.
	^ answer! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 4/1/2006 17:26'!
expanded: firstMed div: secondMed failingTo: aMedBlock 
	| answer remander nextBlock |
	answer := machine createTemporaryRegister.
	remander := machine createTemporaryRegister.
	nextBlock := emitter newBlock.
	self 
		emit: firstMed
		divide: secondMed
		into: answer
		remainder: remander
		failingTo: aMedBlock.
	self 
		checkRoundingNeedsAdjustingForSecondArgument: secondMed
		remainder: remander
		failingTo: nextBlock
		adjustBy:
			[self 
				moveFrom: (self 
					emit: answer
					minus: (MedLiteral literal: 1))
				to: answer].
	^answer! !

!IntermediateEmitter methodsFor: 'Emit - Division' stamp: 'wbk 4/1/2006 17:06'!
expanded: firstMed mod: secondMed failingTo: aMedBlock 
	| answer remander nextBlock |
	answer := machine createTemporaryRegister.
	remander := machine createTemporaryRegister.
	nextBlock := emitter newBlock.
	self 
		emit: firstMed
		divideForMod: secondMed
		into: answer
		remainder: remander
		failingTo: aMedBlock.
	self 
		checkRoundingNeedsAdjustingForSecondArgument: secondMed
		remainder: remander
		failingTo: nextBlock
		adjustBy: 
			[self 
				moveFrom: (self 
					emit: remander
					add: secondMed)
				to: remander].
	^remander! !

!IntermediateEmitter methodsFor: 'Unit Testing' stamp: 'wbk 8/21/2004 22:43'!
exuperyStack
	^ stack! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:53'!
falseAddress
	^ MedMem address: (MedLiteral literal: #falseObj)! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:28'!
fetchAddress: field ofObject: compiledMethod 
	^ MedMem address: (MedArithmatic 
				operator: #add
				arg1: compiledMethod
				arg2: (MedLiteral literal: 4 * field literal + 4))! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:29'!
fetchVariableAddress: indexMed ofObject: objectMed 
	^ MedMem address: (MedArithmatic 
				operator: #add
				arg1: objectMed
				arg2: (MedArithmatic 
						operator: #add
						arg1: (MedArithmatic 
								operator: #sal
								arg1: indexMed
								arg2: (MedLiteral literal: 2))
						arg2: (MedLiteral literal: 4)))! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 1/14/2006 19:01'!
homeContext
	^ MedHomeContext new! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 3/27/2005 18:17'!
ifInNewSpace: childObject jumpTo: nextBlock 
	emitter 
		checkIsNotInteger: childObject
		failTo: nextBlock.
	emitter addExpression: (emitter 
				jumpType: #jl
				to: nextBlock
				dependingOn: (emitter 
						emit: childObject
						cmp: (emitter mem: emitter youngStartAddress)))! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 2/13/2005 12:31'!
ifNotZero: remander jumpTo: aMedBlock 
	emitter addExpression: (self 
				jumpType: #jne
				to: aMedBlock
				dependingOn: (self 
						emit: (MedLiteral literal: 0)
						minus: remander))! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 3/27/2005 18:42'!
ifZero: secondMed jumpTo: aMedBlock 
	emitter addExpression: (emitter 
				jumpType: #je
				to: aMedBlock
				dependingOn: (emitter 
						emit: (MedLiteral literal: 0)
						cmp: secondMed))! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:44'!
incrementStackPtrFor: aContext 
	| newStackPtr |
	newStackPtr _ machine createTemporaryRegister.
	emitter 
		moveFrom: (emitter 
				emit: (emitter mem: (emitter 
								emit: aContext
								add: (MedLiteral literal: 12)))
				add: (MedLiteral literal: 2))
		to: newStackPtr.
	emitter 
		moveFrom: newStackPtr
		to: (emitter mem: (emitter 
						emit: aContext
						add: (MedLiteral literal: 12))).
	^ newStackPtr! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 1/14/2006 18:54'!
initialCompiledMethodAddress
	^MedMem address: (MedArithmatic 
				operator: #add
				arg1: machine currentContext
				arg2: (MedLiteral literal: 16))! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 1/14/2006 19:02'!
initializeMachine: aMachine jumpTargets: aCollection result: aMethod inlining: anObject 
	result := aMethod.
	machine := aMachine.
	self currentBlock: (result blockNumbered: 1).
	emitter := self.
	jumpTargets := Dictionary new.
	aCollection do: 
			[:each | 
			jumpTargets 
				at: each
				put: result newBlock].
	inliningSends := anObject.
	^self! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 1/27/2006 22:00'!
instanceVariableAddress: aSmallInteger 
	^ MedInstanceVariableAddress slot: aSmallInteger! !

!IntermediateEmitter methodsFor: 'Emit - Type Tags' stamp: 'wbk 2/13/2005 12:22'!
integerValueOf: aMed failTo: aLabel 
	^ MedIntegerValueOf 
		argument: aMed
		failureBlock: aLabel! !

!IntermediateEmitter methodsFor: 'Emit - Control Flow' stamp: 'wbk 10/25/2005 23:00'!
jumpIfFalseTo: labelMed onBoolean: booleanMed 
	self addExpression: (self 
				deconvertBooleanJumpingTo: labelMed
				if: booleanMed
				is: #falseObj
				pc: stack pc)! !

!IntermediateEmitter methodsFor: 'Emit - Control Flow' stamp: 'wbk 10/25/2005 23:00'!
jumpIfTrueTo: labelMed onBoolean: booleanMed 
	self addExpression: (self 
				deconvertBooleanJumpingTo: labelMed
				if: booleanMed
				is: #trueObj
				pc: stack pc)! !

!IntermediateEmitter methodsFor: 'Unit Testing' stamp: 'wbk 11/27/2005 22:08'!
jumpTargets
	^ jumpTargets keys asSortedCollection asArray! !

!IntermediateEmitter methodsFor: 'Emit - Control Flow' stamp: 'wbk 8/22/2005 21:00'!
jumpTarget: anInteger 
	| targetLabel |
	targetLabel := jumpTargets at: anInteger.
	currentBlock add: (MedJump 
				type: #jmp
				target: targetLabel).
	self currentBlock: targetLabel! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 2/13/2005 12:46'!
jumpTo: aLabel 
	emitter addExpression: (self basicJumpTo: aLabel)! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 2/7/2006 20:29'!
jumpTo: labelMed if: booleanMed equals: anObject 
self removeMe.
	emitter addExpression: (emitter 
				jumpType: #je
				to: labelMed
				dependingOn: (emitter 
						emit: booleanMed
						cmp: anObject))! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 2/7/2006 20:30'!
jumpTo: notBooleanBlock if: booleanMed notEquals: anObject1 
self removeMe.
	emitter addExpression: (emitter 
				jumpType: #jne
				to: notBooleanBlock
				dependingOn: (emitter 
						emit: booleanMed
						cmp: anObject1))! !

!IntermediateEmitter methodsFor: 'Emit - Low level Jumps' stamp: 'wbk 8/7/2004 21:08'!
jumpType: aSymbol to: aMedBlock dependingOn: aMedArithmatic 
	^ MedJump
		type: aSymbol
		target: aMedBlock
		instruction: aMedArithmatic! !

!IntermediateEmitter methodsFor: 'Emit - Control Flow' stamp: 'wbk 8/22/2005 21:00'!
label
	| newBlock |
	newBlock := self newBlock.
	self jumpTo: newBlock.
	self currentBlock: newBlock.
	^ newBlock! !

!IntermediateEmitter methodsFor: 'Emit - Control Flow' stamp: 'wbk 2/13/2005 12:52'!
labelArguments: someArguments registers: someRegisters around: aMedArithmatic failingTo: aMedTemporaryRegister failureBlock: aMedBlock 
	^ MedLabel 
		arguments: someArguments
		registers: someRegisters
		around: aMedArithmatic
		failingTo: aMedTemporaryRegister
		failureBlock: aMedBlock! !

!IntermediateEmitter methodsFor: 'Emit - Control Flow' stamp: 'wbk 2/13/2005 12:47'!
labelForByteCode: anInteger 
	^ jumpTargets at: anInteger! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 3/21/2005 20:51'!
literalAddress: aNumber 
	| compiledMethod field |
	compiledMethod := self activeCompiledMethodAddress.
	field := MedLiteral literal: aNumber + 1.	"Add the method header"
	^ self 
		fetchAddress: field
		ofObject: compiledMethod	"4 is object header"! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/18/2005 21:26'!
loadCurrentContext
	emitter 
		moveFrom: emitter currentContextAddress
		to: machine currentContext! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 10/14/2002 14:04'!
machine
	^ machine! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 10/2/2004 21:23'!
materialiseStack
	stack materialiseStack! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 2/13/2005 12:03'!
mem: aMedLiteral 
	^ MedMem address: aMedLiteral! !

!IntermediateEmitter methodsFor: 'Emit - Low Level Moves' stamp: 'wbk 2/13/2005 12:44'!
moveFrom: aMedMem to: aMedTemporaryRegister 
	currentBlock add: (MedMov 
				from: aMedMem
				to: aMedTemporaryRegister)! !

!IntermediateEmitter methodsFor: 'Emit - Low Level Moves' stamp: 'wbk 2/13/2005 12:45'!
moveToEax: aMedLiteral 
	currentBlock add: (MedMov 
				from: aMedLiteral
				to: (machine registerNamed: #eax))! !

!IntermediateEmitter methodsFor: 'Emit - Low Level Moves' stamp: 'wbk 2/13/2005 12:43'!
moveToTemp: aMedMem 
	| answer |
	answer _ machine createTemporaryRegister.
	currentBlock add: (MedMov 
				from: aMedMem
				to: answer).
	^ answer! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 10/5/2005 22:38'!
needsLargeContext: anInteger
	 result needsLargeContext: anInteger.! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:08'!
newBlock
	^result newBlock! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:54'!
nilAddress
	^ MedMem address: (MedLiteral literal: #nilObj)! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 3/13/2005 20:43'!
numberOfArguments: aSmallInteger 
	result numberOfArguments: aSmallInteger! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 9/22/2004 20:10'!
numberOfTemporaries
	^result numberOfTemporaries! !

!IntermediateEmitter methodsFor: 'Unit Testing' stamp: 'wbk 9/22/2004 20:10'!
numberOfTemporaries: anInteger 
	result numberOfTemporaries: anInteger! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/27/2005 13:37'!
picLocatedAt: aMedLiteral picEntry: aPicEntry
	self addExpression: (MedPic 
				selectionRegister: aMedLiteral
				picEntry: aPicEntry)! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:29'!
popIntoReceiver: aMedLiteral slot: aSmallInteger 
	^ MedStoreInReceiver 
		slot: aSmallInteger
		value: aMedLiteral! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:29'!
popIntoTemp: aMed slot: anInteger 
	^ MedStoreInTemp 
		slot: anInteger
		value: aMed! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 3/4/2005 15:22'!
pop: aMed 
	currentBlock add: (MedPop argument: aMed)! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 19:23'!
preamble
	"The call preamble"

	"Load the current context, or get the context into registers"

	self setUpStackFrame.
	self loadCurrentContext! !

!IntermediateEmitter methodsFor: 'Emit - Primitives' stamp: 'wbk 5/4/2005 21:23'!
primitiveArgument: aSmallInteger 
	^ emitter mem: (emitter
		emit: (emitter currentContextAddress)
		add: (emitter 
			emit: (emitter 
				emit: (emitter mem: (emitter 
					emit: emitter currentContextAddress
					add: (MedLiteral literal: 12)))
				sal: (MedLiteral literal: 1))
			add: (MedLiteral literal: 22 "Includes a shifted type tag"- (aSmallInteger * 4)) ))! !

!IntermediateEmitter methodsFor: 'Emit - Primitives' stamp: 'wbk 11/6/2005 19:04'!
primitiveReturn: aMedMem popping: aSmallInteger receiver: aClass 
	emitter addExpression: (MedPrimitiveReturn 
				value: aMedMem
				popping: aSmallInteger
				receiver: aClass)! !

!IntermediateEmitter methodsFor: 'Emit - Primitives' stamp: 'wbk 11/6/2005 18:36'!
primitive: aSymbol arguments: someMeds failureBlock: aLabel receiver: anObject 
	^MedPrimitive 
		primitive: aSymbol
		arguments: someMeds
		failureBlock: aLabel
		receiver: anObject! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 2/13/2005 12:25'!
push: aMed 
	currentBlock add: (MedPush argument: aMed)! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:58'!
receiver
	self shouldBeImplemented! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 1/27/2006 20:35'!
receiverAddress
	^ MedReceiverAddress new! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 8/22/2005 21:00'!
recycleContextIfPossible: aMedLiteral 
	| nextBlock |
	nextBlock := emitter newBlock.
	emitter addExpression: (emitter 
				jumpType: #jle
				to: nextBlock
				dependingOn: (emitter 
						emit: (emitter mem: (MedLiteral literal: #reclaimableContextCount))
						cmp: (MedLiteral literal: 0))).
	emitter 
		moveFrom: (emitter 
				emit: (emitter mem: (MedLiteral literal: #reclaimableContextCount))
				minus: (MedLiteral literal: 1))
		to: (emitter mem: (MedLiteral literal: #reclaimableContextCount)).
	emitter addExpression: (emitter 
				jumpType: #jl
				to: nextBlock
				dependingOn: (emitter 
						emit: aMedLiteral
						cmp: (emitter mem: emitter youngStartAddress))).
	emitter 
		moveFrom: (emitter mem: (MedLiteral literal: #freeContexts))
		to: (emitter 
				fetchAddress: (MedLiteral literal: 0)
				ofObject: aMedLiteral).
	emitter 
		moveFrom: aMedLiteral
		to: (emitter mem: (MedLiteral literal: #freeContexts)).
	emitter jumpTo: nextBlock.
	self currentBlock: nextBlock! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 9/19/2004 16:15'!
registerEntryPointWithPC: aSmallInteger label: anIntermediateEmitter 
	result
		registerEntryPointWithPC: aSmallInteger
		label: anIntermediateEmitter! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 3/5/2005 00:04'!
restoreSendersFrame
	emitter 
		moveFrom: (emitter 
				emit: (machine registerNamed: #esp)
				add: (MedLiteral literal: 64))
		to: (machine registerNamed: #esp).
	emitter pop: (machine registerNamed: #edi).
	emitter pop: (machine registerNamed: #esi).
	emitter pop: (machine registerNamed: #ebx).
	emitter 
		moveFrom: (machine registerNamed: #ebp)
		to: (machine registerNamed: #esp).
	emitter pop: (machine registerNamed: #ebp)! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:08'!
result
	^result! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 3/4/2005 14:09'!
ret
	currentBlock add: MedRet new! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 12/24/2005 14:47'!
return
	| returnAddress returnToInterpreter |
	returnToInterpreter := self newBlock.
	"Check's we're not returning into an interpreted block"
	emitter 
		checkIsNotInteger: (emitter mem: (emitter 
						emit: emitter currentContextAddress
						add: (MedLiteral literal: 16)))
		failTo: returnToInterpreter.
	returnAddress := self createTemporaryRegister.
	emitter 
		moveFrom: (emitter mem: (emitter 
						emit: emitter currentContextAddress
						add: (MedLiteral literal: 20)))
		to: returnAddress.
	emitter 
		checkIsInteger: returnAddress
		failTo: returnToInterpreter.
	emitter returnToCompiledMethod: (emitter 
				emit: returnAddress
				minus: (MedLiteral literal: 1)).
	emitter currentBlock: returnToInterpreter.
	self returnToInterpreter! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 3/4/2005 20:26'!
returnSequence
	emitter restoreSendersFrame.
	emitter ret! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 3/4/2005 20:28'!
returnToCompiledMethod: returnAddress 
	"emitter 
		moveFrom: (machine registerNamed: #ebp)
		to: (machine registerNamed: #esp).
	emitter 
		moveFrom: (emitter 
				emit: (machine registerNamed: #esp)
				add: (MedLiteral literal: 4))
		to: (machine registerNamed: #esp)."
	emitter restoreSendersFrame.
	emitter jumpTo: returnAddress! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/18/2006 18:16'!
returnToContext: sendersContext 
	| nextBlock |
	emitter 
		moveFrom: emitter nilAddress
		to: (emitter mem: (emitter
			emit: machine currentContext
			add: (MedLiteral literal: 8))).
	emitter 
		moveFrom: sendersContext
		to: emitter currentContextAddress.
	emitter 
		moveFrom: emitter nilAddress
		to: (emitter mem: (emitter 
						emit: machine currentContext
						add: (MedLiteral literal: 20))).
	nextBlock := self newBlock.
	emitter 
		beRootIfNessisary: emitter currentContextAddress
		exitingTo: nextBlock.
	emitter currentBlock: nextBlock.
	self return! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 3/4/2005 13:49'!
returnToInterpreter
	emitter moveToEax: (MedLiteral literal: 1).
	emitter returnSequence! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 12:15'!
returnValue: aMed 
	^ emitter addExpression: (MedReturn value: aMed)! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:29'!
rootTableAddress
	^ MedLiteral literal: #rootTable! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:30'!
rootTableCountAddress
	^ MedLiteral literal: #rootTableCount! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:58'!
sendersContext
	| sendersContext |
	sendersContext _ machine createTemporaryRegister.
	emitter 
		moveFrom: (emitter mem: (emitter 
						emit: machine currentContext
						add: (MedLiteral literal: 4)))
		to: sendersContext.
	^ sendersContext! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 11/6/2005 18:36'!
sendSelector: selector arguments: someArguments pc: pcInteger selectorName: aSymbol 
	| receiver send failureBlock variables |
	failureBlock := emitter newBlock.
	send := MedSend 
				selector: selector
				arguments: someArguments
				programCounter: pcInteger.
	receiver := (inliningSends 
				detect: [:each | each first = pcInteger]
				ifNone: [^send]) last.
	variables := someArguments collect: [:each | emitter createTemporaryRegister].
	^MedTypeSwitch 
		switchOn: someArguments
		variables: variables
		ifType: receiver
		code: (MedPrimitive 
				primitive: aSymbol
				arguments: variables
				failureBlock: failureBlock
				receiver: receiver)
		failureCode: (MedSend 
				selector: selector
				arguments: variables
				programCounter: pcInteger)
		failureBlock: failureBlock! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 10/25/2005 23:12'!
sendSelector: selector arguments: someArguments selectorName: anObject 
	^self 
		sendSelector: selector
		arguments: someArguments
		pc: stack pc
		selectorName: anObject! !

!IntermediateEmitter methodsFor: 'Emit - Control Flow' stamp: 'wbk 1/21/2006 14:39'!
setInitialStackHeight: aSmallInteger 
	currentBlock initialStackHeight: aSmallInteger! !

!IntermediateEmitter methodsFor: 'Unit Testing' stamp: 'wbk 5/27/2005 22:03'!
setInlinedSends: anArray 
	inliningSends := anArray! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 2/13/2005 12:25'!
setProgramCounter: aMedLiteral 
	self shouldBeImplemented! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 19:18'!
setUpStackFrame
	emitter push: (machine registerNamed: #ebp).
	emitter 
		moveFrom: (machine registerNamed: #esp)
		to: (machine registerNamed: #ebp).
	emitter push: (machine registerNamed: #ebx).
	emitter push: (machine registerNamed: #esi).
	emitter push: (machine registerNamed: #edi).
	emitter 
		moveFrom: (emitter 
				emit: (machine registerNamed: #esp)
				minus: (MedLiteral literal: 64))
		to: (machine registerNamed: #esp)! !

!IntermediateEmitter methodsFor: 'Emit - Control Flow' stamp: 'wbk 3/27/2005 14:52'!
sideEffectingLabelArguments: someArguments registers: someRegisters around: aMedArithmatic failingTo: aMedTemporaryRegister failureBlock: aMedBlock 
	^ MedSideEffectingLabel 
		arguments: someArguments
		registers: someRegisters
		around: aMedArithmatic
		failingTo: aMedTemporaryRegister
		failureBlock: aMedBlock! !

!IntermediateEmitter methodsFor: 'Emit - Control Flow' stamp: 'wbk 6/3/2005 17:34'!
sideEffectsWithFailTo: aBlock failureSpecialSelector: aNumber arguments: someObjects 
	| overflowBlock argumentRegisters aMedTemporaryRegister aMedArithmatic |
	overflowBlock := emitter newBlock.
	argumentRegisters := someObjects collect: [:each | machine createTemporaryRegister].
	aMedArithmatic := aBlock 
				value: argumentRegisters
				value: overflowBlock.
	aMedTemporaryRegister := emitter 
				sendSelector: (emitter specialSelector: aNumber)
				arguments: argumentRegisters
				selectorName: nil.
	^MedSideEffectingLabel 
		arguments: someObjects
		registers: argumentRegisters
		around: aMedArithmatic
		failingTo: aMedTemporaryRegister
		failureBlock: overflowBlock! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 1/14/2006 22:49'!
simplifiedHomeContext: anBoolean
	anBoolean ifFalse: [^emitter machine currentContext].
	^emitter mem: (emitter 
				emit: emitter machine currentContext
				add: (MedLiteral literal: 16))! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 1/14/2006 22:53'!
simplifiedTemporaryAddress: aSmallInteger isInBlock: aBoolean
	^emitter mem: (emitter 
				emit: (emitter simplifiedHomeContext: aBoolean)
				add: (MedLiteral literal: 4 * (7 + aSmallInteger)))! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 5/2/2005 13:14'!
sizeOfObject: aMedLiteral 
	| threeWordHeader nextBlock answer header |
	threeWordHeader := emitter newBlock.
	nextBlock := emitter newBlock.
	answer := machine createTemporaryRegister.
	header := machine createTemporaryRegister.
	emitter 
		moveFrom: (emitter mem: aMedLiteral)
		to: header.
	emitter addExpression: (emitter
		jumpType: #jz
		to:	threeWordHeader
		dependingOn: (emitter
			emit: header
			and: (MedLiteral literal: 3))).
	emitter
		moveFrom: (emitter
			emit: (emitter
				emit: header
				and: (MedLiteral literal: 252))
			sar: (MedLiteral literal: 2))
		to: answer.
	emitter jumpTo: nextBlock.
	emitter currentBlock: threeWordHeader.
	emitter
		moveFrom: (emitter
			emit: (emitter mem: (emitter
				emit: aMedLiteral
				minus: (MedLiteral literal: 8)))
			sar: (MedLiteral literal: 2))
		to: answer.
	emitter jumpTo: nextBlock.
	emitter currentBlock: nextBlock.
	^ answer
	! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 12:28'!
specialObject: anObject 
	^ emitter 
		fetchAddress: (MedLiteral literal: anObject)
		ofObject: (emitter mem: (MedLiteral literal: #specialObjectsOop))! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 2/13/2005 12:28'!
specialSelector: aSmallInteger 
	^ emitter 
		fetchAddress: (MedLiteral literal: aSmallInteger * 2)
		ofObject: (self specialObject: 23)! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:44'!
stackFor: aContext at: newStackPtr put: aMed 
	emitter 
		moveFrom: aMed
		to: (emitter mem: (emitter 
						emit: (emitter 
								emit: aContext
								add: (emitter 
										emit: newStackPtr
										sal: (MedLiteral literal: 1)))
						add: (MedLiteral literal: 22)))! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 8/22/2005 19:07'!
stackHeight: anInteger with: anOrderedCollection 
self removeMe.
	^ ((1 to: anInteger) collect: [:each| self stackRegister: each]), anOrderedCollection! !

!IntermediateEmitter methodsFor: 'Emit - Low Level Moves' stamp: 'wbk 11/3/2005 19:55'!
stackPush: aMedMem to: aMedTemporaryRegister 
	currentBlock add: (self 
				basicStackPush: aMedMem
				to: aMedTemporaryRegister)! !

!IntermediateEmitter methodsFor: 'Emit - Misc' stamp: 'wbk 4/29/2004 21:04'!
stackRegister: aSmallInteger 
	^ machine stackRegister: aSmallInteger! !

!IntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 6/14/2004 18:48'!
state: anExuperyStack 
	stack := anExuperyStack! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 12/24/2005 16:46'!
storeResult: sendersContext inContext: aMed 
	| newStackPtr |
	newStackPtr := self incrementStackPtrFor: sendersContext.
	self 
		stackFor: sendersContext
		at: newStackPtr
		put: aMed! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 1/14/2006 22:15'!
temporaryAddress: anInteger
	^ emitter mem: (emitter 
				emit: emitter homeContext
				add: (MedLiteral literal: 4 * (7 + anInteger)))! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:59'!
trueAddress
	^ MedMem address: (MedLiteral literal: #trueObj)! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 6/16/2005 20:44'!
typeSwitchOn: aByteSymbol ifType:  aByteSymbol2 code: aMedPrimitive failureCode: aMedSend failureBlock: anObject
0 removeMe.
	^ MedTypeSwitch 
		switchOn: aByteSymbol 
		ifType: aByteSymbol2 
		code: aMedPrimitive 
		failureCode: aMedSend 
		failureBlock: anObject 

! !

!IntermediateEmitter methodsFor: 'Emit - Sends and Return' stamp: 'wbk 6/16/2005 20:44'!
typeSwitchOn: aByteSymbol variables: someVariables ifType:  aByteSymbol2 code: aMedPrimitive failureCode: aMedSend failureBlock: anObject
	^ MedTypeSwitch 
		switchOn: aByteSymbol 
		variables: someVariables
		ifType: aByteSymbol2 
		code: aMedPrimitive 
		failureCode: aMedSend 
		failureBlock: anObject 

! !

!IntermediateEmitter methodsFor: 'Unit Testing' stamp: 'wbk 8/17/2003 18:30'!
verify
	" Currently just a stub. The mock contains tests to make sure that the test succeeded here.
	It might be a good idea to have some basic verification tests on the real objects but this
	isn't done yet."! !

!IntermediateEmitter methodsFor: 'Emit - Control Flow' stamp: 'wbk 6/3/2005 17:34'!
withFailTo: aBlock failureSpecialSelector: aNumber arguments: someObjects 
	| overflowBlock argumentRegisters |
	overflowBlock := emitter newBlock.
	argumentRegisters := someObjects collect: [:each | machine createTemporaryRegister].
	^emitter 
		labelArguments: someObjects
		registers: argumentRegisters
		around: (aBlock 
				value: argumentRegisters
				value: overflowBlock)
		failingTo: (emitter 
				sendSelector: (emitter specialSelector: aNumber)
				arguments: argumentRegisters
				selectorName: nil)
		failureBlock: overflowBlock! !

!IntermediateEmitter methodsFor: 'Emit - Memory Access' stamp: 'wbk 2/13/2005 12:30'!
youngStartAddress
	^ MedLiteral literal: #youngStart! !

Object subclass: #IntermediateGenerator
	instanceVariableNames: 'emitter receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!IntermediateGenerator class methodsFor: 'instance creation' stamp: 'wbk 5/30/2004 18:22'!
for: aMachine
	^ self 
		for: aMachine
		jumpTargets: #()
		stackHeights: #()! !

!IntermediateGenerator class methodsFor: 'instance creation' stamp: 'wbk 11/6/2005 18:52'!
for: aMachine jumpTargets: aCollection inlining: anObject receiver: aClass 
	^self new 
		initializeMachine: aMachine
		jumpTargets: aCollection
		inlining: anObject
		receiver: aClass! !

!IntermediateGenerator class methodsFor: 'instance creation' stamp: 'wbk 11/6/2005 18:51'!
for: aMachine jumpTargets: aCollection stackHeights: heightsCollection 
	^self new 
		initializeMachine: aMachine
		jumpTargets: aCollection
		inlining: #()
		receiver: nil! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 10/23/2004 22:59'!
addExpression: aMed
	emitter addExpression: aMed! !

!IntermediateGenerator methodsFor: 'Byte Codes - Misc' stamp: 'wbk 2/1/2006 20:44'!
blockCopyArgumentCount: aLiteral context: aMedContext block: aMedBlock byteCodeAddress: anInteger
	aMedBlock makeAligned.
	^MedBlockCopy 
		arguments: aLiteral
		context: aMedContext
		block: aMedBlock
		byteCodeAddress: anInteger! !

!IntermediateGenerator methodsFor: 'Byte Codes - Jumps' stamp: 'wbk 11/26/2005 17:22'!
byteCodeAddress: anInteger ! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 4/21/2005 22:18'!
createContext
	| answer |
	answer := MedCreateContext new.
	self addExpression: answer.
	^ answer! !

!IntermediateGenerator methodsFor: 'Unit Testing' stamp: 'wbk 10/14/2002 13:08'!
currentBlock
	^ emitter currentBlock! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 10/14/2002 13:37'!
emitter
	^ emitter! !

!IntermediateGenerator methodsFor: 'Unit Testing' stamp: 'wbk 10/14/2002 13:56'!
emitter: anEmitter
	emitter := anEmitter.! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/13/2005 12:53'!
emitWithIntegers: aBlock arg1: aFirstObject arg2: aSecondObject failToSpecialSelector: anInteger 
	| expression |
	^ emitter 
		withFailTo: 
			[:arguments :overflowBlock | 
			expression _ aBlock 
						value: (emitter 
								integerValueOf: arguments first
								failTo: overflowBlock)
						value: (emitter 
								integerValueOf: arguments second
								failTo: overflowBlock)
						value: overflowBlock.
			emitter 
				convertToSmallInteger: expression
				failTo: overflowBlock]
		failureSpecialSelector: anInteger
		arguments: ({ 
				aFirstObject.
				aSecondObject})! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 10/25/2005 20:19'!
finish
	"emitter createProlog"
	(self result blockAt: 1) initialStackHeight: 0! !

!IntermediateGenerator methodsFor: 'Byte Codes - Sends' stamp: 'wbk 6/3/2005 17:34'!
generateBinarySelector: anObject receiver: receiverMed argument: argumentMed 
	^emitter 
		sendSelector: (emitter specialSelector: anObject)
		arguments: { receiverMed. argumentMed }
		selectorName: nil! !

!IntermediateGenerator methodsFor: 'Byte Codes - Sends' stamp: 'wbk 2/13/2005 12:27'!
generateClass: aMedLiteral 
	^ emitter classOf: aMedLiteral! !

!IntermediateGenerator methodsFor: 'Byte Codes - Sends' stamp: 'wbk 6/3/2005 17:34'!
generateUnarySelector: aSmallInteger receiver: aMedMem 
	^emitter 
		sendSelector: (emitter specialSelector: aSmallInteger)
		arguments: { aMedMem }
		selectorName: nil! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/8/2004 16:17'!
generate: aFirstObject add: aSecondObject 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				add: arg2]
		arg1: aFirstObject
		arg2: aSecondObject
		failToSpecialSelector: 0! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/8/2004 16:17'!
generate: firstMed bitAnd: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				and: arg2]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 14! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/5/2004 20:49'!
generate: aFirstObject bitOr: aSecondObject 
	^ self
		emitWithIntegers:
			[:arg1 :arg2 :overflowBlock| emitter
				emit: arg1
				or: arg2]
		arg1: aFirstObject
		arg2: aSecondObject
		failToSpecialSelector: 15
! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/9/2004 21:44'!
generate: firstMed bitShift: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				bitShift: arg2
				failingTo: overflowBlock]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 12! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 12/22/2004 21:46'!
generate: firstMed divide: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				divide: arg2
				failingTo: overflowBlock]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 9! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 12/22/2004 21:45'!
generate: firstMed div: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				div: arg2
				failingTo: overflowBlock]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 13! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/13/2005 12:20'!
generate: aMedLiteral equivilent: aMedLiteral2 
	^ emitter 
		convertComparisionToBoolean: (emitter 
				emit: aMedLiteral
				minus: aMedLiteral2)
		jumpType: #jne! !

!IntermediateGenerator methodsFor: 'Byte Codes - Sends' stamp: 'wbk 6/3/2005 17:34'!
generate: aMedLiteral makePoint: aMedLiteral2 
	^emitter 
		sendSelector: (emitter specialSelector: 11)
		arguments: { aMedLiteral. aMedLiteral2 }
		selectorName: nil! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 12/22/2004 21:47'!
generate: firstMed mod: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				mod: arg2
				failingTo: overflowBlock]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 10! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 3/27/2005 23:01'!
generate: firstMed multiply: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				multiply: arg2
				failingTo: overflowBlock]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 8! !

!IntermediateGenerator methodsFor: 'Byte Codes - Arithmatic' stamp: 'wbk 2/8/2004 16:20'!
generate: firstMed subtract: secondMed 
	^self 
		emitWithIntegers: 
			[:arg1 :arg2 :overflowBlock | 
			emitter 
				emit: arg1
				minus: arg2]
		arg1: firstMed
		arg2: secondMed
		failToSpecialSelector: 1! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 11/27/2005 20:44'!
initializeMachine: aMachine jumpTargets: aCollection inlining: anObject receiver: aClass 
	emitter := IntermediateEmitter 
				machine: aMachine
				jumpTargets: aCollection
				inlining: anObject.
	receiver := aClass.
	^self! !

!IntermediateGenerator methodsFor: 'Helper Methods' stamp: 'wbk 2/13/2005 12:58'!
instanceVariableAddress: aSmallInteger 
	^ emitter 
		fetchAddress: (MedLiteral literal: aSmallInteger)
		ofObject: emitter receiverAddress! !

!IntermediateGenerator methodsFor: 'Unit Testing' stamp: 'wbk 8/8/2004 13:15'!
intermediateString
	^ emitter result intermediateForm! !

!IntermediateGenerator methodsFor: 'Byte Codes - Jumps' stamp: 'wbk 2/13/2005 12:48'!
jumpIfFalse: aMed to: anInteger 
	emitter materialiseStack.
	emitter 
		jumpIfFalseTo: (emitter labelForByteCode: anInteger)
		onBoolean: aMed! !

!IntermediateGenerator methodsFor: 'Byte Codes - Jumps' stamp: 'wbk 2/13/2005 12:48'!
jumpIfTrue: aMed to: anInteger 
	emitter materialiseStack.
	emitter 
		jumpIfTrueTo: (emitter labelForByteCode: anInteger)
		onBoolean: aMed! !

!IntermediateGenerator methodsFor: 'Unit Testing' stamp: 'wbk 11/27/2005 22:08'!
jumpTargets
	^ emitter jumpTargets! !

!IntermediateGenerator methodsFor: 'Byte Codes - Jumps' stamp: 'wbk 2/13/2005 12:47'!
jumpTo: anInteger 
	emitter materialiseStack.
	emitter jumpTo: (emitter labelForByteCode: anInteger)! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 10/14/2002 14:04'!
machine
	^ emitter machine! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 10/5/2005 22:38'!
needsLargeContext: anInteger
	 emitter needsLargeContext: anInteger.! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 3/13/2005 20:43'!
numberOfArguments: aSmallInteger 
	emitter numberOfArguments: aSmallInteger! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 7/4/2003 12:32'!
numberOfTemporaries: anInteger 
	emitter numberOfTemporaries: anInteger! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 2/13/2005 12:29'!
popIntoTemp: aMed slot: anInteger 
	^ emitter 
		popIntoTemp: aMed
		slot: anInteger! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 12/19/2004 14:46'!
popStack: aMed
	emitter addExpression: aMed

! !

!IntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 11/6/2005 19:04'!
primitiveAt
	| methodBody |
	methodBody := emitter newBlock.
	methodBody initialStackHeight: 0.
	emitter 
		primitiveReturn: (emitter 
				primitive: #at:
				arguments: {
						(emitter primitiveArgument: 1).
						(emitter primitiveArgument: 0)
					}
				failureBlock: methodBody
				receiver: receiver)
		popping: 2
		receiver: receiver.
	emitter currentBlock: methodBody! !

!IntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 11/6/2005 19:24'!
primitiveAtPut
	| methodBody |
	methodBody := emitter newBlock.
	methodBody initialStackHeight: 0.
	emitter 
		primitiveReturn: (emitter 
				primitive: #at:put:
				arguments: {
						(emitter primitiveArgument: 2).
						(emitter primitiveArgument: 1).
						(emitter primitiveArgument: 0)
					}
				failureBlock: methodBody
				receiver: receiver)
		popping: 3
		receiver: receiver.
	emitter currentBlock: methodBody! !

!IntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 5/22/2005 14:36'!
primitive: receiver at: index put: value failTo: methodBytecodes 
	emitter moveFrom: value
		to: (emitter 
				addressOfIndexedElementIn: receiver
				at: index
				failTo: methodBytecodes).
	emitter beRoot: receiver ifNeededBy: value.
	^ value! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 2/13/2005 12:49'!
prim: firstMed equals: secondMed 
	^ emitter 
		conditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #jne
		failureSelector: 6! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 2/13/2005 12:49'!
prim: firstMed greaterThanEqual: secondMed 
	^ emitter 
		conditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #jl
		failureSelector: 5! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 2/13/2005 12:49'!
prim: firstMed greaterThan: secondMed 
	^ emitter 
		conditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #jle
		failureSelector: 3! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 2/13/2005 12:49'!
prim: firstMed lessThanEquals: secondMed 
	^ emitter 
		conditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #jg
		failureSelector: 4! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 2/13/2005 12:49'!
prim: firstMed lessThan: secondMed 
	^ emitter 
		conditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #jge
		failureSelector: 2! !

!IntermediateGenerator methodsFor: 'Byte Codes - Comparision' stamp: 'wbk 2/13/2005 12:49'!
prim: firstMed notEquals: secondMed 
	^ emitter 
		conditionalBytecodeArg1: firstMed
		arg2: secondMed
		withJump: #je
		failureSelector: 7! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 2/13/2005 12:54'!
pushConstant: aLiteral slot: aNumber 
	aLiteral class = SmallInteger ifTrue: [^ MedLiteral smallInteger: aLiteral].
	^ emitter literalAddress: aNumber! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 8/24/2005 18:03'!
pushFalse
	^ emitter falseAddress! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 11/1/2004 22:30'!
pushInstanceVariable: aSmallInteger 
	^emitter instanceVariableAddress: aSmallInteger! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 8/22/2005 21:06'!
pushLiteralVariable: aReadOnlyVariableBinding slot: aSmallInteger 
	^ (emitter 
		fetchAddress: (MedLiteral literal: 1)
		ofObject: (emitter literalAddress: aSmallInteger))
	! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 8/24/2005 18:03'!
pushNil
	^ emitter nilAddress! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 8/22/2005 21:06'!
pushSelf
	^ emitter receiverAddress! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 8/22/2005 20:54'!
pushTempAt: anInteger 
	^ emitter temporaryAddress: anInteger! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 8/24/2005 18:03'!
pushTrue
	^  emitter trueAddress! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 8/8/2004 13:15'!
result
	^ emitter result! !

!IntermediateGenerator methodsFor: 'Byte Codes - Return' stamp: 'wbk 2/13/2005 12:53'!
returnFalse
	emitter returnValue: emitter falseAddress! !

!IntermediateGenerator methodsFor: 'Byte Codes - Return' stamp: 'wbk 2/13/2005 12:54'!
returnNil
	emitter returnValue: emitter nilAddress! !

!IntermediateGenerator methodsFor: 'Byte Codes - Return' stamp: 'wbk 2/13/2005 12:58'!
returnSelf
	emitter returnValue: emitter receiverAddress! !

!IntermediateGenerator methodsFor: 'Byte Codes - Return' stamp: 'wbk 2/13/2005 12:15'!
returnTop: aMed 
	^ emitter returnValue: aMed! !

!IntermediateGenerator methodsFor: 'Byte Codes - Return' stamp: 'wbk 2/13/2005 12:59'!
returnTrue
	emitter returnValue: emitter trueAddress! !

!IntermediateGenerator methodsFor: 'Byte Codes - Sends' stamp: 'wbk 6/3/2005 17:36'!
sendAtPutTo: objectMed location: indexMed value: valueMed 
	^emitter 
		sendSelector: (emitter specialSelector: 17)
		arguments: { objectMed. indexMed. valueMed }
		selectorName: #at:put:! !

!IntermediateGenerator methodsFor: 'Byte Codes - Sends' stamp: 'wbk 6/8/2005 21:35'!
sendAtTo: aMedMem with: aMedLiteral 
	^emitter 
		sendSelector: (emitter specialSelector: 16)
		arguments: { aMedMem. aMedLiteral }
		selectorName: #at:! !

!IntermediateGenerator methodsFor: 'Byte Codes - Sends' stamp: 'wbk 6/8/2005 21:38'!
sendSelector: aSymbol inSlot: selectorInteger arguments: someArguments 
	| selector |
	selector := emitter literalAddress: selectorInteger.
	^emitter 
		sendSelector: selector
		arguments: someArguments
		selectorName: nil! !

!IntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 5/8/2005 17:07'!
setPrimitive: aSmallInteger 
	aSmallInteger = 60 ifTrue: [^ self primitiveAt].
	aSmallInteger = 61 ifTrue: [^ self primitiveAtPut].
	Error signal: 'Primitive not recognised'
	! !

!IntermediateGenerator methodsFor: 'Misc' stamp: 'wbk 7/28/2003 13:30'!
state: anExuperyStack 
	emitter state: anExuperyStack! !

!IntermediateGenerator methodsFor: 'Byte Codes - Stack' stamp: 'wbk 2/13/2005 12:29'!
storeAndPopReceiverVariableIndex: anInteger value: aMed 
	^ emitter 
		popIntoReceiver: aMed
		slot: anInteger! !

Object subclass: #JumpTargetRecorder
	instanceVariableNames: 'targets blocks stackTrace stack blockArguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 10/23/2004 22:23'!
addExpression: aJumpTargetRecorder 
! !

!JumpTargetRecorder methodsFor: 'Jumps' stamp: 'wbk 1/16/2006 21:58'!
addJumpTo: aTarget 
	targets add: aTarget.
	stackTrace add: stack stackSize! !

!JumpTargetRecorder methodsFor: 'Operation' stamp: 'wbk 6/14/2004 21:36'!
binaryOperation! !

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 1/18/2006 22:51'!
blockArguments
	^ blockArguments! !

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 2/1/2006 20:43'!
blockCopyArgumentCount: anUndefinedObject context: aMedActiveContext block: anObject byteCodeAddress: anObject1 
	blocks add: stack pc + 3.
	blockArguments add: (anUndefinedObject literal - 1) / 2! !

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 11/27/2005 21:59'!
blockForBytecode: aSmallInteger 
! !

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 11/26/2005 15:54'!
blocks
	^ blocks! !

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 6/14/2004 21:37'!
byteCodeAddress: anInteger 
	(targets includes: anInteger) ifTrue: 
			[stack heightTo: (stackTrace at: (targets indexOf: anInteger))]! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:22'!
bytecodePrimSendNewWithArg: anOrderedCollection receiver: aRecordJumpTargets size: aNumber
	self sendSize: aNumber
	! !

!JumpTargetRecorder methodsFor: 'Blocks' stamp: 'wbk 1/20/2006 21:35'!
createBlockContextWithArguments: aMedLiteral 
	! !

!JumpTargetRecorder methodsFor: 'Operation' stamp: 'wbk 4/21/2005 21:03'!
createContext
! !

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 4/26/2004 22:54'!
emitter
	^ self! !

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 7/6/2003 20:17'!
finish
! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 6/6/2004 17:10'!
generateBinarySelector: anObject receiver: aRecordJumpTargets argument: aNumber 
	self sendSize: 2
	! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:22'!
generateClass: aJumpTargetRecorder 
	self sendSize: 1
! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:23'!
generateNew: aRecordJumpTargets 

	self sendSize: 1
! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:23'!
generateUnarySelector: aSmallInteger receiver: aRecordJumpTargets 
	self sendSize: 1
! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:18'!
generate: firstMed add: secondMed 
	self binaryOperation.
	! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:18'!
generate: aRecordJumpTargets bitAnd: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:18'!
generate: aRecordJumpTargets bitOr: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aRecordJumpTargets bitShift: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aRecordJumpTargets divide: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aRecordJumpTargets div: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aJumpTargetRecorder equivilent: aJumpTargetRecorder2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aRecordJumpTargets makePoint: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: aRecordJumpTargets mod: aRecordJumpTargets2 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: firstMed multiply: secondMed 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Arithmatic' stamp: 'wbk 5/29/2004 22:19'!
generate: firstMed subtract: secondMed 
	self binaryOperation.! !

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 1/18/2006 22:06'!
initialize
	targets := OrderedCollection new.
	blocks := OrderedCollection new.
	blockArguments := OrderedCollection new.
	stackTrace := OrderedCollection new.! !

!JumpTargetRecorder methodsFor: 'Jumps' stamp: 'wbk 6/14/2004 21:37'!
jumpIfFalse: aBoolean to: aTarget 
	self addJumpTo: aTarget! !

!JumpTargetRecorder methodsFor: 'Jumps' stamp: 'wbk 6/14/2004 21:37'!
jumpIfTrue: aRecordJumpTargets to: aTarget 
	self addJumpTo: aTarget! !

!JumpTargetRecorder methodsFor: 'Jumps' stamp: 'wbk 1/20/2006 21:34'!
jumpTarget: aSmallInteger 
	! !

!JumpTargetRecorder methodsFor: 'Jumps' stamp: 'wbk 2/13/2005 12:46'!
jumpTo: aTarget 
	self addJumpTo: aTarget! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 1/20/2006 21:34'!
materialiseStack
	! !

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 2/13/2005 12:44'!
moveFrom: aJumpTargetRecorder to: anUndefinedObject 
	! !

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 10/5/2005 22:55'!
needsLargeContext: aTrue 
! !

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 3/13/2005 20:22'!
numberOfArguments: aSmallInteger 
! !

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 7/4/2003 12:28'!
numberOfTemporaries: aSmallInteger 
	! !

!JumpTargetRecorder methodsFor: 'Operation' stamp: 'wbk 6/14/2004 21:37'!
pop! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:19'!
popIntoTemp: aMed slot: anInteger
	self pop! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:20'!
popStack: aRecordJumpTargets 
	self pop! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed equals: secondMed		
	self binaryOperation! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed greaterThanEqual: secondMed	
	self binaryOperation
! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed greaterThan: secondMed	
	self binaryOperation
	! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed lessThanEquals: secondMed 	
	self binaryOperation
	! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed lessThan: secondMed
		
	self binaryOperation! !

!JumpTargetRecorder methodsFor: 'Comparision' stamp: 'wbk 5/29/2004 23:45'!
prim: firstMed notEquals: secondMed	
	self binaryOperation
! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 1/18/2006 22:47'!
pushConstant: aLiteral slot: aNumber
	aLiteral class = SmallInteger ifTrue: [^ MedLiteral smallInteger: aLiteral].! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 1/18/2006 23:08'!
pushFalse! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 1/18/2006 23:09'!
pushInstanceVariable: aSmallInteger ! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 1/18/2006 23:09'!
pushLiteralVariable: aReadOnlyVariableBinding slot: aSmallInteger ! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 1/18/2006 23:08'!
pushNil! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 1/18/2006 23:08'!
pushSelf! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 1/18/2006 23:08'!
pushTempAt: anInteger! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 1/18/2006 23:08'!
pushTrue! !

!JumpTargetRecorder methodsFor: 'Operation' stamp: 'wbk 6/14/2004 21:38'!
return! !

!JumpTargetRecorder methodsFor: 'Return' stamp: 'wbk 5/29/2004 23:50'!
returnFalse
	self return
	! !

!JumpTargetRecorder methodsFor: 'Return' stamp: 'wbk 5/29/2004 23:50'!
returnNil
	
	self return! !

!JumpTargetRecorder methodsFor: 'Return' stamp: 'wbk 5/29/2004 23:50'!
returnSelf
	self return
! !

!JumpTargetRecorder methodsFor: 'Return' stamp: 'wbk 5/29/2004 23:50'!
returnTop: aMed
	self return! !

!JumpTargetRecorder methodsFor: 'Return' stamp: 'wbk 5/29/2004 23:50'!
returnTrue
	self return
	! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:23'!
sendAtPutTo: aRecordJumpTargets location: aRecordJumpTargets2 value: aRecordJumpTargets22 
	self sendSize: 3
! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:24'!
sendAtTo: aRecordJumpTargets with: aRecordJumpTargets2  
	self sendSize: 2
! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 7/6/2003 17:34'!
sendRentryWithStack: anOrderedCollection atPC: aSmallInteger 
	! !

!JumpTargetRecorder methodsFor: 'Sends' stamp: 'wbk 5/29/2004 22:25'!
sendSelector: aSymbol inSlot: aSmallInteger arguments: anObject 
	self sendSize: anObject size
	! !

!JumpTargetRecorder methodsFor: 'Operation' stamp: 'wbk 6/14/2004 21:38'!
sendSize: aSmallInteger ! !

!JumpTargetRecorder methodsFor: 'Blocks' stamp: 'wbk 1/21/2006 14:50'!
setInitialStackHeight: aSmallInteger 
! !

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 4/20/2005 21:50'!
setPrimitive: aSmallInteger 
! !

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 4/26/2004 22:55'!
stackRegister: aSmallInteger 
	^ nil! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 5/29/2004 22:02'!
stackTrace
	^ stackTrace! !

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 6/14/2004 21:09'!
state: anExuperyStack 
 	stack := anExuperyStack
	! !

!JumpTargetRecorder methodsFor: 'Stack' stamp: 'wbk 12/5/2004 23:16'!
storeAndPopReceiverVariableIndex: aSmallInteger value: aSymbol 
	self pop.! !

!JumpTargetRecorder methodsFor: 'Misc' stamp: 'wbk 10/15/2002 14:05'!
targets
	^ targets! !

Object subclass: #Lattice
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!Lattice class methodsFor: 'instance creation' stamp: 'wbk 10/21/2002 21:39'!
new
	^ super new initializeValue: (Set new)! !

!Lattice class methodsFor: 'instance creation' stamp: 'wbk 10/21/2002 21:34'!
value: aSet
	^ super new initializeValue: aSet! !

!Lattice class methodsFor: 'instance creation' stamp: 'wbk 10/21/2002 19:57'!
with: firstRegister
	^ super new initializeValue: (Set with: firstRegister)! !

!Lattice class methodsFor: 'instance creation' stamp: 'wbk 10/21/2002 19:55'!
with: firstRegister with: secondRegister
	^ super new initializeValue: (Set
			with: firstRegister
			with: secondRegister)! !

!Lattice class methodsFor: 'as yet unclassified' stamp: 'wbk 1/29/2004 21:00'!
with: anUndefinedObject with: anUndefinedObject2 with: aMedTemporaryRegister 
	^ (Lattice
		with: anUndefinedObject
		with: anUndefinedObject2) +
		(Lattice with: aMedTemporaryRegister)! !

!Lattice methodsFor: 'misc' stamp: 'wbk 10/23/2002 14:10'!
do: aBlock
	value do: aBlock! !

!Lattice methodsFor: 'Unit Testing' stamp: 'wbk 11/1/2002 19:54'!
includesAllOf: anArray
	|registerNames|
	registerNames := value collect: [:each| each name].
	anArray do: [:each| (registerNames includes: each) ifFalse: [^ false]].
	^ true! !

!Lattice methodsFor: 'misc' stamp: 'wbk 10/21/2002 19:56'!
initializeValue: aSet
	value := aSet.
	^ self! !

!Lattice methodsFor: 'as yet unclassified' stamp: 'wbk 6/24/2003 10:35'!
isEmpty
	^ value isEmpty! !

!Lattice methodsFor: 'Unit Testing' stamp: 'wbk 10/21/2002 21:31'!
matchesArray: anArray
	|registerNames|
	anArray size = value size ifFalse: [^ false].
	registerNames := value collect: [:each| each name].
	anArray do: [:each| (registerNames includes: each) ifFalse: [^ false]].
	^ true! !

!Lattice methodsFor: 'misc' stamp: 'wbk 10/23/2002 14:29'!
register
	value size ~= 1 ifTrue: [Error signal].
	value do: [:each| ^ each].
	! !

!Lattice methodsFor: 'misc' stamp: 'wbk 10/24/2002 19:05'!
size
	^ value size! !

!Lattice methodsFor: 'misc' stamp: 'wbk 10/21/2002 21:40'!
value
	^ value! !

!Lattice methodsFor: 'Operations' stamp: 'wbk 3/17/2003 18:14'!
+ aLattice
	| newSet |
	newSet := value copy.
	newSet addAll: aLattice value.
	^ self class value: newSet! !

!Lattice methodsFor: 'Operations' stamp: 'wbk 3/17/2003 18:14'!
- aLattice
	| newSet |
	newSet := value copy.
	newSet addAll: aLattice value. "Add the values so that removing them will not cause an error"
	newSet removeAll: aLattice value.
	^ self class value: newSet! !

Object subclass: #LivenessAnalyser
	instanceVariableNames: 'source hasUpdated isValidating'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!LivenessAnalyser class methodsFor: 'instance creation' stamp: 'wbk 8/17/2005 22:38'!
on: aMethod
	| analyser |
self removeMe.
	analyser := self new initializeOn: aMethod.
	analyser run.
	^ analyser! !

!LivenessAnalyser class methodsFor: 'instance creation' stamp: 'wbk 8/17/2005 22:38'!
on: aMethod isValidating: aBoolean
	| analyser |
	analyser := self new 
		initializeOn: aMethod
         	isValidating: aBoolean.
	analyser run.
	^ analyser! !

!LivenessAnalyser methodsFor: 'Analysis' stamp: 'wbk 11/3/2002 20:31'!
analyse
	| origional updated |
	hasUpdated := true.
	[hasUpdated] whileTrue:
		[hasUpdated := false.
		source blocksDo: 
			[:eachBlock| eachBlock numberOfExpressions
				to: 1
				by: -1
				do: 
					[:each| each ~= eachBlock numberOfExpressions ifTrue:
						[origional := (eachBlock expressionAt: each) out.
						updated := (eachBlock expressionAt: each + 1) in.
						(eachBlock expressionAt: each) setOut: updated.
						updated size > origional size ifTrue: [hasUpdated := true]].
					(eachBlock expressionAt: each) visitWith: self]]].! !

!LivenessAnalyser methodsFor: 'Misc' stamp: 'wbk 10/21/2002 19:52'!
initializeGraph
	source instructionsDo:
		[:each| each setIn: Lattice new.
		each setOut: Lattice new].! !

!LivenessAnalyser methodsFor: 'Misc' stamp: 'wbk 10/20/2002 22:38'!
initializeOn: aMethod
	source := aMethod.
	^ self! !

!LivenessAnalyser methodsFor: 'Misc' stamp: 'wbk 8/17/2005 22:38'!
initializeOn: aMethod isValidating: aBoolean
	source := aMethod.
	isValidating := aBoolean.
	^ self! !

!LivenessAnalyser methodsFor: 'Unit Testing' stamp: 'wbk 10/22/2002 14:04'!
isLive: anArray at: anInteger
	^ (source 
		blockAt: 1
		instructionAt: anInteger) in matchesArray: anArray! !

!LivenessAnalyser methodsFor: 'Unit Testing' stamp: 'wbk 10/24/2002 22:27'!
isLive: anArray block: blockInteger at: anInteger
	^ (source 
		blockAt: blockInteger
		instructionAt: anInteger) in matchesArray: anArray! !

!LivenessAnalyser methodsFor: 'Analysis' stamp: 'wbk 8/17/2005 22:40'!
run
	self initializeGraph.
	self analyse.
	isValidating ifTrue:
		[source entryPointBlocksDo: [:each| each checkVariablesDeadAtEntryPoint]]
	! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 4/11/2003 11:05'!
visitAssembly: anAssembly
	|newLattice|
	newLattice := (anAssembly registersUsed + (
		anAssembly out - anAssembly registersDefined)).
	newLattice value size ~= anAssembly in value size ifTrue: [hasUpdated := true].
	anAssembly setIn: newLattice! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 7/5/2003 15:12'!
visitCall: aMedCall 
	"It might be nessisary to do something more with calls. They could kill registers, I'm not sure"
	self visitAssembly: aMedCall! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 3/26/2005 21:07'!
visitComparision: aMedComparision 
	^ self visitAssembly: aMedComparision! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 1/29/2004 20:20'!
visitDivide: aMedX86Divide 
	self visitAssembly: aMedX86Divide! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 2/4/2005 23:37'!
visitJump: aJump
	|newLattice|
	aJump target isMedBlock
		ifTrue:
			[aJump setOut: (aJump out + aJump target in).
			newLattice := aJump out.
			newLattice value size ~= aJump in value size ifTrue: [hasUpdated := true].
			aJump setIn: newLattice]
		ifFalse:
			[self visitAssembly: aJump]! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 11/4/2002 13:54'!
visitMov: anAssembly
	^ self visitAssembly: anAssembly! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 2/9/2004 20:10'!
visitNegate: aMedNegate 
	self visitAssembly: aMedNegate! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 2/25/2005 23:20'!
visitPic: aMedPic 
	self visitAssembly: aMedPic! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 3/4/2005 16:05'!
visitPop: aMedPop 
	
	^ self visitAssembly: aMedPop	! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 6/23/2003 11:47'!
visitPush: aMedPush 
	^ self visitAssembly: aMedPush	! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 3/4/2005 16:38'!
visitRet: anAssembly
	self visitAssembly: anAssembly! !

!LivenessAnalyser methodsFor: 'Analysis Visiting' stamp: 'wbk 2/1/2004 22:04'!
visitX86Cdq: aMedX86CDQ 
	self visitAssembly: aMedX86CDQ! !

Object subclass: #MachineX86
	instanceVariableNames: 'machineRegisters nextRegister registerFile spillSlots nextSpillSlot temporaryRegisters currentContext compiledMethodNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 1/29/2005 21:57'!
activeContextAddress
	<primitive: 'activeContextAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 1/7/2006 18:48'!
addressOf: aMedLiteral 
	aMedLiteral literal = #trueObj ifTrue: [^ self trueObjAddress * 2].
	aMedLiteral literal = #falseObj ifTrue: [^ self falseObjAddress * 2].
	aMedLiteral literal = #exuperySetupMessageSend ifTrue: [^ MedLiteral literal: self setupMessageSendAddress * 2].
	aMedLiteral literal = #specialObjectsOop ifTrue: [^ self specialObjectsOopAddress * 2].
	aMedLiteral literal = #atCache ifTrue: [^ self atCacheAddress * 2].
	aMedLiteral literal = #nilObj ifTrue: [^ self nilObjAddress *2].
	aMedLiteral literal = #youngStart ifTrue: [^ self youngStartAddress * 2].
	aMedLiteral literal = #rootTableCount ifTrue: [^ self rootTableCountAddress * 2].
	aMedLiteral literal = #rootTable ifTrue: [^ self rootTableAddress * 2].
	aMedLiteral literal = #activeContext ifTrue: [^ self activeContextAddress * 2].
	aMedLiteral literal = #reclaimableContextCount ifTrue: [^ self reclaimableContextCount * 2].
	aMedLiteral literal = #freeContexts ifTrue: [^ self freeContexts * 2].
	aMedLiteral literal = #exuperyCreateContext ifTrue: [^ MedLiteral literal: self exuperyCreateContext * 2].
	aMedLiteral literal = #methodArray ifTrue: [^ self methodArray *2].
	aMedLiteral literal = #createExuperyBlock ifTrue: [^ MedLiteral literal: self createExuperyBlockAddress * 2].
	aMedLiteral literal = #exuperyNonlocalReturn ifTrue: [^ MedLiteral literal: self exuperyNonlocalReturnAddress * 2].

	self error: 'Address of Unknown Literal'.! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 8/9/2003 12:11'!
atCacheAddress
	<primitive: 'atCacheAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 3/24/2005 21:37'!
compiledMethodNumber
	^ compiledMethodNumber ! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 3/24/2005 21:35'!
compiledMethodNumber: aSmallInteger 
	compiledMethodNumber := aSmallInteger! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 12/21/2005 17:10'!
createExuperyBlockAddress
	<primitive: 'createExuperyBlockAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 8/22/2005 21:35'!
createTemporaryRegister
	| name register |
	name := 't' , nextRegister asString asSymbol.
	nextRegister := nextRegister + 1.
	register := self makeTemporaryRegister: name.
	temporaryRegisters 
		at: name
		put: register.
	^register! !

!MachineX86 methodsFor: 'Intermediate Generation' stamp: 'wbk 7/24/2004 11:14'!
currentContext
	^ currentContext! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 2/18/2005 21:30'!
exuperyCreateContext
	<primitive: 'exuperyCreateContext' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 1/7/2006 19:07'!
exuperyNonlocalReturnAddress
	
	<primitive: 'nonlocalReturnAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 4/18/2003 15:51'!
falseObjAddress
	<primitive: 'falseObjAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 1/30/2005 19:20'!
freeContexts
	<primitive: 'freeContexts' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/24/2004 15:00'!
initialize
	|registerNames reg|
	machineRegisters := Dictionary new.
	registerFile := OrderedCollection new.
	temporaryRegisters := Dictionary new.
	spillSlots := Dictionary new.
	nextRegister := 1.
	nextSpillSlot := -16.
	registerNames := #(eax ebx ecx edx esi edi).
	registerNames do: [:each| 
		reg := self machineRegister: each.
		registerFile add: reg].
	currentContext := self makeTemporaryRegister: #currentContext.
	^ self! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 11/2/2002 16:14'!
isSpecialRegisterName: name 
	^ name = #ebp | (name = #esp)! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 11/1/2002 12:52'!
isSpecialRegister: aRegister 
	| name |
	name := aRegister name.
	^self isSpecialRegisterName: name! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/9/2004 00:02'!
machineRegister: aSymbol 
	^machineRegisters 
		at: aSymbol
		ifAbsentPut: 
			[self makeMachineRegister: aSymbol]! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 1/21/2005 23:36'!
machineWordIn: aSmallInteger at: aSmallInteger2 put: aSmallInteger3 
	<primitive: 'machineWordInAtPut' module: 'ExuperyPlugin'>
	TestFailure signal.! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/9/2004 20:37'!
makeMachineRegister: name 
	| register |
	register := MedMachineRegister name: name.
	^register! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/9/2004 20:37'!
makeTemporaryRegister: name 
	| register |
	register := MedTemporaryRegister name: name.
	^register! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 3/24/2005 15:01'!
methodArray
	<primitive: 'methodArrayAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 9/12/2002 16:44'!
newSpillSlot
	|answer|
	answer := nextSpillSlot.
	nextSpillSlot := nextSpillSlot -4.
	^ answer! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 12/18/2004 00:04'!
newTemporaryNamed: aSymbol
	|number register|
	register := self makeTemporaryRegister: aSymbol.
	aSymbol first = $t ifTrue:
		[number := (aSymbol copyFrom: 2 to: aSymbol size) asNumber.
		number >= nextRegister ifTrue: [nextRegister := number + 1]].
	temporaryRegisters
		at: aSymbol
		put: register.
	^ register! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 10/4/2003 21:12'!
nilObjAddress
	<primitive: 'nilObjAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Register Allocation' stamp: 'wbk 10/23/2002 17:21'!
numberOfColours
	^ 6! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 1/30/2005 19:20'!
reclaimableContextCount
	<primitive: 'reclaimableContextCount' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 6/28/2004 22:47'!
registerAt: aSmallInteger 
	machineRegisters do: [:each| each index = aSmallInteger ifTrue: [^ each]].
	temporaryRegisters do: [:each| each index = aSmallInteger ifTrue: [^ each]].
	Error signal: 'Register not found'! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 11/1/2002 12:53'!
registerNamed: aSymbol
	^ machineRegisters
		at: aSymbol
		ifAbsent:
			[
				(self isSpecialRegisterName: aSymbol) ifTrue:
					[^ self machineRegister: aSymbol].
				^ self temporaryNamed: aSymbol]! !

!MachineX86 methodsFor: 'Register Allocation' stamp: 'wbk 11/4/2002 16:07'!
reloadRegister: aReg usingMap: aDictionary into: aMedBlock
	|slot instruction |
	slot := spillSlots
		at: aReg
		ifAbsent: [^ self].
	instruction := MedMov
		from: (MedAddressingMode
			offset: slot
			base: (self machineRegister: #ebp))
		to: (aDictionary at: aReg).
	aMedBlock add: instruction! !

!MachineX86 methodsFor: 'Primitives - Memory Testing' stamp: 'wbk 11/21/2003 22:36'!
rootTableAddress
	<primitive: 'rootTableAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Primitives - Memory Testing' stamp: 'wbk 11/21/2003 22:32'!
rootTableCountAddress
	<primitive: 'rootTableCountAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Register Allocation' stamp: 'wbk 11/4/2002 16:08'!
saveRegister: aReg usingMap: aDictionary into: aMedBlock
	|instruction aNumber |
	aNumber := (self spillSlotFor: aReg).
	instruction := MedMov
		 	from: (aDictionary at: aReg)
			to: (MedAddressingMode
				offset: aNumber
				base: (self machineRegister: #ebp)).
	aMedBlock add: instruction! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 6/30/2003 18:31'!
setupMessageSendAddress
	<primitive: 'setupMessageSendAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 7/17/2003 12:44'!
specialObjectsOopAddress
	<primitive: 'specialObjectsOopAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Register Allocation' stamp: 'wbk 9/17/2002 13:34'!
spillSlotFor: aRegister
	^ spillSlots
		at: aRegister
		ifAbsentPut: [self newSpillSlot]! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 7/9/2004 00:04'!
stackRegister:  aSmallInteger 
	 | registerName register |
	registerName := (#s, aSmallInteger printString) asSymbol.
	^ temporaryRegisters
		at: registerName
		ifAbsent:
			[register := self makeTemporaryRegister: registerName.
			temporaryRegisters
				at: registerName
				put: register.
			^ register]! !

!MachineX86 methodsFor: 'Misc' stamp: 'wbk 4/29/2004 21:24'!
temporaryNamed: aSymbol
	^ temporaryRegisters
		at: aSymbol
		ifAbsent: [self newTemporaryNamed: aSymbol]! !

!MachineX86 methodsFor: 'Primitives - Code Cache' stamp: 'wbk 4/18/2003 15:51'!
trueObjAddress
	<primitive: 'trueObjAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

!MachineX86 methodsFor: 'Misc' stamp: 'WBK 8/28/2002 22:50'!
useableRegisters
	^ registerFile! !

!MachineX86 methodsFor: 'Primitives - Memory Testing' stamp: 'wbk 11/21/2003 20:01'!
youngStartAddress
	<primitive: 'youngStartAddress' module: 'ExuperyPlugin'>
	TestFailure signal! !

MachineX86 subclass: #MockExuperyPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!MockExuperyPlugin methodsFor: 'as yet unclassified' stamp: 'wbk 2/18/2005 21:08'!
addressOf: aMedLiteral 
	aMedLiteral literal = #trueObj ifTrue: [^ self trueObjAddress].
	aMedLiteral literal = #falseObj ifTrue: [^ self falseObjAddress].
	(#(exuperySetupMessageSend exuperyCreateContext) includes: aMedLiteral literal) ifTrue: [^ aMedLiteral].

	Error signal. "Unrecognised Constant"! !

!MockExuperyPlugin methodsFor: 'Misc' stamp: 'wbk 3/24/2005 21:36'!
compiledMethodNumber
	^ 0! !

!MockExuperyPlugin methodsFor: 'as yet unclassified' stamp: 'wbk 4/11/2003 16:16'!
falseObjAddress
	^ 16r41133557! !

!MockExuperyPlugin methodsFor: 'as yet unclassified' stamp: 'wbk 4/10/2003 14:21'!
trueObjAddress
	^ 16r40123456! !

Object subclass: #MedLanguage
	instanceVariableNames: 'in out'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

MedLanguage subclass: #MedActiveContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedActiveContext methodsFor: 'Unit Testing' stamp: 'wbk 11/22/2005 22:49'!
intermediateForm
	^ #(activeContext)! !

!MedActiveContext methodsFor: 'Testing' stamp: 'wbk 12/8/2005 19:26'!
isActiveContext
	^ true! !

MedLanguage subclass: #MedAddressingMode
	instanceVariableNames: 'base offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedAddressingMode class methodsFor: 'instance creation' stamp: 'wbk 9/11/2002 17:23'!
address: aSimpleMed
	^ self indirectRegister: aSimpleMed! !

!MedAddressingMode class methodsFor: 'instance creation' stamp: 'wbk 9/11/2002 13:53'!
indirectRegister: aRegister
	^ self new initializeIndirectRegister: aRegister! !

!MedAddressingMode class methodsFor: 'instance creation' stamp: 'wbk 9/12/2002 17:01'!
offset: aNumber base: aRegister
	^ self new 
		initializeOffset: aNumber
		base: aRegister! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 9/12/2002 16:59'!
address
	^ base! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 3/14/2003 14:33'!
base
	^ base! !

!MedAddressingMode methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:46'!
expressionsDo: aBlockContext ! !

!MedAddressingMode methodsFor: 'testing' stamp: 'wbk 4/11/2003 14:00'!
hasOffset
	^ offset isNil not! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 9/12/2002 17:13'!
initialize
	base := nil.! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 9/12/2002 17:02'!
initializeIndirectRegister: aRegister
	self initialize.
	base := aRegister.
	^ self! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 9/12/2002 17:02'!
initializeOffset: aNumber base: aRegister
	self initialize.
	offset := aNumber.
	base := aRegister.
	^ self! !

!MedAddressingMode methodsFor: 'Debugging' stamp: 'wbk 9/12/2002 17:13'!
intermediateForm
	|answer|
	answer := OrderedCollection new.
	offset ~= nil ifTrue: [answer add: offset].
	answer add: base intermediateForm.
	^ answer asArray! !

!MedAddressingMode methodsFor: 'testing' stamp: 'wbk 9/11/2002 23:20'!
isAddressingMode
	^ true! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 3/14/2003 14:33'!
offset
	^ offset! !

!MedAddressingMode methodsFor: 'Debugging' stamp: 'wbk 3/19/2006 22:38'!
printOn: aStream
	"Append to the argument, aStream, a sequence of characters that  
	identifies the receiver."

	aStream 
		nextPut: $(.
	offset isNil ifFalse: [aStream 
		nextPutAll: offset printString; 
		nextPut: $ ].
	base printOn: aStream.
	aStream
		nextPut: $).! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 11/1/2002 16:34'!
registersDo: aBlock
	aBlock value: base ! !

!MedAddressingMode methodsFor: 'Dataflow Analysis' stamp: 'wbk 4/11/2003 12:53'!
registersUsed
	^ Lattice with: base! !

!MedAddressingMode methodsFor: 'misc' stamp: 'wbk 10/5/2002 21:44'!
visitWith: anObject
	^ anObject visitAddressingMode: self! !

MedLanguage subclass: #MedArithmatic
	instanceVariableNames: 'operator arg1 arg2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedArithmatic class methodsFor: 'instance creation' stamp: 'wbk 3/6/2004 19:55'!
operator: aSymbol arg1: firstMed arg2: secondMed
	^ self new 
		initializeOperator: aSymbol
		arg1: firstMed
		arg2: secondMed! !

!MedArithmatic methodsFor: 'Accessing' stamp: 'WBK 8/28/2002 09:46'!
arg1
	^ arg1! !

!MedArithmatic methodsFor: 'Accessing' stamp: 'WBK 8/28/2002 09:46'!
arg2
	^ arg2! !

!MedArithmatic methodsFor: 'Misc' stamp: 'wbk 8/7/2004 22:21'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	arg1 expressionsDo: aBlockContext.
	arg2 expressionsDo: aBlockContext.! !

!MedArithmatic methodsFor: 'Initialization' stamp: 'WBK 8/27/2002 12:47'!
initializeOperator: aSymbol arg1: firstMed arg2: secondMed
	operator := aSymbol.
	arg1 := firstMed.
	arg2 := secondMed.
	^ self! !

!MedArithmatic methodsFor: 'Unit testing' stamp: 'wbk 3/6/2004 20:12'!
intermediateForm
	^ {operator. arg1 intermediateForm. arg2 intermediateForm}! !

!MedArithmatic methodsFor: 'Testing' stamp: 'wbk 11/8/2002 14:20'!
isAdd
	^ operator = #add! !

!MedArithmatic methodsFor: 'Misc' stamp: 'wbk 3/4/2005 23:52'!
isArithmatic
	^ true! !

!MedArithmatic methodsFor: 'Testing' stamp: 'wbk 4/8/2005 22:15'!
isSubtract
	^ operator = #sub! !

!MedArithmatic methodsFor: 'Accessing' stamp: 'WBK 8/28/2002 15:01'!
operator
	^ operator! !

!MedArithmatic methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedArithmatic methodsFor: 'Misc' stamp: 'wbk 10/6/2002 11:30'!
visitWith: aVisitor
	^ aVisitor visitArithmatic: self! !

MedArithmatic subclass: #MedComparision
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedComparision methodsFor: 'Register Allocation' stamp: 'wbk 3/26/2005 21:38'!
buildInterferenceWith: aColouringRegisterAllocator ! !

!MedComparision methodsFor: 'Register Allocation' stamp: 'wbk 3/28/2005 22:35'!
isRegisterRead: aRegister
	{arg1. arg2} do: [:each| each = aRegister ifTrue: [^ true]].
	{arg1. arg2} do: 
		[:each| each isAddressingMode ifTrue: 
			[each registersDo: 
				[:eachRegister| eachRegister = aRegister ifTrue: 
					[^true]]]].
	^ false! !

!MedComparision methodsFor: 'Register Allocation' stamp: 'wbk 3/28/2005 22:35'!
isRegisterWritten: aRegister
	^ false! !

!MedComparision methodsFor: 'Misc' stamp: 'wbk 3/26/2005 21:39'!
name
	^ operator! !

!MedComparision methodsFor: 'Debugging' stamp: 'wbk 3/19/2006 22:25'!
printOn: aWriteStream indentLevel: aSmallInteger 
	self 
		indentLevel: aSmallInteger
		on: aWriteStream.
	aWriteStream
		nextPut: $(;
		nextPutAll: operator;
		nextPut: $ .
	arg1 printOn: aWriteStream.
	aWriteStream nextPut: $ .
	arg2 printOn: aWriteStream.
	aWriteStream
		nextPut: $);
		cr.! !

!MedComparision methodsFor: 'Dataflow Analysis' stamp: 'wbk 3/26/2005 21:12'!
registersDefined
	^ Lattice new! !

!MedComparision methodsFor: 'Misc' stamp: 'wbk 3/26/2005 21:16'!
registersDo: aBlockContext 
	arg1 registersDo: aBlockContext.
	arg2 registersDo: aBlockContext.! !

!MedComparision methodsFor: 'Dataflow Analysis' stamp: 'wbk 3/26/2005 22:05'!
registersUsed
	^ arg1 registersUsed + arg2 registersUsed! !

!MedComparision methodsFor: 'Misc' stamp: 'wbk 3/26/2005 16:32'!
visitWith: aVisitor
	^ aVisitor visitComparision: self! !

MedLanguage subclass: #MedAssembly
	instanceVariableNames: 'name arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedAssembly class methodsFor: 'instance creation' stamp: 'wbk 11/5/2002 14:42'!
name: aSymbol arguments: aCollection
"aSymbol = #mov ifTrue: [self halt]."
	^ self new
		initializeName: aSymbol
		arguments: aCollection! !

!MedAssembly methodsFor: 'misc' stamp: 'wbk 3/17/2003 18:28'!
arg1
	^arguments first! !

!MedAssembly methodsFor: 'misc' stamp: 'wbk 3/14/2003 17:48'!
arg2
	^ arguments at: 2! !

!MedAssembly methodsFor: 'misc' stamp: 'WBK 8/28/2002 21:23'!
argumentsDo: aBlock
	arguments do: aBlock! !

!MedAssembly methodsFor: 'Register Allocation' stamp: 'wbk 1/31/2004 14:51'!
buildInterferenceWith: anAllocator
	| defined |
	(arguments at: 2) isAddressingMode ifTrue: [^ self].
	defined := self registersDefined register.
	out do: 
		[:each | anAllocator 
			addInterferenceEdge: defined 
			to: each]! !

!MedAssembly methodsFor: 'misc' stamp: 'WBK 8/27/2002 20:13'!
initializeName: aSymbol arguments: aCollection
	name := aSymbol.
	arguments := aCollection.
	^ self! !

!MedAssembly methodsFor: 'Unit Testing' stamp: 'WBK 8/28/2002 15:42'!
intermediateForm
	|args answer|
	answer := OrderedCollection with: name.
	args := arguments collect: [:each| each intermediateForm].
	answer addAll: args.
	^ answer asArray! !

!MedAssembly methodsFor: 'Testing' stamp: 'wbk 8/1/2004 14:52'!
isRegisterRead: aMedTemporaryRegister 
	arguments do: [:each| each = aMedTemporaryRegister ifTrue: [^ true]].
	arguments do: 
		[:each| each isAddressingMode ifTrue: 
			[each registersDo: 
				[:eachRegister| eachRegister = aMedTemporaryRegister ifTrue: 
					[^true]]]].
	^ false! !

!MedAssembly methodsFor: 'Testing' stamp: 'wbk 7/31/2004 11:50'!
isRegisterWritten: aMedTemporaryRegister 
	^ (arguments at: 2) = aMedTemporaryRegister! !

!MedAssembly methodsFor: 'misc' stamp: 'WBK 8/28/2002 21:22'!
name
	^ name! !

!MedAssembly methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedAssembly methodsFor: 'Debugging' stamp: 'wbk 3/19/2006 22:40'!
printOn: aWriteStream indentLevel: aSmallInteger 
	self
		indentLevel: aSmallInteger
		on: aWriteStream.
	aWriteStream 
		nextPut: $(;
		nextPutAll: name;
		nextPut: $ .
	arguments do: 
		[:each| each printOn: aWriteStream.
		each == arguments last ifFalse:
			[aWriteStream nextPut: $ ]].
	aWriteStream
		nextPut: $);
		cr.! !

!MedAssembly methodsFor: 'Dataflow Analysis' stamp: 'wbk 11/4/2002 16:00'!
registersDefined
	(arguments at: 2) isAddressingMode ifTrue: [^ Lattice new].
	^ Lattice with: (arguments at: 2)! !

!MedAssembly methodsFor: 'misc' stamp: 'wbk 11/4/2002 16:52'!
registersDo: aBlock
	arguments do: [:each| each registersDo: aBlock]! !

!MedAssembly methodsFor: 'Dataflow Analysis' stamp: 'wbk 3/17/2003 18:28'!
registersUsed
	^(arguments first) registersUsed + (arguments at: 2) registersUsed! !

!MedAssembly methodsFor: 'misc' stamp: 'wbk 10/5/2002 22:30'!
visitWith: aVisitor
	^ aVisitor visitAssembly: self! !

MedLanguage subclass: #MedAtElementAddress
	instanceVariableNames: 'object index failureBlock cacheOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedAtElementAddress class methodsFor: 'instance creation' stamp: 'wbk 12/12/2004 22:10'!
for: objectMed index: indexMed failTo: aMedBlock cacheOffset: anObject
	^ self new initialiseFor: objectMed
		index: indexMed
		failTo: aMedBlock
		cacheOffset: anObject! !

!MedAtElementAddress methodsFor: 'Misc' stamp: 'wbk 12/12/2004 22:26'!
cacheOffset
	^ cacheOffset! !

!MedAtElementAddress methodsFor: 'Misc' stamp: 'wbk 12/12/2004 22:30'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	object expressionsDo: aBlockContext.
	index expressionsDo: aBlockContext.
	failureBlock expressionsDo: aBlockContext.! !

!MedAtElementAddress methodsFor: 'Misc' stamp: 'wbk 12/12/2004 22:25'!
failureBlock
	^ failureBlock! !

!MedAtElementAddress methodsFor: 'Misc' stamp: 'wbk 12/12/2004 22:25'!
index
	^ index! !

!MedAtElementAddress methodsFor: 'Misc' stamp: 'wbk 12/12/2004 22:11'!
initialiseFor: objectMed index: indexMed failTo: aMedBlock cacheOffset: anObject
	object := objectMed.
	index := indexMed.
	failureBlock := aMedBlock.
	cacheOffset := anObject.! !

!MedAtElementAddress methodsFor: 'Unit Testing' stamp: 'wbk 12/12/2004 22:15'!
intermediateForm
	^ {#atElementAddress. object. index intermediateForm. failureBlock. cacheOffset}! !

!MedAtElementAddress methodsFor: 'Misc' stamp: 'wbk 12/12/2004 22:25'!
object
	^ object! !

!MedAtElementAddress methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedAtElementAddress methodsFor: 'Misc' stamp: 'wbk 12/12/2004 22:20'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitAtElementAddress: self! !

MedLanguage subclass: #MedAtPut
	instanceVariableNames: 'receiver index value failureBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedAtPut class methodsFor: 'instance creation' stamp: 'wbk 12/13/2004 21:00'!
receiver: receiverMed index: indexMed value: valueMed failTo: failureBlock
	^ self new 
		initialiseReceiver: receiverMed 
		index: indexMed 
		value: valueMed 
		failTo: failureBlock! !

!MedAtPut methodsFor: 'Misc' stamp: 'wbk 12/13/2004 21:31'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	receiver expressionsDo: aBlockContext.
	index expressionsDo: aBlockContext.
	value expressionsDo: aBlockContext.
	failureBlock expressionsDo: aBlockContext.! !

!MedAtPut methodsFor: 'Misc' stamp: 'wbk 12/13/2004 21:21'!
failureBlock
	^ failureBlock! !

!MedAtPut methodsFor: 'Misc' stamp: 'wbk 12/13/2004 21:21'!
index
	^ index! !

!MedAtPut methodsFor: 'Misc' stamp: 'wbk 12/13/2004 21:02'!
initialiseReceiver: receiverMed  index: indexMed value: valueMed failTo: failureBlockMed
	receiver := receiverMed.
	index := indexMed.
	value := valueMed.
	failureBlock := failureBlockMed.! !

!MedAtPut methodsFor: 'Unit Testing' stamp: 'wbk 12/13/2004 22:21'!
intermediateForm
	^ {#atPut. receiver. index. value. failureBlock blockName}! !

!MedAtPut methodsFor: 'Misc' stamp: 'wbk 12/13/2004 21:10'!
object
	^ receiver! !

!MedAtPut methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedAtPut methodsFor: 'Misc' stamp: 'wbk 12/13/2004 21:12'!
value
	^ value! !

!MedAtPut methodsFor: 'Misc' stamp: 'wbk 12/13/2004 21:07'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitAtPut: self.! !

MedLanguage subclass: #MedBitShift
	instanceVariableNames: 'firstArgument secondArgument failureBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedBitShift class methodsFor: 'instance creation' stamp: 'wbk 12/22/2004 21:43'!
new: firstMed with: secondMed failingTo: aMedBlock 
	^self new 
		initializeNew: firstMed
		shiftedBy: secondMed
		failTo: aMedBlock! !

!MedBitShift methodsFor: 'Misc' stamp: 'wbk 12/12/2004 17:00'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	firstArgument expressionsDo: aBlockContext.
	secondArgument expressionsDo: aBlockContext.
	failureBlock expressionsDo: aBlockContext.! !

!MedBitShift methodsFor: 'Misc' stamp: 'wbk 12/12/2004 16:59'!
failureBlock
	^ failureBlock! !

!MedBitShift methodsFor: 'Misc' stamp: 'wbk 12/12/2004 16:58'!
firstArgument
	^ firstArgument! !

!MedBitShift methodsFor: 'Misc' stamp: 'wbk 12/12/2004 16:38'!
initializeNew: firstMed shiftedBy: secondMed failTo: aMedBlock
	firstArgument := firstMed.
	secondArgument := secondMed.
	failureBlock := aMedBlock.! !

!MedBitShift methodsFor: 'Unit Testing' stamp: 'wbk 12/12/2004 16:40'!
intermediateForm
	^ {#bitShift. firstArgument intermediateForm. secondArgument intermediateForm. failureBlock blockName}! !

!MedBitShift methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedBitShift methodsFor: 'Misc' stamp: 'wbk 12/12/2004 16:59'!
secondArgument
	^ secondArgument! !

!MedBitShift methodsFor: 'Misc' stamp: 'wbk 12/12/2004 16:55'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitBitShift: self! !

MedBitShift subclass: #MedMidDiv
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMidDiv methodsFor: 'Misc' stamp: 'wbk 12/12/2004 17:59'!
intermediateForm
	^ {#midDiv. firstArgument intermediateForm. secondArgument intermediateForm. failureBlock blockName}! !

!MedMidDiv methodsFor: 'Misc' stamp: 'wbk 12/12/2004 18:02'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitMidDiv: self! !

MedBitShift subclass: #MedMidDivide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMidDivide methodsFor: 'Misc' stamp: 'wbk 12/12/2004 19:12'!
intermediateForm
	^ {#midDivide. firstArgument intermediateForm. secondArgument intermediateForm. failureBlock blockName}! !

!MedMidDivide methodsFor: 'Misc' stamp: 'wbk 12/12/2004 19:31'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitMidDivide: self! !

MedBitShift subclass: #MedMidMod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMidMod methodsFor: 'Unit Testing' stamp: 'wbk 12/17/2004 22:55'!
intermediateForm
	^ {#midMod. firstArgument intermediateForm. secondArgument intermediateForm. failureBlock blockName}! !

!MedMidMod methodsFor: 'Misc' stamp: 'wbk 12/17/2004 23:09'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitMidMod: self! !

MedLanguage subclass: #MedBlock
	instanceVariableNames: 'expressions blockNumber isAligned initialStackHeight isBlockElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedBlock class methodsFor: 'instance creation' stamp: 'wbk 1/14/2006 18:28'!
number: anInteger
	^ super new initializeNumber: anInteger.! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 6/3/2005 16:25'!
add: aMed
	aMed isNil ifTrue: [^ self]. "Nil means there wasn't really an instruction"
	expressions add: aMed! !

!MedBlock methodsFor: 'Unit Testing' stamp: 'wbk 10/2/2002 17:34'!
blockName
	^ 'block', blockNumber asString! !

!MedBlock methodsFor: 'Misc' stamp: 'WBK 8/27/2002 19:32'!
blockNumber
	^ blockNumber! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 10/13/2005 22:54'!
checkVariablesDeadAtEntryPoint
	expressions first in do: 
		[:each| each isMachineRegister ifFalse: 
			[Exupery log: '  ERROR Dead variable at an entry point'.
			self error: 'Variable Live at Entry Point']]! !

!MedBlock methodsFor: 'Misc' stamp: 'WBK 8/27/2002 19:31'!
do: aBlock
	^ expressions do: aBlock! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 9/15/2002 21:59'!
expressionAt: aNumber
	^ expressions at: aNumber! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:22'!
expressionsDo: aBlockContext 
	expressions do: [:each| each expressionsDo: aBlockContext].! !

!MedBlock methodsFor: 'Testing' stamp: 'wbk 1/3/2006 22:19'!
ifCreatesBlockContext: aBlockContext 
	expressions isEmpty ifTrue: [^ self].
	expressions first isCreateBlockContext ifTrue: [^ aBlockContext value].! !

!MedBlock methodsFor: 'Dataflow Analysis' stamp: 'wbk 3/17/2003 18:28'!
in
	expressions isEmpty ifTrue: [^ Lattice new].
	^ (expressions at: 1) in! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 1/3/2006 21:28'!
initializeNumber: anInteger
	blockNumber := anInteger.
	expressions := OrderedCollection new.
	isBlockElement := false.
	isAligned := false.
	^ self! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 10/25/2005 17:46'!
initialStackHeight
	^ initialStackHeight! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 10/25/2005 20:11'!
initialStackHeight: anInteger
	initialStackHeight  := anInteger! !

!MedBlock methodsFor: 'Unit Testing' stamp: 'wbk 10/21/2002 21:25'!
instructionAt: anInteger
	^ expressions at: anInteger! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:19'!
instructionsDo: aBlock 
	expressions do: aBlock! !

!MedBlock methodsFor: 'Unit Testing' stamp: 'WBK 8/27/2002 15:16'!
intermediateForm
	|expr|
	expr := OrderedCollection with: #block with: blockNumber.

     expr addAll: (expressions collect: [:each| each intermediateForm]).
	^ expr asArray ! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 1/14/2005 22:46'!
isAligned
	^ isAligned! !

!MedBlock methodsFor: 'Testing' stamp: 'wbk 1/3/2006 20:57'!
isBlockElement
	^ isBlockElement! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 4/5/2005 20:53'!
isEmpty
	^ expressions isEmpty! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 2/4/2005 20:52'!
isMedBlock
	^ true! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 1/5/2006 18:59'!
jumpsDo: aBlockContext 
	self expressionsDo: [:each| each jumpsDo: aBlockContext]! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 4/5/2005 19:58'!
lastExpression
	^ expressions last! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 1/14/2005 22:45'!
makeAligned
	isAligned := true.! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 1/3/2006 22:03'!
makeBlockElement
	isBlockElement := true! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 10/22/2002 10:52'!
numberOfExpressions
	^ expressions size! !

!MedBlock methodsFor: 'Debugging' stamp: 'wbk 3/20/2006 19:50'!
printOn: aStream
	aStream nextPut: $(.
	aStream nextPutAll: self blockName.
	aStream cr.
	expressions do: 
		[:each| each 
			printOn: aStream
			indentLevel: 1].
	aStream nextPut: $)! !

!MedBlock methodsFor: 'Misc' stamp: 'WBK 8/29/2002 17:30'!
registersDo: aBlock
	expressions do: [:each| each registersDo: aBlock]! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 4/5/2005 19:59'!
removeLast
	expressions removeLast! !

!MedBlock methodsFor: 'Debugging' stamp: 'wbk 3/20/2006 18:24'!
targetName
	^ self blockName! !

!MedBlock methodsFor: 'Misc' stamp: 'wbk 10/5/2002 23:01'!
visitWith: aVisitor
	^ aVisitor visitBlock: self.! !

MedLanguage subclass: #MedBlockCopy
	instanceVariableNames: 'argumentCount byteCodeAddress context block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedBlockCopy class methodsFor: 'instance creation' stamp: 'wbk 2/1/2006 20:42'!
arguments: aMedLiteral context: aMedActiveContext block: aMedBlock byteCodeAddress: anInteger
	^self new 
		initializeArguments: aMedLiteral
		context: aMedActiveContext
		block: aMedBlock
		byteCodeAddress: anInteger! !

!MedBlockCopy methodsFor: 'Misc' stamp: 'wbk 12/8/2005 20:02'!
argumentCount
	^ argumentCount! !

!MedBlockCopy methodsFor: 'Misc' stamp: 'wbk 12/8/2005 20:03'!
block
	^ block! !

!MedBlockCopy methodsFor: 'Misc' stamp: 'wbk 2/1/2006 21:32'!
byteCodeAddress
	^ byteCodeAddress! !

!MedBlockCopy methodsFor: 'Misc' stamp: 'wbk 12/8/2005 19:26'!
context
	^ context! !

!MedBlockCopy methodsFor: 'Misc' stamp: 'wbk 12/9/2005 20:09'!
expressionsDo: aBlockContext 
	aBlockContext value: self
	! !

!MedBlockCopy methodsFor: 'Misc' stamp: 'wbk 2/1/2006 20:38'!
initializeArguments: aMedLiteral context: aMedActiveContext block: aMedBlock byteCodeAddress: anObject 
	argumentCount := aMedLiteral.
	byteCodeAddress := anObject.
	context := aMedActiveContext.
	block := aMedBlock! !

!MedBlockCopy methodsFor: 'Unit Testing' stamp: 'wbk 2/1/2006 20:35'!
intermediateForm
	^ {#blockCopy. argumentCount literal. byteCodeAddress. context intermediateForm. block blockName}! !

!MedBlockCopy methodsFor: 'Visiting' stamp: 'wbk 12/8/2005 19:23'!
visitWith: aTreeOptimiser 
	^ aTreeOptimiser visitBlockCopy: self! !

MedLanguage subclass: #MedBlockReturn
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedBlockReturn class methodsFor: 'instance creation' stamp: 'wbk 11/22/2005 22:40'!
value: aMed
	^ self new initializeValue: aMed! !

!MedBlockReturn methodsFor: 'Unit Testing' stamp: 'wbk 12/9/2005 20:58'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	value expressionsDo: aBlockContext.! !

!MedBlockReturn methodsFor: 'Misc' stamp: 'wbk 11/22/2005 22:39'!
initializeValue: aMed
	value := aMed! !

!MedBlockReturn methodsFor: 'Unit Testing' stamp: 'wbk 11/22/2005 22:52'!
intermediateForm
	^ {#blockReturn. value intermediateForm}! !

!MedBlockReturn methodsFor: 'Misc' stamp: 'wbk 12/8/2005 23:00'!
value
	^ value! !

!MedBlockReturn methodsFor: 'Misc' stamp: 'wbk 12/8/2005 22:58'!
visitWith: aTreeOptimiser 
	^ aTreeOptimiser visitBlockReturn: self.! !

MedLanguage subclass: #MedCall
	instanceVariableNames: 'function eax'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedCall class methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2005 22:36'!
function: aSymbol machine: anObject 
	^ self new 
		initializeFunction: aSymbol	"Really an address"
		machine: anObject! !

!MedCall methodsFor: 'Register Allocation' stamp: 'wbk 1/11/2006 20:06'!
buildInterferenceWith: anAllocator 
	out do:
		[:each| anAllocator
			addInterferenceEdge: (anAllocator registerNamed: #eax)
			to: each.anAllocator.
		anAllocator
			addInterferenceEdge: (anAllocator registerNamed: #ecx)
			to: each.
		anAllocator
			addInterferenceEdge: (anAllocator registerNamed: #edx)
			to: each].
! !

!MedCall methodsFor: 'Misc' stamp: 'wbk 8/7/2004 23:04'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	function expressionsDo: aBlockContext.! !

!MedCall methodsFor: 'Misc' stamp: 'wbk 6/21/2003 17:18'!
function
	^ function
! !

!MedCall methodsFor: 'Misc' stamp: 'wbk 2/9/2005 22:37'!
initializeFunction: aSymbol machine: aMachine
	function := aSymbol.
	eax := aMachine registerNamed: #eax.
	^ self! !

!MedCall methodsFor: 'Misc' stamp: 'wbk 6/21/2003 17:24'!
intermediateForm
	^ {#call. function intermediateForm}! !

!MedCall methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedCall methodsFor: 'Debugging' stamp: 'wbk 3/19/2006 22:22'!
printOn: aWriteStream indentLevel: aSmallInteger 
	self 
		indentLevel: aSmallInteger
		on: aWriteStream.
	aWriteStream nextPutAll: '(call '.
	function printOn: aWriteStream.
	aWriteStream
		nextPut: $);
		cr.! !

!MedCall methodsFor: 'Dataflow Analysis' stamp: 'wbk 2/9/2005 22:43'!
registersDefined
	^ Lattice with: eax! !

!MedCall methodsFor: 'Misc' stamp: 'wbk 6/24/2003 11:35'!
registersDo: aBlockContext 
	function registersDo: aBlockContext! !

!MedCall methodsFor: 'Dataflow Analysis' stamp: 'wbk 7/5/2003 15:12'!
registersUsed
	^ function registersUsed! !

!MedCall methodsFor: 'Misc' stamp: 'wbk 6/21/2003 23:15'!
visitWith: aVisitor 
	^aVisitor visitCall: self! !

MedLanguage subclass: #MedConvertBoolean
	instanceVariableNames: 'jumpType expression'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedConvertBoolean class methodsFor: 'instance creation' stamp: 'wbk 8/30/2004 16:49'!
jumpType: aSymbol expression: aMedLiteral 
	^ self new
		initialiseJumpType: aSymbol
		expression: aMedLiteral! !

!MedConvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/30/2004 17:19'!
expression
	^ expression! !

!MedConvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:56'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	expression expressionsDo: aBlockContext.! !

!MedConvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:50'!
initialiseJumpType: aSymbol expression: aMedLiteral 
	jumpType := aSymbol.
	expression := aMedLiteral.! !

!MedConvertBoolean methodsFor: 'Unit Testing' stamp: 'wbk 8/30/2004 18:28'!
intermediateForm
	^ {#convertBoolean. jumpType. expression intermediateForm}.! !

!MedConvertBoolean methodsFor: 'Testing' stamp: 'wbk 12/24/2004 15:18'!
isConvertBoolean
	^ true! !

!MedConvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/30/2004 17:20'!
jumpType
	^ jumpType! !

!MedConvertBoolean methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedConvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/30/2004 17:32'!
visitWith: aMedSimplifier 
	^ aMedSimplifier visitConvertBoolean: self.! !

MedLanguage subclass: #MedCreateBlock
	instanceVariableNames: 'argumentCount byteCodeAddress block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedCreateBlock class methodsFor: 'instance creation' stamp: 'wbk 2/1/2006 21:31'!
argumentCount: aMedLiteral block: aMedBlock byteCodeAddress: anInteger
	^self new 
		initializeArgumentCount: aMedLiteral
		block: aMedBlock
		byteCodeAddress: anInteger! !

!MedCreateBlock methodsFor: 'Misc' stamp: 'wbk 12/21/2005 16:12'!
argumentCount
	^ argumentCount! !

!MedCreateBlock methodsFor: 'Misc' stamp: 'wbk 12/21/2005 16:12'!
block
	^ block! !

!MedCreateBlock methodsFor: 'Misc' stamp: 'wbk 2/1/2006 22:50'!
byteCodeAddress
	^ byteCodeAddress! !

!MedCreateBlock methodsFor: 'Unit Testing' stamp: 'wbk 12/9/2005 20:10'!
expressionsDo: aBlockContext 
 	aBlockContext value: self! !

!MedCreateBlock methodsFor: 'Misc' stamp: 'wbk 2/1/2006 21:30'!
initializeArgumentCount: aMedLiteral block: aMedBlock byteCodeAddress: anInteger
	argumentCount := aMedLiteral.
	block := aMedBlock.
	byteCodeAddress := anInteger! !

!MedCreateBlock methodsFor: 'Unit Testing' stamp: 'wbk 2/1/2006 21:19'!
intermediateForm
	^ {#createBlock. argumentCount intermediateForm. byteCodeAddress. block blockName}! !

!MedCreateBlock methodsFor: 'Misc' stamp: 'wbk 12/21/2005 16:24'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitCreateBlock: self! !

MedLanguage subclass: #MedCreateBlockContext
	instanceVariableNames: 'argumentCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedCreateBlockContext class methodsFor: 'instance creation' stamp: 'wbk 1/18/2006 23:03'!
arguments: aSmallInteger 
	^ self new initializeArguments: aSmallInteger ! !

!MedCreateBlockContext methodsFor: 'Misc' stamp: 'wbk 1/19/2006 20:32'!
argumentCount
	^ argumentCount! !

!MedCreateBlockContext methodsFor: 'Misc' stamp: 'wbk 12/21/2005 13:51'!
expressionsDo: aBlockContext ! !

!MedCreateBlockContext methodsFor: 'Misc' stamp: 'wbk 1/18/2006 23:04'!
initializeArguments: aSmallInteger 
	argumentCount := aSmallInteger! !

!MedCreateBlockContext methodsFor: 'Unit Testing' stamp: 'wbk 1/18/2006 23:05'!
intermediateForm
	^ {#createBlockContext. argumentCount}! !

!MedCreateBlockContext methodsFor: 'Testing' stamp: 'wbk 1/3/2006 22:03'!
isCreateBlockContext
	^ true! !

!MedCreateBlockContext methodsFor: 'Misc' stamp: 'wbk 12/24/2005 17:21'!
visitWith: aTreeOptimiser 
	^ aTreeOptimiser visitCreateBlockContext: self! !

MedLanguage subclass: #MedCreateContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedCreateContext methodsFor: 'Misc' stamp: 'wbk 4/22/2005 20:22'!
expressionsDo: aBlock
	aBlock value: self
	! !

!MedCreateContext methodsFor: 'Unit Testing' stamp: 'wbk 4/21/2005 22:19'!
intermediateForm
	^ #(createContext)! !

!MedCreateContext methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedCreateContext methodsFor: 'Visiting' stamp: 'wbk 4/22/2005 20:30'!
visitWith: aTreeOptimiser 
	^ aTreeOptimiser visitCreateContext: self.! !

MedLanguage subclass: #MedDeconvertBoolean
	instanceVariableNames: 'target boolean desiredBoolean pc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedDeconvertBoolean class methodsFor: 'as yet unclassified' stamp: 'wbk 10/25/2005 22:48'!
jumpTo: aMedBlock if: aMedLiteral is: aSymbol pc: pcInteger 
	^self new 
		initialiseJumpTo: aMedBlock
		if: aMedLiteral
		is: aSymbol
		pc: pcInteger! !

!MedDeconvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/8/2004 20:53'!
boolean
	^ boolean! !

!MedDeconvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/8/2004 20:53'!
desiredBoolean
	^ desiredBoolean! !

!MedDeconvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/29/2004 22:58'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	target expressionsDo: aBlockContext.
	boolean expressionsDo: aBlockContext.! !

!MedDeconvertBoolean methodsFor: 'Misc' stamp: 'wbk 10/25/2005 22:47'!
initialiseJumpTo: aMedBlock if: aMedLiteral is: aSymbol pc: pcInteger 
	target := aMedBlock.
	boolean := aMedLiteral.
	desiredBoolean := aSymbol.
	pc := pcInteger! !

!MedDeconvertBoolean methodsFor: 'Unit Testing' stamp: 'wbk 10/25/2005 22:51'!
intermediateForm
	^ {#deconvertBoolean. desiredBoolean. boolean intermediateForm. target blockName.
	pc}.! !

!MedDeconvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/28/2004 17:46'!
pc
	^ pc! !

!MedDeconvertBoolean methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedDeconvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/8/2004 20:53'!
target
	^ target! !

!MedDeconvertBoolean methodsFor: 'Misc' stamp: 'wbk 8/8/2004 20:50'!
visitWith: aMedSimplifier 
	^ aMedSimplifier visitDeconvertBoolean: self! !

MedLanguage subclass: #MedDivide
	instanceVariableNames: 'arg1 arg2 remander'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedDivide class methodsFor: 'as yet unclassified' stamp: 'wbk 8/8/2004 19:27'!
emit: firstMed divide: secondMed remander: remanderMed 
	^self new 
		initialiseArg1: firstMed
		arg2: secondMed
		remainder: remanderMed! !

!MedDivide class methodsFor: 'as yet unclassified' stamp: 'wbk 1/28/2004 23:02'!
register: aMedTemporaryRegister 
	^ self
		emit: nil
		divide: nil
		remander: aMedTemporaryRegister! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 1/28/2004 23:25'!
arg1
	^ arg1! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 1/28/2004 23:01'!
arg2
	^ arg2! !

!MedDivide methodsFor: 'Misc' stamp: 'wbk 8/8/2004 19:33'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	arg1 expressionsDo: aBlockContext.
	arg2 expressionsDo: aBlockContext.
	remander expressionsDo: aBlockContext.! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 1/24/2004 12:45'!
initialiseArg1: aMedLiteral arg2: aMedLiteral2 remainder: aMedTemporaryRegister 
	arg1 := aMedLiteral.
	arg2 := aMedLiteral2.
	remander := aMedTemporaryRegister! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 8/8/2004 19:32'!
intermediateForm
	^ {#div. arg1 intermediateForm. arg2 intermediateForm. remander intermediateForm}! !

!MedDivide methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 1/28/2004 23:27'!
remainder
	^ remander! !

!MedDivide methodsFor: 'as yet unclassified' stamp: 'wbk 1/26/2004 22:53'!
visitWith: aVisitor
	^ aVisitor visitDivide: self! !

MedLanguage subclass: #MedHomeContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedHomeContext methodsFor: 'Misc' stamp: 'wbk 1/14/2006 17:42'!
expressionsDo: aBlockContext 
	aBlockContext value: self! !

!MedHomeContext methodsFor: 'Unit Testing' stamp: 'wbk 1/14/2006 17:13'!
intermediateForm
	^ #(homeContext)! !

!MedHomeContext methodsFor: 'Visiting' stamp: 'wbk 1/14/2006 17:41'!
visitWith: aTreeOptimiser 
	^ aTreeOptimiser visitHomeContext: self! !

MedLanguage subclass: #MedInstanceVariableAddress
	instanceVariableNames: 'slot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedInstanceVariableAddress class methodsFor: 'instance creation' stamp: 'wbk 1/27/2006 21:25'!
slot: aSmallInteger 
	^ self new initializeSlot: aSmallInteger! !

!MedInstanceVariableAddress methodsFor: 'Misc' stamp: 'wbk 1/27/2006 21:56'!
expressionsDo: aBlockContext 
	aBlockContext value: self! !

!MedInstanceVariableAddress methodsFor: 'Misc' stamp: 'wbk 1/27/2006 21:26'!
initializeSlot: aSmallInteger 
	slot := aSmallInteger! !

!MedInstanceVariableAddress methodsFor: 'Unit Testing' stamp: 'wbk 1/27/2006 22:01'!
intermediateForm
	^ {#instanceVariableAddress. slot}! !

!MedInstanceVariableAddress methodsFor: 'Misc' stamp: 'wbk 1/27/2006 22:13'!
visitWith: anIntermediateSimplifier 
	^anIntermediateSimplifier visitInstanceVariableAddress: slot! !

MedLanguage subclass: #MedIntegerValueOf
	instanceVariableNames: 'argument failureBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedIntegerValueOf class methodsFor: 'instance creation' stamp: 'wbk 10/17/2004 21:02'!
argument: aMed failureBlock: aBlock
	^ self new
		initializeArgument: aMed
		failureBlock: aBlock! !

!MedIntegerValueOf methodsFor: 'Misc' stamp: 'wbk 10/17/2004 22:28'!
argument
	^ argument ! !

!MedIntegerValueOf methodsFor: 'Misc' stamp: 'wbk 10/17/2004 22:32'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	argument expressionsDo: aBlockContext.
	failureBlock expressionsDo: aBlockContext.! !

!MedIntegerValueOf methodsFor: 'Misc' stamp: 'wbk 10/17/2004 22:29'!
failureBlock
	^ failureBlock! !

!MedIntegerValueOf methodsFor: 'Misc' stamp: 'wbk 10/17/2004 21:04'!
initializeArgument: aMed failureBlock: aBlock
	argument := aMed.
	failureBlock := aBlock.! !

!MedIntegerValueOf methodsFor: 'Unit Testing' stamp: 'wbk 10/17/2004 21:10'!
intermediateForm
	^ {#integerValueOf. argument intermediateForm. failureBlock blockName}! !

!MedIntegerValueOf methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedIntegerValueOf methodsFor: 'Misc' stamp: 'wbk 10/17/2004 21:42'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitIntegerValueOf: self! !

MedLanguage subclass: #MedJump
	instanceVariableNames: 'type target instruction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedJump class methodsFor: 'instance creation' stamp: 'wbk 10/2/2004 22:03'!
type: aSymbol target: aMedBlock
	^ self new
		initializeType:  aSymbol 
		block: aMedBlock 
		instruction: nil! !

!MedJump class methodsFor: 'instance creation' stamp: 'wbk 10/2/2004 22:02'!
type: aSymbol target: aMedBlock instruction: aMed 
	^self new 
		initializeType: aSymbol
		block: aMedBlock
		instruction: aMed! !

!MedJump methodsFor: 'Register Allocation' stamp: 'wbk 11/4/2002 16:35'!
buildInterferenceWith: anAllocator! !

!MedJump methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:44'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	instruction ifNil: [^ self].
	instruction expressionsDo: aBlockContext.
	! !

!MedJump methodsFor: 'Misc' stamp: 'wbk 1/5/2006 20:51'!
initializeType:  aSymbol block: aMedBlock instruction: aMed
	type := aSymbol.
	target := aMedBlock.
	instruction := aMed.
	^ self! !

!MedJump methodsFor: 'Misc' stamp: 'wbk 10/3/2002 17:16'!
instruction
	^ instruction! !

!MedJump methodsFor: 'Unit Testing' stamp: 'wbk 2/4/2005 20:56'!
intermediateForm
	|answer|
	answer := OrderedCollection 
		with: type 
		with: ( target class = MedBlock 
			ifTrue: [target blockName asSymbol]
			ifFalse: [target intermediateForm]).
	instruction isNil ifFalse: [answer addLast: instruction intermediateForm].
	^ answer asArray! !

!MedJump methodsFor: 'Testing' stamp: 'wbk 7/10/2004 18:30'!
isJump
	^ true! !

!MedJump methodsFor: 'Testing' stamp: 'wbk 4/7/2005 23:26'!
isUnconditionalJump
	^ type = #jmp! !

!MedJump methodsFor: 'Misc' stamp: 'wbk 1/5/2006 19:00'!
jumpsDo: aBlockContext 
	aBlockContext value: self! !

!MedJump methodsFor: 'Misc' stamp: 'wbk 10/24/2002 11:13'!
name
	"Used in ColouringRegisterAllocator>>buildInstruction"
	^ type! !

!MedJump methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedJump methodsFor: 'Debugging' stamp: 'wbk 3/20/2006 18:24'!
printOn: aWriteStream indentLevel: aSmallInteger 
	self 
		indentLevel: aSmallInteger
		on: aWriteStream.
	aWriteStream 
		nextPut: $(;
		nextPutAll: type;
		nextPut: $ ;
		nextPutAll: target targetName;
		nextPut: $);
		cr.
	! !

!MedJump methodsFor: 'Register Allocation' stamp: 'wbk 2/4/2005 23:37'!
registersDefined
	^ Lattice new.! !

!MedJump methodsFor: 'Misc' stamp: 'wbk 10/3/2002 21:15'!
registersDo: aBlock! !

!MedJump methodsFor: 'Register Allocation' stamp: 'wbk 2/4/2005 23:39'!
registersUsed
	^ Lattice with: target ! !

!MedJump methodsFor: 'Misc' stamp: 'wbk 10/3/2002 17:18'!
target
	^ target! !

!MedJump methodsFor: 'Misc' stamp: 'wbk 10/3/2002 17:17'!
type
	^ type! !

!MedJump methodsFor: 'Misc' stamp: 'wbk 10/5/2002 22:41'!
visitWith: aVisitor
	^ aVisitor visitJump: self! !

MedLanguage subclass: #MedLabel
	instanceVariableNames: 'code failureCode failureBlock arguments argumentRegisters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedLabel class methodsFor: 'instance creation' stamp: 'wbk 12/12/2004 21:59'!
arguments: argumentsMed registers: someRegisters around: aMedArithmatic failingTo: aMedTemporaryRegister failureBlock: aMedBlock 
	^ self new
		initialiseArguments: argumentsMed
		registerst: someRegisters
		around: aMedArithmatic
		failingTo: aMedTemporaryRegister
		failureBlock: aMedBlock! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 12/11/2004 19:47'!
argumentRegisters
	^ argumentRegisters! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 12/11/2004 19:46'!
arguments
	^ arguments! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 9/18/2004 21:47'!
code
	^ code! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 9/18/2004 22:04'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	code expressionsDo: aBlockContext.
	failureBlock expressionsDo: aBlockContext.! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 9/18/2004 21:45'!
failureBlock
	^ failureBlock! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 9/18/2004 21:57'!
failureCode
	^ failureCode! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 12/11/2004 19:32'!
initialiseArguments: argumentsMed registerst: someRegisters around: aMedArithmatic failingTo: aMedTemporaryRegister failureBlock: aMedBlock 
	arguments := argumentsMed.
	argumentRegisters := someRegisters.
	code := aMedArithmatic.
	failureCode := aMedTemporaryRegister.
	failureBlock := aMedBlock.! !

!MedLabel methodsFor: 'Unit Testing' stamp: 'wbk 9/18/2004 13:11'!
intermediateForm
	^ {#label. code. failureCode. failureBlock}! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 12/24/2004 15:17'!
isLabel
	^ true! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 3/27/2005 15:23'!
isSideEffecting
	^ false! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 10/3/2004 12:39'!
isStackable
	^ true! !

!MedLabel methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedLabel methodsFor: 'Simplification' stamp: 'wbk 3/27/2005 14:26'!
simplifyCodeUsing: anIntermediateSimplifier answerIn: aMedTemporaryRegister 
	anIntermediateSimplifier
		codeForLabel: self
		answerIn: aMedTemporaryRegister! !

!MedLabel methodsFor: 'Simplification' stamp: 'wbk 3/27/2005 14:26'!
simplifyFailureCodeUsing: anIntermediateSimplifier answerIn: aMedTemporaryRegister 
	anIntermediateSimplifier
		failureCodeForLabel: self
		answerIn: aMedTemporaryRegister.! !

!MedLabel methodsFor: 'Misc' stamp: 'wbk 9/18/2004 21:30'!
visitWith: aMedSimplifier 
	^ aMedSimplifier visitLabel: self.! !

MedLabel subclass: #MedSideEffectingLabel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedSideEffectingLabel methodsFor: 'Unit Testing' stamp: 'wbk 3/27/2005 13:39'!
intermediateForm
	^ {#sideEffectsLabel1. code. failureCode. failureBlock}! !

!MedSideEffectingLabel methodsFor: 'Misc' stamp: 'wbk 3/27/2005 15:20'!
isSideEffecting
	^ true.! !

!MedSideEffectingLabel methodsFor: 'Simplification' stamp: 'wbk 3/27/2005 17:56'!
simplifyCodeUsing: anIntermediateSimplifier answerIn: aMedTemporaryRegister 
	anIntermediateSimplifier 
		codeForLabel: self ! !

!MedSideEffectingLabel methodsFor: 'Simplification' stamp: 'wbk 3/27/2005 17:56'!
simplifyFailureCodeUsing: anIntermediateSimplifier answerIn: aMedTemporaryRegister 
	anIntermediateSimplifier 
		failureCodeForLabel: self! !

!MedSideEffectingLabel methodsFor: 'Misc' stamp: 'wbk 3/27/2005 15:19'!
visitWith: aMedSimplifier 
	^ aMedSimplifier visitSideEffectingLabel: self.! !

!MedLanguage methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/21/2002 21:27'!
in 
	^ in! !

!MedLanguage methodsFor: 'Debugging' stamp: 'wbk 3/19/2006 22:13'!
indentLevel: aSmallInteger on: aWriteStream 
	1
		to: aSmallInteger
		do: [:each| aWriteStream nextPut: $ ]! !

!MedLanguage methodsFor: 'Unit Testing' stamp: 'wbk 4/17/2005 17:58'!
intermediateForm
	^ self subclassResponsibility.! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 11/8/2002 14:19'!
isAdd
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 9/11/2002 23:19'!
isAddressingMode
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 3/4/2005 23:53'!
isArithmatic
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 12/24/2004 15:18'!
isConvertBoolean
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 1/3/2006 21:58'!
isCreateBlockContext
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 7/10/2004 18:30'!
isJump
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 12/24/2004 15:17'!
isLabel
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'WBK 8/28/2002 14:49'!
isLiteral	
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 11/8/2002 14:39'!
isMachineInteger
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 9/11/2002 23:08'!
isMachineRegister
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 2/4/2005 20:52'!
isMedBlock
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 8/22/2005 22:17'!
isMedLiteral	
	^ self isLiteral! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 9/3/2002 16:51'!
isMem
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'WBK 8/27/2002 20:16'!
isMov
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'WBK 8/27/2002 20:42'!
isRegister
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 7/11/2004 21:51'!
isReturn
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 8/19/2005 20:27'!
isStackable
	^ true! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 10/30/2005 21:12'!
isStackRegister
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 4/8/2005 22:17'!
isSubtract
	^ false! !

!MedLanguage methodsFor: 'Testing' stamp: 'wbk 4/7/2005 23:29'!
isUnconditionalJump
	^ false! !

!MedLanguage methodsFor: 'Misc' stamp: 'wbk 1/5/2006 19:11'!
jumpsDo: aBlockContext 
! !

!MedLanguage methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/21/2002 18:22'!
out
	^ out! !

!MedLanguage methodsFor: 'Misc' stamp: 'wbk 4/17/2005 17:58'!
registersDo: aBlock
	self subclassResponsibility! !

!MedLanguage methodsFor: 'Misc' stamp: 'wbk 11/4/2002 14:26'!
registersIn: aCollection
	|answer|
	answer := OrderedCollection new.
	self registersDo: [:each| (aCollection includes: each) ifTrue: [answer add: each]].
	^ answer! !

!MedLanguage methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/21/2002 11:55'!
setIn: aLattice
	in := aLattice! !

!MedLanguage methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/21/2002 11:55'!
setOut: aLattice
	out := aLattice! !

MedLanguage subclass: #MedLiteral
	instanceVariableNames: 'literal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

MedLiteral subclass: #MedAddress
	instanceVariableNames: 'block byteCodeAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedAddress class methodsFor: 'instance creation' stamp: 'wbk 2/1/2006 22:18'!
addressOf: aBlock 
self removeMe.
	^self new 
		initializeBlock: aBlock
		byteCodeAddress: nil! !

!MedAddress class methodsFor: 'instance creation' stamp: 'wbk 2/1/2006 22:18'!
addressOf: aBlock byteCodeAddress: anInteger
	^self new 
		initializeBlock: aBlock
		byteCodeAddress: anInteger! !

!MedAddress methodsFor: 'Misc' stamp: 'wbk 2/1/2006 22:17'!
initializeBlock: aBlock byteCodeAddress: anInteger
	block := aBlock.
	byteCodeAddress := anInteger! !

!MedAddress methodsFor: 'Unit Testing' stamp: 'wbk 2/1/2006 22:17'!
intermediateForm
	^ {#addressOf. byteCodeAddress. block blockName}! !

!MedAddress methodsFor: 'Misc' stamp: 'wbk 1/20/2005 23:17'!
literal
	^ self error: 'Accidental superclass behaviour'.! !

!MedAddress methodsFor: 'Unit Testing' stamp: 'wbk 3/20/2006 20:28'!
printOn: aStream
	aStream nextPutAll: '(address '.
	aStream nextPutAll: block targetName.
	aStream nextPut: $).! !

!MedAddress methodsFor: 'Misc' stamp: 'wbk 2/4/2006 22:52'!
valueUsing: anEncoder 
	anEncoder 
		addRelocationFor: block
		byteCodeAddress: byteCodeAddress.
	^0! !

!MedAddress methodsFor: 'Misc' stamp: 'wbk 1/20/2005 21:29'!
visitWith: anInstructionSelector 
	anInstructionSelector visitAddress: self! !

MedAddress subclass: #MedBlockAddress
	instanceVariableNames: 'argumentCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedBlockAddress class methodsFor: 'instance creation' stamp: 'wbk 2/4/2006 19:38'!
addressOf: aMedBlock byteCodeAddress: aByteSymbol argumentCount: aByteSymbol3 
	^ self new 
		initializeAddressOf: aMedBlock 
		byteCodeAddress: aByteSymbol 
		argumentCount: aByteSymbol3 ! !

!MedBlockAddress methodsFor: 'Misc' stamp: 'wbk 2/4/2006 20:39'!
initializeAddressOf: aMedBlock byteCodeAddress: aByteSymbol argumentCount: aByteSymbol3 
	super
		initializeBlock: aMedBlock
		byteCodeAddress: aByteSymbol.
	argumentCount := aByteSymbol3! !

!MedBlockAddress methodsFor: 'Unit Testing' stamp: 'wbk 2/4/2006 20:39'!
intermediateForm
	^ {#blockAddress. byteCodeAddress. block blockName. argumentCount}! !

!MedBlockAddress methodsFor: 'Misc' stamp: 'wbk 2/4/2006 23:01'!
valueUsing: anEncoder 
	anEncoder 
		addRelocationFor: block
		byteCodeAddress: byteCodeAddress
		argumentCount: argumentCount.
	^0! !

!MedLiteral class methodsFor: 'instance creation' stamp: 'wbk 9/3/2002 14:09'!
literal: anInteger
	^ self new initialize: anInteger! !

!MedLiteral class methodsFor: 'instance creation' stamp: 'wbk 9/18/2002 16:57'!
smallInteger: aNumber
	^ self literal: aNumber * 2 + 1! !

!MedLiteral methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:45'!
expressionsDo: aBlockContext ! !

!MedLiteral methodsFor: 'Initialization' stamp: 'WBK 8/27/2002 12:26'!
initialize: anInteger
	literal := anInteger! !

!MedLiteral methodsFor: 'Unit Testing' stamp: 'WBK 8/27/2002 15:03'!
intermediateForm
	^ literal! !

!MedLiteral methodsFor: 'Testing' stamp: 'WBK 8/28/2002 14:49'!
isLiteral
	^ true! !

!MedLiteral methodsFor: 'Testing' stamp: 'wbk 11/8/2002 14:34'!
isMachineInteger
	^ literal isInteger! !

!MedLiteral methodsFor: 'Misc' stamp: 'wbk 10/3/2004 12:39'!
isStackable
	^ true! !

!MedLiteral methodsFor: 'Misc' stamp: 'wbk 11/8/2002 14:37'!
literal
	^ literal! !

!MedLiteral methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:31'!
printOn: aStream
	literal printOn: aStream.! !

!MedLiteral methodsFor: 'Misc' stamp: 'wbk 8/2/2004 21:25'!
registersDo: aBlock! !

!MedLiteral methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/23/2002 12:29'!
registersUsed
	^ Lattice new! !

!MedLiteral methodsFor: 'Misc' stamp: 'wbk 1/21/2005 21:59'!
valueUsing: anEncoder
	^ literal isSymbol
		ifTrue: [
			anEncoder addressOfLiteral: self]
		ifFalse: [literal].! !

!MedLiteral methodsFor: 'Misc' stamp: 'wbk 10/5/2002 21:56'!
visitWith: aVisitor
	^ aVisitor visitLiteral: self! !

MedLiteral subclass: #MedPicEntry
	instanceVariableNames: 'picMethodLocation byteCodeAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedPicEntry class methodsFor: 'instance creation' stamp: 'wbk 5/18/2005 21:32'!
byteCodeAddress: aSmallInteger 
	^ self new initializeByteCodeAddress: aSmallInteger! !

!MedPicEntry methodsFor: 'Misc' stamp: 'wbk 2/27/2005 10:45'!
initialize
	literal := (Exupery loadCode: (ByteArray new: 12)) * 2! !

!MedPicEntry methodsFor: 'Misc' stamp: 'wbk 5/18/2005 21:33'!
initializeByteCodeAddress: aSmallInteger 
	byteCodeAddress := aSmallInteger! !

!MedPicEntry methodsFor: 'Misc' stamp: 'wbk 2/27/2005 14:42'!
picMethodLocation
	^ picMethodLocation! !

!MedPicEntry methodsFor: 'Misc' stamp: 'wbk 2/27/2005 14:45'!
picMethodLocation: aSmallInteger 
	picMethodLocation := aSmallInteger! !

!MedPicEntry methodsFor: 'Unit Testing' stamp: 'wbk 3/20/2006 19:52'!
printOn: aStream
	aStream nextPutAll: '(picEntry '.
	literal printOn: aStream.
	aStream nextPutAll: ')'.! !

!MedPicEntry methodsFor: 'Misc' stamp: 'wbk 5/18/2005 21:48'!
relocateInMethodAt: aSmallInteger 
	self 
		setupPicEntryAt: literal / 2
		forPic: picMethodLocation
		inMethod: aSmallInteger.
	^PolymorphicInlineCache 
		entry: literal / 2
		picLocation: picMethodLocation
		methodLocation: aSmallInteger
		byteCodeAddress: byteCodeAddress! !

!MedPicEntry methodsFor: 'Misc' stamp: 'wbk 3/3/2005 23:22'!
setupPicEntryAt: entryInteger forPic:picInteger inMethod: methodInteger
	<primitive: 'setupPicEntryAtforPicinMethod' module: 'ExuperyPlugin'>
	Error signal.
! !

MedLanguage subclass: #MedMachineRegister
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMachineRegister class methodsFor: 'instance creation' stamp: 'wbk 7/9/2004 20:06'!
name: aSymbol 
	^ self new 
		initializeName: aSymbol! !

!MedMachineRegister methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:46'!
expressionsDo: aBlockContext ! !

!MedMachineRegister methodsFor: 'Testing' stamp: 'wbk 4/11/2003 14:00'!
hasOffset
	^ false! !

!MedMachineRegister methodsFor: 'Misc' stamp: 'wbk 7/9/2004 20:06'!
initializeName: aSymbol
	name := aSymbol.
	^ self! !

!MedMachineRegister methodsFor: 'Unit testing' stamp: 'WBK 8/27/2002 15:00'!
intermediateForm
	^ name! !

!MedMachineRegister methodsFor: 'Testing' stamp: 'WBK 8/28/2002 21:25'!
isMachineRegister
	^ true! !

!MedMachineRegister methodsFor: 'Testing' stamp: 'WBK 8/27/2002 20:42'!
isRegister
	^ true! !

!MedMachineRegister methodsFor: 'Misc' stamp: 'WBK 8/28/2002 23:24'!
name
	^ name! !

!MedMachineRegister methodsFor: 'Unit testing' stamp: 'wbk 3/19/2006 22:32'!
printOn: aStream
	aStream nextPutAll: name.! !

!MedMachineRegister methodsFor: 'Unit testing' stamp: 'wbk 9/13/2002 22:56'!
printRegTypeOn: aStream
	aStream nextPutAll: 'reg'.! !

!MedMachineRegister methodsFor: 'Misc' stamp: 'wbk 11/4/2002 13:40'!
registersDo: aBlock
	aBlock value: self! !

!MedMachineRegister methodsFor: 'Dataflow Analysis' stamp: 'wbk 10/23/2002 12:09'!
registersUsed
	^ Lattice with: self! !

!MedMachineRegister methodsFor: 'Debugging' stamp: 'wbk 3/20/2006 18:25'!
targetName
	^ name! !

!MedMachineRegister methodsFor: 'Misc' stamp: 'wbk 10/5/2002 21:49'!
visitWith: anObject
	^ anObject visitMachineRegister: self! !

MedMachineRegister subclass: #MedTemporaryRegister
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedTemporaryRegister methodsFor: 'testing' stamp: 'WBK 8/28/2002 21:26'!
isMachineRegister
	^ false! !

!MedTemporaryRegister methodsFor: 'testing' stamp: 'wbk 10/30/2005 21:14'!
isStackRegister
	^ name first = $s! !

!MedTemporaryRegister methodsFor: 'testing' stamp: 'wbk 9/13/2002 22:55'!
printRegTypeOn: aStream
	aStream nextPutAll: 'temp'.! !

!MedTemporaryRegister methodsFor: 'misc' stamp: 'wbk 10/5/2002 21:54'!
visitWith: anObject
	^ anObject visitTemporaryRegister: self! !

MedLanguage subclass: #MedMem
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMem class methodsFor: 'instance creation' stamp: 'wbk 12/8/2004 22:02'!
address: aMed
	^ self new initializeAddress: aMed! !

!MedMem methodsFor: 'Misc' stamp: 'wbk 9/11/2002 13:51'!
address
	^ address! !

!MedMem methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:57'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	address expressionsDo: aBlockContext.! !

!MedMem methodsFor: 'Misc' stamp: 'wbk 9/3/2002 14:18'!
initializeAddress: aMed
	address := aMed.
	^ self! !

!MedMem methodsFor: 'Unit Testing' stamp: 'wbk 9/3/2002 15:04'!
intermediateForm
	^ {#mem. address intermediateForm}! !

!MedMem methodsFor: 'Testing' stamp: 'wbk 9/3/2002 16:51'!
isMem
	^ true! !

!MedMem methodsFor: 'Misc' stamp: 'wbk 10/4/2004 21:51'!
isStackable
	^ true! !

!MedMem methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedMem methodsFor: 'Misc' stamp: 'wbk 10/6/2002 11:24'!
visitWith: aVisitor
	^ aVisitor visitMem: self! !

MedLanguage subclass: #MedMov
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMov class methodsFor: 'instance creation' stamp: 'wbk 10/31/2005 22:06'!
from: fromMed to: toMed 
	^ self new 
		initializeTo: toMed 
		from: fromMed! !

!MedMov methodsFor: 'Register Allocation' stamp: 'wbk 7/5/2003 15:28'!
buildInterferenceWith: anAllocator
	| defined |
	to isAddressingMode ifTrue: [^ self].
	defined := self registersDefined register.
	^ out do: 
		[:eachRegister | 
		eachRegister = from ifFalse: 
			[anAllocator 
				addInterferenceEdge: defined 
				to: eachRegister]]! !

!MedMov methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:24'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	to expressionsDo: aBlockContext.
	from expressionsDo: aBlockContext.! !

!MedMov methodsFor: 'Accessing' stamp: 'WBK 8/27/2002 20:17'!
from
	^ from! !

!MedMov methodsFor: 'Misc' stamp: 'wbk 10/28/2004 21:38'!
initializeTo: toMed from: fromMed
	to := toMed.
	from := fromMed.
	^ self! !

!MedMov methodsFor: 'Unit Testing' stamp: 'WBK 8/30/2002 15:32'!
intermediateForm
	^ {#mov. from intermediateForm. to intermediateForm}! !

!MedMov methodsFor: 'Testing' stamp: 'WBK 8/27/2002 20:16'!
isMov
	^ true! !

!MedMov methodsFor: 'Testing' stamp: 'wbk 8/1/2004 14:58'!
isRegisterRead: aMedTemporaryRegister 
	from = aMedTemporaryRegister ifTrue: [^true].
	from isAddressingMode ifTrue:
		[from registersDo: [:each| each = aMedTemporaryRegister ifTrue: [^ true]]].
	to isAddressingMode ifTrue:
		[to registersDo: [:each| each = aMedTemporaryRegister ifTrue: [^ true]]].
	^ false! !

!MedMov methodsFor: 'Testing' stamp: 'wbk 7/31/2004 11:40'!
isRegisterWritten: aMedTemporaryRegister 
	^ to = aMedTemporaryRegister! !

!MedMov methodsFor: 'Misc' stamp: 'wbk 11/4/2002 14:29'!
name
	"Used for a type test"
	^ #mov! !

!MedMov methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedMov methodsFor: 'Debugging' stamp: 'wbk 3/19/2006 22:33'!
printOn: aWriteStream indentLevel: aSmallInteger 
	self 
		indentLevel: aSmallInteger
		on: aWriteStream.
	aWriteStream nextPutAll: '(mov '.
	from printOn: aWriteStream.
	aWriteStream nextPut: $ .
	to printOn: aWriteStream.
	aWriteStream
		nextPut: $);
		cr.! !

!MedMov methodsFor: 'Dataflow Analysis' stamp: 'wbk 11/4/2002 13:59'!
registersDefined
	to isAddressingMode ifTrue: [^ Lattice new].
	^ Lattice with: to! !

!MedMov methodsFor: 'Misc' stamp: 'wbk 11/4/2002 13:38'!
registersDo: aBlock
	from registersDo: aBlock.
	to registersDo: aBlock! !

!MedMov methodsFor: 'Dataflow Analysis' stamp: 'wbk 11/4/2002 13:58'!
registersUsed
	to isAddressingMode ifTrue:
		[^ to registersUsed + from registersUsed].
	^ from registersUsed! !

!MedMov methodsFor: 'Accessing' stamp: 'WBK 8/27/2002 20:17'!
to
	^ to! !

!MedMov methodsFor: 'Misc' stamp: 'wbk 10/6/2002 11:32'!
visitWith: aVisitor
	^ aVisitor visitMov: self! !

MedMov subclass: #MedStackPush
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedStackPush methodsFor: 'Unit Testing' stamp: 'wbk 10/31/2005 21:01'!
intermediateForm
	^ {#stackPush. from intermediateForm. to intermediateForm}! !

!MedStackPush methodsFor: 'Misc' stamp: 'wbk 10/31/2005 21:47'!
name
	#stackPush! !

!MedStackPush methodsFor: 'Misc' stamp: 'wbk 11/3/2005 21:38'!
visitWith: aVisitor
	^ aVisitor visitStackPush: self! !

MedLanguage subclass: #MedNegate
	instanceVariableNames: 'argument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedNegate class methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 19:11'!
argument: aMedLiteral 
	^ self new initialiseArgument: aMedLiteral! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 19:54'!
argument
	^ argument! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 20:19'!
buildInterferenceWith: aColouringRegisterAllocator 	
	out do:
		[:each| aColouringRegisterAllocator
			addInterferenceEdge: argument
			to: each]! !

!MedNegate methodsFor: 'Misc' stamp: 'wbk 8/8/2004 20:34'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	argument expressionsDo: aBlockContext! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 19:10'!
initialiseArgument: aMedLiteral 
	argument := aMedLiteral! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 19:12'!
intermediateForm
	^{#neg. argument intermediateForm}! !

!MedNegate methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 20:11'!
registersDefined
	^ Lattice with: argument! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 20:17'!
registersDo: aBlockContext 
	aBlockContext value: argument! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 20:10'!
registersUsed
	^ Lattice with: argument! !

!MedNegate methodsFor: 'as yet unclassified' stamp: 'wbk 2/9/2004 20:43'!
visitWith: anInstructionSelector 
	^ anInstructionSelector visitNegate: self! !

MedLanguage subclass: #MedPic
	instanceVariableNames: 'selectionRegister picEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedPic class methodsFor: 'instance creation' stamp: 'wbk 2/27/2005 13:36'!
selectionRegister: aMed picEntry: anObject 
	^ self new 
		selectionRegister: aMed
		picEntry: anObject! !

!MedPic methodsFor: 'Register Allocation' stamp: 'wbk 2/26/2005 18:14'!
buildInterferenceWith: aColouringRegisterAllocator 
! !

!MedPic methodsFor: 'Unit Testing' stamp: 'wbk 2/26/2005 21:57'!
intermediateForm
	^ ({ 
		#pic.
		selectionRegister intermediateForm})! !

!MedPic methodsFor: 'Misc' stamp: 'wbk 2/26/2005 21:57'!
location
	^ selectionRegister! !

!MedPic methodsFor: 'Misc' stamp: 'wbk 2/27/2005 13:58'!
picEntry
	^ picEntry! !

!MedPic methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedPic methodsFor: 'Debugging' stamp: 'wbk 3/20/2006 18:30'!
printOn: aWriteStream indentLevel: aSmallInteger 
	self
		indentLevel: aSmallInteger
		on: aWriteStream.
	aWriteStream
		nextPutAll: '(pic '.
	selectionRegister printOn: aWriteStream.
	aWriteStream
		nextPutAll: ')';
		cr! !

!MedPic methodsFor: 'Register Allocation' stamp: 'wbk 2/26/2005 21:56'!
registersDefined
	^ Lattice new! !

!MedPic methodsFor: 'Misc' stamp: 'wbk 2/26/2005 21:57'!
registersDo: aBlockContext 
	selectionRegister registersDo: aBlockContext! !

!MedPic methodsFor: 'Register Allocation' stamp: 'wbk 2/26/2005 21:57'!
registersUsed
	^ Lattice with: selectionRegister! !

!MedPic methodsFor: 'Misc' stamp: 'wbk 2/27/2005 14:02'!
selectionRegister: aMed picEntry: aPicEntry
	selectionRegister := aMed.
	picEntry := aPicEntry! !

!MedPic methodsFor: 'Misc' stamp: 'wbk 2/25/2005 23:00'!
visitWith: aLivenessAnalyser 
	aLivenessAnalyser visitPic: self! !

MedLanguage subclass: #MedPrimitive
	instanceVariableNames: 'primitiveName arguments failureBlock receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedPrimitive class methodsFor: 'instance creation' stamp: 'wbk 11/6/2005 19:33'!
primitive: aByteSymbol arguments: anArray failureBlock: anObject receiver: anObject1 
	^self new 
		initializePrimitive: aByteSymbol
		arguments: anArray
		failureBlock: anObject
		receiver: anObject1! !

!MedPrimitive methodsFor: 'Misc' stamp: 'wbk 5/29/2005 18:31'!
arguments
	^ arguments! !

!MedPrimitive methodsFor: 'Misc' stamp: 'wbk 5/29/2005 19:04'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	arguments do: [:each| each expressionsDo: aBlockContext].
	failureBlock expressionsDo: aBlockContext.! !

!MedPrimitive methodsFor: 'Misc' stamp: 'wbk 5/29/2005 18:31'!
failureBlock
	^ failureBlock! !

!MedPrimitive methodsFor: 'Misc' stamp: 'wbk 11/6/2005 19:23'!
initializePrimitive: aByteSymbol arguments: anArray failureBlock: aMedBlock receiver: aClass 
	primitiveName := aByteSymbol.
	arguments := anArray.
	failureBlock := aMedBlock.
	receiver := aClass! !

!MedPrimitive methodsFor: 'Unit Testing' stamp: 'wbk 6/16/2005 19:23'!
intermediateForm
	| answer |
	answer :=  OrderedCollection
		with: #primitive
		with: primitiveName
		with: failureBlock blockName.
	answer addAll: (arguments collect: [:each| each intermediateForm]).
	^ answer asArray! !

!MedPrimitive methodsFor: 'Misc' stamp: 'wbk 5/29/2005 18:30'!
primitive
	^ primitiveName! !

!MedPrimitive methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedPrimitive methodsFor: 'Misc' stamp: 'wbk 11/6/2005 19:26'!
receiver
	^ receiver! !

!MedPrimitive methodsFor: 'Visiting' stamp: 'wbk 5/29/2005 18:24'!
visitWith: aTreeOptimiser 
	^ aTreeOptimiser visitPrimitive: self! !

MedLanguage subclass: #MedPrimitiveReturn
	instanceVariableNames: 'returnValue popItems receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedPrimitiveReturn class methodsFor: 'instance creation' stamp: 'wbk 11/6/2005 19:33'!
value: aMedPrimitive popping: aSmallInteger receiver: aClass 
	^self new 
		initializeValue: aMedPrimitive
		popping: aSmallInteger
		receiver: aClass! !

!MedPrimitiveReturn methodsFor: 'Misc' stamp: 'wbk 5/30/2005 17:33'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	returnValue expressionsDo: aBlockContext! !

!MedPrimitiveReturn methodsFor: 'Misc' stamp: 'wbk 11/6/2005 18:58'!
initializeValue: aMedPrimitive popping: aSmallInteger receiver: aClass 
	returnValue := aMedPrimitive.
	popItems := aSmallInteger.
	receiver := aClass.! !

!MedPrimitiveReturn methodsFor: 'Unit Testing' stamp: 'wbk 5/30/2005 17:54'!
intermediateForm
	^ {#primitiveReturn. popItems. returnValue intermediateForm}! !

!MedPrimitiveReturn methodsFor: 'Misc' stamp: 'wbk 5/30/2005 17:32'!
poppingItems
 	^ popItems! !

!MedPrimitiveReturn methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedPrimitiveReturn methodsFor: 'Misc' stamp: 'wbk 11/6/2005 19:31'!
receiver
	^ receiver! !

!MedPrimitiveReturn methodsFor: 'Misc' stamp: 'wbk 5/30/2005 17:32'!
value
	^ returnValue! !

!MedPrimitiveReturn methodsFor: 'Misc' stamp: 'wbk 5/30/2005 18:06'!
visitWith: aTreeOptimiser 
	^ aTreeOptimiser visitPrimitiveReturn: self.! !

MedLanguage subclass: #MedPush
	instanceVariableNames: 'argument'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

MedPush subclass: #MedPop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedPop methodsFor: 'Dataflow Analysis' stamp: 'wbk 3/4/2005 16:06'!
buildInterferenceWith: anAllocator

	out do:
		[:each| anAllocator
			addInterferenceEdge: argument
			to: each]! !

!MedPop methodsFor: 'Unit Testing' stamp: 'wbk 3/4/2005 15:24'!
intermediateForm
	^ {#pop. argument intermediateForm}! !

!MedPop methodsFor: 'Dataflow Analysis' stamp: 'wbk 3/4/2005 16:05'!
registersDefined
	^ argument registersUsed! !

!MedPop methodsFor: 'Dataflow Analysis' stamp: 'wbk 3/4/2005 16:05'!
registersUsed
	^ Lattice new! !

!MedPop methodsFor: 'Misc' stamp: 'wbk 3/4/2005 15:26'!
visitWith: aVisitor
	aVisitor visitPop: self! !

!MedPush class methodsFor: 'as yet unclassified' stamp: 'wbk 6/21/2003 19:12'!
argument: aSmallInteger 
	^ self new initializeArgument: aSmallInteger! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 6/21/2003 16:13'!
argument
	^ argument! !

!MedPush methodsFor: 'Register Allocation' stamp: 'wbk 7/5/2003 15:26'!
buildInterferenceWith: anAllocator ! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 8/7/2004 22:39'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	argument expressionsDo: aBlockContext! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 6/20/2003 20:41'!
initializeArgument: aSmallInteger 
	argument := aSmallInteger.
	^ self! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 6/21/2003 17:30'!
intermediateForm
	^ {#push. argument intermediateForm}! !

!MedPush methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedPush methodsFor: 'Debugging' stamp: 'wbk 3/19/2006 22:14'!
printOn: aWriteStream indentLevel: aSmallInteger 
	self
		indentLevel: aSmallInteger
		on: aWriteStream.
	aWriteStream 
		nextPutAll: '(push '.
	argument printOn: aWriteStream.
	aWriteStream
		nextPut: $);
		cr.
	! !

!MedPush methodsFor: 'Dataflow Analysis' stamp: 'wbk 6/23/2003 11:55'!
registersDefined
	^ Lattice new! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 6/24/2003 10:30'!
registersDo: aBlockContext 
	argument registersDo: aBlockContext! !

!MedPush methodsFor: 'Dataflow Analysis' stamp: 'wbk 6/23/2003 11:54'!
registersUsed
	^ argument registersUsed! !

!MedPush methodsFor: 'Misc' stamp: 'wbk 6/21/2003 15:47'!
visitWith: anInstructionSelector 
	^ anInstructionSelector visitPush: self! !

MedLanguage subclass: #MedReceiverAddress
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedReceiverAddress methodsFor: 'Unit Testing' stamp: 'wbk 1/27/2006 20:31'!
expressionsDo: aBlockContext 
	aBlockContext value: self! !

!MedReceiverAddress methodsFor: 'Unit Testing' stamp: 'wbk 1/27/2006 20:32'!
intermediateForm
	^ #(receiverAddress)! !

!MedReceiverAddress methodsFor: 'Misc' stamp: 'wbk 1/27/2006 20:32'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier  visitReceiverAddress! !

MedLanguage subclass: #MedRet
	instanceVariableNames: 'resultRegister'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedRet class methodsFor: 'instance creation' stamp: 'wbk 3/4/2005 16:30'!
resultRegister: aRegister
	^ self new initialisResultRegister: aRegister! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 11/4/2002 15:20'!
argumentsDo: aBlock! !

!MedRet methodsFor: 'Register Allocation' stamp: 'wbk 11/4/2002 16:35'!
buildInterferenceWith: anAllocator! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:47'!
expressionsDo: aBlockContext 
	aBlockContext value: self.! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 3/4/2005 16:31'!
initialisResultRegister: aRegister
	resultRegister := aRegister! !

!MedRet methodsFor: 'Unit testing' stamp: 'wbk 3/4/2005 15:08'!
intermediateForm
	^ #(#ret)! !

!MedRet methodsFor: 'Testing' stamp: 'wbk 7/11/2004 21:51'!
isReturn
	^ true! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 3/4/2005 13:49'!
name
	^ #returnSequence! !

!MedRet methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedRet methodsFor: 'Debugging' stamp: 'wbk 3/20/2006 18:28'!
printOn: aWriteStream indentLevel: aSmallInteger 
	self
		indentLevel: aSmallInteger
		on: aWriteStream.
	aWriteStream nextPutAll: '(ret '.
	resultRegister printOn: aWriteStream.
	aWriteStream
		nextPut: $);
		cr.
	! !

!MedRet methodsFor: 'Register Allocation' stamp: 'wbk 3/4/2005 16:39'!
registersDefined
	^ Lattice new! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 11/4/2002 15:17'!
registersDo: aBlock! !

!MedRet methodsFor: 'Register Allocation' stamp: 'wbk 3/4/2005 16:39'!
registersUsed
	^ Lattice with: resultRegister! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 3/4/2005 17:40'!
resultRegister
	^ resultRegister! !

!MedRet methodsFor: 'Misc' stamp: 'wbk 10/6/2002 11:26'!
visitWith: aVisitor
	^ aVisitor visitRet: self! !

MedLanguage subclass: #MedReturn
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedReturn class methodsFor: 'object creation' stamp: 'wbk 10/2/2004 10:06'!
value: aMed
	^ self new initializeValue: aMed! !

!MedReturn methodsFor: 'Misc' stamp: 'wbk 10/2/2004 10:43'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	value expressionsDo: aBlockContext.! !

!MedReturn methodsFor: 'Misc' stamp: 'wbk 10/2/2004 10:06'!
initializeValue: aMed
	value := aMed! !

!MedReturn methodsFor: 'Unit Testing' stamp: 'wbk 10/2/2004 10:09'!
intermediateForm
	^ {#return. value intermediateForm}! !

!MedReturn methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedReturn methodsFor: 'Misc' stamp: 'wbk 10/2/2004 10:37'!
value
	^ value! !

!MedReturn methodsFor: 'Visiting' stamp: 'wbk 10/2/2004 10:30'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitReturn: self.! !

MedLanguage subclass: #MedSend
	instanceVariableNames: 'selector arguments pc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedSend class methodsFor: 'instance creation' stamp: 'wbk 10/25/2005 23:11'!
selector: aMedMem arguments: anArray programCounter: aSmallInteger 
	^self new 
		initialiseSelector: aMedMem
		arguments: anArray
		programCounter: aSmallInteger! !

!MedSend methodsFor: 'Misc' stamp: 'wbk 9/19/2004 12:14'!
arguments
	^ arguments! !

!MedSend methodsFor: 'Misc' stamp: 'wbk 9/19/2004 13:00'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	selector expressionsDo: aBlockContext.
	arguments do: [:each| each expressionsDo: aBlockContext].! !

!MedSend methodsFor: 'Misc' stamp: 'wbk 10/25/2005 23:09'!
initialiseSelector: aMedMem arguments: anArray programCounter: aSmallInteger 
	selector := aMedMem.
	arguments := anArray.
	pc := aSmallInteger! !

!MedSend methodsFor: 'Unit Testing' stamp: 'wbk 10/25/2005 23:09'!
intermediateForm
	^ {#send. selector. (arguments collect: [:each| each intermediateForm]). pc}! !

!MedSend methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedSend methodsFor: 'Misc' stamp: 'wbk 9/19/2004 12:14'!
programCounter
	^ pc! !

!MedSend methodsFor: 'Misc' stamp: 'wbk 9/19/2004 12:13'!
selector
	^ selector! !

!MedSend methodsFor: 'Misc' stamp: 'wbk 9/19/2004 12:58'!
visitWith: aMedSimplifier 
	^ aMedSimplifier visitSend: self.! !

MedLanguage subclass: #MedStoreInReceiver
	instanceVariableNames: 'slot value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedStoreInReceiver class methodsFor: 'instance creation' stamp: 'wbk 11/1/2004 21:14'!
slot: aSmallInteger value: aMedLiteral 
	^ self new
		initializeSlot: aSmallInteger 
		value: aMedLiteral! !

!MedStoreInReceiver methodsFor: 'Misc' stamp: 'wbk 11/3/2004 22:27'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	value expressionsDo: aBlockContext.
	! !

!MedStoreInReceiver methodsFor: 'Misc' stamp: 'wbk 11/1/2004 21:16'!
initializeSlot: anInteger value: aMed 
	slot := anInteger.
	value := aMed! !

!MedStoreInReceiver methodsFor: 'Unit Testing' stamp: 'wbk 1/26/2006 20:46'!
intermediateForm
	^{#storeInReceiver. slot. value intermediateForm}! !

!MedStoreInReceiver methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedStoreInReceiver methodsFor: 'Misc' stamp: 'wbk 11/1/2004 22:27'!
slot
	^ slot! !

!MedStoreInReceiver methodsFor: 'Misc' stamp: 'wbk 11/1/2004 22:15'!
value
	^ value! !

!MedStoreInReceiver methodsFor: 'Misc' stamp: 'wbk 11/1/2004 21:46'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitStoreInReceiver: self! !

MedLanguage subclass: #MedStoreInTemp
	instanceVariableNames: 'slot valueStored'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedStoreInTemp class methodsFor: 'instance creation' stamp: 'wbk 10/23/2004 18:37'!
slot: anInteger value: aMed
	^ self new
		initializeSlot: anInteger
		value: aMed! !

!MedStoreInTemp methodsFor: 'Misc' stamp: 'wbk 10/24/2004 10:41'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	valueStored expressionsDo: aBlockContext! !

!MedStoreInTemp methodsFor: 'Misc' stamp: 'wbk 10/24/2004 22:02'!
initializeSlot: anInteger value: aMed
	slot := anInteger.
	valueStored := aMed.! !

!MedStoreInTemp methodsFor: 'Unit Testing' stamp: 'wbk 10/23/2004 18:58'!
intermediateForm
	^{#storeInTemp. slot. valueStored intermediateForm}! !

!MedStoreInTemp methodsFor: 'Misc' stamp: 'wbk 10/24/2004 19:10'!
isRegister
	^ false! !

!MedStoreInTemp methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedStoreInTemp methodsFor: 'Misc' stamp: 'wbk 10/24/2004 10:39'!
slot
	^ slot! !

!MedStoreInTemp methodsFor: 'Misc' stamp: 'wbk 10/24/2004 18:00'!
value
	^ valueStored! !

!MedStoreInTemp methodsFor: 'Misc' stamp: 'wbk 10/24/2004 17:35'!
visitWith: anIntermediateSimplifier 
	^ anIntermediateSimplifier visitStoreInTemp: self! !

MedLanguage subclass: #MedTypeSwitch
	instanceVariableNames: 'ifType code failureCode failureBlock variables arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

MedTypeSwitch class
	instanceVariableNames: 'switchValue'!

!MedTypeSwitch class methodsFor: 'instance creation' stamp: 'wbk 6/15/2005 22:54'!
switchOn: aByteSymbol variables: variableMeds ifType: aByteSymbol2 code: aMedPrimitive failureCode: aMedSend failureBlock: anObject 
	^self new 
		initializeSwitchOn: aByteSymbol
		variables: variableMeds 
		ifType: aByteSymbol2
		code: aMedPrimitive
		failureCode: aMedSend
		failureBlock: anObject! !

!MedTypeSwitch methodsFor: 'Misc' stamp: 'wbk 6/15/2005 22:58'!
arguments
	^arguments! !

!MedTypeSwitch methodsFor: 'Misc' stamp: 'wbk 5/29/2005 16:34'!
code
	^ code! !

!MedTypeSwitch methodsFor: 'Misc' stamp: 'wbk 6/15/2005 22:58'!
expressionsDo: aBlockContext 
	aBlockContext value: self.
	arguments expressionsDo: aBlockContext.
	ifType expressionsDo: aBlockContext.
	code expressionsDo: aBlockContext.
	failureCode expressionsDo: aBlockContext.
	failureBlock expressionsDo: aBlockContext! !

!MedTypeSwitch methodsFor: 'Misc' stamp: 'wbk 5/29/2005 16:35'!
failureBlock
	^ failureBlock! !

!MedTypeSwitch methodsFor: 'Misc' stamp: 'wbk 5/29/2005 16:35'!
failureCode
	^ failureCode! !

!MedTypeSwitch methodsFor: 'Misc' stamp: 'wbk 5/29/2005 16:22'!
ifType
	^ ifType! !

!MedTypeSwitch methodsFor: 'Misc' stamp: 'wbk 6/15/2005 22:58'!
initializeSwitchOn: aByteSymbol variables: variableMeds ifType: aByteSymbol2 code: aMedPrimitive failureCode: aMedSend failureBlock: anObject 
	arguments := aByteSymbol.
	variables := variableMeds.
	ifType := aByteSymbol2.
	code := aMedPrimitive.
	failureCode := aMedSend.
	failureBlock := anObject! !

!MedTypeSwitch methodsFor: 'Unit Testing' stamp: 'wbk 6/16/2005 18:37'!
intermediateForm
	^{
		#typeSwitch.
		arguments.
		variables collect: [:each| each intermediateForm].
		(failureBlock blockName).
		{ { ifType. (code intermediateForm) } }.
		(failureCode intermediateForm)
	}! !

!MedTypeSwitch methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedTypeSwitch methodsFor: 'Misc' stamp: 'wbk 6/16/2005 20:21'!
variables
	^ variables! !

!MedTypeSwitch methodsFor: 'Visiting' stamp: 'wbk 5/31/2005 20:43'!
visitWith: aTreeOptimiser 
	^ aTreeOptimiser visitTypeSwitch: self! !

MedLanguage subclass: #MedX86CDQ
	instanceVariableNames: 'eax edx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedX86CDQ class methodsFor: 'as yet unclassified' stamp: 'wbk 2/1/2004 22:18'!
eax: eaxRegister edx: edxRegister
	^ self new						"WBK, change super back to self after the old call has
										been removed"
		initialiseEax: eaxRegister
		edx: edxRegister! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/2/2004 20:41'!
buildInterferenceWith: aColouringRegisterAllocator 
	out do:
		[:each| aColouringRegisterAllocator
			addInterferenceEdge: edx
			to: each]
	! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/1/2004 22:18'!
initialiseEax: aMedMachineRegister edx: aMedMachineRegister2 
	eax := aMedMachineRegister.
	edx := aMedMachineRegister2.! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 20:07'!
intermediateForm
	^ #(cdq)! !

!MedX86CDQ methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedX86CDQ methodsFor: 'Debugging' stamp: 'wbk 3/30/2006 22:54'!
printOn: aWriteStream indentLevel: aSmallInteger 
	self
		indentLevel: aSmallInteger
		on: aWriteStream.
	aWriteStream 
		nextPutAll: '(cdq)';
		cr.! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/1/2004 22:23'!
registersDefined
	^ Lattice with: edx! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/2/2004 19:31'!
registersDo: aBlockContext 
	aBlockContext value: eax.
	aBlockContext value: edx.! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/1/2004 22:19'!
registersUsed
	^ Lattice with: eax! !

!MedX86CDQ methodsFor: 'as yet unclassified' stamp: 'wbk 2/1/2004 22:03'!
visitWith: anAnalyser 
	anAnalyser visitX86Cdq: self
! !

MedLanguage subclass: #MedX86Divide
	instanceVariableNames: 'argument eax edx'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedX86Divide class methodsFor: 'as yet unclassified' stamp: 'wbk 1/29/2004 21:35'!
register: argumentRegister eax: eaxRegister edx: edxRegister
	^ self new
		initializeArgument: argumentRegister
		eax: eaxRegister
		edx: edxRegister! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 15:49'!
argument
	^ argument! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 15:08'!
buildInterferenceWith: anAllocator 
	{eax. edx} do:
		[:eachDefine| out do:
			[:eachUse| anAllocator
				addInterferenceEdge: eachDefine
				to: eachUse]]
	! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/29/2004 21:41'!
initializeArgument: aMedTemporaryRegister eax: eaxRegister edx: edxRegister
	argument := aMedTemporaryRegister.
	eax := eaxRegister.
	edx := edxRegister.
	^ self! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/28/2004 23:31'!
intermediateForm
	^ {#div. argument name}! !

!MedX86Divide methodsFor: 'Unit Testing' stamp: 'wbk 3/19/2006 22:09'!
printOn: aStream
	aStream nextPutAll: self intermediateForm asString! !

!MedX86Divide methodsFor: 'Debugging' stamp: 'wbk 3/30/2006 22:53'!
printOn: aWriteStream indentLevel: aSmallInteger 
	self
		indentLevel: aSmallInteger
		on: aWriteStream.
	aWriteStream nextPutAll: '(div '.
	argument printOn: aWriteStream.
	aWriteStream
		nextPut: $);
		cr.! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 15:32'!
register
	^ argument! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/29/2004 22:05'!
registersDefined
	^ Lattice
		with: eax
		with: edx! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 12:42'!
registersDo: aBlockContext 
	aBlockContext value: argument.
	aBlockContext value: eax.
	aBlockContext value: edx! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/29/2004 20:59'!
registersUsed
	^ Lattice
		with: eax
		with: edx
		with: argument! !

!MedX86Divide methodsFor: 'as yet unclassified' stamp: 'wbk 1/31/2004 15:11'!
visitWith: anAnalyser 
	^ anAnalyser visitDivide: self! !

Object subclass: #MedMethod
	instanceVariableNames: 'blocks nextBlockNumber prolog entryPoints numberOfTemporaries numberOfArguments needsLargeContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Intermediate'!

!MedMethod class methodsFor: 'Unit Testing' stamp: 'wbk 10/5/2002 18:38'!
createAssembly: anArray for: aMachine
	^ IntermediateCreator
		createAssembly: anArray
		for: aMachine! !

!MedMethod class methodsFor: 'Unit Testing' stamp: 'wbk 10/5/2002 13:37'!
createIntermediate: anArray for: aMachine
	^ IntermediateCreator
		createIntermediate: anArray
		for: aMachine! !

!MedMethod class methodsFor: 'instance creation' stamp: 'wbk 10/3/2002 20:10'!
from: aMedMethod
	^ super new initializeFrom: aMedMethod! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/5/2002 21:15'!
addBlock: aMedBlock
	blocks add: aMedBlock! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 7/11/2004 18:43'!
blockAt: aNumber
	^ blocks at: aNumber! !

!MedMethod methodsFor: 'Unit Testing' stamp: 'wbk 10/21/2002 21:26'!
blockAt: blockInteger instructionAt: instructionInteger
	^ (blocks at: blockInteger) instructionAt: instructionInteger! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/3/2002 16:51'!
blockNumbered: anInteger
	^blocks
		detect:  [:each| each blockNumber = anInteger]
		ifNone: 
			[|newBlock|
			newBlock := MedBlock number: anInteger.
			self addBlock: newBlock.
			^ newBlock]! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 7/6/2003 20:49'!
blocksCollect: aBlock
	^ blocks collect: aBlock! !

!MedMethod methodsFor: 'Misc' stamp: 'WBK 8/28/2002 16:13'!
blocksDo: aBlock
	blocks do: aBlock! !

!MedMethod methodsFor: 'Jump Removal' stamp: 'wbk 4/5/2005 21:50'!
blocks: anOrderedCollection 
	blocks := anOrderedCollection.! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 8/17/2005 22:15'!
entryPointBlocksDo: aBlock
	aBlock value: blocks first.
	blocks do: [:each| each isAligned ifTrue: [aBlock value: each]]! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 9/19/2004 16:18'!
entryPoints
	^ entryPoints! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:21'!
expressionsDo: aBlockContext 
	blocks do: [:each| each expressionsDo: aBlockContext].! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 9/22/2004 20:12'!
initialize
	blocks := OrderedCollection new.
	nextBlockNumber := 2.
	entryPoints := OrderedCollection new.
	numberOfTemporaries := 0.
	^ self! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 7/6/2003 20:48'!
initializeFrom: aMedMethod
	self initialize.
	blocks := aMedMethod blocksCollect: [:each| MedBlock number: each blockNumber].
	nextBlockNumber := aMedMethod numberOfBlocks + 1.! !

!MedMethod methodsFor: 'Debugging' stamp: 'wbk 7/11/2004 18:23'!
inspect
	ExuperyMethodInspector inspect: self.! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:19'!
instructionsDo: aBlock 
	self blocksDo: [:each | each instructionsDo: aBlock]! !

!MedMethod methodsFor: 'Unit Testing' stamp: 'wbk 7/6/2003 19:01'!
intermediateForm
	|answer|
	answer := blocks collect: [:each| each intermediateForm].
	^ answer asArray! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/5/2005 22:57'!
needsLargeContext
	^ needsLargeContext ! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/5/2005 22:57'!
needsLargeContext: anInteger
	needsLargeContext := anInteger! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/3/2002 20:17'!
newBlock
	| number newBlock |
	number := nextBlockNumber.
	nextBlockNumber := nextBlockNumber + 1.
	newBlock := MedBlock number: number.
	self addBlock: newBlock.
	^ newBlock! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/3/2002 20:26'!
newBlockFor: aMedBlock
	^ self blockNumbered: aMedBlock blockNumber! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 8/30/2004 15:52'!
nextBlockNumber: aSmallInteger 
	nextBlockNumber := aSmallInteger! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 3/13/2005 20:50'!
numberOfArguments
	^ numberOfArguments! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 3/13/2005 20:44'!
numberOfArguments: aSmallInteger 
	numberOfArguments := aSmallInteger ! !

!MedMethod methodsFor: 'Unit Testing' stamp: 'wbk 10/2/2002 17:59'!
numberOfBlocks
	^ blocks size.! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 9/22/2004 20:12'!
numberOfTemporaries
	^ numberOfTemporaries! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 9/22/2004 20:15'!
numberOfTemporaries: aSmallInteger 
	numberOfTemporaries := aSmallInteger! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 7/6/2003 19:02'!
prolog
	| number |
	prolog ifNotNil: [^ prolog].
	number := nextBlockNumber.
	nextBlockNumber := nextBlockNumber + 1.
	prolog := MedBlock number: number.
	blocks addFirst: prolog.
	^ prolog
	! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 9/19/2004 16:14'!
registerEntryPointWithPC: aSmallInteger label: anIntermediateEmitter 
	entryPoints add: (MethodEntryPoint 
				address: aSmallInteger
				label: anIntermediateEmitter)! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 10/23/2002 22:10'!
registersDo: aBlock
	self instructionsDo: [:each| each registersDo: aBlock].! !

!MedMethod methodsFor: 'Misc' stamp: 'wbk 3/10/2003 10:48'!
visitWith: aVisitor
	^ aVisitor visitMethod: self! !

Object subclass: #MethodEntryPoint
	instanceVariableNames: 'address label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!MethodEntryPoint class methodsFor: 'as yet unclassified' stamp: 'wbk 7/6/2003 18:27'!
address: aSmallInteger label: aSymbol 
	^ self new 
		initializeAddress: aSmallInteger 
		label: aSymbol ! !

!MethodEntryPoint methodsFor: 'as yet unclassified' stamp: 'wbk 7/6/2003 18:47'!
address
	^ address! !

!MethodEntryPoint methodsFor: 'as yet unclassified' stamp: 'wbk 7/6/2003 18:28'!
initializeAddress: aSmallInteger label: aSymbol 
	address := aSmallInteger.
	label := aSymbol.! !

!MethodEntryPoint methodsFor: 'as yet unclassified' stamp: 'wbk 7/6/2003 18:47'!
label
	^ label! !

Object subclass: #MockIntermediateEmitter
	instanceVariableNames: 'callPosition callList expectedRegisteredPC expectedRegisteredBlock registeredPC registeredBlock hasCreatedProlog isAnyOrder expressionsExpected currentBlock blockList storedExpressions currentExpression machine stackSetValue result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!MockIntermediateEmitter class methodsFor: 'as yet unclassified' stamp: 'wbk 11/17/2003 21:58'!
newWith: aMockExuperyPlugin 
	^ self new initialiseMachine: aMockExuperyPlugin! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 1/14/2006 17:19'!
activeCompiledMethodAddress
	^self check: #(#activeCompiledMethodAddress )! !

!MockIntermediateEmitter methodsFor: 'Set Up' stamp: 'wbk 8/5/2003 20:35'!
addExpectedEmission: anArray 
	self createCall: anArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 8/22/2005 18:32'!
addExpression: aMed 
	"Verifies that aMed has been added to the current block. If this fails then check if
	a top level expression is not being added"

	storedExpressions ifNil: [^self].
	aMed ifNil: [^self].
	(aMed isKindOf: MedLanguage) ifTrue: [^self].
	"Registers may be returned by 											
	expressions but they are not part of the
	intermediate generated."
	(aMed isKindOf: MedMachineRegister) ifTrue: [^self].
	aMed first = #emitExpandedSend ifTrue: [^self].
	self uncheckedAddExpression: aMed! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 8/22/2005 18:32'!
addIfRequired: aMed
	(storedExpressions at: currentExpression) = aMed ifTrue:
		[self uncheckedAddExpression: aMed]
! !

!MockIntermediateEmitter methodsFor: 'Mocked Primitives' stamp: 'wbk 5/8/2005 17:13'!
addressOfIndexedElementIn: aMedTemporaryRegister at: aMedTemporaryRegister2 failTo: aMedBlock 
	^ self check: {#addressOfIndexedElement. self asMed: aMedTemporaryRegister.
		self asMed: aMedTemporaryRegister2. aMedBlock blockName}! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 2/1/2006 22:42'!
addressOf: aMedBlock byteCodeAddress: anInteger
	^ self check: {#address. anInteger. aMedBlock blockName}! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/4/2006 19:29'!
addressOf: aMedBlock byteCodeAddress: aByteSymbol argumentCount: aMedLiteral 
	^ self check: {#blockAddress. aByteSymbol. aMedBlock blockName. aMedLiteral}! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 2/13/2005 12:49'!
alignedLabel
	^ self check: #(#alignedLabel)! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 2/13/2005 12:49'!
alignedLabel: aMedBlock 
	^ self checkAndAdd: #(#alignedLabel)! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 7/15/2003 20:20'!
anyOrder
	isAnyOrder := true.! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/13/2005 12:52'!
arithmaticOperator: aSymbol arg1: aMedLiteral arg2: aMedLiteral3 
	^ self check: ({ 
				aSymbol.
				self asMed: aMedLiteral.
				self asMed: aMedLiteral3})! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 2/27/2005 13:29'!
asMed: aMed 
	(aMed isKindOf: MedPicEntry) ifTrue: [^ #picEntry].
	(aMed isKindOf: MedBlock) ifTrue: [^ aMed blockName].
	^ (aMed isKindOf: MedLanguage) 
		ifTrue: [aMed intermediateForm]
		ifFalse: [aMed]! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 11/17/2003 23:31'!
assert: aBoolean 
	self
		assert: aBoolean
		message: 'Assertion failed'! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 11/17/2003 23:30'!
assert: aBoolean message: aString
	aBoolean ifFalse: [self signalFailure: aString]! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:26'!
atCacheEntryEntry: aSymbol index: aSymbol2 
	^ self check: ({ 
				#emitAtCacheEntry.
				aSymbol.
				aSymbol2 intermediateForm})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:26'!
atElementAddressFor: aSmallInteger with: aSmallInteger2 failTo: aMedBlock cacheOffset: anObject 
	^ self check: ({ 
				#emitAtElementAddress.
				self asMed: aSmallInteger.
				self asMed: aSmallInteger2.
				aMedBlock blockName.
				anObject})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 12/13/2004 21:52'!
atPutReceiver: aSymbol index: aSymbol2 value: aSymbol3 failTo: aMedBlock 
	^ self check: {#atPut. self asMed: aSymbol. self asMed: aSymbol2. self asMed: aSymbol3.
					aMedBlock blockName}! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 1/5/2006 21:11'!
basicJumpTo: aMedBlock 
	^ self check: {#jmp. aMedBlock blockName}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 2/13/2005 12:44'!
basicMoveFrom: aMedTemporaryRegister to: aMedLiteral 
	^ self check: ({ 
				#mov.
				self asMed: aMedTemporaryRegister.
				self asMed: aMedLiteral})! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 11/3/2005 19:56'!
basicStackPush: aMedLiteral to: aMedTemporaryRegister 
	^ self check: {#stackPush. self asMed: aMedLiteral. self asMed: aMedTemporaryRegister}! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:27'!
beRootIfNessisary: anArray exitingTo: aMedBlock 
	self checkAndAdd: ({ 
				#beRootIfNessisary.
				anArray.
				aMedBlock blockName})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:27'!
beRoot: anArray ifNeededBy: aSymbol 
	self checkAndAdd: ({ 
				#emitBeRootIfNeeded.
				self asMed: anArray.
				self asMed: aSymbol})! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 1/5/2006 22:10'!
blockReturn: aMedLiteral 
	^ self check: {#blockReturn. self asMed: aMedLiteral}! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/17/2005 21:51'!
callFunctionNamed: aSymbol with: someMeds 
	| answer |
	answer _ ({ 
				#callFunction.
				aSymbol}) asOrderedCollection.
	answer addAll: (someMeds collect: [:each | self asMed: each]).
	^ self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 2/8/2005 23:22'!
checkAndAdd: anArray 
	self addExpression: anArray.
	self check: anArray.
	^ anArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 5/8/2005 20:53'!
checkIsInteger: aSymbol failTo: aSymbol2 
	| blockName |
	blockName := (aSymbol2 isKindOf: MedLanguage) 
				ifTrue: [aSymbol2 blockName]
				ifFalse: [aSymbol2].
	^ self checkAndAdd: ({ 
				#emitCheckIsInteger.
				self asMed: aSymbol.
				blockName})! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 6/21/2003 20:36'!
checkIsMed: anObject
	^ self assert: (anObject isKindOf: MedLanguage)! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 6/4/2005 11:47'!
checkIsNotInteger: aSymbol failTo: aSymbol2 
	^ self checkAndAdd: ({ 
				#emitCheckIsNotInteger.
				self asMed: aSymbol.
				self asMed: aSymbol2})! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 10/13/2003 23:08'!
checkMed: firstMed 
	self assert: (firstMed isKindOf: Array) | firstMed isString | (firstMed isKindOf: MedLanguage).
	^self asMed: firstMed! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/5/2003 21:24'!
check: answer 
	|correct remainingExpressions |
	currentBlock ifNotNil: [self assert: (blockList at: callPosition) = currentBlock].
	callList isEmpty ifTrue: [^ self]. "A crude way to avoid this check when there isn't a call	
									list."
  	correct := self nextCallValue.
	isAnyOrder
		ifTrue: 
			[remainingExpressions := expressionsExpected
				at: answer
				put: (expressionsExpected at: answer) - 1.
			self assert: remainingExpressions >= 0.]
		ifFalse: [self assert: correct = answer].
	^ answer! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 5/31/2005 20:27'!
classOf: aSymbol 
	^ self check: ({ 
				#emitClass.
				self asMed: aSymbol})! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 2/13/2005 12:49'!
conditionalBytecodeArg1: aMedLiteral arg2: aMedLiteral2 withJump: aSymbol failureSelector: aSmallInteger 
	^ self check: ({ 
				#emitConditionalBytecode.
				self asMed: aMedLiteral.
				self asMed: aMedLiteral2.
				aSymbol.
				aSmallInteger})! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 11/6/2005 12:20'!
conditionalJumpTo: aMedBlock onBoolean: aMedLiteral ifBooleanIs: aSymbol pc: aSmallInteger stack: anObject 
	^self checkAndAdd: {
				#conditionalJumpTo.
				(aMedBlock blockName).
				aSymbol.
				(self asMed: aMedLiteral).
				aSmallInteger
			}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/13/2005 12:20'!
convertComparisionToBoolean: aMed jumpType: anObject 
	^ self check: ({ 
				#emitConvertComparisionToBoolean.
				anObject.
				self asMed: aMed})! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 4/9/2006 13:22'!
convertStackToRegisters
	^ self checkAndAdd: #(convertStackToRegisters)! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/13/2005 12:20'!
convertToSmallInteger: aMed failTo: aLabel 
	^ self check: ({ 
				#emitConvertToSmallInteger.
				aLabel blockName.
				aMed})! !

!MockIntermediateEmitter methodsFor: 'Set Up' stamp: 'wbk 1/20/2006 18:47'!
createCall: anArray
	2
		to: anArray size
		do: 
			[:each| 
				(anArray at: each) isCollection & (anArray at: each) isString not
					ifTrue: [self createCall: (anArray at: each)]].
	callList add: anArray.
	blockList add: currentBlock.
	expressionsExpected
		at: anArray
		put: (expressionsExpected
			at: anArray
			ifAbsent: [0]) + 1.! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/6/2003 20:12'!
createProlog
	self assert: hasCreatedProlog not.
	hasCreatedProlog := true.! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 11/17/2003 21:56'!
createTemporaryRegister
	^ machine createTemporaryRegister! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/10/2003 11:48'!
currentBlock
	^ currentBlock! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 9/13/2004 22:08'!
currentBlock: aMedBlock 
	currentBlock := aMedBlock blockName! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 1/2/2005 16:25'!
currentContextAddress
	^ self check: #(currentContextAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 10/25/2005 23:00'!
deconvertBooleanJumpingTo: aMedBlock if: aMedLiteral is: aSymbol pc: aSmallInteger 
	^self check: {
				#deconvertBoolean.
				aSymbol.
				(self asMed: aMedLiteral).
				(aMedBlock blockName).
				aSmallInteger
			}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 5/30/2004 21:52'!
emitJumpTarget: anInteger stackHeight: secondInteger
	stackSetValue := secondInteger.
	^ self check: {#emitJumpTarget. anInteger. secondInteger}.! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 8/10/2003 16:07'!
emit: aSymbol add: anArray 
	^ self check: {#add. self checkMed: aSymbol. self checkMed: anArray}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 11/21/2003 00:07'!
emit: aMedTemporaryRegister and: aLargePositiveInteger 
	^ self check: {#and. self checkMed: aMedTemporaryRegister. self checkMed: aLargePositiveInteger}! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 12/22/2004 21:26'!
emit: firstMed bitShift: secondMed failingTo: aBlock
	^ self check: {#bitShift. aBlock blockName. self asMed: firstMed. self asMed: secondMed}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 3/26/2005 15:20'!
emit: aMedLiteral cmp: anArray 
	^ self check: {#cmp. self asMed: aMedLiteral. self asMed: anArray}! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 12/22/2004 21:46'!
emit: anArray divide: anArray2 failingTo: aMedBlock 
	^self check: { 
				#emitDivide.
				aMedBlock blockName.
				self asMed: anArray.
				self asMed: anArray2}! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 12/22/2004 21:45'!
emit: anArray div: anArray2 failingTo: aMedBlock 
	^self check: { 
				#emitDiv.
				aMedBlock blockName.
				self asMed: anArray.
				self asMed: anArray2}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 11/16/2003 19:17'!
emit: firstMed minus: secondMed 
	| arg2 arg1 |
	arg1 := self checkMed: firstMed.
	arg2 := self checkMed: secondMed.
	^self check: { 
				#sub.
				arg1.
				arg2}! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 12/22/2004 21:47'!
emit: anArray mod: anArray2 failingTo: aMedBlock 
	^self check: { 
				#emitMod.
				aMedBlock blockName.
				self asMed: anArray.
				self asMed: anArray2}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 12/22/2004 21:44'!
emit: firstMed multiply: secondMed failingTo: aLabel 
	^self check: { 
				#emitMultiply.
				aLabel blockName.
				firstMed.
				secondMed}! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 11/21/2003 19:11'!
emit: aLargePositiveInteger or: aMedTemporaryRegister 
	^ self check: {#or. self checkMed: aLargePositiveInteger. self checkMed: aMedTemporaryRegister}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 11/21/2003 19:08'!
emit: aSmallInteger sal: aMedTemporaryRegister 
	^ self check: {#sal. self checkMed: aSmallInteger. self checkMed: aMedTemporaryRegister}! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 3/7/2004 23:33'!
emit: aMedLiteral sar: aMedLiteral2 
	^self check: { 
				#sar.
				self checkMed: aMedLiteral.
				self checkMed: aMedLiteral2}! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:28'!
expandedAtElementAddressFor: aMedLiteral with: aMedLiteral2 failTo: aMedLiteral3 cacheOffset: aMedLiteral4 
	^ self check: ({ 
				#emitExpandedAtElementAddress.
				self asMed: aMedLiteral.
				self asMed: aMedLiteral2.
				aMedLiteral3 blockName.
				aMedLiteral4})! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 12/24/2005 15:06'!
expandedBlockReturnValue: anArray 
	^ self check: ({ 
				#expandedBlockReturn.
				self asMed: anArray})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:22'!
expandedIntegerValueOf: aMedLiteral failTo: aMedBlock 
	^ self check: ({ 
				#emitExpandedIntegerValueOf.
				aMedBlock blockName.
				self asMed: aMedLiteral})! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 1/5/2006 20:23'!
expandedNonlocalReturnValue: anArray 
	^ self check: ({ 
				#expandedNonlocalReturn.
				self asMed: anArray})! !

!MockIntermediateEmitter methodsFor: 'Mocked Primitives' stamp: 'wbk 5/30/2005 17:50'!
expandedPrimitiveReturn: anArray popping: aSmallInteger 
	^ self checkAndAdd: {#expandedPrimitiveReturn. self asMed: anArray. aSmallInteger}! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 12:02'!
expandedReturnValue: aMedMov 
	^ self check: ({ 
				#expandedReturn.
				self asMed: aMedMov})! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 10/25/2005 22:38'!
expandedSendSelector: selectorMed arguments: aCollection pc: pcInteger stack: stackCollection 
	| answer |
	answer := { #emitExpandedSend. (self asMed: selectorMed) } asOrderedCollection.
	answer addAll: (aCollection collect: 
					[:each | 
					(each isKindOf: MedLanguage) 
						ifTrue: [each intermediateForm]
						ifFalse: [each]]).
	answer add: #stack.
	answer addAll: (stackCollection collect: [:each | self asMed: each]).
	self addIfRequired: answer asArray.
	^self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/13/2005 12:52'!
expanded: aMedLiteral divide: aMedLiteral2 failingTo: aMedBlock 
	^ self check: ({ 
				#emitExpandedDivide.
				self asMed: aMedLiteral.
				self asMed: aMedLiteral2.
				aMedBlock blockName})! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/13/2005 12:51'!
expanded: aMedLiteral div: aMedLiteral2 failingTo: aMedBlock 
	^ self check: ({ 
				#emitExpandedDiv.
				self asMed: aMedLiteral.
				self asMed: aMedLiteral2.
				aMedBlock blockName})! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/13/2005 12:52'!
expanded: aMedLiteral mod: aMedLiteral2 failingTo: aMedBlock 
	^ self check: ({ 
				#emitExpandedMod.
				self asMed: aMedLiteral.
				self asMed: aMedLiteral2.
				aMedBlock blockName})! !

!MockIntermediateEmitter methodsFor: 'Set Up' stamp: 'wbk 12/21/2004 13:36'!
expectEmission: anArray 
	| blockName |
	storedExpressions := OrderedCollection new.
	anArray do: 
			[:each | 
			blockName := each at: 1.
			currentBlock := blockName.
			2 
				to: each size
				do: 
					[:eachLocation | 
					self addExpectedEmission: (each at: eachLocation).
					"Don't expect sends because they are already fully added. They may
				occur in expression trees (they return a register)."
					
					storedExpressions addLast: (each at: eachLocation)]].
	currentBlock := #block1! !

!MockIntermediateEmitter methodsFor: 'Set Up' stamp: 'wbk 7/6/2003 15:59'!
expectRegisterEntryPointPC: aSmallInteger blockNumbered: aSmallInteger2 
	expectedRegisteredPC := aSmallInteger.
	expectedRegisteredBlock := aSmallInteger2.! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 3/27/2005 12:43'!
failToOperation: operation failTo: aBlockContext failureSelector: aSmallInteger arguments: anArray 
	| registers answer |
	answer := OrderedCollection new.
	answer add: operation.
	answer addAll: (anArray collect: [:each | self asMed: each]).
	registers := anArray size = 2 
				ifTrue: 
					[#(#t1 #t2 )]
				ifFalse: 
					[#(#t1 #t2 #t3 )].
	answer addAll: registers.
	answer add: (aBlockContext 
				value: registers
				value: result newBlock).
	answer add: aSmallInteger.
	^self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 2/13/2005 12:53'!
falseAddress
	^ self check: #(#falseAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:28'!
fetchAddress: aSmallInteger ofObject: anArray 
	| index |
	index _ (aSmallInteger isKindOf: MedLanguage) 
				ifTrue: [aSmallInteger literal]
				ifFalse: [aSmallInteger].
	^ self check: ({ 
				#emitFetchAddress.
				index.
				self asMed: anArray})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:29'!
fetchVariableAddress: anArray ofObject: aSymbol 
	^ self check: ({ 
				#emitFetchVariableAddress.
				anArray.
				aSymbol})! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/6/2003 20:10'!
hasCreatedProlog
	^ hasCreatedProlog! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 1/14/2006 22:01'!
homeContext
	^ self check: #(homeContext)! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 1/14/2006 18:55'!
initialCompiledMethodAddress
	^ self check: #(initialCompiledMethodAddress)! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 11/17/2003 21:59'!
initialiseMachine: aMockExuperyPlugin 
	machine := aMockExuperyPlugin.
	^ self! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:13'!
initialize
	callPosition := 1.
	callList := OrderedCollection new.
	hasCreatedProlog := false.
	isAnyOrder := false.
	result := MedMethod new.
	result blockNumbered: 1.	"Simulate creation of the first block"
	expressionsExpected := Dictionary new.
	blockList := OrderedCollection new.
	currentExpression := 1.
	^self! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 11/3/2004 22:04'!
instanceVariableAddress: aSmallInteger 
	^ self check: {#instanceVariableAddress. aSmallInteger}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/13/2005 12:22'!
integerValueOf: aFirstObject failTo: overflowBlock 
	^ self check: ({ 
				#emitIntegerValueOf.
				overflowBlock blockName.
				self asMed: aFirstObject})! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 11/26/2005 21:49'!
jumpIfFalseTo: aLabel onBoolean: anExpression 
	^ self checkAndAdd: ({ 
				#emitJumpIfFalse.
				aLabel.
				self asMed: anExpression})! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 2/13/2005 12:48'!
jumpIfTrueTo: anArray onBoolean: aSymbol 
	^ self check: ({ 
				#emitJumpIfTrue.
				anArray.
				aSymbol})! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 11/26/2005 23:23'!
jumpTarget: anInteger 
	^ self checkAndAdd: ({ 
				#emitJumpTarget.
				anInteger})! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 2/13/2005 12:46'!
jumpTo: aLabel 
	| label |
	label _ aLabel class ~= MedBlock 
				ifTrue: [self asMed: aLabel]
				ifFalse: [aLabel blockName].
	^ self checkAndAdd: ({ 
				#jmp.
				label})! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 8/30/2004 18:02'!
jumpType: aSymbol to: aSymbol2 dependingOn: anArray 
	| blockName |
	blockName := aSymbol2 isString
		ifTrue: [aSymbol2]
		ifFalse: [aSymbol2 blockName].
	^ self check: {aSymbol. blockName. self asMed: anArray}! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 2/13/2005 12:47'!
label
	^ self check: #(#label)! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/13/2005 12:52'!
labelArguments: someArguments registers: someRegisters around: anArray failingTo: anArray3 failureBlock: anObject 
	| answer |
	answer _ OrderedCollection new.
	answer add: #label1.
	answer add: anObject blockName.
	answer addAll: (someArguments collect: [:each | self asMed: each]).
	answer addAll: (someRegisters collect: [:each | self asMed: each]).
	answer add: anArray.
	answer add: anArray3.
	^ self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 2/13/2005 12:47'!
labelForByteCode: anInteger 
	^ self check: ({ 
				#emitLabelForByteCode.
				anInteger})! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 2/13/2005 12:54'!
literalAddress: aSmallInteger 
	^ self check: ({ 
				#emitLiteralAddress.
				aSmallInteger})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 4/23/2005 17:16'!
loadCurrentContext
	^ self checkAndAdd: #(loadCurrentContext)! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 12/11/2004 19:55'!
machine
	machine isNil ifFalse: [^ machine].
	^ MockExuperyPlugin new! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 11/26/2005 21:45'!
materialiseStack
	^ self checkAndAdd: #(materialiseStack)! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 2/13/2005 12:03'!
mem: aMedLiteral 
	^ self check: ({ 
				#mem.
				self checkMed: aMedLiteral})! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:13'!
method
	^result! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 2/13/2005 12:44'!
moveFrom: fromMed to: toMed 
	^ self checkAndAdd: ({ 
				#mov.
				self checkMed: fromMed.
				self checkMed: toMed})! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 2/13/2005 12:45'!
moveToEax: aMed 
	self assert: (aMed isKindOf: MedLanguage).
	self checkAndAdd: ({ 
				#emitMoveToEax.
				aMed literal})! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 2/13/2005 12:43'!
moveToTemp: anArray 
	^ self check: ({ 
				#emitMoveToTemp.
				self checkMed: anArray})! !

!MockIntermediateEmitter methodsFor: 'Mocked Misc' stamp: 'wbk 10/5/2005 22:59'!
needsLargeContext: aSmallInteger 
	! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 8/30/2004 16:13'!
newBlock
	^result newBlock! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 7/15/2003 21:48'!
nextCallValue
	| answer |
	self assert: callPosition <= callList size.
	answer := callList at: callPosition.
	callPosition := callPosition + 1.
	^ answer! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 2/13/2005 12:54'!
nilAddress
	^ self check: #(#nilAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Misc' stamp: 'wbk 1/14/2006 18:16'!
nowSimplifying
	! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 3/13/2005 20:44'!
numberOfArguments: aSmallInteger 
	! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/6/2003 20:07'!
numberOfTemporaries: aSmallInteger 
	! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/27/2005 13:37'!
picLocatedAt: aMedTemporaryRegister picEntry: anObject 
	self checkAndAdd: ({ 
				#pic.
				self asMed: aMedTemporaryRegister})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:29'!
popIntoReceiver: aSymbol slot: aSmallInteger 
	^ self check: ({ 
				#storeInReceiver.
				aSmallInteger.
				self asMed: aSymbol})! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:29'!
popIntoTemp: aMedLiteral slot: aSmallInteger 
	^ self check: ({ 
				#storeInTemp.
				aSmallInteger.
				self asMed: aMedLiteral})! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 3/4/2005 14:21'!
pop: aMedMachineRegister 
	^ self checkAndAdd: {#pop. self asMed: aMedMachineRegister}! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 12:04'!
preamble
	self checkAndAdd: #(#preamble)! !

!MockIntermediateEmitter methodsFor: 'Mocked Primitives' stamp: 'wbk 4/30/2005 17:12'!
primitiveArgument: aSmallInteger 
	^ self check: {#primitiveArgument. aSmallInteger}! !

!MockIntermediateEmitter methodsFor: 'Mocked Primitives' stamp: 'wbk 4/30/2005 17:39'!
primitiveReturn: anArray 
	self checkAndAdd: {#primitiveReturn. self asMed: anArray}! !

!MockIntermediateEmitter methodsFor: 'Mocked Primitives' stamp: 'wbk 11/6/2005 19:03'!
primitiveReturn: anArray popping: aSmallInteger receiver: anObject 
	^self checkAndAdd: {
				#primitiveReturn.
				(self asMed: anArray).
				aSmallInteger
			}! !

!MockIntermediateEmitter methodsFor: 'Mocked Primitives' stamp: 'wbk 11/6/2005 18:34'!
primitive: aByteSymbol arguments: anArray failureBlock: aMedBlock receiver: anObject 
	| answer |
	answer := OrderedCollection 
				with: #primitive
				with: aByteSymbol
				with: aMedBlock blockName.
	answer addAll: (anArray collect: [:each | self asMed: each]).
	^self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/18/2005 21:14'!
push: aMedMachineRegister 
	^ self checkAndAdd: {#push. self asMed: aMedMachineRegister}! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 2/13/2005 12:58'!
receiver
	^ self check: #(#receiver)! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 2/13/2005 12:58'!
receiverAddress
	^ self check: #(#receiverAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 1/30/2005 14:44'!
recycleContextIfPossible: aMedTemporaryRegister 
	self checkAndAdd: {#recycleContextIfPossible. self asMed: aMedTemporaryRegister}! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 12:10'!
registerEntryPointWithPC: aLiteral label: aMedBlock 
	expectedRegisteredPC ifNil: [^self].
	registeredPC := aLiteral.
	registeredBlock := aMedBlock isMedBlock
		ifTrue: [aMedBlock blockName]
		ifFalse: [aMedBlock].
	self assert: registeredPC literal = expectedRegisteredPC.
	self assert: registeredBlock = expectedRegisteredBlock.
	self assert: (aLiteral isKindOf: MedLanguage)! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/11/2006 11:38'!
reloadStack: anArray 
	| answer |
	answer := { #reloadStack } asOrderedCollection.
	answer addAll: (anArray collect: [:each | self checkMed: each]).
	self checkAndAdd: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 12:04'!
restoreContextWithPC: aSmallInteger stack: anObject 
	| answer |
	answer _ ({ 
				#emitRestoreContext.
				aSmallInteger}) asOrderedCollection.
	answer addAll: (anObject collect: 
					[:each | 
					each isSymbol | each isNumber 
						ifTrue: [each]
						ifFalse: [each name]]).
	self checkAndAdd: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 3/4/2005 20:26'!
restoreSendersFrame
	^ self checkAndAdd: #(restoreSendersFrame)! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:13'!
result
	^result! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/30/2004 16:17'!
result: aMedMethod 
	result := aMedMethod! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 3/4/2005 14:10'!
ret
	self checkAndAdd: #(ret)! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 5/5/2005 21:49'!
return
	^ self checkAndAdd: #(return)! !

!MockIntermediateEmitter methodsFor: 'Mocked Low Level Emission ' stamp: 'wbk 3/4/2005 13:49'!
returnSequence
	self checkAndAdd: ({ 
				#returnSequence})! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/12/2005 23:08'!
returnToCompiledMethod: anArray 
	self checkAndAdd: {#returnToCompiledMethod. self asMed: anArray}! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 10:21'!
returnToInterpreter
	^ self checkAndAdd: #(returnToInterpreter)! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 11/26/2005 23:25'!
returnValue: anArray 
	| answer |
	answer := ({ 
				#emitReturnValue.
				self asMed: anArray}).
	self addExpression: answer.
	^ self check: answer! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:30'!
rootTableAddress
	^ self check: #(#rootTableAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:30'!
rootTableCountAddress
	^ self check: #(#rootTableCountAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Misc' stamp: 'wbk 3/28/2006 21:52'!
saveRegistersAround: anArray 
	| answer |
	answer := {#saveRegistersAround. anArray value}.
	self check: answer.
	^ answer! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 4/9/2006 13:25'!
saveStackPointerIntoContext: anOrderedCollection 
	^ self checkAndAdd: #(saveStackPointerIntoContext)! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 3/29/2006 22:11'!
saveStackToContext: anOrderedCollection 
	^ self checkAndAdd: #(saveStackToContext)! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 10/25/2005 23:12'!
sendSelector: anEmitter arguments: aCollection pc: pcInteger selectorName: anObject 
	| answer |
	answer := {
				#emitSend.
				(anEmitter intermediateForm).
				pcInteger
			} asOrderedCollection.
	answer addAll: (aCollection collect: 
					[:each | 
					(each isKindOf: MedLanguage) 
						ifTrue: [each intermediateForm]
						ifFalse: [each]]).
	^self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 6/3/2005 17:34'!
sendSelector: anEmitter arguments: aCollection selectorName: anObject 
	| answer |
	answer := { #emitSend. anEmitter } asOrderedCollection.
	answer addAll: (aCollection collect: 
					[:each | 
					(each isKindOf: MedLanguage) 
						ifTrue: [each intermediateForm]
						ifFalse: [each]]).
	^self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 11/26/2005 22:00'!
setInitialStackHeight: aSmallInteger 
! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 12:25'!
setProgramCounter: aMedLiteral 
	self check: ({ 
				#emitSetProgramCounter.
				aMedLiteral literal})! !

!MockIntermediateEmitter methodsFor: 'Mocked Arithmatic' stamp: 'wbk 3/27/2005 14:53'!
sideEffectingLabelArguments: someArguments registers: someRegisters around: anArray failingTo: anArray3 failureBlock: anObject 
	| answer |
	answer := OrderedCollection new.
	answer add: #sideEffectsLabel1.
	answer add: anObject blockName.
	answer addAll: (someArguments collect: [:each | self asMed: each]).
	answer addAll: (someRegisters collect: [:each | self asMed: each]).
	answer add: anArray.
	answer add: anArray3.
	^ self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 3/27/2005 12:45'!
sideEffectsWithFailTo: aBlockContext failureSpecialSelector: aSmallInteger arguments: anArray 
	
	^ self 
		failToOperation: #sideEffectsWithFailTo
		failTo: aBlockContext
		failureSelector: aSmallInteger
		arguments: anArray! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/17/2003 17:00'!
signalFailure: anObject 
	TestResult failure sunitSignalWith: anObject! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 1/27/2006 22:25'!
simplifiedHomeContext
	^ self check: #(simplifiedHomeContext)! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 1/14/2006 22:47'!
simplifiedHomeContext: anObject 
	^self check: #(#simplifiedHomeContext )! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 1/27/2006 22:15'!
simplifiedInstanceVariableAddress: aSmallInteger 
	^ self check: {#simplifiedInstanceVariableAddress. aSmallInteger}! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 1/27/2006 21:01'!
simplifiedReceiverAddress
	^ self check: #(simplifiedReceiverAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 1/14/2006 22:53'!
simplifiedTemporaryAddress: aSmallInteger isInBlock: anObject 
	^self check: { #simplifiedTemporaryAddress. aSmallInteger }! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 4/30/2005 17:35'!
sizeOfObject: aMedTemporaryRegister 
	^ self check: {#sizeOfObject. self asMed: aMedTemporaryRegister}! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:18'!
specialObject: aSmallInteger 
	^ self check: ({ 
				#emitSpecialObject.
				aSmallInteger})! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 2/13/2005 12:18'!
specialSelector: aSmallInteger 
	^ self check: ({ 
				#emitSpecialSelector.
				aSmallInteger})! !

!MockIntermediateEmitter methodsFor: 'Mocked Primitives' stamp: 'wbk 5/6/2005 21:38'!
stackFor: anArray at: aMedTemporaryRegister put: aMedLiteral 
	^ self checkAndAdd: 
		{#stackForAtPut. self asMed: anArray. self asMed: aMedTemporaryRegister.
			self asMed: aMedLiteral}! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 6/27/2004 22:47'!
stackRegister: aSmallInteger 
	^ machine registerNamed: ('s', aSmallInteger printString) asSymbol! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 5/30/2004 21:36'!
stackSetValue
	^ stackSetValue! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 7/28/2003 13:32'!
state: anExuperyStack 
	! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 2/13/2005 12:59'!
temporaryAddress: anInteger 
	^ self check: ({ 
				#emitTemporaryAddress.
				anInteger})! !

!MockIntermediateEmitter methodsFor: 'Mocked Addresses' stamp: 'wbk 2/13/2005 12:59'!
trueAddress
	^ self check: #(#trueAddress)! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 6/16/2005 20:56'!
typeSwitchOn: someArguments ifType: aMedLiteral2 code: aMedArithmatic failureCode: aMedSend failureBlock: aMedBlock 
0 removeMe.
	^self check: {
				#typeSwitch.
				(self asMed: someArguments).
				(self asMed: aMedBlock).
				(self asMed: aMedLiteral2).
				(self asMed: aMedArithmatic).
				(self asMed: aMedSend)
			}! !

!MockIntermediateEmitter methodsFor: 'Mocked Sends and Returns' stamp: 'wbk 6/16/2005 20:59'!
typeSwitchOn: someArguments variables: someVariables ifType: ifMed code: codeMed failureCode: failureMed failureBlock: aMedBlock 
	| answer |
	answer := OrderedCollection with: #typeSwitch.
	answer addAll: (someArguments collect: [:each | self asMed: each]).
	answer addAll: (someVariables collect: [:each | self asMed: each]).
	answer addAll: 
		{(self asMed: aMedBlock).
			(self asMed: ifMed).
			(self asMed: codeMed).
			(self asMed: failureMed)}.
	^self check: answer asArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Interface' stamp: 'wbk 11/26/2005 23:23'!
uncheckedAddExpression: aMed 
	| correct |
	correct := storedExpressions at: currentExpression.
	self 
		assert: (self asMed: aMed) = correct
		message: 'Wrong expression added to the current block'.
	currentExpression := currentExpression + 1! !

!MockIntermediateEmitter methodsFor: 'Misc' stamp: 'wbk 8/17/2003 17:00'!
verify
	callPosition = (callList size + 1) ifFalse: [self signalFailure: 'Wrong Number of Calls'].
	expectedRegisteredPC ifNotNil: [self assert: registeredPC isNil not].
	storedExpressions ifNotNil: [self assert: currentExpression = (storedExpressions size + 1)].! !

!MockIntermediateEmitter methodsFor: 'Mocked Jumps and Conditionals' stamp: 'wbk 3/27/2005 12:48'!
withFailTo: aBlockContext failureSpecialSelector: aSmallInteger arguments: anArray 
	^ self 
		failToOperation: #emitWithFailTo
		failTo: aBlockContext
		failureSelector: aSmallInteger
		arguments: anArray! !

!MockIntermediateEmitter methodsFor: 'Mocked Memory Access' stamp: 'wbk 2/13/2005 12:30'!
youngStartAddress
	^ self check: #(#youngStartAddress)! !

Object subclass: #MockIntermediateGenerator
	instanceVariableNames: 'byteCodes primitive stackString doEmitAddresses callList callPosition expectedTemporaries isTemporariesSet isCheckingSendRentry sendPosition stackSizeOnSend state numberOfArguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!MockIntermediateGenerator methodsFor: 'Misc Mocked Methods' stamp: 'wbk 10/23/2004 22:23'!
addExpression: aMockIntermediateGenerator 
! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 7/11/2003 22:36'!
addUnknownByteCode
	self error: 'Unknown bytecode'.! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 7/4/2003 12:17'!
assert: aBoolean
	aBoolean ifFalse: [TestResult failure sunitSignalWith: 'Assertion Failed']! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/15/2002 14:38'!
byteCodeAddress: anInteger
	doEmitAddresses ifTrue: [byteCodes add: {#byteCode. anInteger}]! !

!MockIntermediateGenerator methodsFor: 'accessing' stamp: 'WBK 8/26/2002 20:12'!
byteCodeString
	|answer|
	answer := ''.
	byteCodes do: [:each| each isString 
		ifTrue: [answer := answer , ' ', each]
		ifFalse: [answer := answer, ' ', (each at: 1), ' ', (each at: 2) asString]].
	^ answer 
		copyFrom: 2 
		to: answer size! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 7/15/2003 13:09'!
checkStackSizeOnSend: aSmallInteger 
	stackSizeOnSend := aSmallInteger! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 4/21/2005 22:08'!
check: anArray 
	| rightAnswer |
	callList isNil ifTrue: [^anArray].
	rightAnswer := self nextCall.
	rightAnswer = anArray ifFalse: [self failure].
	^anArray! !

!MockIntermediateGenerator methodsFor: 'Misc Mocked Methods' stamp: 'wbk 4/21/2005 20:45'!
createContext
	^ self check: #(createContext)! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 10/20/2002 16:19'!
createExpectedCall: anArray
	2
		to: anArray size
		do:
			[:each| ((anArray at: each) isString | (anArray at: each) isNumber) not ifTrue: 
				[self createExpectedCall: (anArray at: each)]].
	callList addLast: anArray! !

!MockIntermediateGenerator methodsFor: 'Misc Mocked Methods' stamp: 'wbk 10/25/2005 22:25'!
currentBlock
	^ MedBlock new! !

!MockIntermediateGenerator methodsFor: 'Mocked Stack Registers' stamp: 'wbk 6/27/2004 22:56'!
emitter
	^ MockIntermediateEmitter newWith: MachineX86 new.! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 10/20/2002 16:34'!
failure
	TestResult failure sunitSignalWith: 'Assertion Failed'! !

!MockIntermediateGenerator methodsFor: 'Misc Mocked Methods' stamp: 'wbk 7/6/2003 20:17'!
finish
! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 2/22/2004 16:36'!
generateBinarySelector: anObject receiver: receiverMed argument: argumentMed 
	stackSizeOnSend ifNotNil: [self assert: state stackSize = stackSizeOnSend].
	^self check: { 
				#binarySendWithSpecialSelector.
				anObject.
				receiverMed.
				argumentMed}! !

!MockIntermediateGenerator methodsFor: 'Mocked Common Sends' stamp: 'wbk 3/1/2004 19:48'!
generateClass: anArray 
	^ self check: {#class. anArray}! !

!MockIntermediateGenerator methodsFor: 'Mocked Common Sends' stamp: 'wbk 2/14/2004 15:21'!
generateNew: anArray 
	^ self check: {#sendNew. anArray}! !

!MockIntermediateGenerator methodsFor: 'Mocked Common Sends' stamp: 'wbk 2/22/2004 13:28'!
generateUnarySelector: aSmallInteger receiver: anArray 
	^ self check: {#sendUnarySelector. aSmallInteger. anArray}! !

!MockIntermediateGenerator methodsFor: 'Arithmatic' stamp: 'wbk 10/24/2004 22:48'!
generate: firstObject add: secondObject 
	byteCodes add: 'sendPlus'.
	^self check: { 
				#sendAdd.
				firstObject.
				secondObject}! !

!MockIntermediateGenerator methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:17'!
generate: anArray bitAnd: anArray2 
	^self check: { 
				#bitAnd.
				anArray.
				anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/5/2004 20:44'!
generate: anArray bitOr: anArray2 
	^ self check: {#bitOr. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/8/2004 19:09'!
generate: anArray bitShift: anArray2 
	^ self check: {#bitShift. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Arithmatic' stamp: 'wbk 2/8/2004 16:18'!
generate: anArray divide: anArray2 
	^self check: { 
				#divide.
				anArray.
				anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/5/2004 22:06'!
generate: anArray div: anArray2 
	^ self check: {#div. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/27/2004 21:25'!
generate: anArray equivilent: anArray2 
	^ self check: {#equivilent. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Common Sends' stamp: 'wbk 2/13/2004 20:30'!
generate: anArray makePoint: anArray2 
	^ self check: {#makePoint. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Arithmatic' stamp: 'wbk 2/7/2004 20:36'!
generate: anArray mod: anArray2 
	^ self check: {#mod.  anArray.  anArray2}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 2/8/2004 16:19'!
generate: firstObject multiply: secondObject 
	byteCodes add: 'sendMultiply'.
	^self check: { 
				#sendMultiply.
				firstObject.
				secondObject}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 2/8/2004 16:20'!
generate: firstObject subtract: secondObject 
	byteCodes add: 'sendMultiply'.
	^self check: { 
				#sendMinus.
				firstObject.
				secondObject}! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 7/6/2003 17:13'!
initialize
	byteCodes := OrderedCollection new.
	stackString := ''.
	doEmitAddresses := false.
	primitive := 0.
	isTemporariesSet := false.
	isCheckingSendRentry := false.! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 2/28/2004 15:35'!
jumpIfFalse: aMed to: anInteger 
	byteCodes add: { 
				#jumpFalse.
				anInteger}.
	^self check: { 
				#jumpFalse.
				aMed.
				anInteger}! !

!MockIntermediateGenerator methodsFor: 'Mocked Jumps' stamp: 'wbk 2/14/2004 11:54'!
jumpIfTrue: anArray to: aSmallInteger 
	^ self check: {#jumpIfTrue. anArray. aSmallInteger}! !

!MockIntermediateGenerator methodsFor: 'Mocked Jumps' stamp: 'wbk 2/13/2005 12:46'!
jumpTo: anInteger 
	byteCodes add: ({ 
				#jumpTo.
				anInteger}).
	^ self check: ({ 
				#jumpTo.
				anInteger})! !

!MockIntermediateGenerator methodsFor: 'Misc Mocked Methods' stamp: 'wbk 10/5/2005 22:55'!
needsLargeContext: aTrue 
! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 10/20/2002 16:17'!
nextCall
	| answer |
	answer := callList at: callPosition.
	callPosition := callPosition + 1.
	^ answer! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 3/13/2005 18:20'!
numberOfArguments
	^ numberOfArguments! !

!MockIntermediateGenerator methodsFor: 'Misc Mocked Methods' stamp: 'wbk 3/13/2005 20:21'!
numberOfArguments: aSmallInteger 
	numberOfArguments := aSmallInteger! !

!MockIntermediateGenerator methodsFor: 'accessing' stamp: 'WBK 8/26/2002 18:23'!
numberOfBytecodes
	^ byteCodes size! !

!MockIntermediateGenerator methodsFor: 'Misc Mocked Methods' stamp: 'wbk 7/4/2003 12:20'!
numberOfTemporaries: anInteger
	expectedTemporaries ifNil: [^ self].
	self assert: anInteger = expectedTemporaries.
	isTemporariesSet := true.! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/24/2004 22:48'!
popIntoTemp: aValue slot: anInteger 
	byteCodes add: { 
				#popIntoTemp.
				anInteger}.
	^ self check: { 
				#popIntoTemp.
				anInteger.
				aValue}! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 10/4/2003 19:42'!
popStack: aMed 
	^self check: { 
				#popStack.
				aMed}! !

!MockIntermediateGenerator methodsFor: 'accessing' stamp: 'WBK 8/26/2002 18:40'!
primitiveNumber
	^ primitive! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/14/2004 21:36'!
prim: anArray equals: anArray2 
	^ self check: {#equals. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/14/2004 21:19'!
prim: anArray greaterThanEqual: anArray2 
	^ self check: {#greaterThanEqual. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/12/2004 21:50'!
prim: anArray greaterThan: anArray2 
	^ self check: {#greaterThan. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/17/2004 22:13'!
prim: firstObject lessThanEquals: secondObject 
	byteCodes add: 'sendLessThanEquals'.
	^self check: { 
				#sendLessThanEquals.
				firstObject.
				secondObject}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/6/2004 23:21'!
prim: anArray lessThan: anArray2 
	^ self check: {#lessThan. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Comparision' stamp: 'wbk 1/17/2004 19:04'!
prim: anArray notEquals: anArray2 
	^ self check: {#notEquals. anArray. anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/4/2003 19:42'!
pushConstant: aLiteral slot: aNumber 
	byteCodes add: { 
				'pushConstant'.
				aLiteral}.
	^self check: { 
				#pushConstant.
				aLiteral}! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 6/13/2004 16:00'!
pushFalse
	byteCodes add: 'pushFalse'.
	^self check: #(#pushFalse)! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 10/4/2003 19:42'!
pushInstanceVariable: aSmallInteger 
	^self check: { 
				#pushInstanceVariable.
				aSmallInteger}! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/4/2003 19:42'!
pushLiteralVariable: aReadOnlyVariableBinding slot: aSmallInteger 
	byteCodes add: { 
				'pushLiteralVariable'.
				aSmallInteger}.
	^self check: { 
				#pushLiteralVariable.
				aSmallInteger}! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 2/28/2004 16:09'!
pushNil
	byteCodes add: #pushNil.
	^self check: #(#pushNil)! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/4/2003 19:42'!
pushSelf
	byteCodes add: { 
				#pushSelf}.
	^self check: { 
				#pushSelf}! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/4/2003 19:42'!
pushTempAt: anInteger 
	byteCodes add: { 
				#pushTemp.
				anInteger}.
	^self check: { 
				#pushTemp.
				anInteger}! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 6/13/2004 15:59'!
pushTrue
	byteCodes add: 'pushTrue'.
	^self check: { 
				#pushTrue}! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 10/15/2002 14:41'!
recordByteCodeNumbers
	doEmitAddresses := true.! !

!MockIntermediateGenerator methodsFor: 'return bytecodes' stamp: 'wbk 11/27/2003 21:20'!
returnFalse
	self check: #(returnFalse)! !

!MockIntermediateGenerator methodsFor: 'return bytecodes' stamp: 'wbk 10/18/2003 12:54'!
returnNil
	^ self check: #(returnNil)! !

!MockIntermediateGenerator methodsFor: 'return bytecodes' stamp: 'wbk 10/4/2003 19:42'!
returnSelf
	byteCodes add: 'returnSelf'.
	self check: { 
				#returnSelf}! !

!MockIntermediateGenerator methodsFor: 'return bytecodes' stamp: 'wbk 10/4/2003 19:42'!
returnTop: anObject 
	byteCodes add: 'returnTop'.
	^self check: { 
				#returnTop.
				anObject}! !

!MockIntermediateGenerator methodsFor: 'return bytecodes' stamp: 'wbk 11/27/2003 19:49'!
returnTrue
	^ self check: #(returnTrue)! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 10/4/2003 19:42'!
sendAtPutTo: anArray location: anArray2 value: anArray22 
	^self check: { 
				#sendAtPut.
				anArray.
				anArray2.
				anArray22}! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 10/4/2003 19:42'!
sendAtTo: anArray with: anArray2 
	^self check: { 
				'sendAt'.
				anArray.
				anArray2}! !

!MockIntermediateGenerator methodsFor: 'Mocked Byte Codes' stamp: 'wbk 10/4/2003 19:42'!
sendSelector: aSymbol inSlot: selectorInteger arguments: someArguments 
	| answer |
	stackSizeOnSend ifNotNil: [self assert: state stackSize = stackSizeOnSend].
	answer := { 
				#send.
				aSymbol} asOrderedCollection.
	"aStack size - argumentInteger to: aStack size
		do: [:each | answer addLast: (aStack at: each)]."
	someArguments do: [:each | answer addLast: each].
	byteCodes add: answer.
	isCheckingSendRentry ifTrue: [sendPosition := callPosition].
	^self check: answer asArray! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 10/20/2002 16:25'!
setExpectedBytecodes: anArray
	callPosition := 1.
	callList := OrderedCollection new.
	anArray do: [:each| self createExpectedCall: each].! !

!MockIntermediateGenerator methodsFor: 'Checking Expected Calls' stamp: 'wbk 7/4/2003 12:11'!
setExpectedTemporaries: aSmallInteger 
	expectedTemporaries := aSmallInteger! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'WBK 8/26/2002 18:39'!
setPrimitive: anInteger
	primitive := anInteger! !

!MockIntermediateGenerator methodsFor: 'accessing' stamp: 'WBK 8/26/2002 21:57'!
stackString
	^ stackString
! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 7/29/2003 12:10'!
state: anExuperyStack 
	state := anExuperyStack
	! !

!MockIntermediateGenerator methodsFor: 'Primitives' stamp: 'wbk 6/13/2004 16:05'!
storeAndPopReceiverVariableIndex: aSymbol value: aSymbol2 
	byteCodes add: {#storeIntoReceiver. aSymbol}.
	self check: { 
				#storeAndPopReceiverVariable.
				aSymbol.
				aSymbol2}! !

!MockIntermediateGenerator methodsFor: 'misc' stamp: 'wbk 10/18/2003 13:48'!
verify
	expectedTemporaries ifNotNil: [self assert: isTemporariesSet].
	isCheckingSendRentry ifTrue: [self assert: sendPosition isNil].
	callList ifNotNil: [self assert: callList size + 1 = callPosition]! !

Object subclass: #MockRelocator
	instanceVariableNames: 'relocations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!MockRelocator methodsFor: 'Mocked' stamp: 'wbk 2/4/2006 12:20'!
addRelocationAt: aSmallInteger for: aMedBlock 
self removeMe.
	relocations remove: aSmallInteger -> aMedBlock blockName.! !

!MockRelocator methodsFor: 'Mocked' stamp: 'wbk 2/4/2006 12:23'!
addRelocationAt: aSmallInteger for: aMedBlock byteCodeAddress: anInteger
	relocations remove: {aSmallInteger. aMedBlock blockName. anInteger}! !

!MockRelocator methodsFor: 'Mocked' stamp: 'wbk 2/4/2006 23:14'!
addRelocationAt: aSmallInteger for: aMedBlock byteCodeAddress: aByteSymbol argumentCount: aByteSymbol4 
	relocations remove: {aSmallInteger. aMedBlock blockName. aByteSymbol. aByteSymbol4}! !

!MockRelocator methodsFor: 'Misc' stamp: 'wbk 2/4/2006 12:22'!
expectRelocationAt: anInteger
self removeMe.
	relocations add: anInteger! !

!MockRelocator methodsFor: 'Misc' stamp: 'wbk 2/4/2006 12:12'!
expectRelocationAt: aSmallInteger to: aSymbol byteCodeAddress: anInteger 
	relocations add: {aSmallInteger. aSymbol. anInteger}! !

!MockRelocator methodsFor: 'Misc' stamp: 'wbk 2/4/2006 22:51'!
expectRelocationAt: aSmallInteger to: aByteSymbol byteCodeAddress: aByteSymbol3 argumentCount: aByteSymbol4 
	relocations add: {aSmallInteger. aByteSymbol. aByteSymbol3. aByteSymbol4}! !

!MockRelocator methodsFor: 'Misc' stamp: 'wbk 1/21/2005 20:56'!
initialize
	relocations := Set new.! !

!MockRelocator methodsFor: 'Misc' stamp: 'wbk 1/2/2005 11:47'!
verify
	self assert: relocations isEmpty! !

Object subclass: #MoveNode
	instanceVariableNames: 'to from maxColours'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!MoveNode class methodsFor: 'creation' stamp: 'wbk 6/20/2004 10:49'!
move: aMedMov withGraph: anInterferenceGraph maxColours: aNumber
	^ self new 
		initialiseMove: aMedMov
		withGraph: anInterferenceGraph
		maxColours: aNumber! !

!MoveNode methodsFor: 'Move Coalescing' stamp: 'wbk 6/20/2004 10:22'!
doesInterfere
	^ (from interferesWith: to) ! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 8/2/2004 22:22'!
freezeWeight
	| weight |
	weight := 0.
	from currentSize < maxColours ifTrue:
		[weight := weight + (from currentSize / from currentMoves)].
	to currentSize < maxColours ifTrue:
		[weight := weight + (to currentSize / to currentMoves)].
	^ weight! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/21/2004 22:07'!
fromCurrentNode
	^ from currentVersion! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/19/2004 23:41'!
fromNode
	^ from ! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/21/2004 22:18'!
initialiseMove: aMedMov withGraph: anInteferenceGraph maxColours: aNumber
	maxColours := aNumber.
	self 
		markAsMoveRelated: aMedMov to
		withGraph: anInteferenceGraph.
	self markAsMoveRelated: aMedMov from
		withGraph: anInteferenceGraph.
	from := anInteferenceGraph at: aMedMov from.
	to := anInteferenceGraph at: aMedMov to.
	^ self! !

!MoveNode methodsFor: 'Move Coalescing' stamp: 'wbk 3/5/2005 22:58'!
isCoalescable
	| edges |
	"A quick fast check for the easy common cases"
	from currentEdges size > maxColours | (to currentEdges size > maxColours) ifTrue: [^ false].
	from currentEdges size + to currentEdges size < maxColours ifTrue: [^ true].
	"The actual check"
	edges := from currentEdges copy asSet.
	edges addAll: to currentEdges.
	^ edges size < maxColours.! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/19/2004 23:32'!
markAsMoveRelated: aRegister withGraph: anInterferenceGraph
	| node |
	node := (anInterferenceGraph at: aRegister).
	node markAsMoveRelated.
	node incrementCurrentMoves.! !

!MoveNode methodsFor: 'Unit Testing' stamp: 'wbk 3/5/2005 00:59'!
printOn: aStream
	aStream nextPutAll: 'MoveNode ['.
	aStream nextPutAll: from register name.
	aStream nextPut: $ .
	aStream nextPutAll: to register name.
	aStream nextPutAll: ']'.! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/21/2004 22:08'!
toCurrentNode
	^ to currentVersion! !

!MoveNode methodsFor: 'Misc' stamp: 'wbk 6/19/2004 23:42'!
toNode
	^ to! !

Object subclass: #NodeLattice
	instanceVariableNames: 'set'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!NodeLattice class methodsFor: 'instance creation' stamp: 'wbk 6/25/2004 23:16'!
value: aSet
	^ self new initialiseSet: aSet! !

!NodeLattice methodsFor: 'Proxied - remove later' stamp: 'wbk 6/27/2004 19:05'!
addNode: anInterferenceNode 
	set add: anInterferenceNode! !

!NodeLattice methodsFor: 'Proxied - remove later' stamp: 'wbk 6/23/2004 22:17'!
asSet
	^ set copy! !

!NodeLattice methodsFor: 'Proxied - remove later' stamp: 'wbk 6/26/2004 00:31'!
includesNode: anInterferenceNode 
	^ set includes: anInterferenceNode! !

!NodeLattice methodsFor: 'Misc' stamp: 'wbk 6/27/2004 23:13'!
initialiseSet: aSet
	set := aSet.! !

!NodeLattice methodsFor: 'Misc' stamp: 'wbk 6/27/2004 23:18'!
initialize
	set := Set new! !

!NodeLattice methodsFor: 'Proxied - remove later' stamp: 'wbk 6/26/2004 00:25'!
nodesDo: aBlockContext 
	^ set do: aBlockContext! !

!NodeLattice methodsFor: 'Misc' stamp: 'wbk 6/25/2004 23:37'!
set
	^ set! !

!NodeLattice methodsFor: 'Proxied - remove later' stamp: 'wbk 6/23/2004 22:16'!
size
	^ set size! !

!NodeLattice methodsFor: 'Operations' stamp: 'wbk 6/25/2004 23:36'!
+ aNodeLattice
	| newSet |
	newSet := set copy.
	newSet addAll: aNodeLattice set.
	^ self class value: newSet! !

!Object methodsFor: '*Exupery-Additions' stamp: 'wbk 9/25/2004 08:33'!
isStackable
	^ false! !

!Object methodsFor: '*Exupery-Additions' stamp: 'wbk 4/17/2005 17:33'!
removeMe
	self error: 'Should be removed'! !

Object subclass: #OffsetPatcher
	instanceVariableNames: 'target location assembler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!OffsetPatcher class methodsFor: 'as yet unclassified' stamp: 'wbk 4/3/2003 20:30'!
target: aMedBlock location: aSmallInteger assembler: anAssemblerExupery 
	^ self new
		initializeTarget: aMedBlock 
		location: aSmallInteger 
		assembler: anAssemblerExupery! !

!OffsetPatcher methodsFor: 'as yet unclassified' stamp: 'wbk 4/3/2003 20:29'!
initializeTarget: aMedBlock location: anInteger assembler: anAssembler
	target := aMedBlock.
	location := anInteger.
	assembler := anAssembler.
	^ self! !

!OffsetPatcher methodsFor: 'as yet unclassified' stamp: 'wbk 2/26/2005 20:37'!
patch
	|targetAddress offset |
	targetAddress := assembler addressFor: target.
	offset := targetAddress - location.
	assembler
		patchByteAt: location - 3
		with: (offset bitAnd: 255).
	assembler
		patchByteAt: location - 2
		with: ((offset bitShift: -8) bitAnd: 255).
	assembler
		patchByteAt: location - 1
		with: ((offset bitShift: -16) bitAnd: 255).
	assembler
		patchByteAt: location
		with: ((offset bitShift: -24) bitAnd: 255).
! !

!OffsetPatcher methodsFor: 'as yet unclassified' stamp: 'wbk 2/26/2005 20:39'!
patchLiteral
	| offset |
	offset :=  target.
	assembler
		patchByteAt: location - 3
		with: (offset bitAnd: 255).
	assembler
		patchByteAt: location - 2
		with: ((offset bitShift: -8) bitAnd: 255).
	assembler
		patchByteAt: location - 1
		with: ((offset bitShift: -16) bitAnd: 255).
	assembler
		patchByteAt: location
		with: ((offset bitShift: -24) bitAnd: 255).
! !

Object subclass: #PolymorphicInlineCache
	instanceVariableNames: 'entry picLocation methodLocation byteCodeAddress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery'!

!PolymorphicInlineCache class methodsFor: 'instance creation' stamp: 'wbk 5/18/2005 21:43'!
entry: aSmallInteger picLocation: aSmallInteger2 methodLocation: aSmallInteger3 byteCodeAddress: anObject 
	^self new 
		initialiseEntry: aSmallInteger
		picLocation: aSmallInteger2
		methodLocation: aSmallInteger3
		bytpCodeAddress: anObject! !

!PolymorphicInlineCache methodsFor: 'Misc' stamp: 'wbk 5/18/2005 21:20'!
byteCodeAddress
	^ byteCodeAddress! !

!PolymorphicInlineCache methodsFor: 'Misc' stamp: 'wbk 5/18/2005 21:43'!
initialiseEntry: aSmallInteger picLocation: aSmallInteger2 methodLocation: aSmallInteger3 byteCodeAddress: anObject 
	entry := aSmallInteger.
	picLocation := aSmallInteger2.
	methodLocation := aSmallInteger3.
	byteCodeAddress := anObject! !

!PolymorphicInlineCache methodsFor: 'Misc' stamp: 'wbk 5/18/2005 21:47'!
initialiseEntry: aSmallInteger picLocation: aSmallInteger2 methodLocation: aSmallInteger3 bytpCodeAddress: anObject 
	entry := aSmallInteger.
	picLocation := aSmallInteger2.
	methodLocation := aSmallInteger3.
	byteCodeAddress := anObject.! !

!PolymorphicInlineCache methodsFor: 'Misc' stamp: 'wbk 5/19/2005 22:09'!
receivers
	^ (self receiversPrimitive: entry) select: [:each| each notNil].! !

!PolymorphicInlineCache methodsFor: 'Primitives' stamp: 'wbk 5/19/2005 22:07'!
receiversPrimitive: anEntry
	<primitive: 'fetchReceivers' module: 'ExuperyPlugin'>
	Error signal.! !

Object subclass: #ProfileSample
	instanceVariableNames: 'class selector senders'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Tools'!

!ProfileSample class methodsFor: 'instance creation' stamp: 'wbk 6/22/2005 22:13'!
class: aClass selector: aSymbol
	^ self new
		initializeClass: aClass 
		selector: aSymbol! !

!ProfileSample methodsFor: 'misc' stamp: 'wbk 6/22/2005 22:35'!
addSender: aSample
	senders add: aSample! !

!ProfileSample methodsFor: 'misc' stamp: 'wbk 6/22/2005 22:28'!
hash
	^ class hash bitXor: selector hash! !

!ProfileSample methodsFor: 'misc' stamp: 'wbk 6/22/2005 22:10'!
initialize
	senders := Bag new.! !

!ProfileSample methodsFor: 'misc' stamp: 'wbk 6/22/2005 22:13'!
initializeClass: aClass selector: aSymbol
	senders := Bag new.
	class := aClass.
	selector := aSymbol! !

!ProfileSample methodsFor: 'misc' stamp: 'wbk 8/25/2005 22:18'!
method
	^ selector! !

!ProfileSample methodsFor: 'misc' stamp: 'wbk 8/25/2005 22:19'!
methodClass
	^ class! !

!ProfileSample methodsFor: 'misc' stamp: 'wbk 6/22/2005 23:17'!
numberOfSenders
	^ senders size! !

!ProfileSample methodsFor: 'misc' stamp: 'wbk 6/22/2005 22:27'!
objectClass 
	^ class! !

!ProfileSample methodsFor: 'misc' stamp: 'wbk 6/22/2005 23:16'!
printOn: aStream
	class printOn: aStream.
	aStream nextPutAll: '>>'.
	selector printOn: aStream.
	aStream space.
	senders size printOn: aStream! !

!ProfileSample methodsFor: 'misc' stamp: 'wbk 6/22/2005 22:27'!
selector
	^ selector! !

!ProfileSample methodsFor: 'misc' stamp: 'wbk 6/22/2005 22:27'!
= anObject
	(anObject isKindOf: ProfileSample) ifFalse: [^ false].
	^ class = anObject objectClass & (selector = anObject selector)! !

Object subclass: #SystemInvestigation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Plugin'!

!SystemInvestigation methodsFor: 'Image Experiments' stamp: 'wbk 4/12/2003 22:07'!
countBytecodes
	|bytecodes methods classes|
	" This method doesn't handle methods with no bytecodes, they count as -1 bytes.
	It looks like I'm averaging 70 bytecodes/method, I don't know how reasonable this
	is but the ballpark seems tolerable."
	bytecodes := 0.
	methods := 0.
	classes := 0.
	Smalltalk allClassesDo: 
		[:eachClass| classes := classes + 1.
		eachClass methodsDo:
			[:eachMethod| methods := methods + 1.
			bytecodes := bytecodes + eachMethod endPC + eachMethod initialPC + 1]].
	^ {bytecodes. methods. classes}! !

Object subclass: #WBKToys
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

!WBKToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/22/2004 19:46'!
forBytecodes

| weakRef |
weakRef := WeakValueAssociation new.
Smalltalk garbageCollect. "make it old"
weakRef value: Object new.
Smalltalk garbageCollectMost. "incr. GC"
weakRef value. "and it's still there"! !

!WBKToys class methodsFor: 'as yet unclassified' stamp: 'wbk 3/22/2004 19:13'!
gcTest: weakRef
weakRef value: Object new.! !

!WBKToys methodsFor: 'For Talk' stamp: 'wbk 3/14/2006 23:24'!
add: a to: b
	^ a + b! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 7/31/2003 20:23'!
arithmaticLoop
	| acc |
	acc := 0.
	1
		to: 2000000
		do: [:each| acc := acc + 1].
	^ 5! !

!WBKToys methodsFor: 'Refactoring Toys' stamp: 'wbk 7/28/2003 15:29'!
aTest
	| x4 |
	x4 := 10.
	x4 + x4.
	1 + 2 + 3 
		abc: 55
		def: 66
		ghi: 77.
	1 
		abc: 2
		def: 3.
	1 abc: 2! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 6/22/2005 20:57'!
class
	^ self class! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 11/2/2004 21:20'!
javaLoop
 | x |
    x := 0.
    1
	to: 100000000
	do: [:each| x := x + 1].
x! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 4/7/2003 18:43'!
returnFalse
	^ false! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 4/7/2003 18:42'!
returnTrue
	^ true! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 4/20/2003 21:31'!
senders
	^ self sent! !

!WBKToys methodsFor: 'Toys' stamp: 'wbk 4/20/2003 21:32'!
sent
	|a|
	a := thisContext.
	self halt.
	^ 42! !

!CompiledMethod methodsFor: '*Exupery-Accessing' stamp: 'wbk 10/5/2005 22:59'!
needsLargeContext
	^ (self header bitShift: -17) bitAnd: 1! !

InterpreterPlugin subclass: #ExuperyPlugin
	instanceVariableNames: 'codeCache nextMethodAddress methods picList compiledMethodArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Plugin'!

!ExuperyPlugin class methodsFor: 'Hacky Hacks' stamp: 'ar 12/18/2004 18:21'!
declareCVarsIn: codeGenerator
	"Only methodCache is really a bad hack"
	"Method cache should be removed, it's not used"
	"codeGenerator 
		var: 'methodCache'
		declareC: 'extern int * methodCache'."
	codeGenerator
		var: #codeCache
		declareC: 'unsigned char * codeCache'.
	codeGenerator
		var: #nextMethodAddress
		declareC: 'unsigned char * nextMethodAddress'.
"
	codeGenerator addHeaderFile: '<unistd.h>'.
	codeGenerator addHeaderFile: '<sys/mman.h>'.
"! !

!ExuperyPlugin class methodsFor: 'Hacky Hacks' stamp: 'ar 12/18/2004 18:21'!
hasHeaderFile
	^true! !

!ExuperyPlugin class methodsFor: 'Hacky Hacks' stamp: 'ar 12/18/2004 18:47'!
requiresPlatformFiles
	"this plugin requires platform specific files in order to work"
	^true! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 1/29/2005 21:59'!
activeContextAddress
	| address |
	self export: true.
	address := self exuperyActiveContextAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 4/18/2004 20:56'!
atCacheAddress
	| address |
	self export: true.
	address := self exuperyAtCacheAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 1/19/2006 21:30'!
blockValue
	| block |
	self export: true.
	block := interpreterProxy stackValue: 0.
	self exuperyBlock: block Value: 0.! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 1/19/2006 21:30'!
blockValue1Argument
	| block |
	self export: true.
	block := interpreterProxy stackValue: 1.
	self exuperyBlock: block Value: 1.! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 1/22/2006 16:11'!
blockValue2Argument
	| block |
	self export: true.
	block := interpreterProxy stackValue: 2.
	self exuperyBlock: block Value: 2.! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 1/22/2006 16:24'!
blockValue3Argument
	| block |
	self export: true.
	block := interpreterProxy stackValue: 3.
	self exuperyBlock: block Value: 3.! !

!ExuperyPlugin methodsFor: 'Test Primitives' stamp: 'wbk 11/22/2003 17:25'!
checkIsRootObject
	| object objectPtr |
	self export: true.
	objectPtr := interpreterProxy stackValue: 0.
	object := interpreterProxy longAt: objectPtr. "The header"
	"Check object is in the cache"
	"First check the header is tagged"
	(object bitAnd: 16r40000000) = 0 ifTrue: 
		[interpreterProxy primitiveFail.
		^ 0].
	"Then check there is an entry in the remembered set"
	(self exuperyCheckRootTableFor: objectPtr) ifFalse: 
		[interpreterProxy primitiveFail.
		^ 0].

	interpreterProxy pop: 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 10/13/2005 21:11'!
codeCacheSize
	^ 1000000! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 12/21/2005 17:21'!
createExuperyBlockAddress
	|address|
	self export: true.

	address := self exuperyCreateExuperyBlockAddress.
	interpreterProxy 
		pop: 1 
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 2/18/2005 21:31'!
exuperyCreateContext
	|address|
	self export: true.

	address := self exuperyCreateContextAddress.
	interpreterProxy 
		pop: 1 
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 4/18/2004 20:57'!
falseObjAddress
	| address |
	self export: true.
	address := self exuperyFalseObjAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 5/20/2005 20:51'!
fetchReceivers
	| entry answer class|
	self export: true.
	entry := self stackValue: 0.
	answer := interpreterProxy
		instantiateClass: self classArray
		indexableSize: 3.
	0	
		to: 2
		do: 
			[:each| 
			class := (self cCode: '*(int *)(*(int *)(entry - 1) + 1 + (11 * each))').
			class = 16r90909090 ifFalse:
				[interpreterProxy
					storePointer: each
					ofObject: answer
					withValue: class]].

	interpreterProxy 
		pop: 2
		thenPush: answer! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 3/12/2005 21:56'!
flushPics
	|pic|
	pic := picList.
	[pic ~= nil] whileTrue:
		[0 
			to: 32
			do: [:each| self cCode: '*(char *)(*(int *)pic + each) = 0x90'].
	pic := self cCode: '((int *) pic) [1]']! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 1/30/2005 19:21'!
freeContexts
	| address |
	self export: true.
	address := self exuperyFreeContexts.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 9/3/2005 12:11'!
initialiseExupery 
	self export: true.
	self exuperyRegisterLookupMethod: (self cCode: '(int) lookupSelectorclass').
	self exuperyRegisterRemapObjects: (self cCode: '(int) remapObjects').
	self exuperyRegisterMarkObjects: (self cCode: '(int) markObjects').
	self exuperyRegisterReturnMethod: (self cCode: '(int) lookupReturnMethod').
	self exuperyRegisterFullGCHook: (self cCode: '(int) flushPics').
	nextMethodAddress := codeCache.
	methods := interpreterProxy stackValue: 0.
	picList := nil.
	interpreterProxy pop: 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 9/7/2005 22:20'!
initialiseModule
	| cacheSize |
	self export: true.
	cacheSize := self codeCacheSize.
	codeCache := self ioMapCodeCache: cacheSize.
	nextMethodAddress := 0.
	compiledMethodArray := interpreterProxy nilObject.
	^ true! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 10/12/2005 21:27'!
loadCode
	| array arraySize byteValue bytes i methodAddress|
	self export: true.

	self
		var: #bytes
		declareC: 'unsigned char * bytes'.

	array := interpreterProxy stackValue: 0.

	(interpreterProxy isBytes: array) & (nextMethodAddress ~= 0) ifFalse: 
		[^interpreterProxy primitiveFail].
	
	arraySize := interpreterProxy stSizeOf: array.
	
	nextMethodAddress + arraySize > (codeCache + self codeCacheSize) ifTrue:
		[^interpreterProxy primitiveFail].


	bytes := interpreterProxy firstIndexableField: array.
	
	i := 0.
	[i < arraySize] whileTrue:
		[byteValue := bytes at: i.
		nextMethodAddress
			at: i
			put: byteValue.
		i := i + 1.].

	methodAddress := nextMethodAddress.
	nextMethodAddress := nextMethodAddress + arraySize.
	
	"Make sure nextMethodAddress is word aligned"
	nextMethodAddress := (((self cCode: '(int) nextMethodAddress') - 1) bitOr: 3) + 1.

	self 
		pop: 2
		thenPush: (self cCode: '(int) methodAddress + 1').! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 1/2/2005 20:09'!
lookupReturnMethod: aContext
	| methodLocal compiledReturn |
	self
		var: #aContext
		declareC: 'int *aContext'.
	methodLocal := (aContext at: 4).
	(methodLocal bitAnd: 1) = 1 ifTrue: [^ nil]. "It's a BlockContext which isn't currently handled."
	compiledReturn := aContext at: 5.
	(compiledReturn bitAnd: 1) = 0 ifTrue: [^ nil]. "It's not a compiledMethod, just let the interpreter deal wiht it"
	^ compiledReturn - 1. "return the detagged return address, which must be aligned to a 2 byte boundary	
							because of tagging"	! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 4/17/2005 11:21'!
lookupSelector: aSelector class: aClass
	"This method lookup tolerates integers as Dictionary keys to support
	execution of images in which Symbols have been compacted out"
 	| length index mask wrapAround nextSelector methodArray selectorStart answer hashBits |
	selectorStart := 2.
	length := self fetchWordLengthOf: methods.
	mask := length - selectorStart - 1.
	hashBits := ((self cCode: '*(int *)aClass') >> 17) bitAnd: 16rFFF.
	index := (mask bitAnd: hashBits) + selectorStart.
	"It is assumed that there are some nils in this dictionary, and search will
	stop when one is encountered.  However, if there are no nils, then wrapAround
	will be detected the second time the loop gets to the end of the table."
	wrapAround := false.
	[true] whileTrue:
		[nextSelector := self 
			fetchPointer: index
			ofObject: methods.
		nextSelector= interpreterProxy nilObject ifTrue: [^ nil].
		nextSelector=aClass ifTrue: [
			methodArray := self 
				fetchPointer: 1 "MethodArrayIndex"
				ofObject: methods.
			answer := self 
				fetchPointer:  index - selectorStart
				ofObject: methodArray.
			^ self 
				lookupSelector: aSelector 
				in: answer "Subtract one to detag the integer"
		].
		index := index + 1.
		index = length ifTrue: 
			[wrapAround ifTrue: [^ nil].
			wrapAround := true.
			index := selectorStart]]! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 4/17/2005 11:20'!
lookupSelector: aSelector in: aDictionary
	"This method lookup tolerates integers as Dictionary keys to support
	execution of images in which Symbols have been compacted out"
 	| length index mask wrapAround nextSelector methodArray selectorStart answer hashBits |
	selectorStart := 2.
	length := self fetchWordLengthOf: aDictionary.
	mask := length - selectorStart - 1.
	hashBits := ((self cCode: '*(int *)aSelector') >> 17) bitAnd: 16rFFF.
	index := (mask bitAnd: hashBits) + selectorStart.
	"It is assumed that there are some nils in this dictionary, and search will
	stop when one is encountered.  However, if there are no nils, then wrapAround
	will be detected the second time the loop gets to the end of the table."
	wrapAround := false.
	[true] whileTrue:
		[nextSelector := self 
			fetchPointer: index
			ofObject: aDictionary.
		nextSelector= interpreterProxy nilObject ifTrue: [^ nil].
		nextSelector= aSelector ifTrue: [
			methodArray := self 
				fetchPointer: 1 "MethodArrayIndex"
				ofObject: aDictionary.
			answer := self 
				fetchPointer:  index - selectorStart
				ofObject: methodArray.
			^ answer - 1 "Subtract one to detag the integer"
		].
		index := index + 1.
		index = length ifTrue: 
			[wrapAround ifTrue: [^ nil].
			wrapAround := true.
			index := selectorStart]]! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 1/22/2005 11:09'!
machineWordInAtPut
	| method location value |
	self export: true.
	method := self stackValue: 2.
	location := self stackValue: 1.
	value := self stackValue: 0.
	self pop: 3.
	self cCode: '*(int *)(method - 1 + location / 2) = method + (value / 2)'! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 3/25/2005 00:19'!
markObjects
	self markAndTrace: methods.
	self markAndTrace: compiledMethodArray.! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 9/7/2005 22:21'!
methodArrayAddress
	| address |
	self export: true.
	address := self addressOf: compiledMethodArray.
	interpreterProxy 
		pop: 1
		thenPush: address + 1
! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 10/4/2003 20:51'!
nilObjAddress
	|address|
	self export: true.

	address := self exuperyNilObjAddress.
	interpreterProxy 
		pop: 1 
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 1/7/2006 19:25'!
nonlocalReturnAddress
	| address |
	self export: true.
	address := self exuperyNonlocalReturnAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 12/27/2002 23:00'!
nullFunction! !

!ExuperyPlugin methodsFor: 'Unit Tests' stamp: 'wbk 1/30/2003 19:57'!
pointerToReturn42
	self export: true.
	interpreterProxy 
		pop: 1
		thenPush: (self cCode: '((int) return42Context + 1)')! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 1/30/2005 19:21'!
reclaimableContextCount
	| address |
	self export: true.
	address := self exuperyReclaimableContextCount.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 3/25/2005 00:22'!
remapObjects
	methods := self remap: methods.
	compiledMethodArray := self remap: compiledMethodArray.! !

!ExuperyPlugin methodsFor: 'Unit Tests' stamp: 'wbk 3/2/2003 13:52'!
return42Context: aContext
	|sender oldStackPtr newStackPtr |
	self export: true.
	sender := self cCode: '((int *) aContext) [1]'.
	oldStackPtr := self cCode: '*(int *) (sender + 12)' .
	newStackPtr := oldStackPtr + 2.
	self cCode: '*(int *) (sender + 12) = newStackPtr'.
	self cCode: '((int *) sender) [ 6 + (newStackPtr >> 1)] = 83'. ! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 11/21/2003 22:37'!
rootTableAddress
	| address |
	self export: true.
	address := self exuperyRootTableAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 11/21/2003 22:33'!
rootTableCountAddress
	| address |
	self export: true.
	address := self exuperyRootTableCountAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'VM Callbacks' stamp: 'wbk 9/7/2005 22:22'!
setMethodArray
	self export: true.
	compiledMethodArray := interpreterProxy stackValue: 0.
	 self pop: 1.! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 6/30/2003 17:43'!
setupMessageSendAddress
	|address|
	self export: true.

	address := self exuperySetupMessageSendAddress.
	interpreterProxy 
		pop: 1 
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 3/12/2005 22:13'!
setupPicEntryAtforPicinMethod
	| picEntry picLocation method|
	self export: true.
	picEntry := self stackValue: 2.
	picLocation := self stackValue: 1.
	method := self stackValue: 0.
	self pop: 3.
	self cCode: '*(int *)(picEntry - 1 ) = method - 1 + (picLocation / 2)'.
	self cCode: '*(int *)(picEntry + 3 ) = picList'.
	self cCode: '*(int *)(picEntry + 7) = 0'.
	picList := picEntry - 1.! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 7/18/2003 10:14'!
specialObjectsOopAddress
	|address|
	self export: true.

	address := self exuperySpecialObjectsOopAddress.
	interpreterProxy 
		pop: 1 
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 4/18/2004 20:59'!
trueObjAddress
	| address |
	self export: true.
	address := self exuperyTrueObjAddress.
	interpreterProxy 
		pop: 1
		thenPush: address + 1! !

!ExuperyPlugin methodsFor: 'Primitives' stamp: 'wbk 11/21/2003 20:02'!
youngStartAddress
	|address|
	self export: true.

	address := self exuperyYoungStartAddress.
	interpreterProxy 
		pop: 1 
		thenPush: address + 1! !

Exception subclass: #ExuperyTestException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

TestCase subclass: #AssemblerTests
	instanceVariableNames: 'machine intermediate code relocator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!AssemblerTests methodsFor: 'Misc' stamp: 'wbk 10/29/2005 20:49'!
basicAssemble: anArray 
	^ self
		basicAssemble: anArray
		withPlugin: ExuperyStoryTests! !

!AssemblerTests methodsFor: 'Misc' stamp: 'wbk 1/21/2005 22:40'!
basicAssemble: anArray withPlugin: aPlugin
	intermediate := MedMethod 
		createAssembly: anArray 
		for: machine.
	code := (AssemblerExupery 
		basicAssemble: intermediate
		withPlugin: aPlugin
		relocator: relocator) byteCodes.! !

!AssemblerTests methodsFor: 'Misc' stamp: 'wbk 1/2/2005 11:48'!
setUp
	machine := MachineX86 new.
	relocator := MockRelocator new.! !

!AssemblerTests methodsFor: 'Tests - Add' stamp: 'wbk 8/23/2003 15:30'!
testAddFromConstant
	self basicAssemble: #(#(#block 1 #(#add 42 #eax))).
	self should: [code = #(129 192 42 0 0 0) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Add' stamp: 'wbk 3/21/2003 08:58'!
testAddFromIndirection
	self basicAssemble: #(#(#block 1 #(#add #(8 #ebx) #eax))).
	self should: [code = #(3 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Add' stamp: 'wbk 3/21/2003 08:58'!
testAddToIndirection
	self basicAssemble: #(#(#block 1 #(#add #eax #(4 #ebx)))).
	self should: [code = #(1 67 4) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Alignment' stamp: 'wbk 10/29/2005 20:49'!
testAlignBlocks
	intermediate := MedMethod 
		createAssembly: #(#(#block 1 #(#add #(8 #ebx) #eax)) #(#block 2 #(#add #(8 #ebx) #eax)))
		for: machine.
	(intermediate blockAt: 2) makeAligned.
	code := (AssemblerExupery 
		basicAssemble: intermediate
		withPlugin: ExuperyStoryTests
		relocator: relocator) byteCodes.
	self should: [code = #(3 67 8 0 3 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - And' stamp: 'wbk 4/4/2003 15:53'!
testAndFromConstant
	self basicAssemble: #(#(#block 1 #(#and 42 #eax))).
	self should: [code = #(16r81 16rE0 42 0 0 0) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - And' stamp: 'wbk 4/4/2003 14:43'!
testAndFromIndirection
	self basicAssemble: #(#(#block 1 #(#and #(8 #ebx) #eax))).
	self should: [code = #(16r23 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - And' stamp: 'wbk 4/4/2003 14:55'!
testAndToIndirection
	self basicAssemble: #(#(#block 1 #(#and #eax #(4 #ebx)))).
	self should: [code = #(16r21 67 4) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - BitTest' stamp: 'wbk 3/28/2005 19:07'!
testBitTestFromConstant
	self basicAssemble: #(#(#block 1 #(bitTest 42 #eax))).
	self should: [code = #(16r0F 16rBA 16rE0 42) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - BitTest' stamp: 'wbk 3/28/2005 18:27'!
testBitTestToIndirection
	self basicAssemble: #(#(#block 1 #(#bitTest #eax #(4 #ebx)))).
	self should: [code = #(16r0F 16rA3 67 4) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 6/25/2003 16:33'!
testCall
	self basicAssemble: #(#(#block 1 (call 16r12345678))).
	self assert: code = #(16rFF 16r15 16r78 16r56 16r34 16r12) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 6/30/2003 20:21'!
testCallRegister
	self basicAssemble: #(#(#block 1 (call eax))).
	self assert: code = #(16rFF 16rD0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Cdq' stamp: 'wbk 2/2/2004 21:25'!
testCdq
	self basicAssemble: #(#(#block 1 (cdq) )).
	self should: [code = #(16r99) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Cmp' stamp: 'wbk 3/26/2005 16:28'!
testCmpFromConstant
	self basicAssemble: #(#(#block 1 #(#cmp 42 #eax))).
	self should: [code = #(16r81 248 42 0 0 0) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Cmp' stamp: 'wbk 3/26/2005 16:23'!
testCmpFromIndirection
	self basicAssemble: #((block 1 (cmp (8 ebx) eax))).
	self should: [code = #(16r3B 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Cmp' stamp: 'wbk 3/26/2005 16:23'!
testCmpToIndirection
	self basicAssemble: #(#(#block 1 #(#cmp #eax #(4 #ebx)))).
	self should: [code = #(16r39 67 4) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Div' stamp: 'wbk 1/31/2004 18:31'!
testDivide
	self basicAssemble: #(#(#block 1 (div ebx) )).
	self should: [code = #(16rF7 16rFB) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Div' stamp: 'wbk 1/31/2004 18:31'!
testDivide2
	self basicAssemble: #(#(#block 1 (div ecx) )).
	self should: [code = #(16rF7 16rF9) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Pic' stamp: 'wbk 2/27/2005 10:46'!
testDoublePicEntry
	| picEntry picEntry2 |
	picEntry := (Exupery loadCode: ByteArray new) * 2.
	picEntry2 := picEntry + 12.
	self basicAssemble: #(#(#block 1 #(#mov (picEntry) #ebx) #(#mov (picEntry) #ebx))).
	self assert: (code at: 1) = 187.
	self assert: (code at: 2) = (picEntry bitAnd: 255).
	self assert: (code at: 3) = ((picEntry bitShift: -8) bitAnd: 255).
	self assert: (code at: 4) = ((picEntry bitShift: -16) bitAnd: 255).
	self assert: (code at: 5) = ((picEntry bitShift: -24) bitAnd: 255).

	self assert: (code at: 6) = 187.
	self assert: (code at: 7) = (picEntry2 bitAnd: 255).
	self assert: (code at: 8) = ((picEntry2 bitShift: -8) bitAnd: 255).
	self assert: (code at: 9) = ((picEntry2 bitShift: -16) bitAnd: 255).
	self assert: (code at: 10) = ((picEntry2 bitShift: -24) bitAnd: 255).! !

!AssemblerTests methodsFor: 'Tests - Registers' stamp: 'wbk 4/3/2003 23:20'!
testEcx
	self basicAssemble: #(#(#block 1 #(#mov #eax #ecx))).
	self should: [code = #(137 16rC1) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Registers' stamp: 'wbk 4/17/2003 11:01'!
testEdi
	self basicAssemble: #(#(#block 1 #(#mov #eax #edi)) ).
	self should: [code = #(137 16rC7 ) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Registers' stamp: 'wbk 4/3/2003 23:22'!
testEdx
	self basicAssemble: #(#(#block 1 #(#mov #eax #edx))).
	self should: [code = #(137 16rC2) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - True and False Objects' stamp: 'wbk 4/11/2003 16:12'!
testEncodeFalse
	self 
		basicAssemble: #(#(#block 1 #(mov falseObj ebx)))
		withPlugin: MockExuperyPlugin new.
	self should: [code = #(187 16r57 16r35 16r13 16r41) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - True and False Objects' stamp: 'wbk 4/9/2003 22:44'!
testEncodeTrue
	self 
		basicAssemble: #(#(#block 1 #(mov trueObj ebx)))
		withPlugin: MockExuperyPlugin new.
	self should: [code = #(187 16r56 16r34 16r12 16r40) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Registers' stamp: 'wbk 4/4/2003 11:19'!
testEsi
	self basicAssemble: #((block 1 (mov eax esi))).
	self should: [code = #(137 16rC6) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Registers' stamp: 'wbk 4/4/2003 11:22'!
testEsp
	self basicAssemble: #(#(#block 1 #(#mov #eax #esp))).
	self should: [code = #(137 16rC4) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:18'!
testForwardJump
	self basicAssemble: #(#(#block 1 #(#jz #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r84 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:17'!
testForwardJumpFurther
	self basicAssemble: #((block 1 (jz block2) (mov eax ebx)) (block 2) ).
	self assert: code = #(16r0F 16r84 2 0 0 0 137 195 ) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:18'!
testJumpAlways
	self basicAssemble: #(#(#block 1 #(#jmp #block2)) #(#block 2) ).
	self assert: code = #(16rE9 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 2/6/2005 19:07'!
testJumpAlwaysComputed
	self basicAssemble: #(#(#block 1 #(#jmp #eax)) #(#block 2) ).
	self assert: code = #(16rFF 16rE0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 2/6/2005 19:08'!
testJumpAlwaysComputed2
	self basicAssemble: #(#(#block 1 #(#jmp #ebx)) #(#block 2) ).
	self assert: code = #(16rFF 16rE3) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 3/30/2005 21:05'!
testJumpCarry
	self basicAssemble: #(#(#block 1 #(#jc #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r82 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:18'!
testJumpEqual
	self basicAssemble: #(#(#block 1 #(#je #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r84 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:17'!
testJumpGreater
	self basicAssemble: #((block 1 (jg block2) (mov eax ebx)) (block 2) ).
	self assert: code = #(16r0F 16r8F 2 0 0 0 137 195 ) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 11/21/2003 21:05'!
testJumpGreaterEquals
	self basicAssemble: #(#(#block 1 #(#jge #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r8D 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:21'!
testJumpLess
	self basicAssemble: #(#(#block 1 #(#jl #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r8C 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 11:19'!
testJumpLessThanEquals
	self basicAssemble: #(#(#block 1 #(#jle #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r8E 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 3/28/2005 18:36'!
testJumpNoCarry
	self basicAssemble: #(#(#block 1 #(#jnc #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r83 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 1/14/2004 21:50'!
testJumpNotEquals
	self basicAssemble: #(#(#block 1 #(#jne #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r85 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:18'!
testJumpNotZero
	self basicAssemble: #(#(#block 1 #(#jnz #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r85 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Jump' stamp: 'wbk 8/10/2003 00:18'!
testJumpOverflow
	self basicAssemble: #(#(#block 1 #(#jo #block2)) #(#block 2) ).
	self assert: code = #(16r0F 16r80 0 0 0 0) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 2/4/2006 12:12'!
testMoveFromBlockAddress
	relocator 
		expectRelocationAt: 1
		to: #block2
		byteCodeAddress: #byteCodeAddress.
	self basicAssemble: #(
				#(
					#block
					1
					#(
						#mov
						#(#addressOf #byteCodeAddress #block2 )
						#eax
					)
				)
			).
	self should: [code = #(184 0 0 0 0 ) asByteArray].
	relocator verify! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 2/4/2006 22:49'!
testMoveFromBlockCreationAddress
	relocator 
		expectRelocationAt: 1
		to: #block2
		byteCodeAddress: #byteCodeAddress
		argumentCount: #argumentCount.
	self basicAssemble: #(
				#(
					#block
					1
					#(
						#mov
						#(blockAddress #byteCodeAddress #block2 argumentCount)
						#eax
					)
				)
			).
	self should: [code = #(184 0 0 0 0 ) asByteArray].
	relocator verify! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testMoveFromConstant
	self basicAssemble: #(#(#block 1 #(#mov 1 #eax))).
	self should: [code = #(184 1 0 0 0) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testMoveFromConstantToEBX
	self basicAssemble: #(#(#block 1 #(#mov 1 #ebx))).
	self should: [code = #(187 1 0 0 0) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testMoveFromConstantToIndirect
	self basicAssemble: #(#(#block 1 #(#mov 87 #(28 #eax)))).
	self should: [code = #(199 64 28 87 0 0 0) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testMoveFromIndirectAddress
	self basicAssemble: #(#(#block 1 #(#mov #(8 #ebx) #eax))).
	self should: [code = #(139 67 8) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 7/18/2003 12:25'!
testMoveLargeOffsetIndirectAddress
	self basicAssemble: #(#(#block 1 #(#mov #eax #(16rEE #ebx)))).
	self should: [code = #(137 16r83 16rEE 0 0 0) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 4/11/2003 13:57'!
testMoveToBasicIndirectAddress
	self basicAssemble: #((block 1 (mov eax (ebx)))).
	self should: [code = #(137 16r03) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testMoveToIndirectAddress
	self basicAssemble: #(#(#block 1 #(#mov #eax #(4 #ebx)))).
	self should: [code = #(137 67 4) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 6/2/2004 22:00'!
testMoveToNegative128Offset
	self basicAssemble: #(#(#block 1 #(#mov #eax #(-128 #ebx)))).
	self should: [code = #(137 67 16r80) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 6/2/2004 21:58'!
testMoveToNegativeOffset
	self basicAssemble: #(#(#block 1 #(#mov #eax #(-1 #ebx)))).
	self should: [code = #(137 67 255) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Mul' stamp: 'wbk 4/11/2003 17:52'!
testMulFromIndirection
	self basicAssemble: #(#(#block 1 #(#mul #(8 #ebx) #eax))).
	self should: [code = #(16r0F 16rAF 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Negate' stamp: 'wbk 2/9/2004 21:13'!
testNegate
	self basicAssemble: #(#(#block 1 #(#neg #(8 #ebx)))).
	self should: [code = #(16rF7 16r5B 8) asByteArray ].! !

!AssemblerTests methodsFor: 'Tests - Or' stamp: 'wbk 11/21/2003 22:52'!
testOrFromConstant
	self basicAssemble: #(#(#block 1 #(#or 42 #eax))).
	self should: [code = #(16r81 16rC8 42 0 0 0) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Or' stamp: 'wbk 11/21/2003 22:56'!
testOrFromIndirection
	self basicAssemble: #(#(#block 1 #(#or #(8 #ebx) #eax))).
	self should: [code = #(16r0B 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Or' stamp: 'wbk 11/21/2003 22:53'!
testOrToIndirection
	self basicAssemble: #(#(#block 1 #(#or #eax #(4 #ebx)))).
	self should: [code = #(16r09 67 4) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Pic' stamp: 'wbk 10/29/2005 20:49'!
testPic
	| pic picEntry assembler |
	intermediate := MedMethod 
				createAssembly: #(#(#block 1 #(#pic 1233)))
				for: machine.
	pic := (intermediate blockAt: 1) expressionAt: 1.
	picEntry := pic picEntry.
	assembler := AssemblerExupery 
				basicAssemble: intermediate
				withPlugin: ExuperyStoryTests
				relocator: relocator.
	code := assembler byteCodes.
	self assert: code = #(144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 144 ) asByteArray.
	self assert: picEntry picMethodLocation isInteger.
	self assert: assembler picEntries size = 1.
	self assert: assembler picEntries first = picEntry.! !

!AssemblerTests methodsFor: 'Tests - Pic' stamp: 'wbk 2/27/2005 10:46'!
testPicEntry
	| picEntry |
	picEntry := (Exupery loadCode: ByteArray new) * 2.
	self basicAssemble: #(#(#block 1 #(#mov (picEntry) #ebx))).
	self assert: (code at: 1) = 187.
	self assert: (code at: 2) = (picEntry bitAnd: 255).
	self assert: (code at: 3) = ((picEntry bitShift: -8) bitAnd: 255).
	self assert: (code at: 4) = ((picEntry bitShift: -16) bitAnd: 255).
	self assert: (code at: 5) = ((picEntry bitShift: -24) bitAnd: 255).! !

!AssemblerTests methodsFor: 'Tests - Pic' stamp: 'wbk 2/27/2005 10:36'!
testPicEntry2
	| picEntry afterPicEntry |
	picEntry := Exupery loadCode: ByteArray new.
	self basicAssemble: #(#(#block 1 #(#mov (picEntry) #ebx) )).
	afterPicEntry := Exupery loadCode: ByteArray new.
	self assert: afterPicEntry - picEntry = 6 "We count in double bytes because of tagging"
	! !

!AssemblerTests methodsFor: 'Tests - Pop' stamp: 'wbk 3/4/2005 16:19'!
testPopEbx
	self basicAssemble: #(#(#block 1 #(#pop ebx))).
	self should: [code = #(16r5B) asByteArray ].! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 1/21/2005 22:26'!
testPreamble
	intermediate := MedMethod 
		createAssembly: #(#(#block 1 (mov eax ebx))) 
		for: machine.
	code := (AssemblerExupery 
		assemble: intermediate
		withPlugin: MockExuperyPlugin
		relocator: MockRelocator new) byteCodes.
	self should: [code = #( 137 195 ) asByteArray]
! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 6/25/2003 16:16'!
testPush
	self basicAssemble: #(#(#block 1 (push eax))).
	self assert: code = #(16r50) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 6/25/2003 16:23'!
testPushEbx
	self basicAssemble: #(#(#block 1 (push ebx))).
	self assert: code = #(16r53) asByteArray! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 3/4/2005 15:12'!
testRet
	self basicAssemble: #(#(#block 1 #(#ret))).
	self should: [code = #("131 196 64 95 94 91 137 236 93" 195) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Sal' stamp: 'wbk 3/17/2003 14:35'!
testSalWithConstant
	self basicAssemble: #(#(#block 1 #(#sal 2 #eax))).
	self should: [code = #(193 224 2) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Sal' stamp: 'wbk 2/8/2004 21:22'!
testSalWithRegister
	self basicAssemble: #(#(#block 1 #(#sal #ecx #eax))).
	self should: [code = #(16rD3 16rE0) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Sal' stamp: 'wbk 2/8/2004 21:54'!
testSalWithRegisterAndIndirection
	self basicAssemble: #(#(#block 1 #(#sal #ecx (8 ebx)))).
	self should: [code = #(16rD3 16r63 8) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Sar' stamp: 'wbk 4/4/2003 15:59'!
testSarWithConstant
	self basicAssemble: #(#(#block 1 #(#sar 2 #eax))).
	self should: [code = #(16rC1 16rF8 2) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Sar' stamp: 'wbk 2/8/2004 22:10'!
testSarWithRegister
	self basicAssemble: #(#(#block 1 #(#sar #ecx #eax))).
	self should: [code = #(16rD3 16rF8) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Sar' stamp: 'wbk 3/4/2004 20:52'!
testSarWithRegisterAndIndirection
	self basicAssemble: #(#(#block 1 #(#sar #ecx (8 ebx)))).
	self should: [code = #(16rD3 16r7B 8) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testSingleMoveAssembling
	self basicAssemble: #(#(#block 1 #(#mov #eax #ebx))).
	self should: [code = #(137 195) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testSingleMoveDifferentFirstRegisterAssembling
	self basicAssemble: #(#(#block 1 #(#mov #ebx #ebx))).
	self should: [code = #(137 219) asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Sub' stamp: 'wbk 4/7/2003 21:12'!
testSubFromConstant
	self basicAssemble: #(#(#block 1 #(#sub 42 #eax))).
	self should: [code = #(16r81 16rE8 42 0 0 0) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Sub' stamp: 'wbk 4/7/2003 20:55'!
testSubFromIndirection
	self basicAssemble: #(#(#block 1 #(sub (8 ebx) eax))).
	self should: [code = #(16r2B 67 8) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Sub' stamp: 'wbk 4/7/2003 20:59'!
testSubToIndirection
	self basicAssemble: #(#(#block 1 #(#sub #eax #(4 #ebx)))).
	self should: [code = #(16r29 67 4) asByteArray].! !

!AssemblerTests methodsFor: 'Tests - Misc' stamp: 'wbk 3/17/2003 14:35'!
testTrivialAssembling
	self basicAssemble: #(#(#block 1)).
	self should: [code = #() asByteArray]! !

!AssemblerTests methodsFor: 'Tests - Move' stamp: 'wbk 3/17/2003 14:35'!
testUsingRegisterEbp
	self basicAssemble: #(#(#block 1 #(#mov #eax #ebp))).
	self should: [code = #(137 197) asByteArray]! !

TestCase subclass: #ExuperyStoryTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

!ExuperyStoryTests methodsFor: 'Test - Inlining' stamp: 'wbk 6/8/2005 21:16'!
activeReceiverAt: anArrayProvider
	^ anArrayProvider array at: 2! !

!ExuperyStoryTests methodsFor: 'Example Methods' stamp: 'wbk 10/11/2003 17:19'!
additionOverflow
	^ 1000000000 + 1000000000! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/8/2005 18:09'!
array: firstArray equals: secondArray.
	self assert: firstArray size = secondArray size.
	firstArray
		with: secondArray
		do: [:a :b| self assert: a = b].
	! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 7/6/2003 14:29'!
basicSend
	^ self basicTarget + 1! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 3/17/2005 21:02'!
basicTarget
	^ 2 + 3! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 7/19/2003 16:26'!
bytecodePrimSendWithArg
	^ Array new: 5! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 3/25/2005 22:08'!
captureSend
	| answer |
	answer :=  thisContext.
	^ answer sender! !

!ExuperyStoryTests methodsFor: 'Misc' stamp: 'wbk 11/22/2003 17:49'!
checkIsNotRootObject: anExuperyInstanceVariables 
	self 
		should: [self checkIsRootObject: anExuperyInstanceVariables]
		raise: Error! !

!ExuperyStoryTests methodsFor: 'Misc' stamp: 'wbk 11/12/2003 21:36'!
checkIsRootObject: anExuperyInstanceVariables 
	<primitive: 'checkIsRootObject' module: 'ExuperyPlugin'>
	Error signal.
! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/2/2005 20:06'!
compileArrayAt
	Exupery
		compileMethod: #at:
		class: ExuperyArray.! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/2/2005 20:06'!
compileArrayAtAndAtPut
	Exupery
		compileMethod: #at:
		class: ExuperyArray.
	Exupery
		compileMethod: #at:put:
		class: ExuperyArray.! !

!ExuperyStoryTests methodsFor: 'Misc' stamp: 'wbk 10/3/2004 11:36'!
compileExpression: aString 
	self 
		compile: ' ^ ', aString! !

!ExuperyStoryTests methodsFor: 'Misc' stamp: 'wbk 10/3/2004 11:38'!
compileMethod: aString into: aSymbol 
	self class
		compile: aSymbol, ' ', aString
		classified: 'Generated'.
	self
		compile: aSymbol
		into: aSymbol! !

!ExuperyStoryTests methodsFor: 'Misc' stamp: 'wbk 10/3/2004 11:23'!
compile: aString 
	self
		compileMethod: aString
		into: #example! !

!ExuperyStoryTests methodsFor: 'Misc' stamp: 'wbk 5/28/2005 22:00'!
compile: sourceMethod into: targetMethod 
	Exupery 
		compileMethod: sourceMethod
		into: targetMethod
		forClass: self class
		inlining: #()! !

!ExuperyStoryTests methodsFor: 'Misc' stamp: 'wbk 5/28/2005 22:02'!
compile: sourceMethod into: targetMethod class: aClass 
	Exupery 
		compileMethod: sourceMethod
		into: targetMethod
		forClass: aClass
		inlining: #()! !

!ExuperyStoryTests methodsFor: 'Generated' stamp: 'wbk 4/19/2006 20:56'!
example |a| a := 1. ^(a:= a +1) + (a := a + 1)! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:21'!
extendedSend
	self method1.
	self method2.
	self method3.
	self method4.
	self method5.
	self method6.
	self method7.
	self method8.
	self method9.
	self method10.
	self method11.
	self method12.
	self method13.
	self method14.
	self method15.
	self method16.
	^ self method17.! !

!ExuperyStoryTests methodsFor: 'Test - Assembling Methods' stamp: 'wbk 4/11/2003 18:12'!
iterativeFactorial
	|acc n|
	n := 3.
	acc := 1.
	1
		to: n
		do: [:each| acc := acc * each].
	^ acc! !

!ExuperyStoryTests methodsFor: 'Example Methods' stamp: 'wbk 4/11/2003 16:29'!
lessThanEqualsWhenEquals
	^ 2 <= 2! !

!ExuperyStoryTests methodsFor: 'Example Methods' stamp: 'wbk 4/11/2003 14:27'!
lessThanEqualsWhenGreater
	^ 3 <= 2! !

!ExuperyStoryTests methodsFor: 'Example Methods' stamp: 'wbk 4/7/2003 18:46'!
lessThanEqualsWhenLess
	^ 2 <= 3! !

!ExuperyStoryTests methodsFor: 'Test - Jumps' stamp: 'wbk 10/29/2005 20:50'!
longJumpIfFalseOnNonInteger
	ExuperyStoryTests new
		ifTrue: [^ 1 + 2].
	^ 42! !

!ExuperyStoryTests methodsFor: 'Test - Jumps' stamp: 'wbk 2/13/2004 23:10'!
longJumpIfTrue
	true ifFalse:
		[^ 1+2.].
	^ 42! !

!ExuperyStoryTests methodsFor: 'Test - Jumps' stamp: 'wbk 2/14/2004 13:19'!
longJumpIfTrueOnFalse
	false ifFalse:
		[^ 1+2.].
	^ 42! !

!ExuperyStoryTests methodsFor: 'Test - Jumps' stamp: 'wbk 10/29/2005 20:51'!
longJumpIfTrueOnNonInteger
	ExuperyStoryTests new
		ifFalse: [^ 1 + 2].
	^ 42! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method1
	^ 1! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method10
	^ 1! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method11
	^ 1! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method12
	^ 1! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method13
	^ 1! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:21'!
method14
	^ 1! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:21'!
method15
	^ 1! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:21'!
method16
	^ 1! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:21'!
method17
	^ 42! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method2
	^ 1! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method3
	^ 1! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method4
	^ 1! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method5
	^ 1! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method6
	^ 1! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method7
	^ 1! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method8
	^ 1! !

!ExuperyStoryTests methodsFor: 'Extended Send' stamp: 'wbk 6/16/2004 22:20'!
method9
	^ 1! !

!ExuperyStoryTests methodsFor: 'Test - Jumps' stamp: 'wbk 2/15/2004 12:20'!
mustBeBoolean
	ExuperyTestException signal! !

!ExuperyStoryTests methodsFor: 'Primitive Support' stamp: 'wbk 4/18/2003 15:54'!
pointerToReturn42
	<primitive: 'pointerToReturn42' module: 'ExuperyPlugin'>
	TestFailure signal! !

!ExuperyStoryTests methodsFor: 'Example Methods' stamp: 'wbk 7/31/2003 17:24'!
popStack
	1 printString.
	^ 5! !

!ExuperyStoryTests methodsFor: 'Test - Bugs' stamp: 'wbk 4/20/2005 20:13'!
proc8: array1Par with: array2Par with: intParI1 with: intParI2
	| intLoc intGlob|
	intLoc := intParI1 + 5.
	array1Par at: intLoc put: intParI2.
	array1Par at: intLoc + 1 put: (array1Par at: intLoc).
	array1Par at: intLoc + 30 put: intLoc.
	intLoc to: intLoc + 2 do: [:intIndex |
		(array2Par at: intLoc) at: intIndex put: intLoc.
		(array2Par at: intLoc) at: intLoc - 1 put: ((array2Par at: intLoc) at: intLoc - 1) + 1.
		(array2Par at: intLoc + 20) at: intLoc put: (array1Par at: intLoc)].
	intGlob := 5! !

!ExuperyStoryTests methodsFor: 'Example Methods' stamp: 'wbk 10/4/2003 18:47'!
pushConstantMinusOne
	"The variable a is used to avoid a quick return method. This way we use the desired bytecode
	rather than the short-cut primitive"
	| a |
	a := -1.
	^ a! !

!ExuperyStoryTests methodsFor: 'Example Methods' stamp: 'wbk 10/4/2003 19:19'!
pushConstantNil
	| a |
	a :=  nil.
	^ a! !

!ExuperyStoryTests methodsFor: 'Example Methods' stamp: 'wbk 10/4/2003 19:19'!
pushConstantTrue
	| a |
	a :=  true.
	^ a! !

!ExuperyStoryTests methodsFor: 'Example Methods' stamp: 'wbk 7/11/2003 11:25'!
pushConstantZero
	" The shuffle through a temporary is so we actually use the push constant zero bytecode
	rather than the fast return 0 primitive"
	|a|
	a := 0.
	^ a! !

!ExuperyStoryTests methodsFor: 'Example Methods' stamp: 'wbk 7/30/2003 18:01'!
pushFalse
	| a |
	a := false.
	^ a! !

!ExuperyStoryTests methodsFor: 'Example Methods' stamp: 'wbk 7/11/2003 22:34'!
pushLiteralVariable
	^ Array! !

!ExuperyStoryTests methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/9/2004 15:58'!
return4
	^ 4! !

!ExuperyStoryTests methodsFor: 'Test - Assembling Methods' stamp: 'wbk 3/30/2003 21:09'!
return43
	^ 43! !

!ExuperyStoryTests methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/9/2004 15:58'!
return5
	^ 5! !

!ExuperyStoryTests methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/9/2004 15:58'!
return6
	^ 6! !

!ExuperyStoryTests methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/9/2004 15:58'!
return7
	^ 7! !

!ExuperyStoryTests methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/14/2004 21:39'!
return8
	^ 8! !

!ExuperyStoryTests methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/14/2004 21:39'!
return9
	^ 9! !

!ExuperyStoryTests methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 4/11/2003 18:42'!
returnArgument: anInteger
	^ anInteger * 2! !

!ExuperyStoryTests methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 11/27/2003 19:52'!
returnFalse
	'Forcing a returnNil bytecode rather than a quick return primitive'.
	^ false! !

!ExuperyStoryTests methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 10/18/2003 12:27'!
returnNil
	'Forcing a returnNil bytecode rather than a quick return primitive'.
	^ nil! !

!ExuperyStoryTests methodsFor: 'Example Methods' stamp: 'wbk 12/28/2002 17:05'!
returnNumber
	"This method will be overridden by a compiled method that returns 42"
	^ 5! !

!ExuperyStoryTests methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 4/20/2003 17:06'!
returnSelf
	|answer|
	answer := self.
	^ answer! !

!ExuperyStoryTests methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 10/16/2003 22:23'!
returnSelfBytecode
	'Just making sure that we really generate a returnReceiver bytecode'.
	^ self! !

!ExuperyStoryTests methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 4/7/2003 16:12'!
returnString
	^ 'Hello World'! !

!ExuperyStoryTests methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 11/24/2003 23:18'!
returnTrue
	'Forcing a returnNil bytecode rather than a quick return primitive'.
	^ true! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 8/15/2003 14:04'!
sendAtOutsideTheArray: anArray
	^ anArray at: 4! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 7/31/2003 16:12'!
sendAtPut: anArray
	^ anArray 
		at: 3
		put: 50.! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/23/2003 23:37'!
sendAt: anInteger Put: anObject to: anArray
	^ anArray 
		at: anInteger
		put: anObject.! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/24/2003 23:09'!
sendAt: anInteger to: anArray
	^ anArray 
		at: anInteger.! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 7/19/2003 22:31'!
sendPrimAt: anArray
	^ anArray at: 2! !

!ExuperyStoryTests methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/17/2004 21:20'!
sendReturn4
	^ self return4 + 10! !

!ExuperyStoryTests methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/17/2004 22:24'!
sendReturn4Hook
	^ self return4 + 20! !

!ExuperyStoryTests methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/17/2004 21:21'!
sendReturn6
	^ self return6 + 10! !

!ExuperyStoryTests methodsFor: 'Test - Multiple Methods' stamp: 'wbk 4/17/2004 22:25'!
sendReturn6Hook
	^ self return6 + 20! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 7/2/2003 11:03'!
sendStringConcatenate
	^ 'abc', 'def'! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 3/17/2005 20:52'!
sendTree
	^ self captureSend! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 3/17/2005 21:19'!
sendTree2
	^ self sendTree! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 7/4/2003 12:56'!
sendWithArg1: arg1 arg2: arg2
	| a b |
	a := 4.
	b := 5.
	^ self basicTarget + 1 + a + b + arg1 + arg2! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 7/2/2003 15:52'!
sendWithTemporaries
	| a b |
	a := 4.
	b := 5.
	^ self basicTarget + 1 + a + b! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 9/29/2004 21:31'!
sendWithTemporariesSimple
	| b |
	b := 5.
	^ self basicTarget +  b ! !

!ExuperyStoryTests methodsFor: 'Misc' stamp: 'wbk 4/18/2004 22:20'!
setUp
	Exupery initialiseExupery! !

!ExuperyStoryTests methodsFor: 'Test - Jumps' stamp: 'wbk 2/28/2004 16:11'!
shortUnconditionalJump
^ 20 = 20 ifFalse: [^ 15 + 20].! !

!ExuperyStoryTests methodsFor: 'Test - Jumps' stamp: 'wbk 2/28/2004 16:12'!
shortUnconditionalJump2
^ 20 = 20 ifFalse: [^ #success]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testAdditionArgumentNotInteger
	self compileExpression: '3 + 4.0'.
	self should: [self example = 7.0]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/11/2003 17:20'!
testAdditionOverflow
	self 
		compile: #additionOverflow
		into: #additionOverflow.
	self should: [self additionOverflow = 2000000000]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testAdditionReceiverNotInteger
	self compileExpression: '3.0 + 2'.
	self should: [self example = 5.0]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testAddMultipleValues
	self compileExpression: '2 + 3 + 4 + 5'.
	self should: [self example = 14]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:33'!
testAddMultipleValuesWithTemps
	self compile: '|a b| a := 3. b := 4. ^ 2 + a + b'.
	self should: [self example = 9]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 9/19/2004 18:43'!
testAddThreePlusFour
	self 
		compile: #threePlusFour
		into: #returnNumber.
	self should: [self returnNumber = 7]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testAddThreeValues
	self compileExpression: '2 + 3 + 4'.
	self should: [self example = 9]! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testAnd
	self compileExpression: ' 3 bitAnd: 3'.
	self assert: self example = 3! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testAnd2
	self compileExpression: ' 3 bitAnd: 1'.
	self assert: self example = 1! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testAnd3
	self compileExpression: ' 5 bitAnd: 3'.
	self assert: self example = 1! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testAndArgumentOverflow
	self compileExpression: ' 5 bitAnd: 50000000006'.
	self assert: self example = 4! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testAndReceiverOverflow
	self compileExpression: ' 50000000002 bitAnd: 3'.
	self assert: self example = 2! !

!ExuperyStoryTests methodsFor: 'Test - Assembling Methods' stamp: 'wbk 4/17/2003 10:38'!
testAssembledReturn43
	self 
		compile: #return43
		into: #returnNumber.
	self should: [self returnNumber = 43]! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/6/2005 23:42'!
testAtAfter
	| array answer |
	array := ExuperyArray 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1. "Prime the atCache"
	self 
		compile: #sendAt:to:
		into: #sendAt:to:.
	self compileArrayAt.
	self
		should:
			[answer := self 
				sendAt: 4
				to: array]
		raise: Error.
	self assert: answer = nil.
	! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/6/2005 23:38'!
testAtAfterFromInterpretedCode
	| array answer |
	array := ExuperyArray 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1. "Prime the atCache"
	self compileArrayAt.
	self
		should:
			[answer := self 
				sendAt: 4
				to: array]
		raise: Error.
	self assert: answer = nil.
	! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/6/2005 23:50'!
testAtBefore
	| array answer |
	array := ExuperyArray 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1. "Prime the atCache"
	self 
		compile: #sendAt:to:
		into: #sendAt:to:.
	self compileArrayAt.
	self
		should:
			[answer := self 
				sendAt: 0
				to: array]
		raise: Error.
	self assert: answer = nil.
	! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testAtEnd
	self compileExpression: '(ReadStream on: #()) atEnd'.
	self assert: self example = true! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testAtEnd2
	self compileExpression: '(ReadStream on: #(1 2 3 4)) atEnd'.
	self assert: self example = false! !

!ExuperyStoryTests methodsFor: 'Test - Inlining' stamp: 'wbk 10/29/2005 20:51'!
testAtExuperyArray
	Exupery 
		compileMethod: #sendAt:to:
		class: ExuperyStoryTests
		inlining: {{7. ExuperyArray}}.
	self assert: (self 
		sendAt: 2
		to: (ExuperyArray
			with: 10
			with: 20)) = 20! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/22/2005 12:59'!
testAtFirst
	| array answer |
	array := ExuperyArray 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1. "Prime the atCache"
	self 
		compile: #sendAt:to:
		into: #sendAt:to:.
	self compileArrayAt.
	answer := self 
		sendAt: 1
		to: array.
	self assert: answer = 10.! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/5/2005 22:28'!
testAtFirstFromInterpretedCode
	| array answer |
	array :=  ExuperyArray 
		with: 10 
		with: 20 
		with: 30.
	array at: 1. "Prime the atCache"
	self compileArrayAt.
	answer := self 
		sendAt: 1
		to: array.
	self assert: answer = 10.
	! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/6/2005 17:13'!
testAtFirstWithInstVars
	| array answer |
	array := ExuperyArrayInstVars
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1. "Prime the atCache"
	Exupery
	  	compileMethod: #sendAt:to:
		class: self class
		inlining: {{7. ExuperyArrayInstVars}}.
	self compileArrayAt.
	answer := self 
		sendAt: 1
		to: array.
	self assert: answer = 10.! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/6/2005 23:11'!
testAtLast
	| array answer |
	array := ExuperyArray 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1. "Prime the atCache"
	self 
		compile: #sendAt:to:
		into: #sendAt:to:.
	self compileArrayAt.
	answer := self 
		sendAt: 3
		to: array.
	self assert: answer = 30.! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/6/2005 23:10'!
testAtLastFromInterpretedCode
	| array answer |
	array := ExuperyArray 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1. "Prime the atCache"
	self compileArrayAt.
	answer := self 
		sendAt: 3
		to: array.
	self assert: answer = 30.
	! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/8/2005 18:08'!
testAtPutAfter
	| array |
	array := ExuperyArray 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1
		put: 11. "Prime the atCache"
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.
	self compileArrayAtAndAtPut.
	self
		should:
			[self 
				sendAt: 4
				Put: 50
				to: array]
		raise: Error.
	self 
		array: array 
		equals: #(11 20 30).
	! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/8/2005 18:10'!
testAtPutBefore
	| array |
	array := ExuperyArray 
		with: 10 
		with: 20 
		with: 30.
	array
		at: 1
		put: 11. "Prime the atCache"
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.
	self compileArrayAtAndAtPut.
	self
		should:
			[self 
				sendAt: 0
				Put: 50
				to: array]
		raise: Error.
	self 
		array: array
		equals: #(11 20 30).
	! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/8/2005 18:14'!
testAtPutBothOld
	| newObject array |
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.
	self compileArrayAtAndAtPut.

	newObject := 'A new string' copy.
	array := ExuperyArray 
		with: 10
		with: 20
		with: 30.
	Smalltalk garbageCollect.

	array
		at: 1
		put: 11. "Prime the atCache"
	self checkIsNotRootObject: array.
	self
		sendAt: 1
		Put: newObject
		to: array.

	self checkIsNotRootObject: array.
	self 
		array: array 
		equals:  #( 'A new string' 20 30)! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/8/2005 18:15'!
testAtPutBothYoung
	| newObject array |
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.
	self compileArrayAtAndAtPut.

	Smalltalk garbageCollect.
	newObject := 'A new string' copy.
	array := ExuperyArray 
		with: 10
		with: 20
		with: 30.

	array
		at: 1
		put: 11. "Prime the atCache"
	self checkIsNotRootObject: array.
	self
		sendAt: 1
		Put: newObject
		to: array.

	self checkIsNotRootObject: array.
	self 
		array: array 
		equals: #( 'A new string' 20 30)! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 6/3/2005 16:53'!
testAtPutFirst
	| answer array |
	array := ExuperyArray 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.
	self compileArrayAtAndAtPut.
	array
		at: 1
		put: 11. "Prime the atCache"
	answer := self 
		sendAt: 1
		Put: 50
		to: array.
	self assert: answer = 50.
	self
		array: array 
		equals: #(50 20 30).
	! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/8/2005 18:16'!
testAtPutFromOldToYoung
	| newObject array |
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.
	self compileArrayAtAndAtPut.

	array := ExuperyArray 
		with: 10
		with: 20
		with: 30.
	Smalltalk garbageCollect.
	newObject := 'A new string' copy.

	array
		at: 1
		put: 11. "Prime the atCache"
	self checkIsNotRootObject: array.
	self
		sendAt: 1
		Put: newObject
		to: array.

	self checkIsRootObject: array.
	self 
		array: array 
		equals: #( 'A new string' 20 30)! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/8/2005 18:15'!
testAtPutFromYoungToOld
	| newObject array |
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.
	self compileArrayAtAndAtPut.

	newObject := 'A new string' copy.
	Smalltalk garbageCollect.
	array := ExuperyArray 
		with: 10
		with: 20
		with: 30.

	array
		at: 1
		put: 11. "Prime the atCache"
	self checkIsNotRootObject: array.
	self
		sendAt: 1
		Put: newObject
		to: array.

	self checkIsNotRootObject: array.
	self 
		array: array 
		equals: #( 'A new string' 20 30)! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/9/2005 18:51'!
testAtPutLargeAfter
	| answer array |
	array := ExuperyArray new: 1000.
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.
	Exupery
		compileMethod: #at:put:
		class: ExuperyArray.
	array
		at: 1
		put: 11. "Prime the atCache"
	self 
		should:
			[answer := self 
				sendAt: 1001
				Put: 50
				to: array]
		raise: Error.
	self assert: (array at: 1000) = nil.
	! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/9/2005 18:36'!
testAtPutLastLarge
	| answer array |
	array := ExuperyArray new: 1000.
	self 
		compile: #sendAt:Put:to:
		into: #sendAt:Put:to:.
	Exupery
		compileMethod: #at:put:
		class: ExuperyArray.
	array
		at: 1
		put: 11. "Prime the atCache"
	answer := self 
		sendAt: 1000
		Put: 50
		to: array.
	self assert: answer = 50.
	self assert: (array at: 1000) = 50.
	! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/2/2005 20:08'!
testAtPutSideEffecting
	self compile: '|array| array := ExuperyArray new: 1. array at: 1 put: 42. ^ array'.
	self compileArrayAtAndAtPut.
	self assert: (self example at: 1) = 42.
	! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 12/31/2005 15:47'!
testBasicBlock
	self compileExpression: '[42] value'.
	self assert: self example = 42! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 12/26/2005 20:03'!
testBasicBlockCreation
	| block | 
	self compileExpression: '[42]'.
	block := self example.
	self assert: block class = ExuperyBlockContext! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 1/13/2006 22:48'!
testBasicBlockNonLocalReturn
	self compile: ' [^ 42] value. ^ #wrong'.
	self assert: self example = 42! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/22/2003 17:10'!
testBasicRememberSets
	| object newObject |
	object := ExuperyInstanceVariables new.
	self 
		compile: #a:b:
		into: #a:b:
		class: ExuperyInstanceVariables.

	Smalltalk garbageCollect.
	newObject := 'A new string' copy.

	object
		a: newObject
		b: 20.

	self checkIsRootObject: object.
	self assert: object getA = newObject.
	self assert: object getB = 20.! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 11/23/2003 21:40'!
testBasicRememberSetsBothOld
	| object newObject |
	object := ExuperyInstanceVariables new.
	self 
		compile: #a:b:
		into: #a:b:
		class: ExuperyInstanceVariables.

	newObject := 'A new string' copy.
	Smalltalk garbageCollect.

	object
		a: newObject
		b: 20.

	self checkIsNotRootObject: object.
	self assert: object getA = newObject.
	self assert: object getB = 20.! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 1/31/2005 20:50'!
testBasicRememberSetsBothYoung
	| object newObject |
	self 
		compile: #a:b:
		into: #a:b:
		class: ExuperyInstanceVariables.

	Smalltalk garbageCollect.
	object := ExuperyInstanceVariables new.

	newObject := 'A new string' copy.

	object
		a: newObject
		b: 20.

	self checkIsNotRootObject: object.
	self assert: object getA = newObject.
	self assert: object getB = 20.! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 1/24/2004 15:35'!
testBasicRememberSetsFromYoungToOld
	| object newObject |
	self 
		compile: #a:b:
		into: #a:b:
		class: ExuperyInstanceVariables.

	newObject := 'A new string' copy.
	Smalltalk garbageCollect.
	object := ExuperyInstanceVariables new.

	object 
		a: newObject
		b: 20.

	self checkIsNotRootObject: object.
	self assert: object getA = newObject.
	self assert: object getB = 20! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 7/14/2003 15:18'!
testBasicSend
	self 
		compile: #basicSend
		into: #basicSend.
	self assert: self basicSend = 6! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 7/15/2003 22:38'!
testBasicSend2
	self 
		compile: #sendStringConcatenate
		into: #sendStringConcatenate.
	self assert: self sendStringConcatenate = 'abcdef'! !

!ExuperyStoryTests methodsFor: 'Test - Real Methods' stamp: 'wbk 4/17/2005 15:31'!
testBenchFib
	Exupery 
		compileMethod: #benchFib
		class: SmallInteger.
	self assert: 1 benchFib = 1.
	self assert: 2 benchFib = 3.
	self assert: 3 benchFib = 5! !

!ExuperyStoryTests methodsFor: 'Test - Real Methods' stamp: 'wbk 4/17/2005 15:31'!
testBenchFibLarge
	"A large number of calls to compiled methods used to blow the C stack.
	The problem was caused by some recursion used to handle re-entering compiled
	code from compiled code. This will also occur if a lot of primitives are called from
	a compiled method."

	Exupery 
		compileMethod: #benchFib
		class: SmallInteger.
	self assert: 30 benchFib = 2692537! !

!ExuperyStoryTests methodsFor: 'Test - Real Methods' stamp: 'wbk 5/10/2005 20:18'!
testBenchmark
	Exupery 
		compileMethod: #benchmark
		class: SmallInteger.
	Exupery
		compileMethod: #at:
		class: Array.
	Exupery
		compileMethod: #at:put:
		class: Array.
	self assert: 0 benchmark = nil.
	self assert: 1 benchmark = 1028.
	self assert: 3 benchmark = 1028! !

!ExuperyStoryTests methodsFor: 'Test - Real Methods' stamp: 'wbk 5/10/2005 20:19'!
testBenchmarkLarge
	Exupery 
		compileMethod: #benchmark
		class: SmallInteger.
	Exupery
		compileMethod: #at:
		class: Array.
	Exupery
		compileMethod: #at:put:
		class: Array.
	self assert: 10 benchmark = 1028! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShift
	self compileExpression: '5 bitShift: 2'.
	self assert: self example = 20! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShift2
	self compileExpression: '5 bitShift: 3'.
	self assert: self example = 40! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShift3
	self compileExpression: '5 bitShift: 1'.
	self assert: self example = 10! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShift4
	"Test a shift of more than one byte. To check some Intel instruction set weirdness"

	self compileExpression: '5 bitShift: 512'.
	self assert: self example class = LargePositiveInteger! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShift5
	"Test a shift of more than one byte. To check some Intel instruction set weirdness"

	self compileExpression: '5 bitShift: 32'.
	self assert: self example = 21474836480! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShift6
	"Test a shift of more than one byte. To check some Intel instruction set weirdness"

	self compileExpression: '5 bitShift: 33'.
	self assert: self example = 42949672960! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShift7
	"Test a shift of more than one byte. To check some Intel instruction set weirdness"

	self compileExpression: '5 bitShift: 256'.
	self assert: self example class = LargePositiveInteger! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftNegative
	self compileExpression: '100 bitShift: -3'.
	self assert: self example = 12! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftNegative2
	self compileExpression: '100 bitShift: -1'.
	self assert: self example = 50! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftNegative3
	self compileExpression: '2 bitShift: -512'.
	self assert: self example = 0! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftNegativeNumber
	self compileExpression: '-1 bitShift: -5'.
	self assert: self example = -1! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftNegativeNumber2
	self compileExpression: '-1 bitShift: 1'.
	self assert: self example = -2! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftOverflows
	self compileExpression: '1000000000 bitShift: 1'.
	self assert: self example = 2000000000! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftOverflows2
	"this makes sure that we handle overflows correctly. It's possible that the generic wrapper
	code will handle overflows by one bit. This overflows by a lot. As a 32 bit number, the
	result should be zero, so unless we resort to the primitive it will fail."

	self compileExpression: '1000000000 bitShift: 15'.
	self assert: self example = 32768000000000! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftOverflows3
	"this makes sure that we handle overflows correctly. It's possible that the generic wrapper
	code will handle overflows by one bit. This overflows by a lot. As a 32 bit number, the
	result should be zero, so unless we resort to the primitive it will fail."

	self compileExpression: '1024 bitShift: 30'.
	self assert: self example = 1099511627776! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftReceiverLarge
	self compileExpression: '5000000000 bitShift: 2'.
	self assert: self example = 20000000000! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftReceiverLarge2
	self compileExpression: '5000000001 bitShift: 2'.
	self assert: self example = 20000000004! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftReceiverLarge3
	self compileExpression: '5000000001 bitShift: 4'.
	self assert: self example = 80000000016! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testBitShiftZero
	self compileExpression: '5 bitShift: 0'.
	self assert: self example = 5! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 1/14/2006 19:55'!
testBlockAccessingLiteralFrame
	self compileExpression: '[#answer] value'.
	self assert: self example = #answer! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 3/29/2006 22:00'!
testBlockBug
	" If it doesn't crash it succeeded"
	Exupery
	   compileMethod: #valueOfPreference:ifAbsent:
	class: Preferences class.
	1 
		to: 100000 
		do: [:each| Preferences alternativeScrollbarLook]! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 2/18/2006 16:22'!
testBlockClearsArguments
	| block |
	self compile: '|a|  a := [42]. a value. ^a'.
	block := self example.
	self assert: block interpretedStackPointer = 1.
	self assert: block interpretedProgramCounter isNil.
	self assert: block sender isNil.! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 2/18/2006 16:22'!
testBlockClearsArgumentsNonLocalReturn
	| block |
	self compile: '|a|  a := [^ a]. a value. ^wrong'.
	block := self example.
	self assert: block interpretedStackPointer = 1.
	self assert: block interpretedProgramCounter isNil.
	self assert: block sender isNil.! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 2/18/2006 22:53'!
testBlockCreationWithGC
	"Crashing is a failure"
	self compileExpression: '[42] value'.
	SmalltalkImage current vmParameterAt: 5 put: 1.
	self example.
	SmalltalkImage current vmParameterAt: 5 put: 4000.! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 1/26/2006 19:47'!
testBlockEnsureUnwinding
	| variables |
	Exupery 
		compileMethod: #ensureUnwinding
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables ensureUnwinding.
	self assert: variables a = 42! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 1/21/2006 14:44'!
testBlockNestedDo
	"This expression had a bug in it. I found it by trying to benchmark blocks. It's a simple
	stack tracing bug, but it really should have a story test that covers it."
	self compile: 
		'|answer| 
		answer := 0. 
		1 to: 2 do: [:x|(1 to: 10) do: [:each| answer := answer + 1]]. 
		^ answer'.
	self assert: self example = 20! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 4/16/2006 18:49'!
testBlockNumArgs
	self compileExpression: '[] numArgs'.
	self assert: self example = 0! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 4/16/2006 18:51'!
testBlockNumArgs1
	self compileExpression: '[:a |] numArgs'.
	self assert: self example = 1! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 4/16/2006 18:51'!
testBlockNumArgs2
	self compileExpression: '[:a :b |] numArgs'.
	self assert: self example = 2! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 4/16/2006 17:10'!
testBlockOnDo
	self compileExpression: '[ExuperyTestException signal] on: ExuperyTestException do: [^#correct]'.
	self assert: self example = #correct! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 1/14/2006 22:59'!
testBlockReadTemporary
	self compile: '|a| a := 42. ^[a] value'.
	self assert: self example = 42! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 1/15/2006 18:55'!
testBlockSendFrom
	self compileExpression: '[''abc'', ''def''] value'.
	self assert: self example = 'abcdef'! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 1/26/2006 21:22'!
testBlockSettingAnInstanceVariable
	| variables |
	Exupery 
		compileMethod: #blockSetA
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables blockSetA.
	self assert: variables a = 42! !

!ExuperyStoryTests methodsFor: 'Test - Bugs' stamp: 'wbk 4/9/2006 13:12'!
testBlocksCauseCrashes
	"If it doesn't crash while compiling the second method the the bug's been fixed."
	Exupery
   		compileMethod: #at:ifAbsentPut:
   		class: Dictionary.
	Exupery
   		compileMethod: #displayString:on:from:to:at:kern:baselineY:
   		class: TTCFont.! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 4/16/2006 17:03'!
testBlocksReceiver
	self compileExpression: '[42] receiver'.
	self assert: self example class = ExuperyStoryTests! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 4/19/2006 20:52'!
testBlocksSelector
	self compileExpression: '[42] selector'.
	self assert: self example = #example! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 1/22/2006 16:23'!
testBlockWith3Args
	self compileExpression: '[:a :b :c | (a* 100) + (b * 10) + c] value: 3 value: 4 value: 5'.
	self assert: self example = 345! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 1/18/2006 18:50'!
testBlockWithArg
	self compileExpression: '[:arg| arg] value: 42'.
	self assert: self example = 42! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 1/18/2006 18:51'!
testBlockWithArgs
	self compileExpression: '[:a :b | a + b] value: 3 value: 4'.
	self assert: self example = 7! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 1/14/2006 23:00'!
testBlockWriteTemporary
	self compile: '|a|  [a := 42] value. ^a'.
	self assert: self example = 42! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 2/10/2006 18:34'!
testBlockWriteTemporaryNested
	self compile: '|a|  [[a := 42] value] value. ^a'.
	self assert: self example = 42! !

!ExuperyStoryTests methodsFor: 'Test - Blocks' stamp: 'wbk 2/10/2006 18:35'!
testBlockWriteTemporaryNested2
	self compile: '|a|  [[[a := 42] value] value] value. ^a'.
	self assert: self example = 42! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 7/19/2003 20:09'!
testBytecodePrimSendWithArg
	| answer |
	self 
		compile: #bytecodePrimSendWithArg
		into: #bytecodePrimSendWithArg.
	answer := self bytecodePrimSendWithArg.
	self should: [answer class = Array].
	self assert: answer size = 5.
	! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testClass
	"There are three cases to concider. First, the class is an integer. Second, the class is
	a compact class. Third, the class has a full class header"

	self compileExpression: '10 class'.
	self assert: self example = SmallInteger! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testClass2
	| answer |
	self compileExpression: 'Array new class'.
	answer := self example.
	self assert: answer = Array! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testClass3
	self compileExpression: 'Set new class'.
	self assert: self example = Set! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/29/2005 20:50'!
testClass4
	self compileExpression: 'ExuperyStoryTests new class'.
	self assert: self example = ExuperyStoryTests! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 4/16/2005 17:02'!
testClass5
	self compileExpression: '#aSymbol class'.
	self assert: self example = ByteSymbol! !

!ExuperyStoryTests methodsFor: 'Test - Bugs' stamp: 'wbk 9/28/2005 18:29'!
testCorruptContextBug
	
	

	Exupery
		compileMethod: #pathName:isEncoded:
		class: FilePath.
	Exupery
		compileMethod: #convertFromWithConverter:
		class: ByteString.
	Exupery
		compileMethod: #sorts:before:
		class: Heap.! !

!ExuperyStoryTests methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 18:53'!
testDeconversionRemoveIfTrue
	self compileExpression: '6 = 5 ifTrue: [10]'.
	self should: [self example = nil]! !

!ExuperyStoryTests methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 18:52'!
testDeconversionRemoveIfTrue2
	self compileExpression: '6 = 6 ifTrue: [10]'.
	self should: [self example = 10]! !

!ExuperyStoryTests methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 20:32'!
testDeconversionRemoveLongJumpIfFalse
	self compile: '6 = 6 ifTrue: [^ 10]. ^ 20'.
	self should: [self example = 10]! !

!ExuperyStoryTests methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 20:32'!
testDeconversionRemoveLongJumpIfFalse2
	self compile: '6 = 5 ifTrue: [^ 10]. ^ 20'.
	self should: [self example = 20]! !

!ExuperyStoryTests methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 20:33'!
testDeconversionRemoveLongJumpIfTrue
	self compile: '6 = 5 ifFalse: [^ 10]. ^ 20'.
	self should: [self example = 10]! !

!ExuperyStoryTests methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 20:34'!
testDeconversionRemoveLongJumpIfTrue2
	self compile: '6 = 6 ifFalse: [^ 10]. ^ 20'.
	self should: [self example = 20]! !

!ExuperyStoryTests methodsFor: 'Test - Bugs' stamp: 'wbk 1/21/2006 21:43'!
testDictionaryAtIfAbsentCrashes
	Exupery
		compileMethod: #at:ifAbsent:
		class: Dictionary.
	ExuperyBenchmarks new compilerBenchmark! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDiv
	self compileExpression: '7 // 2'.
	self should: [self example = 3]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDiv2
	self compileExpression: '11 // 2'.
	self should: [self example = 5]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDiv3
	self compileExpression: '-11 // 2'.
	self should: [self example = -6]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivArgumentNotInteger
	self compileExpression: '2001 // 7000000000'.
	self should: [self example = 0]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivide
	self compileExpression: '6 / 2'.
	self should: [self example = 3]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivide2
	self compileExpression: '6 / 3'.
	self should: [self example = 2]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivideArgumentNotInteger
	self compileExpression: '6 / 2.0'.
	self should: [self example = 3.0]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivideByZero
	self compileExpression: '6 / 0'.
	self 
		should: [self example]
		raise: ZeroDivide! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivideCreatingFraction
	self compileExpression: '5 / 2'.
	self should: [self example = (5 / 2)]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivideCreatingFraction2
	self compileExpression: '12 / 7'.
	self should: [self example = (12 / 7)]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivideNegativeNumber
	"The Intel x86 CPU uses two registers to represent the dividend. The top register
	needs to be the sign extended version of the bottom register. This means that clearing
	the top register (EDX) would work for positive numbers but not negative numbers. Thus
	we need to check negatives for division but not for other arithmatic operations"

	self compileExpression: '-6 / 2'.
	self should: [self example = -3]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivideNegativeNumber2
	"The Intel x86 CPU uses two registers to represent the dividend. The top register
	needs to be the sign extended version of the bottom register. This means that clearing
	the top register (EDX) would work for positive numbers but not negative numbers. Thus
	we need to check negatives for division but not for other arithmatic operations"

	self compileExpression: '-6000 / 3000'.
	self should: [self example = -2]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivideOverFlow
	| answer |
	self compileExpression: 'SmallInteger minVal / -1'.
	answer := self example.
	self assert: answer = (SmallInteger minVal * -1).
	self assert: (answer isKindOf: LargePositiveInteger)! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivideReceiverNotInteger
	self compileExpression: '6.0 / 2'.
	self should: [self example = 3.0]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivReceiverNotInteger
	self compileExpression: '11000000001 // 2'.
	self should: [self example = 5500000000]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testDivReceiverNotInteger2
	self compileExpression: '-21000000001 // 2'.
	self should: [self example = -10500000001]! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 1/16/2006 19:29'!
testDo
	self compile: '|answer| answer := 0. (1 to: 5) do: [:each| answer := answer + 1]. ^ answer'.
	self assert: self example = 5! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testEqualsSendingEqual
	self compileExpression: '5.0 = 5.0'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testEqualsSendingGreater
	self compileExpression: '6.0 = 5.0'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testEqualsSendingLess
	self compileExpression: '4.0 = 5.0'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testEqualsWhenEquals
	self compileExpression: '6 = 6'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testEqualsWhenGreater
	self compileExpression: '6 = 5'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testEqualsWhenLess
	self compileExpression: '4 = 5'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testEquivilent
	self compileExpression: '10 == 20 ifFalse: [^ #failed]'.
	self assert: self example = #failed! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testEquivilent2
	self compileExpression: '10 == 20 '.
	self assert: self example = false! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testEquivilent3
	self compileExpression: '20 == 20 '.
	self assert: self example = true! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 6/16/2004 22:39'!
testExtendedSend
	self 
		compile: #extendedSend
		into: #extendedSend.
	self assert: self extendedSend = 42! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 10/4/2004 21:43'!
testExtendedTemporaries
	| variables |
	Exupery 
		compileMethod: #basicTemps
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	self assert: variables basicTemps = 35! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanEqualSendingEqual
	self compileExpression: '5.0 >= 5.0'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanEqualSendingGreater
	self compileExpression: '6.0 >= 5.0'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanEqualSendingLess
	self compileExpression: '4.0 >= 5.0'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanEqualWhenEquals
	self compileExpression: '5 >= 5'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanEqualWhenGreater
	self compileExpression: '6 >= 5'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanEqualWhenLess
	self compileExpression: '4 >= 5'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanSendingEquals
	self compileExpression: '5.0 > 5.0'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanSendingGreater
	self compileExpression: '6.0 > 5.0'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanSendingLess
	self compileExpression: '4.0 > 5.0'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanWhenEquals
	self compileExpression: '5 > 5'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanWhenGreater
	self compileExpression: '7 > 6'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testGreaterThanWhenLess
	self compileExpression: '5 > 6'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 18:53'!
testIfFalseDeconversionRemoval
	self compileExpression: '6 = 5 ifFalse: [10]'.
	self should: [self example = 10]! !

!ExuperyStoryTests methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 18:55'!
testIfFalseDeconversionRemoval2
	self compileExpression: '6 = 6 ifFalse: [10]'.
	self should: [self example = nil]! !

!ExuperyStoryTests methodsFor: 'Test - Inlining' stamp: 'wbk 10/29/2005 20:51'!
testInliningAtPut

	| array |
	Exupery 
		compileMethod: #sendAt:Put:to:
		class: ExuperyStoryTests
		inlining: (OrderedCollection with:
			(OrderedCollection
				with: 8
				with: Array)).
	array := #(10 20 30).
	self 
		sendAt: 2
		Put: 50
		to: array.
	self assert: array = #(10 50 30)! !

!ExuperyStoryTests methodsFor: 'Test - Inlining' stamp: 'wbk 10/29/2005 20:51'!
testInliningGetsArrayOnlyOnce
	|array|
	Exupery 
		compileMethod: #activeReceiverAt:
		class: ExuperyStoryTests
		inlining: (OrderedCollection with:
			(OrderedCollection
				with: 12
				with: Array)).
	array := ExuperyInstanceVariables new.
	self assert: (self activeReceiverAt: array) = #b.
	self assert: array count = 1
	! !

!ExuperyStoryTests methodsFor: 'Test - Assembling Methods' stamp: 'wbk 4/17/2003 10:39'!
testIterativeFactorial
	self
		compile: #iterativeFactorial
		into: #returnNumber.
	self should: [self returnNumber = 6]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanEqualArgumentNotInteger
	self compileExpression: '5 <= 6.0'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanEqualReceiverNotInteger
	self compileExpression: '5.0 <= 6'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanEqualSendingAndEquals
	self compileExpression: '5 <= 5.0'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanEqualSendingAndGreater
	self compileExpression: '5 <= 4.0'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanEqualSendingAndLess
	self compileExpression: '4 <= 5.0'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 4/17/2003 10:39'!
testLessThanEqualsWhenEquals
	self
		compile: #lessThanEqualsWhenEquals
		into: #returnNumber.
	self should: [self returnNumber = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 4/17/2003 10:40'!
testLessThanEqualsWhenGreater
	self
		compile: #lessThanEqualsWhenGreater
		into: #returnNumber.
	self should: [self returnNumber = false]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 4/17/2003 10:41'!
testLessThanEqualsWhenLess
	self
		compile: #lessThanEqualsWhenLess
		into: #returnNumber.
	self should: [self returnNumber = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanSendingEquals
	self compileExpression: '5.0 < 5.0'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanSendingGreater
	self compileExpression: '4 < 3.0'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanSendingLess
	self compileExpression: '4.0 < 5'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanWhenEquals
	self compileExpression: '5 < 5'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanWhenGreater
	self compileExpression: '4 < 3'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testLessThanWhenLess
	self compileExpression: '4 < 5'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Method Registering' stamp: 'wbk 7/17/2004 18:43'!
testLoadOverflow
	self
		should: 
			[[true] whileTrue: [Exupery loadCode: (ByteArray new: 10000)]]
		raise: Exception.
	! !

!ExuperyStoryTests methodsFor: 'Test - Jumps' stamp: 'wbk 2/15/2004 12:20'!
testLongJumpIfFalseOnNonInteger
	self 
		compile: #longJumpIfFalseOnNonInteger
		into: #longJumpIfFalseOnNonInteger.
	self 
		should: [self longJumpIfFalseOnNonInteger]
		raise: ExuperyTestException
! !

!ExuperyStoryTests methodsFor: 'Test - Jumps' stamp: 'wbk 2/13/2004 21:48'!
testLongJumpIfTrue
	self 
		compile: #longJumpIfTrue
		into: #longJumpIfTrue.
	self assert: self longJumpIfTrue = 42
! !

!ExuperyStoryTests methodsFor: 'Test - Jumps' stamp: 'wbk 2/14/2004 13:20'!
testLongJumpIfTrueOnFalse
	self 
		compile: #longJumpIfTrueOnFalse
		into: #longJumpIfTrueOnFalse.
	self assert: self longJumpIfTrueOnFalse = 3
! !

!ExuperyStoryTests methodsFor: 'Test - Jumps' stamp: 'wbk 2/14/2004 13:40'!
testLongJumpIfTrueOnNonInteger
	self 
		compile: #longJumpIfTrueOnNonInteger
		into: #longJumpIfTrueOnNonInteger.
	self 
		should: [self longJumpIfTrueOnNonInteger]
		raise: ExuperyTestException
! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testMakePoint
	self compileExpression: ' 7 @ 13'.
	self assert: self example = (7 @ 13)! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testMakePointFloat
	self compileExpression: ' 7.5 @ 13'.
	self assert: self example = (7.5 @ 13)! !

!ExuperyStoryTests methodsFor: 'Test - Inlining' stamp: 'wbk 10/29/2005 20:51'!
testManualInlining
	Exupery 
		compileMethod: #sendAt:to:
		class: ExuperyStoryTests
		inlining: (OrderedCollection with:
			(OrderedCollection
				with: 7
				with: Array)).
	self assert: (self 
		sendAt: 2
		to: #(10 20 30)) = 20! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMod
	self compileExpression: '7 \\ 2'.
	self should: [self example = 1]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMod2
	self compileExpression: '10 \\ 4'.
	self should: [self example = 2]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMod3
	self compileExpression: '-10 \\ 4'.
	self should: [self example = 2]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMod4
	self compileExpression: '-30 \\ 7'.
	self should: [self example = 5]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMod5
	self compileExpression: '-30 \\ -7'.
	self should: [self example = -2]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMod6
	self compileExpression: '30 \\ -7'.
	self should: [self example = -5]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 3/30/2006 22:23'!
testMod7
	self compileExpression: '-1 \\ 12'.
	self should: [self example = 11]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 4/1/2006 13:59'!
testMod8
	self compileExpression: '-1 \\ -12'.
	self should: [self example = -1]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 4/1/2006 14:00'!
testMod9
	self compileExpression: '0 \\ -12'.
	self should: [self example = 0]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testModArgumentNotInteger
	self compileExpression: '1000 \\ 5000000000'.
	self should: [self example = 1000]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testModReceiverNotInteger
	self compileExpression: '-10000000001 \\ 4'.
	self should: [self example = 3]! !

!ExuperyStoryTests methodsFor: 'Test - Bugs' stamp: 'wbk 10/19/2005 20:56'!
testMoveS1S1
	Exupery
		compileMethod: #sortKey
		class: MCMethodDefinition.! !

!ExuperyStoryTests methodsFor: 'Test - Multiple Methods' stamp: 'wbk 10/29/2005 20:52'!
testMultipleMethods
	Exupery 
		compileMethod: #return4
		into: #return5
		forClass: ExuperyStoryTests
		inlining: #().
	Exupery 
		compileMethod: #return6
		into: #return7
		forClass: ExuperyStoryTests
		inlining: #().
	Exupery 
		compileMethod: #return8
		into: #return9
		forClass: ExuperyStoryTests
		inlining: #().
	self assert: self return5 = 4.
	self assert: self return7 = 6.
	self assert: self return9 = 8! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMultiplicationArgumentNotInteger
	self compileExpression: '2 * 3.0'.
	self should: [self example = 6.0]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMultiplicationOverflow
	self compileExpression: '1000000000 * 2'.
	self should: [self example = 2000000000]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testMultiplicationReceiverNotInteger
	self compileExpression: '2.0 * 5'.
	self should: [self example = 10.0]! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testNew
	self compileExpression: ' OrderedCollection new'.
	self assert: self example class = OrderedCollection! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testNew2
	self compileExpression: ' Array new'.
	self assert: self example class = Array! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testNext
	self compileExpression: '(Month month: 2 year: 2000) next'.
	self assert: self example asString = 'March 2000'! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testNext2
	self compileExpression: '(Month month: 6 year: 2000) next'.
	self assert: self example asString = 'July 2000'! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testNextPut
	self compileExpression: '((WriteStream on: Array new) nextPut: #abcd) contents'.
	self assert: self example = #(#abcd)! !

!ExuperyStoryTests methodsFor: 'Test - Deconversion Removal' stamp: 'wbk 12/24/2004 20:36'!
testNonIntegerDeconversionRemoval
	self compileExpression: '6.0 = 5 ifFalse: [10]'.
	self should: [self example = 10]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testNotEqualsSendingEqual
	self compileExpression: '5.0 ~= 5.0'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testNotEqualsSendingGreater
	self compileExpression: '6.0 ~= 5.0'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testNotEqualsSendingLess
	self compileExpression: '4.0 ~= 5.0'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testNotEqualsWhenEquals
	self compileExpression: '5 ~= 5'.
	self should: [self example = false]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testNotEqualsWhenGreater
	self compileExpression: '6 ~= 5'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Comparision' stamp: 'wbk 10/3/2004 11:34'!
testNotEqualsWhenLess
	self compileExpression: '4 ~= 5'.
	self should: [self example = true]! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testOr
	self compileExpression: ' 1 bitOr: 2'.
	self assert: self example = 3! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testOr2
	self compileExpression: ' 8 bitOr: 3'.
	self assert: self example = 11! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testOrArgumentLarge
	self compileExpression: ' 11 bitOr: 5000000000'.
	self assert: self example = 5000000011! !

!ExuperyStoryTests methodsFor: 'Test - Bitwise Operators' stamp: 'wbk 10/3/2004 11:34'!
testOrReceiverLarge
	self compileExpression: ' 5000000000 bitOr: 3'.
	self assert: self example = 5000000003! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 3/13/2005 21:28'!
testPicMultipleSends
	self 
		compile: #trivialSend:
		into: #trivialSend:.
	self 
		compile: #basicTarget
		into: #basicTarget.
	Exupery 
		compileMethod: #basicTarget
		class: ExuperyInstanceVariables.
	Exupery 
		compileMethod: #basicTarget
		class: CompilerToys.
"	Exupery 
		compileMethod: #basicTarget
		class: ExuperyInstanceVariables."
	self assert: (self trivialSend: self) = 5.
	self assert: (self trivialSend: ExuperyInstanceVariables new) = 6.
	self assert: (self trivialSend: CompilerToys new) = 7.
	self assert: (self trivialSend: ExuperyBenchmarks new) = 8.

	self assert: (self trivialSend: self) = 5.
	self assert: (self trivialSend: ExuperyInstanceVariables new) = 6.
	self assert: (self trivialSend: CompilerToys new) = 7.
	self assert: (self trivialSend: ExuperyBenchmarks new) = 8.! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 3/6/2005 12:48'!
testPicSend
	self 
		compile: #trivialSend
		into: #trivialSend.
	self 
		compile: #basicTarget
		into: #basicTarget.
	self assert: self trivialSend = 5.
	self assert: self trivialSend = 5! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 3/13/2005 14:06'!
testPicSendToArgument
	self 
		compile: #trivialSend:
		into: #trivialSend:.
	self 
		compile: #basicTarget
		into: #basicTarget.
	self assert: (self trivialSend: self) = 5.
	self assert: (self trivialSend: self) = 5.! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 3/12/2005 22:46'!
testPicTwoSends
	self 
		compile: #trivialSend:
		into: #trivialSend:.
	self 
		compile: #basicTarget
		into: #basicTarget.
	Exupery 
		compileMethod: #basicTarget
		class: ExuperyInstanceVariables.
	self assert: (self trivialSend: self) = 5.
	self assert: (self trivialSend: ExuperyInstanceVariables new) = 6.
	self assert: (self trivialSend: self) = 5.
	self assert: (self trivialSend: ExuperyInstanceVariables new) = 6.! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testPointX
	self compileExpression: '(10 @ 20) x'.
	self assert: self example = 10! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testPointX2
	self compileExpression: '(15 @ 20) x'.
	self assert: self example = 15! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testPointY
	self compileExpression: '(10 @ 20) y'.
	self assert: self example = 20! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testPointY2
	self compileExpression: '(10 @ 25) y'.
	self assert: self example = 25! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testPopReceiverLarge
	| variables |
	Exupery 
		compileMethod: #i16
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables i16: 42.
	self assert: variables i16 = 42! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testPopReceiverLarge2
	| variables |
	Exupery 
		compileMethod: #i17
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables i17: 42.
	self assert: variables i17 = 42! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 7/31/2003 16:22'!
testPopStack
	self compile: #popStack into: #popStack.
	self assert: self popStack = 5! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 10/4/2003 18:45'!
testPushConstantMinusOne
	self 
		compile: #pushConstantMinusOne
		into: #pushConstantMinusOne.
	self should: [self pushConstantMinusOne = -1]! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 10/4/2003 21:44'!
testPushConstantNill
	self 
		compile: #pushConstantNil
		into: #pushConstantNil.
	self should: [self pushConstantNil = nil]! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 7/19/2003 20:54'!
testPushConstantTrue
	| answer |
	self 
		compile: #pushConstantTrue
		into: #pushConstantTrue.
	answer := self pushConstantTrue.
	self should: [answer = true].
	! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 7/11/2003 11:24'!
testPushConstantZero
	self 
		compile: #pushConstantZero
		into: #pushConstantZero.
	self should: [self pushConstantZero = 0]! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 7/31/2003 16:22'!
testPushFalse
	| answer |
	self 
		compile: #pushFalse
		into: #pushFalse.
	answer := self pushFalse.
	self assert: answer = false.
	! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 7/31/2003 16:22'!
testPushLiteralVariable
	self 
		compile: #pushLiteralVariable
		into: #pushLiteralVariable.
	self assert: self pushLiteralVariable = Array
	! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testPushReceiverLarge
	| variables |
	Exupery 
		compileMethod: #i16:
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables i16: 42.
	self assert: variables i16 = 42! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testPushReceiverLarge2
	| variables |
	Exupery 
		compileMethod: #i17:
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables i17: 42.
	self assert: variables i17 = 42! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testPushReceiverLarge3
	"The push bytecode overflows at 8 rather than 16 as with pops. This tests
	the smallest compact bytecodes decoding"

	| variables |
	Exupery 
		compileMethod: #i8:
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	variables i8: 42.
	self assert: variables i8 = 42! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 9/29/2003 21:04'!
testPushReceiverVariables
	| object |
	object := ExuperyInstanceVariables new.
	self 
		compile: #a
		into: #a
		class: ExuperyInstanceVariables.
	object
		a: 10
		b: 20.
	self assert: object a = 10.! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 9/29/2003 21:04'!
testPushReceiverVariables2
	| object |
	object := ExuperyInstanceVariables new.
	self
		compile: #b
		into: #b
		class: ExuperyInstanceVariables.
	object
		a: 10
		b: 20.
	self assert: object b = 20.! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 10/21/2004 20:37'!
testPushReceiverVariablesWithSideEffects
	| object |
	object := ExuperyInstanceVariables new.
	self 
		compile: #sideEffects
		into: #sideEffects
		class: ExuperyInstanceVariables.
	self assert: object sideEffects = 7.! !

!ExuperyStoryTests methodsFor: 'Test - Bugs' stamp: 'wbk 10/29/2005 20:53'!
testPystone
	Exupery
		compileMethod: #proc8:with:with:with:
		class: ExuperyStoryTests.

	ExuperyStoryTests new
		proc8:( Array new: 51 withAll: 0)
		with: (((1 to: 51) collect: [:i | ( Array new: 51 withAll: 0)]) asArray)
		with: 3
		with: 7.
	"If it doesn't crash it passed"! !

!ExuperyStoryTests methodsFor: 'Test - Inlining' stamp: 'wbk 10/29/2005 20:51'!
testReadPics
	| pics pic |
	self 
		compile: #trivialSend
		into: #trivialSend.
	self 
		compile: #basicTarget
		into: #basicTarget.
	self trivialSend = 5.
	pics := Exupery 
		picsInMethod: #trivialSend
		class: ExuperyStoryTests.
	self assert: pics size = 1.
	pic := pics first.
	self assert: pic byteCodeAddress = 10.
	self assert: pic receivers size = 1.
	self assert: pic receivers first = ExuperyStoryTests.
	! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 10/3/2004 11:34'!
testRecursiveStackTracing
	self compileExpression: 'false 
			ifTrue: [5] 
			ifFalse: [false 
				ifTrue: [10]
				ifFalse: [15]]'.
	self assert: self example = 15! !

!ExuperyStoryTests methodsFor: 'Test - Bugs' stamp: 'wbk 10/14/2005 23:17'!
testRegisterAllocatorSpillsNativeRegister
	|collection|
	Exupery
		compileMethod: #reset
		class: OrderedCollection.
	collection := OrderedCollection new.
	collection addAll: #(a b c).
	collection reset.
	self assert: collection isEmpty
! !

!ExuperyStoryTests methodsFor: 'Test - Method Registering' stamp: 'wbk 10/29/2005 20:50'!
testRegisterFunctionTwice
	Exupery 
		compileMethod: #returnNumber
		class: ExuperyStoryTests.
	Exupery 
		compileMethod: #returnNumber
		class: ExuperyStoryTests.
	self should: [self returnNumber = 5]! !

!ExuperyStoryTests methodsFor: 'Test - Real Methods' stamp: 'wbk 12/12/2004 23:37'!
testRegisterPressure
	self compileExpression: '1 + (2 + (3 + (4 + (5 + (6 + (7 + 8))))))'.
	self assert: self example = 36! !

!ExuperyStoryTests methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 4/17/2003 10:49'!
testReturnArgument
 	self
		compile: #returnArgument:
		into: #returnArgument:.
	self should: [(self returnArgument: 3) = 6].
	self should: [(self returnArgument: 4) = 8]! !

!ExuperyStoryTests methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 11/27/2003 19:52'!
testReturnFalse
	self 
		compile: #returnFalse
		into: #returnFalse.
	self assert: self returnFalse = false! !

!ExuperyStoryTests methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 10/18/2003 13:39'!
testReturnNil
	self 
		compile: #returnNil
		into: #returnNil.
	self assert: self returnNil = nil! !

!ExuperyStoryTests methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 10/16/2003 22:13'!
testReturnSelf
	self 
		compile: #returnSelf
		into: #returnSelf.
	self assert: self returnSelf = self! !

!ExuperyStoryTests methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 10/16/2003 22:24'!
testReturnSelfBytecode
	self 
		compile: #returnSelfBytecode
		into: #returnSelfBytecode.
	self assert: self returnSelfBytecode = self! !

!ExuperyStoryTests methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 4/17/2003 10:49'!
testReturnString
	self
		compile: #returnString
		into: #returnString.
	self should: [self returnString = 'Hello World']! !

!ExuperyStoryTests methodsFor: 'Test - Return Bytecodes' stamp: 'wbk 11/24/2003 23:14'!
testReturnTrue
	self 
		compile: #returnTrue
		into: #returnTrue.
	self assert: self returnTrue = true! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/2/2005 20:09'!
testSendAtOutsideTheArray
	| array |
	array := ExuperyArray 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendAtOutsideTheArray:
		into: #sendAtOutsideTheArray:.
	self compileArrayAt.
	self 
		should: [self sendAtOutsideTheArray: array.]
		raise: Error
		description: 'Array out of bounds failing'.
	self 
		should: [self sendAtOutsideTheArray: array.]
		raise: Error
		description: 'Array out of bounds failing'.
	! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/8/2005 18:11'!
testSendAtPut
	| answer array |
	array := ExuperyArray 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendAtPut:
		into: #sendAtPut:.
	self compileArrayAtAndAtPut.
	answer := self sendAtPut: array.
	self assert: answer = 50.
	self 
		array: array 
		equals: #(10 20 50).
	! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/8/2005 18:12'!
testSendAtPutDouble
	"Double because of the atCache, the first time primes the cache"
	| answer array |
	array := ExuperyArray 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendAtPut:
		into: #sendAtPut:.
	self compileArrayAtAndAtPut.
	answer := self sendAtPut: array.
	answer := self sendAtPut: array.
	self assert: answer = 50.
	self 
		array: array 
		equals: #(10 20 50).
	! !

!ExuperyStoryTests methodsFor: 'Test - Memory Management (GC)' stamp: 'wbk 5/2/2005 20:09'!
testSendPrimAt
	| answer array |
	array := ExuperyArray 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendPrimAt:
		into: #sendPrimAt:.
	self compileArrayAt.
	answer := self sendPrimAt: array.
	self should: [answer = 20].
	! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 8/10/2003 18:05'!
testSendPrimAtDouble
	| answer array |
	"Tests that the cache works, the first call will prime the atCache and the second call
	should use the cache"
	array := Array 
		with: 10 
		with: 20 
		with: 30.
	self 
		compile: #sendPrimAt:
		into: #sendPrimAt:.
	answer := self sendPrimAt: array.
	self assert: answer = 20.
	answer := self sendPrimAt: array.
	self assert: answer = 20.
	! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 3/25/2005 22:13'!
testSendTree
	| context |
	self 
		compile: #sendTree2
		into: #sendTree2.
	self 
		compile: #sendTree
		into: #sendTree.
	context := self sendTree2.
	context := self sendTree2.
	self assert: context class = MethodContext.
	self assert: context method selector = #sendTree.! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 4/12/2004 15:32'!
testSendWithArguments
	" Checks that rematerialising the stack doesn't trash arguments and temporaries. Temporaries
	  occur just before the stack in the frame."
	self 
		compile: #sendWithArg1:arg2:
		into: #sendWithArg1:arg2:.
	self assert: (self 
		sendWithArg1: 100
		arg2: 200) = 315! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 7/7/2003 13:02'!
testSendWithTemporaries
	" Checks that rematerialising the stack doesn't trash temporaries. Temporaries
	  occur just before the stack in the frame."
	self 
		compile: #sendWithTemporaries
		into: #sendWithTemporaries.
	self assert: self sendWithTemporaries = 15! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 9/29/2004 21:28'!
testSendWithTemporariesSimple
	" Checks that rematerialising the stack doesn't trash temporaries. Temporaries
	  occur just before the stack in the frame."
	self 
		compile: #sendWithTemporariesSimple
		into: #sendWithTemporariesSimple.
	self assert: self sendWithTemporariesSimple = 10! !

!ExuperyStoryTests methodsFor: 'Test - Jumps' stamp: 'wbk 2/28/2004 15:12'!
testShortUnconditionalJump
	self 
		compile: #shortUnconditionalJump
		into: #shortUnconditionalJump.
	self assert: self shortUnconditionalJump = nil
! !

!ExuperyStoryTests methodsFor: 'Test - Jumps' stamp: 'wbk 2/28/2004 15:12'!
testShortUnconditionalJump2
	self 
		compile: #shortUnconditionalJump2
		into: #shortUnconditionalJump2.
	self assert: self shortUnconditionalJump2 = nil
! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testSize
	self compileExpression: '#abcd size'.
	self assert: self example = 4! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 10/3/2004 11:34'!
testSize2
	self compileExpression: '''abcde'' size'.
	self assert: self example = 5! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 10/3/2004 11:34'!
testStackTracing
	"The origional stack tracing code did not handle tracing the stack across jumps. These
	tests cover the stack being non empty across jumps."

	self compileExpression: 'true ifTrue: [5] ifFalse: [10]'.
	self assert: self example = 5! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 10/3/2004 11:34'!
testStackTracing2
	self compileExpression: 'false ifTrue: [5] ifFalse: [10]'.
	self assert: self example = 10! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 12/2/2004 22:39'!
testStoreAndPopReceiverVariables
	| object |
	object := ExuperyInstanceVariables new.
	self 
		compile: #a:b:
		into: #a:b:
		class: ExuperyInstanceVariables.
	object
		a: 10
		b: 20.
	self assert: object a = 10.
	self assert: object b = 20.! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testStoreInstanceExtended
	| variables |
	Exupery 
		compileMethod: #storeInstanceExtended2
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	self assert: variables storeInstanceExtended2 = 20! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 7/15/2004 23:33'!
testStoreTempExtended
	| variables |
	Exupery 
		compileMethod: #storeTempExtended
		class: ExuperyInstanceVariables.
	variables := ExuperyInstanceVariables new.
	self assert: variables storeTempExtended = 30! !

!ExuperyStoryTests methodsFor: 'Test - Bugs' stamp: 'wbk 9/4/2005 22:59'!
testStressCrashOne
	Exupery initialiseExupery.
	Exupery
		compileMethod: #printStringBase:
		class: LargePositiveInteger.
	LargePositiveIntegerTest buildSuite run.! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testSubtractArgumentNotInteger
	self compileExpression: '5 - 4.0'.
	self should: [self example = 1.0]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testSubtractOverflow
	self compileExpression: '-1000000000 - 1000000000'.
	self should: [self example = -2000000000]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 10/3/2004 11:34'!
testSubtractReceiverNotInteger
	self compileExpression: '5.0 - 2'.
	self should: [self example = 3.0]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 4/9/2005 23:03'!
testSubtractThreeNumbers
	self compileExpression: '10 - 2 -1'.
	self should: [self example = 7]! !

!ExuperyStoryTests methodsFor: 'Test - Stack' stamp: 'wbk 10/21/2004 20:26'!
testTemporariesWithSideEffects
	self compile: '|a| a := 1. ^(a:= a +1) + (a := a + 1)'.
	self should: [self example = 5]! !

!ExuperyStoryTests methodsFor: 'Test - Arithmatic' stamp: 'wbk 4/17/2003 10:50'!
testThreeTimesFour
	self 
		compile: #threeTimesFour
		into: #returnNumber.
	self should: [self returnNumber = 12]! !

!ExuperyStoryTests methodsFor: 'Test - Multiple Methods' stamp: 'wbk 10/29/2005 20:52'!
testTwoMethods
	Exupery 
		compileMethod: #return4
		into: #return5
		forClass: ExuperyStoryTests
		inlining: #().
	Exupery 
		compileMethod: #return6
		into: #return7
		forClass: ExuperyStoryTests
		inlining: #().
	self assert: self return5 = 4.
	self assert: self return7 = 6! !

!ExuperyStoryTests methodsFor: 'Test - Multiple Methods' stamp: 'wbk 10/29/2005 20:52'!
testTwoReturns
	Exupery 
		compileMethod: #sendReturn4
		into: #sendReturn4Hook
		forClass: ExuperyStoryTests
		inlining: #().
	Exupery 
		compileMethod: #sendReturn6
		into: #sendReturn6Hook
		forClass: ExuperyStoryTests
		inlining: #().
	self assert: self sendReturn4Hook = 14.
	self assert: self sendReturn6Hook = 16! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 1/21/2006 21:43'!
testValue
	self 
		compile: #valueMethod:
		into: #valueMethod:.
	self assert: ((self valueMethod: [#theAnswer]) = #theAnswer)! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 1/21/2006 21:43'!
testValueWithArg
	self 
		compile: #valueWithArgMethod:
		into: #valueWithArgMethod:.
	self assert: ((self valueWithArgMethod: [:x| 32 + x]) = 42)! !

!ExuperyStoryTests methodsFor: 'Example Methods' stamp: 'wbk 3/30/2003 21:09'!
threePlusFour
	^ 3 + 4! !

!ExuperyStoryTests methodsFor: 'Example Methods' stamp: 'wbk 4/11/2003 17:40'!
threeTimesFour
	^ 3 * 4! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 3/3/2005 21:54'!
trivialSend
	^ self basicTarget! !

!ExuperyStoryTests methodsFor: 'Test - Sends' stamp: 'wbk 3/12/2005 22:43'!
trivialSend: anObject
	^ anObject basicTarget! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 5/15/2005 19:33'!
valueMethod: aBlock
	^ aBlock value! !

!ExuperyStoryTests methodsFor: 'Test - Common Sends' stamp: 'wbk 5/15/2005 20:51'!
valueWithArgMethod: aBlock
	^ aBlock value: 10! !

TestCase subclass: #ExuperyTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

ExuperyTests subclass: #ByteCodeReaderTests
	instanceVariableNames: 'generator method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 7/31/2003 15:34'!
atPutSend
	^ 1 
		at: 2
		put: 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 7/29/2003 11:41'!
atSend
	^ 1 at: 2! !

!ByteCodeReaderTests methodsFor: 'Tests - Sends' stamp: 'wbk 4/18/2003 22:05'!
basicSend
	^ self basicTarget! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/4/2004 20:16'!
bitAnd
	^ 6 bitAnd: 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/5/2004 20:39'!
bitOr
	^ 6 bitOr: 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 18:55'!
bitShift
	^ 6 bitShift: 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Block' stamp: 'wbk 11/22/2005 18:03'!
blockMethod
 	^ [42]! !

!ByteCodeReaderTests methodsFor: 'Tests - Block' stamp: 'wbk 1/20/2006 21:09'!
blockMethodWith2Args
 	^ [:a :b| 42]! !

!ByteCodeReaderTests methodsFor: 'Tests - Block' stamp: 'wbk 1/18/2006 21:43'!
blockMethodWithArg
 	^ [:each| 42]! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 7/14/2003 07:21'!
bytecodePrimSendWithArg
	^ 4 new: 5! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 10/25/2005 20:23'!
conditionalJumps
	self ifTrue: [10] ifFalse: [20]! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/5/2004 22:03'!
div
	^ 6 // 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 1/18/2004 17:21'!
divide
	^ 6 / 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:33'!
equals
	^ 2 = 3! !

!ByteCodeReaderTests methodsFor: 'Misc' stamp: 'wbk 4/26/2004 23:43'!
execute
	ByteCodeReader 
		newMethod: method
		using: generator
		stack: (TestExuperyStack 
			newPC: method initialPC
			emitter: nil)! !

!ByteCodeReaderTests methodsFor: 'Misc' stamp: 'wbk 1/20/2006 23:13'!
generateWithMock: aMockEmitter 
	"Copied from Exupery>>generateIntermediate"

	| jumpFinder reader |
	jumpFinder := JumpTargetRecorder new.
	ByteCodeReader 
		newMethod: method
		using: jumpFinder
		jumpTargets: #()
		stackHeights: #().
	generator := IntermediateGenerator 
				for: MachineX86 new
				jumpTargets: jumpFinder targets
				inlining: #()
				receiver: nil.
	generator emitter: aMockEmitter.
	reader := ByteCodeReader 
				newMethod: method
				using: generator
				jumpTargets: jumpFinder targets
				stackHeights: jumpFinder stackTrace.
	method := generator result.
	^reader! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/10/2004 15:56'!
greaterThan
	^ 2 > 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:16'!
greaterThanEqual
	^ 2 >= 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 3/13/2003 13:48'!
ifTrueIfFalse
	1 <= 2
		ifTrue: [^1]
		ifFalse: [^2].! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/9/2004 20:51'!
iterativeFactorial: n
	|acc|
	acc := 1.
	1
		to: n
		do: [:each| acc := acc * each].
	^ acc! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 11/26/2005 21:19'!
jumpTracking
 	^ 10 ifTrue: [30] ifFalse: [40]! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/6/2004 22:39'!
lessThan
	^ 2 < 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 3/13/2003 13:48'!
lessThanEquals
	^ 1 <= 2! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 2/13/2004 23:45'!
longJumpIfTrue
	true ifFalse:
		[^ 1+2.].
	^ 42! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/13/2004 19:07'!
makePoint
	^ 6 @ 3! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/4/2003 12:27'!
methodWithTemporaries
	| a b | 
	^ a + b! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/7/2004 20:31'!
mod
	^ 6 \\ 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/29/2004 23:54'!
nestedIfTrueIfFalse
	^ 1 <= 2
		ifTrue: [10]
		ifFalse: [20].! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/17/2004 18:57'!
notEquals
	^ 2 ~= 3! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/31/2003 16:37'!
popStack
	1 add.! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/19/2003 21:11'!
pushConstantTrue
	| a |
	a:=  true.
	^ a! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/11/2003 11:57'!
pushConstantZero
	" The shuffle through a temporary is so we actually use the push constant zero bytecode
	rather than the fast return 0 primitive"
	|a|
	a := 0.
	^ a! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 10/4/2003 19:29'!
pushFalse
	| a |
	a := false.
	^ a! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/11/2003 22:26'!
pushLiteralVariable
	^ Array! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 10/4/2003 19:15'!
pushMinusOne
	| a |
	a:= -1.
	^ a! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 10/4/2003 19:29'!
pushNil
	| a |
	a := nil.
	^ a! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 3/13/2003 13:49'!
pushTemp
	|a|
	a := 1! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 3/13/2003 13:49'!
pushTemporary
	|a|
	^ a! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 6/11/2004 21:50'!
recursivefTrueIfFalse
	^ false 
		ifTrue: [5] 
		ifFalse: [false 
			ifTrue: [10]
			ifFalse: [15]]! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 3/13/2003 13:49'!
return4
	^ 4! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/9/2004 20:52'!
returnAddSmallInt
	^ 1 + 2! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 11/27/2003 21:16'!
returnFalse
	'Avoid a quick return primitive'.
	^ false! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 10/18/2003 12:51'!
returnNil
	'Avoid a quick return primitive'.
	^ nil! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 4/18/2003 22:45'!
returnString
	^ 'Test String'! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 11/27/2003 19:36'!
returnTrue
	'Avoid a quick return primitive'.
	^ true! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 19:32'!
sendAtEnd
	^ #abcd atEnd! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 3/1/2004 19:05'!
sendClass
	^ 10 class! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 1/16/2006 19:33'!
sendDo
	^ 10 do: 20! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/27/2004 21:22'!
sendEquivilent
	^ #abcd == #efgh! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/14/2004 15:10'!
sendNew
	^ Array new! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 15:05'!
sendNext
	^ #abcd next! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 16:34'!
sendNextPut
	^ #abcd nextPut: #efgh! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 13:14'!
sendSize
	^ #abcd size! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 5/15/2005 19:42'!
sendValue
	^ Array value! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 5/15/2005 21:02'!
sendValueWithArg
	^ 6 value: 3! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/28/2004 17:39'!
sendX
	^ #abcd x! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/28/2004 17:43'!
sendY
	^ #abcd y! !

!ByteCodeReaderTests methodsFor: 'Misc' stamp: 'wbk 7/4/2003 12:05'!
setUp
	generator := MockIntermediateGenerator new.! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 2/28/2004 15:24'!
shortUnconditionalJump
	^ #bool ifFalse: [^ #success].! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/9/2004 20:45'!
simpleMinus
	^ 2 - 1! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/9/2004 20:48'!
simpleMultiply
	^ 2 * 3! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 10/3/2003 23:01'!
storeAndPopReceiverVariable
	"This method is just a test. It should never be called."
	generator := 10! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/24/2004 23:36'!
storeTemp
 	|a|
	a := 1.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/24/2004 22:39'!
storeTempExtended
 	|a|
	^ (a := 1) + 5! !

!ByteCodeReaderTests methodsFor: 'Sample Methods' stamp: 'wbk 7/2/2003 11:25'!
stringConcatenate
	^ 'abc', 'def'! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/21/2005 20:48'!
testAtEnd
	method := ByteCodeReaderTests compiledMethodAt: #sendAtEnd.
	generator setExpectedBytecodes: #((createContext) #(#returnTop #(#sendUnarySelector 21 #(#pushConstant #abcd)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/21/2005 20:48'!
testAtPutSend
	method := ByteCodeReaderTests compiledMethodAt: #atPutSend.
	generator checkStackSizeOnSend: 0.
	generator 
		setExpectedBytecodes: #((createContext) #(#returnTop #(#sendAtPut (pushConstant 1) #(pushConstant 2) (pushConstant 3)))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/21/2005 20:48'!
testAtSend
	method := ByteCodeReaderTests compiledMethodAt: #atSend.
	generator checkStackSizeOnSend: 0.
	generator 
		setExpectedBytecodes: #((createContext) #(#returnTop #(#sendAt (pushConstant 1) #(pushConstant 2) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Block' stamp: 'wbk 1/30/2006 22:11'!
testBasicBlocks
	| compiler |
	method := self class compiledMethodAt: #blockMethod.
	compiler := Exupery new 
				initializeMethod: method
				inlining: #()
				receiver: nil.
	generator := compiler generateIntermediate intermediateGenerator.

	self assert: generator result intermediateForm =
		#((block 1 
			(createContext) 
			(stackPush (blockCopy 1 14 (activeContext) block3) s1)
			(jmp block2) 
			(jmp block3)) 
		  (block 2 
			(return s1)) 
		  (block 3 
			(createBlockContext 0)
			(blockReturn 85) 
			(jmp block2) )).
	self assert: (generator result blockAt: 3) isAligned.
	self assert: (generator result blockAt: 3) initialStackHeight = 0! !

!ByteCodeReaderTests methodsFor: 'Tests - Block' stamp: 'wbk 1/30/2006 22:12'!
testBasicBlocksWith2Args
	| compiler |
	method := self class compiledMethodAt: #blockMethodWith2Args.
	compiler := Exupery new 
				initializeMethod: method
				inlining: #()
				receiver: nil.
	generator := compiler generateIntermediate intermediateGenerator.

	self assert: generator result intermediateForm =
		#((block 1 
			(createContext) 
			(stackPush (blockCopy 5 14 (activeContext) block3) s1)
			(jmp block2) 
			(jmp block3)) 
		  (block 2 
			(return s1)) 
		  (block 3 
			(createBlockContext 2)
			(storeInTemp 1 s2)
			(storeInTemp 0 s1)
			(blockReturn 85) 
			(jmp block2) )).
	self assert: (generator result blockAt: 3) isAligned.
	self assert: (generator result blockAt: 3) initialStackHeight = 2! !

!ByteCodeReaderTests methodsFor: 'Tests - Block' stamp: 'wbk 1/30/2006 22:12'!
testBasicBlocksWithArg
	| compiler |
	method := self class compiledMethodAt: #blockMethodWithArg.
	compiler := Exupery new 
				initializeMethod: method
				inlining: #()
				receiver: nil.
	generator := compiler generateIntermediate intermediateGenerator.

	self assert: generator result intermediateForm =
		#((block 1 
			(createContext) 
			(stackPush (blockCopy 3 14 (activeContext) block3) s1)
			(jmp block2) 
			(jmp block3)) 
		  (block 2 
			(return s1)) 
		  (block 3 
			(createBlockContext 1)
			(storeInTemp 0 s1)
			(blockReturn 85) 
			(jmp block2) )).
	self assert: (generator result blockAt: 3) isAligned.
	self assert: (generator result blockAt: 3) initialStackHeight = 1! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 5/15/2005 21:00'!
testBitAnd
	method := ByteCodeReaderTests compiledMethodAt: #bitAnd.
	generator 
		setExpectedBytecodes: 
			#( (createContext) (returnTop (bitAnd (pushConstant 6) (pushConstant 3)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 5/15/2005 20:59'!
testBitOr
	method := ByteCodeReaderTests compiledMethodAt: #bitOr.
	generator 
		setExpectedBytecodes: 
			#( (createContext) (returnTop (bitOr (pushConstant 6) (pushConstant 3)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 4/21/2005 20:47'!
testBitShift
	method := ByteCodeReaderTests compiledMethodAt: #bitShift.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (bitShift (pushConstant 6) (pushConstant 3)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/21/2005 20:48'!
testBytecodePrimSendWithArg
	method := ByteCodeReaderTests compiledMethodAt: #bytecodePrimSendWithArg.
	generator checkStackSizeOnSend: 0.
	generator setExpectedBytecodes: 
		#((createContext) 
		#(#returnTop 
			#(#binarySendWithSpecialSelector 29 
			#(#pushConstant 4) 
			#(#pushConstant 5)))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/21/2005 20:48'!
testClass
	method := ByteCodeReaderTests compiledMethodAt: #sendClass.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (class (pushConstant 10 )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 4/21/2005 20:47'!
testDiv
	method := ByteCodeReaderTests compiledMethodAt: #div.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (div (pushConstant 6) (pushConstant 3)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 4/21/2005 20:47'!
testDivide
	method := ByteCodeReaderTests compiledMethodAt: #divide.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (divide (pushConstant 6) (pushConstant 3)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 1/16/2006 19:55'!
testDo
	method := ByteCodeReaderTests compiledMethodAt: #sendDo.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (binarySendWithSpecialSelector 27 (pushConstant 10 ) (pushConstant 20) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/21/2005 20:49'!
testEquals
	method := ByteCodeReaderTests compiledMethodAt: #equals.
	generator 
		setExpectedBytecodes: 
			#((createContext) #(#returnTop #(#equals 
				(pushConstant 2) 
				(pushConstant 3) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/21/2005 20:48'!
testEquivilent
	method := ByteCodeReaderTests compiledMethodAt: #sendEquivilent.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (equivilent (pushConstant abcd ) (pushConstant efgh) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 11/6/2005 18:45'!
testExtendedStoreStackTracing
	| compiler reader |
	compiler := Exupery new 
				initializeMethod: (ExuperyInstanceVariables compiledMethodAt: #storeInstanceExtended2)
				inlining: #()
				receiver: nil.
	reader := compiler generateIntermediate.
	self assert: reader stackHeights asArray = #(0 1 ).
	self assert: compiler generator jumpTargets asArray = #(15 16 )! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/21/2005 20:49'!
testGreaterThan
	method := ByteCodeReaderTests compiledMethodAt: #greaterThan.
	generator 
		setExpectedBytecodes: 
			#((createContext) #(#returnTop #(#greaterThan 
				(pushConstant 2) 
				(pushConstant 3) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/21/2005 20:49'!
testGreaterThanEqual
	method := ByteCodeReaderTests compiledMethodAt: #greaterThanEqual.
	generator 
		setExpectedBytecodes: 
			#((createContext) #(#returnTop #(#greaterThanEqual 
				(pushConstant 2) 
				(pushConstant 3) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 4/21/2005 20:50'!
testIfTrueIfFalse
	method := ByteCodeReaderTests compiledMethodAt: #ifTrueIfFalse.
	generator := MockIntermediateGenerator new.
	generator setExpectedBytecodes: #(
		(createContext) 
		(jumpFalse (sendLessThanEquals (pushConstant 1) (pushConstant 2)) 11) 
		(returnTop (pushConstant 1)) 
		(returnTop (pushConstant 2))).
	self execute.
	self should: [generator byteCodeString = 'pushConstant 1 pushConstant 2 sendLessThanEquals jumpFalse 11 pushConstant 1 returnTop pushConstant 2 returnTop']! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 11/26/2005 23:27'!
testJumpTracking
	| emitter |
	method := self class compiledMethodAt: #jumpTracking.
	
	emitter := MockIntermediateEmitter new.
	emitter expectEmission:
		#((block1 
				(materialiseStack)
				(emitJumpIfFalse (emitLabelForByteCode 21) 21)
				(materialiseStack)
				(jmp (emitLabelForByteCode 22))
				(materialiseStack) 
				(emitJumpTarget 21)
				(materialiseStack)
				(emitJumpTarget 22)
				(emitReturnValue 81) )).
	self generateWithMock: emitter.

	emitter verify! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/21/2005 20:49'!
testLessThan
	method := ByteCodeReaderTests compiledMethodAt: #lessThan.
	generator 
		setExpectedBytecodes:
			#((createContext) (returnTop (lessThan 
				(pushConstant 2) 
				(pushConstant 3) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/21/2005 20:49'!
testLessThanEquals
	method := ByteCodeReaderTests compiledMethodAt: #lessThanEquals.
	generator setExpectedBytecodes: 
		#((createContext) (returnTop
			(sendLessThanEquals
				(pushConstant 1)
				(pushConstant 2)))).
	self execute.
	self should: 
		[generator byteCodeString = 'pushConstant 1 pushConstant 2 sendLessThanEquals returnTop']
	! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:52'!
testLoadLargeReceiver
	method := ExuperyInstanceVariables compiledMethodAt: #i17.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (sendAdd (pushInstanceVariable 16) (pushConstant 0)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:52'!
testLoadLargeTemporary
	method := ExuperyInstanceVariables compiledMethodAt: #loadExtendedTemp.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (pushTemp 16))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 4/21/2005 20:50'!
testLongJumpIfTrue
	method := ByteCodeReaderTests compiledMethodAt: #longJumpIfTrue.
	generator 
		setExpectedBytecodes: 
			#((createContext) 
			(jumpIfTrue (pushTrue) 16)
			   (returnTop (sendAdd (pushConstant 1) (pushConstant 2)))
				(returnTop (pushConstant 42))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/21/2005 20:48'!
testMakePoint
	method := ByteCodeReaderTests compiledMethodAt: #makePoint.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (makePoint (pushConstant 6) (pushConstant 3)))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 4/21/2005 20:47'!
testMod
	method := ByteCodeReaderTests compiledMethodAt: #mod.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (mod (pushConstant 6) (pushConstant 3)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/21/2005 20:48'!
testNew
	method := ByteCodeReaderTests compiledMethodAt: #sendNew.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (sendUnarySelector 28 (pushLiteralVariable 0 )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/21/2005 20:48'!
testNext
	method := ByteCodeReaderTests compiledMethodAt: #sendNext.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (sendUnarySelector 19 (pushConstant abcd )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/21/2005 20:49'!
testNextPut
	method := ByteCodeReaderTests compiledMethodAt: #sendNextPut.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (binarySendWithSpecialSelector 20 (pushConstant abcd ) (pushConstant efgh) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Comparision' stamp: 'wbk 4/21/2005 20:50'!
testNotEquals
	method := ByteCodeReaderTests compiledMethodAt: #notEquals.
	generator 
		setExpectedBytecodes: 
			#((createContext) 
				#(#returnTop #(#notEquals 
					(pushConstant 2) 
					(pushConstant 3) ))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/21/2005 20:49'!
testPointX
	method := ByteCodeReaderTests compiledMethodAt: #sendX.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (sendUnarySelector 30 (pushConstant abcd )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/21/2005 20:49'!
testPointY
	method := ByteCodeReaderTests compiledMethodAt: #sendY.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (sendUnarySelector 31 (pushConstant abcd )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:52'!
testPopStack
	method := ByteCodeReaderTests compiledMethodAt: #popStack.
	generator 
		setExpectedBytecodes: #((createContext)  (popStack (send add (pushConstant 1))) #(#returnSelf)).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:52'!
testPushConstantMinusOne
	method := ByteCodeReaderTests compiledMethodAt: #pushMinusOne.
	generator 
		setExpectedBytecodes: #((createContext)  (popIntoTemp 0 (pushConstant -1)) #(#returnTop (pushTemp 0)) ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:52'!
testPushConstantTrue
	method := ByteCodeReaderTests compiledMethodAt: #pushConstantTrue.
	generator 
		setExpectedBytecodes: #((createContext) (popIntoTemp 0 (pushTrue)) #(#returnTop (pushTemp 0)) ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:52'!
testPushConstantZero
	method := ByteCodeReaderTests compiledMethodAt: #pushConstantZero.
	generator 
		setExpectedBytecodes: #((createContext)  (popIntoTemp 0 (pushConstant 0)) #(#returnTop (pushTemp 0))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:52'!
testPushFalse
	method := ByteCodeReaderTests compiledMethodAt: #pushFalse.
	generator 
		setExpectedBytecodes: #((createContext) (popIntoTemp 0 (pushFalse)) #(#returnTop (pushTemp 0)) ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:52'!
testPushLiteralVariable
	method := ByteCodeReaderTests compiledMethodAt: #pushLiteralVariable.
	generator 
		setExpectedBytecodes: #((createContext)  (returnTop (pushLiteralVariable 0)) ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:52'!
testPushNil
	method := ByteCodeReaderTests compiledMethodAt: #pushNil.
	generator 
		setExpectedBytecodes: #((createContext) (popIntoTemp 0 (pushNil)) #(#returnTop (pushTemp 0)) ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:53'!
testPushReceiverVariables
	method := ExuperyInstanceVariables compiledMethodAt: #a.
	generator 
		setExpectedBytecodes: 
			#((createContext) 
				(returnTop (sendAdd
					(pushInstanceVariable 0) (pushConstant 0) ))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:53'!
testPushTemp
	method := ByteCodeReaderTests compiledMethodAt: #pushTemp.
	generator := MockIntermediateGenerator new.
	generator setExpectedBytecodes: #(
		(createContext) 
		(popIntoTemp 0
			(pushConstant 1))
		(returnSelf)).
	self execute.
	self should: [generator byteCodeString = 'pushConstant 1 popIntoTemp 0 returnSelf']
	! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/20/2006 23:13'!
testPushTempAddsStoreToIntermediate
	"Checks that the popIntoTemp instruction is actually being added. 
	This is ugly."

	| emitter |
	method := ByteCodeReaderTests compiledMethodAt: #pushTemp.
	generator := IntermediateGenerator 
				for: MachineX86 new
				jumpTargets: #()
				inlining: #()
				receiver: #().
	emitter := MockIntermediateEmitter new.
	emitter expectEmission: #(
				#(
					#block1
					#(#storeInTemp 0 3 )
					#(#emitReturnValue #(#receiverAddress ) )
				)
			).
	generator emitter: emitter.
	ByteCodeReader 
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().
	"self should: [generator result intermediateForm =  
		#(block 1 (popIntoTemp 0
			(pushConstant 1)))]"
	emitter verify! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:53'!
testPushTemporaryVariable
	method := ByteCodeReaderTests compiledMethodAt: #pushTemporary.
	generator := MockIntermediateGenerator new.
	generator setExpectedBytecodes: #(
		(createContext) 
		(returnTop
			(pushTemp 0))).
	self execute.
	self should: [generator byteCodeString = 'pushTemp 0 returnTop']! !

!ByteCodeReaderTests methodsFor: 'Tests - Misc' stamp: 'wbk 4/26/2004 23:45'!
testReadByteCodeNumbers
	method := CompilerToys compiledMethodAt: #simpleMethod2.
	generator := MockIntermediateGenerator new.
	generator recordByteCodeNumbers.
	self execute.
	self should: [generator byteCodeString = 'byteCode 5 pushConstant 1 byteCode 6 pushConstant 2 byteCode 7 sendPlus byteCode 8 returnTop']! !

!ByteCodeReaderTests methodsFor: 'Tests - Misc' stamp: 'wbk 3/13/2005 18:16'!
testReadNumberOfArguments
	method := CompilerToys compiledMethodAt: #simpleMethod.
	self execute.
	self should: [generator numberOfArguments = 0].
	! !

!ByteCodeReaderTests methodsFor: 'Tests - Misc' stamp: 'wbk 3/13/2005 18:17'!
testReadNumberOfArguments2
	method := ByteCodeReaderTests compiledMethodAt: #iterativeFactorial:.
	self execute.
	self should: [generator numberOfArguments = 1].
	! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 11/6/2005 18:45'!
testRegisterJumpTargets
	| compiler |
	compiler := Exupery new 
				initializeMethod: (ByteCodeReaderTests compiledMethodAt: #ifTrueIfFalse)
				inlining: #()
				receiver: nil.
	compiler generateIntermediate.
	self should: [compiler generator jumpTargets asArray = #(11 )]! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 11/6/2005 18:45'!
testRegisterNestedStackTracing
	| compiler reader |
	compiler := Exupery new 
				initializeMethod: (ByteCodeReaderTests compiledMethodAt: #nestedIfTrueIfFalse)
				inlining: #()
				receiver: nil.
	reader := compiler generateIntermediate.
	self should: [reader stackHeights asArray = #(0 1 )]! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 11/6/2005 18:45'!
testRegisterStackTracing
	| compiler reader |
	compiler := Exupery new 
				initializeMethod: (ByteCodeReaderTests compiledMethodAt: #ifTrueIfFalse)
				inlining: #()
				receiver: nil.
	reader := compiler generateIntermediate.
	self should: [reader stackHeights asArray = #(0 )]! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:53'!
testReturnFalse
	method := ByteCodeReaderTests compiledMethodAt: #returnFalse.
	generator 
		setExpectedBytecodes: #((createContext) (returnFalse )).
	self execute.
	self verify.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:53'!
testReturnNil
	method := ByteCodeReaderTests compiledMethodAt: #returnNil.
	generator 
		setExpectedBytecodes: #((createContext) (returnNil )).
	self execute.
	self verify.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:53'!
testReturnTrue
	method := ByteCodeReaderTests compiledMethodAt: #returnTrue.
	generator 
		setExpectedBytecodes: #((createContext) (returnTrue )).
	self execute.
	self verify.! !

!ByteCodeReaderTests methodsFor: 'Tests - Sends' stamp: 'wbk 4/21/2005 20:51'!
testSendBasic
	method := ByteCodeReaderTests compiledMethodAt: #basicSend.
	generator checkStackSizeOnSend: 0.
	generator 
		setExpectedBytecodes: #((createContext) #(#returnTop #(#send #basicTarget #(#pushSelf) ))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Sends' stamp: 'wbk 10/29/2005 20:49'!
testSendExtended
	method := ExuperyStoryTests compiledMethodAt: #extendedSend.
	generator checkStackSizeOnSend: 0.
	generator 
		setExpectedBytecodes: #(#(createContext) 
			(#popStack #(#send #method1 #(#pushSelf)))
			(#popStack #(#send #method2 #(#pushSelf)))
			(#popStack #(#send #method3 #(#pushSelf)))
			(#popStack #(#send #method4 #(#pushSelf)))
			(#popStack #(#send #method5 #(#pushSelf)))
			(#popStack #(#send #method6 #(#pushSelf)))
			(#popStack #(#send #method7 #(#pushSelf)))
			(#popStack #(#send #method8 #(#pushSelf)))
			(#popStack #(#send #method9 #(#pushSelf)))
			(#popStack #(#send #method10 #(#pushSelf)))
			(#popStack #(#send #method11 #(#pushSelf)))
			(#popStack #(#send #method12 #(#pushSelf)))
			(#popStack #(#send #method13 #(#pushSelf)))
			(#popStack #(#send #method14 #(#pushSelf)))
			(#popStack (#send #method15 #(#pushSelf)))
			(#popStack #(#send #method16 #(#pushSelf)))
			(#returnTop #(#send #method17 #(#pushSelf) ))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Sends' stamp: 'wbk 4/21/2005 20:51'!
testSendStringConcatenate
	method := ByteCodeReaderTests compiledMethodAt: #stringConcatenate.
	generator 
		setExpectedBytecodes: #((createContext) #(#returnTop #(#send #, (pushConstant #abc) (pushConstant #def) ))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Misc' stamp: 'wbk 4/26/2004 23:46'!
testSetNumberOfTemporaries
	method := ByteCodeReaderTests compiledMethodAt: #methodWithTemporaries.
	generator setExpectedTemporaries: 2.
	self execute.
	self verify! !

!ByteCodeReaderTests methodsFor: 'Tests - Jumps' stamp: 'wbk 4/26/2004 23:50'!
testShortUnconditionalJump
	method := ByteCodeReaderTests compiledMethodAt: #shortUnconditionalJump.
	"The following is commented out because this method does not follow stack discipline strictly
	enough for the mock based tester"
	"generator 
		setExpectedBytecodes: 
			#((jumpFalse (pushConstant bool) 17)
			  (pushNil)
				(jumpTo 19)
			   (returnTop (pushConstant #success))
				(returnTop (pushNil) ))."
	self execute.
	self assert: generator byteCodeString = 'pushConstant bool jumpFalse 17 pushNil jumpTo 19 pushConstant success returnTop returnTop'
! !

!ByteCodeReaderTests methodsFor: 'Tests - Misc' stamp: 'wbk 4/26/2004 23:56'!
testSimpleMethod
	method := CompilerToys compiledMethodAt: #simpleMethod.
	generator := MockIntermediateGenerator new.
	self execute.
	self should: [generator numberOfBytecodes = 0].
	self should: [generator primitiveNumber = 262].
	! !

!ByteCodeReaderTests methodsFor: 'Tests - Misc' stamp: 'wbk 4/21/2005 20:51'!
testSimpleMethod2
	method := CompilerToys compiledMethodAt: #simpleMethod2.
	generator := MockIntermediateGenerator new.
	generator setExpectedBytecodes: #(
		(createContext) 
		(returnTop
			(sendAdd
				(pushConstant 1)
				(pushConstant 2)))).
	self execute.
	self should: [generator numberOfBytecodes = 4].
	self should: [generator primitiveNumber = 0].
	self should: [generator byteCodeString = 'pushConstant 1 pushConstant 2 sendPlus returnTop']! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 4/21/2005 20:47'!
testSimpleMinus
	method := ByteCodeReaderTests compiledMethodAt: #simpleMinus.
	generator := MockIntermediateGenerator new.
	generator 
		setExpectedBytecodes: #(#(createContext) (#returnTop #(#sendMinus #(#pushConstant 2) #(#pushConstant 1)))).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 4/21/2005 20:47'!
testSimpleMultiply
	method := ByteCodeReaderTests compiledMethodAt: #simpleMultiply.
	generator := MockIntermediateGenerator new.
	generator 
		setExpectedBytecodes: #(#(createContext) (#returnTop #(#sendMultiply #(#pushConstant 2) #(#pushConstant 3)))).
	self execute.
	"self should: [generator stackString = '(returnTop (sendMultiply (literal 2) (literal 3)))' ]."! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/21/2005 20:49'!
testSize
	method := ByteCodeReaderTests compiledMethodAt: #sendSize.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (sendUnarySelector 18 (pushConstant abcd )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 10/25/2005 17:21'!
testStackHeightIntial
	|machine|
	method := CompilerToys compiledMethodAt: #simpleMethod2.
	machine := MachineX86 new.
	generator := IntermediateGenerator for: machine.
	generator emitter: (IntermediateEmitter 
		machine: machine
		jumpTargets: #()
		inlining: #()).
	self execute.
	self assert: (generator result blockAt: 1) initialStackHeight = 0! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 11/6/2005 18:45'!
testStackHeightWithAnPrimitive
	| compiler |
	method := Object compiledMethodAt: #at:put:.
	compiler := Exupery new 
				initializeMethod: method
				inlining: #()
				receiver: nil.
	compiler generateIntermediate.
	method := compiler getMethod.
	" The 10th block is the start of the real method. Flakey I know."
	self assert: (method blockAt: 10) initialStackHeight = 0! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 11/6/2005 18:47'!
testStackHeightWithJumps
	| compiler |
	method := ByteCodeReaderTests compiledMethodAt: #conditionalJumps.
	compiler := Exupery 
				compileMethod: method
				inlining: #()
				receiver: nil.
	method := compiler getMethod.
	self assert: (method blockAt: 1) initialStackHeight = 0.
	self assert: (method blockAt: 2) initialStackHeight = 0.
	self assert: (method blockAt: 3) initialStackHeight = 1! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 4/21/2005 20:55'!
testStackTracking
	method := CompilerToys compiledMethodAt: #simpleMethod2.
	generator := MockIntermediateGenerator new.
	generator setExpectedBytecodes: #(
		(createContext) 
		(returnTop
			(sendAdd
				(pushConstant 1)
				(pushConstant 2)))).
	self execute.
	self should: [generator primitiveNumber = 0].
	self should: [generator byteCodeString = 'pushConstant 1 pushConstant 2 sendPlus returnTop']! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 1/20/2006 23:13'!
testStackUpdating
	| reader |
	reader := ByteCodeReader 
				newMethod: (ByteCodeReaderTests compiledMethodAt: #return4)
				using: generator
				jumpTargets: #(5 )
				stackHeights: #(10 ).
	reader byteCodeAddressing: 5.
	self assert: reader stackHeight = 10! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack Tracing' stamp: 'wbk 1/20/2006 23:13'!
testStackUpdating2
	| reader |
	reader := ByteCodeReader 
				newMethod: (ByteCodeReaderTests compiledMethodAt: #return4)
				using: generator
				jumpTargets: #(2 4 6 )
				stackHeights: #(20 40 30 ).
	reader byteCodeAddressing: 2.
	self assert: reader stackHeight = 20.
	reader byteCodeAddressing: 3.
	self assert: reader stackHeight = 20.
	reader byteCodeAddressing: 4.
	self assert: reader stackHeight = 40.
	reader byteCodeAddressing: 6.
	self assert: reader stackHeight = 30! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/20/2006 23:13'!
testStoreAndPopExtendedReceiverAddsStoreToIntermediate
	"Checks that the popIntoTemp instruction is actually being added. 
	This is ugly."

	| emitter machine |
	method := ExuperyInstanceVariables compiledMethodAt: #i16:.
	machine := MachineX86 new.
	generator := IntermediateGenerator 
				for: machine
				jumpTargets: #()
				inlining: #()
				receiver: #().
	emitter := MockIntermediateEmitter new.
	emitter initialiseMachine: machine.
	emitter expectEmission: #(
				#(
					#block1
					#(#mov #(#emitTemporaryAddress 0 ) #s1 )
					#(#storeInReceiver 15 #s1 )
					#(#emitReturnValue #(#receiverAddress ) )
				)
			).
	generator emitter: emitter.
	ByteCodeReader 
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().
	"self should: [generator result intermediateForm =  
		#(block 1 (popIntoTemp 0
			(pushConstant 1)))]"
	emitter verify! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/20/2006 23:13'!
testStoreAndPopReceiverAddsStoreToIntermediate
	"Checks that the popIntoTemp instruction is actually being added. 
	This is ugly."

	| emitter |
	method := ByteCodeReaderTests compiledMethodAt: #storeAndPopReceiverVariable.
	generator := IntermediateGenerator 
				for: MachineX86 new
				jumpTargets: #()
				inlining: #()
				receiver: nil.
	emitter := MockIntermediateEmitter new.
	emitter expectEmission: #(
				#(
					#block1
					#(#storeInReceiver 1 21 )
					#(#emitReturnValue #(#receiverAddress ) )
				)
			).
	generator emitter: emitter.
	ByteCodeReader 
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().
	"self should: [generator result intermediateForm =  
		#(block 1 (popIntoTemp 0
			(pushConstant 1)))]"
	emitter verify! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:54'!
testStoreAndPopReceiverVariables
	method := ExuperyInstanceVariables compiledMethodAt: #a:.
	generator 
		setExpectedBytecodes: 
			#(	(createContext) 
				(storeAndPopReceiverVariable 0 (pushTemp 0))
				(returnSelf)  ).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/14/2004 22:35'!
testStoreInstanceExtendedWithoutPopping
	method := ExuperyInstanceVariables compiledMethodAt: #storeInstanceExtended.
	self execute.
	self assert: generator byteCodeString = 'pushTrue jumpFalse 15 pushConstant 10 storeIntoReceiver 15 jumpTo 16 pushNil returnTop'! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:55'!
testStoreLargeReceiver
	method := ExuperyInstanceVariables compiledMethodAt: #i16:.
	generator 
		setExpectedBytecodes: 
			#((createContext) (storeAndPopReceiverVariable 15 (pushTemp 0)) (returnSelf)).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:55'!
testStoreLargeTemporary
	method := ExuperyInstanceVariables compiledMethodAt: #storeExtendedTemp.
	generator 
		setExpectedBytecodes: 
			#((createContext) (popIntoTemp 16 (pushConstant 17)) (returnSelf)).
	self execute.! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:55'!
testStoreTemp
	method := ByteCodeReaderTests compiledMethodAt: #storeTemp.
	generator setExpectedBytecodes: 
		#(	(createContext) 
			(popIntoTemp 0 (pushConstant 1))
			(returnSelf)).
	self execute.
	self verify! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/14/2004 22:43'!
testStoreTempExtendedWithoutPopping
	method := ExuperyInstanceVariables compiledMethodAt: #storeTempExtended2.
	self execute.
	self assert: generator byteCodeString = 'pushTrue jumpFalse 15 pushConstant 15 popIntoTemp 15 jumpTo 16 pushNil returnTop'! !

!ByteCodeReaderTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/21/2005 20:55'!
testStoreTempExtendedWithoutPopping2
	method := ByteCodeReaderTests compiledMethodAt: #storeTempExtended.
	generator setExpectedBytecodes: 
		#((createContext) (returnTop (sendAdd (popIntoTemp 0 (pushConstant 1)) (pushConstant 5)))).
	self execute.
	self verify! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 5/15/2005 19:41'!
testValue
	method := ByteCodeReaderTests compiledMethodAt: #sendValue.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (sendUnarySelector 25 (pushLiteralVariable 0 )))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 5/15/2005 21:07'!
testValueWithArg
	method := ByteCodeReaderTests compiledMethodAt: #sendValueWithArg.
	generator 
		setExpectedBytecodes: 
			#((createContext) (returnTop (binarySendWithSpecialSelector 26 (pushConstant 6) (pushConstant 3)))).
	self execute! !

!ByteCodeReaderTests methodsFor: 'Misc' stamp: 'wbk 7/4/2003 12:14'!
verify
	generator verify! !

ExuperyTests subclass: #ColouringRegisterAllocatorTests
	instanceVariableNames: 'machine allocator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 8/17/2005 22:45'!
createAllocator: med 
	| source |
	machine := MachineX86 new.
	source := MedMethod 
		createAssembly: med 
		for: machine.
	^ allocator := ColouringRegisterAllocator new 
		initialiseSource: source 
		machine: machine
		isValidating: false! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 8/2/2004 21:14'!
createAndPrepareAllocator: anArray
	allocator := self createAllocator: anArray.
	allocator setUp.
	^ allocator! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 6/2/2004 22:50'!
createAssignments: anArray
	| assignments |
	assignments := Dictionary new.
	anArray do: 
		[:each| assignments
			at: (machine registerNamed: each first)
			put: (machine registerNamed: each last)].
	^ assignments

! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 8/2/2004 20:59'!
nodeNamed: aSymbol 
	^ allocator interferenceGraph at: (machine registerNamed: aSymbol)! !

!ColouringRegisterAllocatorTests methodsFor: 'Test - Allocate' stamp: 'wbk 11/9/2002 15:47'!
testAllocateBasicCoalesce
	self createAllocator: #(#(#block 1 #(#mov #t1 #t2) #(#add #t1 #t2))).
	allocator run.
	self should: [allocator intermediateForm = #(#(#block 1 #(#add #eax #eax)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Test - Allocate' stamp: 'wbk 3/4/2005 15:14'!
testAllocateReturn42
	self createAllocator: 
		#(#(#block 1 
			#(#mov 8 #t3) 
			#(#add #ebp #t3) 
			#(#mov #(#t3) #t4) 
			#(#mov #(#t4) #t5) 
			#(#mov #t5 #t1) 
			#(#mov 8 #t6) 
			#(#add #t1 #t6) 
			#(#mov #(#t6) #t7) 
			#(#mov 1 #t8) 
			#(#add #t7 #t8) 
			#(#mov #t8 #t2) 
			#(#mov 8 #t9) 
			#(#add #t1 #t9) 
			#(#mov #t2 #(#t9)) 
			#(#mov 4 #t10) 
			#(#mul #t2 #t10) 
			#(#mov #t10 #t11) 
			#(#add #t1 #t11) 
			#(#mov 24 #t12) 
			#(#add #t11 #t12) 
			#(#mov 85 #(#t12)) 
			#(#ret))).
	allocator run.
	self should: [allocator hasNoTemporaries].
	self should: [(allocator result blockNumbered: 1) numberOfExpressions = 19].
	self verifyAllocator! !

!ColouringRegisterAllocatorTests methodsFor: 'Test - Allocate' stamp: 'wbk 11/9/2002 15:48'!
testAllocateWithSpills
	allocator := self createAllocator: #(#	(#block 1 #(#add #t1 #t2) #(#add #t3 #t4) #(#add #t5 #t6) #(#add #t6 #t7) 
					(#add #t3 #t5) #(#add #t5 #t1) #(#jmp #block1)) 
				(#block 2 #(#add #t8 #t5))).

	allocator run.

	self should: [allocator hasNoTemporaries].
	self should: [self usesAllAvailibleRegisters: allocator].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 2/1/2006 23:00'!
testAssignAddress
	self createAllocator: #((block 1 (mov (addressOf byteCodeAddress block1) t1) )).

	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov (addressOf byteCodeAddress block1) eax)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:44'!
testAssignAddressingMode
	self createAllocator: #((block 1 (mov (ebp) t1) (mov 2 t2) (add t1 t2))).

 	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov (ebp) eax) (mov 2 ebx) (add eax ebx)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 2/2/2004 21:16'!
testAssignCdq
	self createAllocator: #((block 1 (cdq) )).
	self createAssignments: #((t1 ebx) (t2 ebx)).

 	allocator assignRegisters.

	self should: 
			[allocator intermediateForm 
				= #((block 1 (cdq) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:45'!
testAssignCoalescedMove
	self createAllocator: #((block 1 (mov t1 t2) (add t1 t2))).
	
	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 eax))).

	self should: 
			[allocator intermediateForm 
				= #(#(#block 1  #(#add #eax #eax)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 3/28/2005 22:33'!
testAssignComparision
	self createAllocator: #((block 1 (mov 1 t1) (mov 2 t2) (cmp t1 t2))).

	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov 1 eax) (mov 2 ebx) (cmp eax ebx)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 1/16/2005 19:54'!
testAssignCopyAlignedFlag
	
	self createAllocator: #((block 1) (block 2)).

	(allocator source blockAt: 2) makeAligned.

 	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 ) (block 2))].
	self assert: (allocator  result blockAt: 1) isAligned not.
	self assert: (allocator result blockAt: 2) isAligned.
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:44'!
testAssignDivide
	self createAllocator: #((block 1 (div t1) )).

 	allocator assignRegisters: (self createAssignments: #((t1 ebx) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (div ebx) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:46'!
testAssignJump
	self createAllocator: #((block 1 (mov 1 t1) (jz block2) (jo block2) (jmp block2)) 
							(block 2)).

	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov 1 eax) (jz block2) (jo block2) (jmp block2)) 
					(block 2))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 2/4/2005 23:42'!
testAssignJumpCalculated
	self createAllocator: #((block 1 (jmp t1) ) 
							(block 2)).

	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1  (jmp eax) ) 
					(block 2))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 7/6/2003 21:31'!
testAssignKeepsBlocksInOrder
	self createAllocator: #((block 4 (jz block2) ) (block 1 ) (block 2 (jmp block3) ) (block 3)).
	self createAssignments: #((t1 eax) (t2 ebx)).
	allocator assignRegisters.

	self should: 
			[allocator intermediateForm 
				= #((block 4 (jz block2) ) (block 1 ) (block 2 (jmp block3) ) (block 3))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:47'!
testAssignMachineRegister
	self createAllocator: #((block 1 (mov ebp t1) (mov 2 t2) (add t1 t2))).

	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov ebp eax) (mov 2 ebx) (add eax ebx)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:47'!
testAssignNeg
	self createAllocator: #((block 1 (neg t1) )).

 	allocator assignRegisters: (self createAssignments: #((t1 ebx) (t2 ecx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (neg ebx) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 3/4/2005 15:11'!
testAssignRet
	self createAllocator: #(#(#block 1 #(#ret))).
	self createAssignments: #(#(#t1 #eax) #(#t2 #ebx)).
	allocator assignRegisters.
	self should: [allocator intermediateForm = #(#(#block 1 #(#ret)))].
	self verifyAllocator! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:48'!
testAssignSimple
	self createAllocator: #((block 1 (mov 1 t1) (mov 2 t2) (add t1 t2))).

	allocator assignRegisters: (self createAssignments: #((t1 eax) (t2 ebx))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov 1 eax) (mov 2 ebx) (add eax ebx)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:49'!
testAssignSpillCode
	self createAllocator: #((block 1 (mov (-16 ebp) t1) (add 1 t1) 
									(mov t1 (-16 ebp)))).

	allocator assignRegisters: (self createAssignments: #((t1 eax))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (mov (-16 ebp) eax) (add 1 eax) (mov eax (-16 ebp))))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:50'!
testCall
	self createAllocator: #((block 1 (call t1))).

	allocator assignRegisters: (self createAssignments: #((t1 eax))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (call eax) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 8/2/2004 21:04'!
testCoalesceAfterSimplifyInterferes
	self createAndPrepareAllocator: #(#	(#block 1 (mov 1 t2) (add t1 t2) (mov t2 t3) (mov 1 t4)  (add t4 t3) )).
	allocator simplify.
	allocator coalesce.

	self 
		verifyInterferes: #t1
		with: #t3.
	self 
		verifyInterferes: #t3
		with: #t1.
	self should: [(self nodeNamed: #t2) currentSize = 0].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:29'!
testCoalesceBuildMovWorklistIndirectAddressing
	self createAndPrepareAllocator: #(#(#block 1 #(#mov (t1) #t2) (mov t1 (t2)) )).

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 2].
	self should: [allocator spillWorklist isEmpty].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:30'!
testCoalesceBuildMovWorklistInterferes
	" A single add does not produce an interference edge, add %eax, %eax is the same assuming
	t1 and t2 are never used again later."
	self createAndPrepareAllocator: #(#(#block 1 #(#mov t1 #t2) (add t1 t2) (add t1 t2) )). 

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 2].
	self should: [allocator spillWorklist isEmpty].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:30'!
testCoalesceBuildMovWorklistSimple
	self createAndPrepareAllocator: #(#(#block 1 #(#mov t1 #t2) )).

	self should: [allocator moveWorklist size = 1].
	self should: [allocator simplifyWorklist isEmpty].
	self should: [allocator spillWorklist isEmpty].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 8/2/2004 21:04'!
testCoalesceBuildWorklistsMoveCountsSimple
	self createAndPrepareAllocator: #(#(#block 1 #(#mov t1 #t2) )).

	self should: [(self nodeNamed: #t1) currentMoves = 1].
	self should: [(self nodeNamed: #t2) currentMoves = 1].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 8/2/2004 21:05'!
testCoalesceBuildWorklistsMoveCountsTwoMoves
	self createAndPrepareAllocator: #(#(#block 1 #(#mov t1 #t2) (mov t2 t3) )).

	self should: [(self nodeNamed: #t1) currentMoves = 1].
	self should: [(self nodeNamed: #t2) currentMoves = 2].
	self should: [(self nodeNamed: #t3) currentMoves = 1].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 4/24/2004 13:12'!
testCoalesceConstrainsNextMov
	self createAndPrepareAllocator: #((block 1 (mov t1 t2) (mov t2 t3) (mov 1 t1) (mov 2 t3) (add t1 t3))).
	self should: [allocator coalesce].

	self should: [allocator coalescedMoves size = 1].
	self should: [allocator moveWorklist size = 0].
	self should: [allocator simplifyWorklist size = 2].
	self should: [allocator spillWorklist size = 0].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:01'!
testCoalesceDecrementsIndirectCounts
	"When a move is decremented."
	|  movet3t4 movet2t3 movet1t3 |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 t3) 
			(mov 1 t2) "Avoiding pollution with t1"
			(mov t2 t3) 
			(mov t3 t4)   )).

	
	movet3t4 := allocator 
		getMoveFrom: #t3 
		to: #t4.
	movet2t3 := allocator 
		getMoveFrom: #t2 
		to: #t3.
	movet1t3 := allocator 
		getMoveFrom: #t1 
		to: #t3.

	allocator coalesceNode: movet3t4.
	self assert: (self nodeNamed: #t4) currentMoves = 2.
	
	allocator coalesceNode: movet2t3.
	self assert: (self nodeNamed: #t4) currentMoves = 1.
	
	allocator coalesceNode: movet1t3.
	self assert: (self nodeNamed: #t4) currentMoves = 0.
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:02'!
testCoalesceDecrementsIndirectCounts2
	"Trying to catch the case in live where a move count isn't properly	 	incremented/decremented.."
	|  movet2t3 movet1t2 movet21t22 movet22t2 movet23t22 |
	self createAndPrepareAllocator: 
		#(#	(#block 1
			(mov t21 t22)
			(mov 0 t23) "Avoiding interference"
			(mov t23 t22)
			(mov t22 t2)
			 
			(mov 0 t1) "Just to avoid interference"
			(mov t1 t2) 
			(mov t2 t3) 
			"(mov t3 t4)"   )).

	
	movet1t2 := allocator 
		getMoveFrom: #t1
		to: #t2.
	movet2t3 := allocator 
		getMoveFrom: #t2 
		to: #t3.
	movet21t22 := allocator 
		getMoveFrom: #t21 
		to: #t22.
	movet22t2 := allocator 
		getMoveFrom: #t22 
		to: #t2.
	movet23t22 := allocator 
		getMoveFrom: #t23 
		to: #t22.

	allocator coalesceNode: movet22t2.
	self assert: (self nodeNamed: #t3) currentMoves = 1.

	allocator coalesceNode: movet2t3.
	self assert: (self nodeNamed: #t3) currentMoves = 3.
	
	allocator coalesceNode: movet1t2.
	self assert: (self nodeNamed: #t3) currentMoves = 2.

	allocator coalesceNode: movet21t22.
	self assert: (self nodeNamed: #t3) currentMoves = 1.
	
	allocator coalesceNode: movet23t22.
	self assert: (self nodeNamed: #t3) currentMoves = 0.
	self verifyAllocator.
	
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:32'!
testCoalesceFreezeOneHighDegree
	self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2)  (add t3 t4) (add t4 t5) (add t6 t7) (add t7 t8) )).

	self should: [allocator freeze].

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 7].
	self should: [allocator spillWorklist size = 1].
	self should: [(allocator spillWorklist at: 1) register intermediateForm = #t2].
	self should: [allocator coalescedMoves size = 0].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 8/2/2004 22:50'!
testCoalesceFreezeRegistersUsedInOtherMoves
	self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2) (mov t2 t3) )).

	self should: [allocator freeze].

	self should: [(self nodeNamed: #t2) currentMoves = 1].
	self should: [(self nodeNamed: #t3) currentMoves = 0].
	self should: [allocator moveWorklist size = 1].
	self should: [allocator simplifyWorklist size = 1].
	self should: [allocator spillWorklist isEmpty].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:33'!
testCoalesceFreezeSimple
	allocator := self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2) (add t1 t2) )).

	self should: [allocator freeze].

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 2].
	self should: [allocator spillWorklist isEmpty].
	self should: [allocator coalescedMoves size = 0].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:33'!
testCoalesceFreezeTwoHighDegrees
	self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2) (add t2 t1) (add t3 t4) (add t4 t5) (add t6 t7) (add t7 t8) )).

	self shouldnt: [allocator freeze].

	self should: [allocator moveWorklist size = 1].
	self should: [allocator simplifyWorklist size = 4].
	self should: [allocator spillWorklist size = 2].
	self should: [allocator coalescedMoves size = 0].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 7/25/2004 16:05'!
testCoalesceFromPhysicalRegister
	"Tests that when we merge a move with a precoloured node the new merged node is
	also precoloured."
	|  move |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov eax t1)  )).
			
	move := allocator 
		getMoveFrom: #eax
		to: #t1.
		
	allocator coalesceNode: move.
	self verifyAllocator. "Check everything is OK"
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:02'!
testCoalesceInterferingMove
	"This test is an attempt to isolate a bug that's effecting the bitShift"| movet2t3 |
.
	self createAndPrepareAllocator: 
		#(#	(#block 1 (mov 1 t1)  
					(mov t1 t2) (mov t2 t3) (add 2 t3) (mov t1 t4)  (add t4 t4) )).

	movet2t3 := allocator 
		getMoveFrom: #t2 
		to: #t3.
		
	allocator coalesceNode: movet2t3.
	self 
		verifyInterferes: #t1 
		with: #t2.
	self verifyAllocator.
! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:00'!
testCoalesceLoop
	"Tests that we handle coalsecing a move to a register that has already been
	coalesced away."
	|  movet1t2 movet2t1 |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 t2) 
			(mov t2 t1) )).

	
	movet1t2 := allocator 
		getMoveFrom: #t1
		to: #t2.
	movet2t1 := allocator 
		getMoveFrom: #t2
		to: #t1.
		
	allocator coalesceNode: movet1t2.
	self verifyAllocator. "Check everything is OK"
	allocator coalesceNode: movet2t1.
	self verifyAllocator.	"Check that cloaing the loop didn't corrupt us"
	
	self assert: (self nodeNamed: #t1) currentVersion register name = #t2.
	self assert: (self nodeNamed: #t1) currentVersion currentMoves = 0.

	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:03'!
testCoalesceMoveCounts
	"Tests that we handle coalsecing a move to a register that has already been
	coalesced away."
	|  movet3t4 |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 t3) 
			(mov 1 t2) "Avoiding pollution with t1"
			(mov t2 t3) 
			(mov t3 t4)   )).

	
	movet3t4 := allocator 
		getMoveFrom: #t3 
		to: #t4.
		
	allocator coalesceNode: movet3t4.
	
	self assert: (self nodeNamed: #t4) currentMoves = 2.
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 5/22/2004 22:11'!
testCoalesceMultipleMoves
	"Tests that we handle coalsecing a move to a register that has already been
	coalesced away."
	| movet2t3 movet1t2 |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov 1 t1)  "Create an interference edge for t1"
			(add t5 t6)
			(mov t1 t2)
			(mov t2 t3)   )).

	
	movet2t3 := allocator 
		getMoveFrom: #t2 
		to: #t3.
	movet1t2 := allocator
		getMoveFrom: #t1
		to: #t2.
	allocator coalesceNode: movet2t3.
	allocator coalesceNode: movet1t2.	
	self verifyAllocator.
		
	"The check is that it didn't raise an error. If it fails then it will try and add to
	an empty array."
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 7/25/2004 17:09'!
testCoalesceSelfMove
	"Tests that moving a node onto itself is correctly handled. This does not remove a register,
	it just removes the move. It was a no-op move before we started processing."
	|  move |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 t1) 
			(mov t1 t3) )).
	move := allocator 
		getMoveFrom: #t1
		to: #t1.
		
	allocator coalesceNode: move.
	self verifyAllocator. "Check everything is OK"
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:33'!
testCoalesceSimple
	self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2) (add t1 t2) )).

	allocator coalesce.

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 1].
	self should: [allocator spillWorklist isEmpty].
	self should: [allocator coalescedMoves size = 1].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 8/2/2004 21:06'!
testCoalesceSimpleInterferes
	self createAndPrepareAllocator: #(#	(#block 1 (mov 1 t2) (add t1 t2) (mov t2 t3) (mov 1 t4)  (add t4 t3) )).
	allocator coalesce.

	self 
		verifyInterferes: #t1
		with: #t3.
	self 
		verifyInterferes: #t3
		with: #t1.
	self should: [(self nodeNamed: #t2) currentSize = 0].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 11/9/2002 15:34'!
testCoalesceSpillMove
	self createAndPrepareAllocator: #(#	(#block 1 (mov t1 t2) (add t1 t2) )).

	allocator spillMove.

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 2].
	self should: [allocator spillWorklist isEmpty].
	self should: [allocator coalescedMoves size = 0].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 11/9/2002 15:34'!
testCoalesceTooManyHighDegreeNodes
	self createAndPrepareAllocator: #(	(#block 1 (mov t1 t8) (add t1 t2) (add t3 t4) (add t5 t6) (add t1 t7) )).

	allocator coalesce.

	self should: [allocator moveWorklist size = 1].
	self should: [allocator coalescedMoves size = 0].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 7/25/2004 16:06'!
testCoalesceToPhysicalRegister
	"Tests that when we merge a move with a precoloured node the new merged node is
	also precoloured."
	|  move |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 eax)  )).
			
	move := allocator 
		getMoveFrom: #t1
		to: #eax.
		
	allocator coalesceNode: move.
	self verifyAllocator. "Check everything is OK"
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce, origional' stamp: 'wbk 4/24/2004 13:14'!
testCoalesceTwoInstructions
	self createAndPrepareAllocator: #(#	(#block 1 (mov t3 t1) (mov t1 t2) (add t1 t2) )).

	allocator coalesce.
	allocator coalesce.

	self should: [allocator moveWorklist isEmpty].
	self should: [allocator simplifyWorklist size = 1].
	self should: [allocator spillWorklist isEmpty].
	self should: [allocator coalescedMoves size = 2].
	self verifyAllocator.
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Coalesce' stamp: 'wbk 8/2/2004 21:03'!
testFreezeMoveWatchingCounts
	"Tests that we handle coalsecing a move to a register that has already been
	coalesced away."
	|  movet1t2 movet2t3 |
	self createAndPrepareAllocator: 
		#(#	(#block 1 
			(mov t1 t2)
			(mov t2 t3) )).

	
	movet1t2 := allocator 
		getMoveFrom: #t1 
		to: #t2.
	movet2t3 := allocator 
		getMoveFrom: #t2
		to: #t3.
		
	allocator coalesceNode: movet2t3.
	self assert: (self nodeNamed: #t3) currentMoves = 1.
	
	allocator freezeMove: movet1t2.
	self assert: (self nodeNamed: #t3) currentMoves = 0.
	self verifyAllocator.
	
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Test - Allocate' stamp: 'wbk 6/24/2003 12:36'!
testFromSpecialRegister
	self createAllocator: #(#(#block 1 #(mov ebp t1) )).
	allocator run.
	self should: [allocator intermediateForm = #(#(#block 1 #(mov ebp #eax) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Assign Registers' stamp: 'wbk 6/2/2004 21:50'!
testPush
	self createAllocator: #((block 1 (push t1))).

	allocator assignRegisters: (self createAssignments: #((t1 eax))).

	self should: 
			[allocator intermediateForm 
				= #((block 1 (push eax) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Create Statistics' stamp: 'wbk 8/2/2004 20:58'!
testRegisterCountsBasic
	self createAndPrepareAllocator: #((block 1 (mov 1 t1))).
	
	self assert: (self nodeNamed: #t1) registerCount = 1.
	
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Create Statistics' stamp: 'wbk 8/2/2004 21:06'!
testRegisterCountsBasic2
	self createAndPrepareAllocator: #((block 1 (mov t1 t1))).
	
	self assert: (self nodeNamed: #t1) registerCount = 2.
	
	! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 3/4/2005 15:16'!
testSelectDoesntMarkAsSpilled
	self createAllocator: #(#(#block 1 #(#mov 8 #t3) #(#add #ebp #t3) #(#mov #(#t3) #t4) #(#mov #(#t4) #t5) #(#mov #t5 #t1) #(#mov 8 #t6) #(#add #t1 #t6) #(#mov #(#t6) #t7) #(#mov 1 #t8) #(#add #t7 #t8) #(#mov #t8 #t2) #(#mov 8 #t9) #(#add #t1 #t9) #(#mov #t2 #(#t9)) #(#mov 4 #t10) #(#mul #t2 #t10) #(#mov #t10 #t11) #(#add #t1 #t11) #(#mov 24 #t12) #(#add #t11 #t12) #(#mov 85 #(#t12)) #(#ret))).
	allocator analyseLiveness.
	allocator buildInterferenceGraph.
	allocator registerStack: #(#t9 #t4 #t6 #t8 #t7 #t2 #t11 #t12 #t1 #t10 #t3 #t5).
	allocator select.
	self verifyNoSpiltRegisters: allocator.
	self verifyAllocator! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 3/4/2005 15:16'!
testSelectDoNotSpill
	self createAllocator: 
		#(#(#block 1 
			#(#mov 8 #t3) 
			#(#add #ebp #t3) 
			#(#mov #(#t3) #t4) 
			#(#mov #(#t4) #t5) 
			#(#mov #t5 #t1) 
			#(#mov 8 #t6) 
			#(#add #t1 #t6) 
			#(#mov #(#t6) #t7) 
			#(#mov 1 #t8) 
			#(#add #t7 #t8) 
			#(#mov #t8 #t2) 
			#(#mov 8 #t9) 
			#(#add #t1 #t9) 
			#(#mov #t2 #(#t9)) 
			#(#mov 4 #t10) 
			#(#mul #t2 #t10) 
			#(#mov #t10 #t11) 
			#(#add #t1 #t11) 
			#(#mov 24 #t12) 
			#(#add #t11 #t12) 
			#(#mov 85 #(#t12)) 
			#(#ret))).
	allocator analyseLiveness.
	allocator buildInterferenceGraph.
	allocator registerStack: #(#t9 #t12 #t11 #t6 #t3 #t10 #t7 #t4 #t2 #t1 #t5 #t8).
	allocator select.
	self should: [allocator spiltRegisters size = 0].
	self verifyAllocator! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 11/9/2002 15:51'!
testSelectSimple
	| assignments t1 t2 |
	self createAndPrepareAllocator: #(#(#block 1 #(#mov 1 #t1) #(#mov 2 #t2) #(#add #t1 #t2))).

	allocator simplify.
	allocator select.

	assignments := allocator registerAssignments.
	t1 := assignments at: (machine registerNamed: #t1).
	t2 := assignments at: (machine registerNamed: #t2).
	self should: [t1 isMachineRegister].
	self should: [t2 isMachineRegister].
	self should: [t1 ~= t2].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 5/2/2004 18:11'!
testSelectWithPrecolouredRegisters
	| assignments t1 eax t2 |
	self createAndPrepareAllocator: #(#(#block 1 (mov 1 t2) #(#mov 2 #eax) #(#mov 1 #t1)    #(#add #eax #t1 ) (add t2 eax) )).

	allocator simplify.
	allocator registerStack: #(t2 eax t1). "Just to make the test deterministic"
	allocator select.

	assignments := allocator registerAssignments.
	t1 := assignments at: (machine registerNamed: #t1).
	t2 := assignments at: (machine registerNamed: #t2).
	eax := assignments at: (machine registerNamed: #eax).
	self assert: eax name = #eax. "eax must be assigned to eax otherwise after register reallocation
									we will have clashes"
	self assert: t1 ~= eax.
	self assert: t2 ~= eax.
	self assert: t1 ~= t2.
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 11/9/2002 15:51'!
testSelectWithSpilling
	self createAllocator: #((block 1
									(add t1 t2) (add t3 t4) (add t5 t6) (add t6 t7) 
									(add t3 t5) (add t5 t1)  (jmp block1) )
						(block 2 (add t8 t5) )).

	allocator analyseLiveness.
	allocator buildInterferenceGraph.
	allocator registerStack: #(  t1 t2 t3 t4 t5 t6 t7 t8).
	(allocator registerStack at: 1) markAsSpilled.

	allocator select.

	self should: [(allocator spiltRegisters at: 1) name = #t1].
	self verifyAllocator.
! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Select' stamp: 'wbk 8/2/2004 21:18'!
testSelectWithSpills
	self createAndPrepareAllocator: #((block 1
									(add t1 t2) (add t3 t4) (add t5 t6) (add t6 t7) 
									(add t3 t5) (add t5 t1)  (jmp block1) )
						(block 2 (add t8 t5) )).

	allocator simplifyAndSpill.
	allocator select.

	self should: [allocator spiltRegisters size = 1].
	self verifyAllocator.
! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify and Spill' stamp: 'wbk 11/7/2002 13:57'!
testSimpleColouringRegisterAllocation
	| source assignments t1 t2 |
	machine := MachineX86 new.
	source := MedMethod 
		createAssembly: #((block 1 (mov 1 t1) (mov 2 t2) (add t1 t2)))
		for: machine.
	allocator := ColouringRegisterAllocator
		on: source 
		for: machine.

	assignments := allocator registerAssignments.

	t1 := (assignments at: (machine registerNamed: #t1)).
	t2 := (assignments at: (machine registerNamed: #t2)).
	self should: [t1 isMachineRegister].
	self should: [t2 isMachineRegister].
	self should: [t1 ~= t2].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify and Spill' stamp: 'wbk 8/2/2004 21:17'!
testSimplifyAndSpill
	self createAndPrepareAllocator: #((block 1
										(add t1 t2) (add t3 t4) (add t5 t6) (add t6 t7) 
										(add t3 t5) (add t5 t1)  (jmp block1) )
									(block 2 (add t8 t5) )).

	allocator simplifyAndSpill.

	self should: [allocator stackSize = 8].
	self verifyAllocator.
! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify and Spill' stamp: 'wbk 11/9/2002 15:36'!
testSimplifyForSpill
	self createAndPrepareAllocator: #((block 1
									(add t1 t2) (add t3 t4) (add t5 t6) (add t6 t7) 
									(add t3 t5) (add t5 t1)  (jmp block1) )
						(block 2 (add t8 t5) )).

	allocator simplify.

	self should: [allocator unallocated size = 7].
	self should: [allocator stackIncludes: (machine registerNamed: #t8)].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify and Spill' stamp: 'wbk 10/17/2005 19:24'!
testSimplifyPickRegisterToSpill
	self createAndPrepareAllocator:  
		#(	#(#block 1 
				#(#add #t1 #t2) 
				#(#add #t3 #t4) 
				#(#add #t5 #t6) 
				#(#add #t6 #t7) 
				#(#add #t3 #t5) 		
				#(#add #t5 #t1) 
				#(#jmp #block1)) 
			#(#block 2 
				#(#add #t8 #t5))).

	allocator simplify.

	self should: [allocator stackSize = 1].
	allocator spillRegister.
	self should: [allocator stackSize = 2].
	self should: [(allocator registerStack at: 2) isSpilled].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify and Spill' stamp: 'wbk 3/5/2005 22:37'!
testSimplifyPrecolouredNode
	self createAndPrepareAllocator: #(#(#block 1 #(#mov 1 #eax) #(#mov 2 #t2) #(#add #eax #t2))).

	(self nodeNamed: #eax) simplify.

	self assert: (self nodeNamed: #t2) currentEdges size = 1.
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify and Spill' stamp: 'wbk 11/9/2002 15:52'!
testSimplifySimple
	self createAndPrepareAllocator: #(#(#block 1 #(#mov 1 #t1) #(#mov 2 #t2) #(#add #t1 #t2))).

	allocator simplify.

	self should: [allocator stackIncludes: (machine registerNamed: #t1)].
	self should: [allocator stackIncludes: (machine registerNamed: #t2)].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Simplify and Spill' stamp: 'wbk 10/17/2005 21:12'!
testSpillAvoidingMachineRegister
	self createAndPrepareAllocator:  
		#(	#(#block 1 
				#(#add #t1 #t1)
				#(#add #t1 #t1)
				#(#add #t1 #t1)
				#(#add #eax #t1) ) ).

	"Populate the spill work list for the selector."
	allocator interferenceGraph do: [:each| allocator spillWorklist add: each].
	
	allocator spillRegister.
	self should: [allocator stackSize = 1].
	self should: [(allocator registerStack at: 1) register isMachineRegister not].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 12/18/2004 00:05'!
testSpillCurrentContext
	self createAllocator: #(#(#block 1 #(#mov #currentContext 1))).
	allocator spiltRegisters: {machine registerNamed: #currentContext}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1  #(#mov (-16 ebp) currentContextv1) #(#mov currentContextv1 1)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:02'!
testSpilledVariablesNotSpillable
	self createAllocator: #(#(#block 1 #(#mov 1 #t1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self assert: (allocator hasSpill:  (machine registerNamed: #t1v1)).
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:03'!
testSpillKeepsBlocksInOrder
	self createAllocator: #((block 4 (jz block2) ) (block 1 ) (block 2 (jmp block3) ) (block 3)).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#((block 4 (jz block2) ) (block 1 ) (block 2 (jmp block3) ) (block 3))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:03'!
testSpillMultipleRanges
	self createAllocator: #(#(#block 1 #(#mov 1 #t1) #(#mov 2 #t1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#((block 1  (mov 1 t1v1) (mov t1v1 (-16 ebp)) 
							(mov 2 t1v2) (mov t1v2 (-16 ebp))))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:04'!
testSpillMultipleSpilling
	self createAllocator: #(#(#block 1 #(#mov #t1 #t2))).
	allocator spiltRegisters:
		{machine registerNamed: #t1.
		machine registerNamed: #t2}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1 #(#mov #(-16 #ebp) #t1v1)  #(#mov #t1v1 #t2v1)
							  #(#mov #t2v1 #(-20 #ebp))))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 4/6/2005 20:49'!
testSpillOnceForSequentualUses
	self createAllocator: #(#(#block 1 #(#mov #t1 1 ) (mov  t1 2))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
		[allocator source intermediateForm =
			#((block 1  
				(mov  (-16 ebp) t1v1)  
				(mov #t1v1 1 )
				(mov t1v1 2) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 4/20/2005 20:36'!
testSpillOnceForSequentualUsesAcrossBlocks
	self createAllocator: 
		#(#(#block 1 
				#(#mov #t1 1 ) 
				(mov  t1 2))
			(block 2
				(mov t1 3))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
		[allocator source intermediateForm =
			#((block 1  
					(mov  (-16 ebp) t1v1)  
					(mov #t1v1 1 )
					(mov t1v1 2) )
				(block 2
					(mov (-16 ebp) t1v2) 
					(mov t1v2 3)))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:03'!
testSpillReadArithmatic
	self createAllocator: #(#(#block 1 #(#add t1 1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1 #(#mov #(-16 #ebp) #t1v1) #(#add  #t1v1 1) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 3/28/2005 21:58'!
testSpillReadComparision
	self createAllocator: #(#(#block 1 #(#cmp t1 1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1 #(#mov #(-16 #ebp) #t1v1) #(cmp #t1v1 1) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:03'!
testSpillSimple
	self createAllocator: #(#(#block 1 #(#mov 1 #t1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1  #(#mov 1 #t1v1) #(#mov #t1v1 #(-16 #ebp))))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:05'!
testSpillWithJump
	self createAllocator: #(#(#block 1 #(#jmp #block2)) #(#block 2)).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[(allocator source blockAt: 1 instructionAt: 1) target =
				(allocator source blockNumbered: 2)].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:02'!
testSpillWriteArithmatic
	self createAllocator: #(#(#block 1 #(#add 1 t1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1 
						#(#mov #(-16 #ebp) #t1v1) 
						#(#add  1 #t1v1) 
						(mov t1v1 (-16 ebp))))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 3/28/2005 22:36'!
testSpillWriteComparision
	self createAllocator: #(#(#block 1 #(cmp 1 t1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#((block 1 
					(mov (-16 ebp) t1v1) 
					(cmp  1 #t1v1) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:02'!
testSpillWriteIndirectArithmatic
	self createAllocator: #(#(#block 1 #(#add 1 (t1)))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1 
						#(#mov #(-16 #ebp) #t1v1) 
						#(#add  1 (#t1v1)) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:06'!
testSpillWriteIndirectArithmatic2
	self createAllocator: #(#(#block 1 #(#add (t1) 1))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#(#(#block 1 
						#(#mov #(-16 #ebp) #t1v1) 
						#(#add (#t1v1) 1) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:02'!
testSpillWriteIndirectMove
	self createAllocator: #(#(#block 1 #(#mov 1 (t1)))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#((block 1 
						(mov (-16 ebp) t1v1) 
						(mov 1 (t1v1)) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Tests - Spill Insertion' stamp: 'wbk 8/1/2004 15:02'!
testSpillWriteIndirectMove2
	self createAllocator: #(#(#block 1  #(#mov (t1) 1 ))).
	allocator spiltRegisters: {machine registerNamed: #t1}.

	allocator insertSpills.

	self should: 
			[allocator source intermediateForm =
				#((block 1 
						(mov (-16 ebp) t1v1) 
						(mov (t1v1) 1 ) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Test - Allocate' stamp: 'wbk 6/24/2003 13:28'!
testToSpecialRegister
	self createAllocator: #((block 1 (mov t1 ebp) )).
	allocator run.
	self should: [allocator intermediateForm = #((block 1 (mov eax ebp) ))].
	self verifyAllocator.! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 11/3/2002 19:14'!
usesAllAvailibleRegisters: anAllocator
	| used |
	used := Set new.
	anAllocator result registersDo: 
		[:each| (machine isSpecialRegister: each) ifFalse: [used add: each]].
	^ used size = 6	! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 7/25/2004 15:51'!
verifyAllocator
	allocator verify.! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 5/22/2004 21:52'!
verifyAllocatorMoveCounts
	allocator verify.! !

!ColouringRegisterAllocatorTests methodsFor: 'Interference Graph' stamp: 'wbk 3/13/2003 14:40'!
verifyInterferes: firstString with: secondString
	self should:
		[allocator
			interferes: (machine registerNamed: firstString)
			with: (machine registerNamed: secondString)].! !

!ColouringRegisterAllocatorTests methodsFor: 'Support' stamp: 'wbk 4/17/2005 18:04'!
verifyNoSpiltRegisters: anAllocator
	anAllocator registerStack do: [:each| self shouldnt: [each isSpilled]]! !

!ExuperyTests methodsFor: 'Checking Methods' stamp: 'wbk 3/13/2003 13:47'!
stringShould: aString contain: aSubString
	self should: 
		[(aString 
			indexOfSubCollection: aSubString
			startingAt: 1) ~= 0]! !

ExuperyTests subclass: #InstructionSelectionTests
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!InstructionSelectionTests methodsFor: 'Support' stamp: 'wbk 3/13/2003 14:15'!
selectInstructions: anArray
	| med machine| 
	machine := MachineX86 new.
	med := MedMethod
		createIntermediate: anArray
		for: machine.
	selector := InstructionSelector 
		on: med
		for: machine.
	^ selector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/1/2006 22:59'!
testAddressOf
	selector := self selectInstructions: #((block 1 (mov (addressOf byteCodeAddress block2) t1) )).
	self should: [selector writtenResult = #((block 1 (mov (addressOf byteCodeAddress block2) t1) ) (block 2))].
	self should: 
		[(selector result 
			blockAt: 1
			instructionAt: 1) class = MedMov].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 20:59'!
testArithmaticSelection
	selector := self selectInstructions: #((block 1 (add 1 2) )).
	self should: [selector writtenResult = #((block 1  (mov 2 t1) (mov t1 t2) (add 1 t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/28/2005 17:39'!
testbitTest
	"This test is here because subtracts  need their arguments reversed for x86 assembly, this is
	because med uses normal ordering and the assembly is in AT&T order with two arguments"
	
	selector := self selectInstructions: #((block 1 (bitTest 10 2) )).
	self should: [selector writtenResult = #((block 1  (mov 10 t1)  (bitTest 2 t1) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 20:59'!
testCall
	selector := self selectInstructions: #(#(#block 1 #(call 1234) )).
	self should: 
		[selector writtenResult = #(#(#block 1 #(call 1234) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/26/2005 17:40'!
testCmp
	"This test is here because subtracts  need their arguments reversed for x86 assembly, this is
	because med uses normal ordering and the assembly is in AT&T order with two arguments"
	
	selector := self selectInstructions: #((block 1 (cmp 10 2) )).
	self should: [selector writtenResult = #((block 1  (mov 10 t1)  (cmp 2 t1) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/26/2005 22:16'!
testCmpArg2Indirect
	"This test is here because subtracts  need their arguments reversed for x86 assembly, this is
	because med uses normal ordering and the assembly is in AT&T order with two arguments"
	
	selector := self selectInstructions: #((block 1 (cmp (mem (add ebp 10)) 2) )).
	self should: [selector writtenResult = #((block 1  (mov 2 t1)  (cmp t1 (10 ebp)) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 1/15/2005 13:06'!
testCopyAlignedFlag
	| med machine| 
	machine := MachineX86 new.
	med := MedMethod
		createIntermediate: #((block 1) (block 2))
		for: machine.
	(med blockAt: 2) makeAligned.
	selector := InstructionSelector 
		on: med
		for: machine.
	self assert: (selector result blockAt: 1) isAligned not.
	self assert: (selector result blockAt: 2) isAligned.
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:00'!
testDivide
	selector := self 
				selectInstructions: #(#(#block 1 (mov #(div t1 t2 t3) t4) )).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 
						(mov t1 eax) 
						(cdq)    "Sign extends EAX into EDX:EAX"
						(div t2) "This is an X86 division, the rest of the arguments are in EAX:EDX"
						(mov eax t5) 
						(mov edx t3) 
						(mov t5 t4) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:00'!
testDivide2
	selector := self 
				selectInstructions: #(#(#block 1 (mov #(div (add 1 t1) (add 2 t2) t3) t4) )).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 
						(mov t1 t6)
						(add 1 t6)
						(mov t2 t7)
						(add 2 t7)
						(mov t6 eax) 
						(cdq) 
						(div t7) "This is an X86 division, the rest of the arguments are in EAX:EDX"
						(mov eax t5) 
						(mov edx t3) 
						(mov t5 t4) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:00'!
testIndirectConstant
	selector := self 
				selectInstructions: #(#(#block 1 #(#mov #(#mem #falseObj) 't1') )).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 (mov falseObj t2) #(#mov (t2) t1) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:01'!
testInstructionArithmaticWithLeftAddressing
	selector := self 
				selectInstructions: #(#(#block 1 #(#add #(#mem #(#add #ebp 8)) #eax))).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 #(#mov #eax #t1) #(#add #(8 #ebp) #t1)))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:01'!
testInstructionArithmaticWithRightAddressing
	selector := self 
				selectInstructions: #(#(#block 1 #(#add #eax #(#mem #(#add #ebp 8)) ))).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 #(#mov (8 ebp) #t1) (mov t1 t2) #(#add #eax t2) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:01'!
testInstructionMemWithAddressing
	selector := self selectInstructions: #((block 1 (mem (add ebp 8) ) )).
	self should: [selector writtenResult = #((block 1 (mov (8 ebp) t1) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:01'!
testInstructionMoveWithBothAddressing
	selector := self 
				selectInstructions: #(#(#block 1 (mov (mem eax) (mem (add ebp 8))) )).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 (mov (eax) t1) #(#mov t1 (8 ebp)) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:02'!
testInstructionMoveWithLeftAddressing
	selector := self selectInstructions: #(#(#block 1 #(#mov #(#mem #(#add #ebp 8)) #eax))).
	self should: [selector writtenResult = #(#(#block 1 #(#mov #(8 #ebp) #eax)))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:02'!
testInstructionMoveWithRightAddressing
	selector := self 
				selectInstructions: #(#(#block 1 (mov eax (mem (add ebp 8))) )).
	self should: 
			[selector writtenResult 
				= #(#(#block 1 #(#mov eax (8 ebp)) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 15:18'!
testInstructionSelection
	selector := self selectInstructions: #(#(#block 1 #(#mov #(#add 1 2) #eax) #(#ret))).
	self should: 
		[selector writtenResult = 
			#(#(#block 1 
				#(#mov 2 #t1) 
				#(#mov #t1 #t2) 
				#(#add 1 #t2) 
				#(#mov #t2 #eax) 
				#(#ret)))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:02'!
testInstructionSelectionForBasicMem
	selector := self selectInstructions: #((block 1 (mov (mem ebp) eax))).
	self should: [selector writtenResult = #((block 1 (mov (ebp) eax) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:02'!
testInstructionSelectionForMemTarget
	selector := self selectInstructions: #((block 1 (mov eax (mem t1)))).
	self should: [selector writtenResult = #((block 1 (mov eax (t1)) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:00'!
testIPush
	selector := self selectInstructions: #(#(#block 1 #(push eax) )).
	self should: 
		[selector writtenResult = #(#(#block 1 #(push eax) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/4/2005 21:32'!
testJumpComputed
	selector := self selectInstructions: #((block 1 (jmp (sub t1 1)) )).
	self should: [selector writtenResult = #((block 1 (mov t1 t2) (sub 1 t2) (jmp t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:03'!
testJumpInsideEpressionSelection
	selector := self selectInstructions: #((block 1 (mov (jo block2 (add 1 2)) t2) ) (block 2 (mov 2 t2) )).
	self should: 
		[selector writtenResult = 
		#((block 1  (mov 2 t3) (mov t3 t4) (add 1 t4) (jo block2) (mov t4 t2)) 
			(block 2 (mov 2 t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:03'!
testJumpInstructionSelection
	selector := self selectInstructions: #((block 1 (jo block2 (mov 1 t1)) ) (block 2 (mov 2 t2) )).
	self should: [selector writtenResult = #((block 1 (mov 1 t1) (jo block2) ) (block 2 (mov 2 t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:03'!
testJumpJmpInstructionSelection
	"Tests that we can generate a simple nonconditional jump (jmp)"
	selector := self selectInstructions: #((block 1 (jmp block2 ) ) (block 2  )).
	self should: [selector writtenResult = #((block 1 (jmp block2) ) (block 2 ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:03'!
testJumpSelectsJumpClass
	selector := self selectInstructions: #((block 1 (jmp block1) )).
	self should: [selector writtenResult = #((block 1 (jmp block1) ))].
	self should: 
		[(selector result 
			blockAt: 1
			instructionAt: 1) class = MedJump].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:04'!
testMovSelectsMovClass
	selector := self selectInstructions: #((block 1 (mov 1 t1) )).
	self should: [selector writtenResult = #((block 1 (mov 1 t1) ))].
	self should: 
		[(selector result 
			blockAt: 1
			instructionAt: 1) class = MedMov].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:04'!
testMovToMemSelectsMovClass
	selector := self selectInstructions: #((block 1 (mov 1 (mem t1)) )).
	self should: [selector writtenResult = #((block 1 (mov 1 (t1)) ))].
	self should: 
		[(selector result 
			blockAt: 1
			instructionAt: 1) class = MedMov].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 12/25/2004 22:49'!
testMultiplyLiteral
	selector := self selectInstructions: #((block 1 (mul 42 t1) )).
	self should: [selector writtenResult = #((block 1  (mov 42 t2) (mov t1 t3) (mul t2 t3) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:04'!
testNegRegister
	selector := self selectInstructions: #((block 1 (neg t1) )).
	self should: [selector writtenResult = #((block 1 (mov t1 t2) (neg t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:04'!
testNegRegister2
	selector := self selectInstructions: #((block 1 (mov (neg t1) t2) )).
	self should: [selector writtenResult = #((block 1 (mov t1 t3) (neg t3) (mov t3 t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/26/2005 10:18'!
testPic
	selector := self selectInstructions: #(#(#block 1 #(pic ecx) )).
	self should: 
		[selector writtenResult = #(#(#block 1 #(pic ecx) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 15:56'!
testPop
	selector := self selectInstructions: #(#(#block 1 #(pop eax) )).
	self should: 
		[selector writtenResult = #(#(#block 1 #(pop eax) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:05'!
testPrologBlock
	selector := self selectInstructions: #((block 3) (block 1 ) (block 2) ).
	self should: [selector writtenResult = #((block 3) (block 1 ) (block 2) )].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 21:05'!
testPushExpression
	selector := self selectInstructions: #(#(#block 1 #(push (add 1 2)) )).
	self should: 
		[selector writtenResult = #(#(#block 1 (mov 2 t1) (mov t1 t2) (add 1 t2) #(push t2) ))].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 15:10'!
testReturnSelectsRetClass
	selector := self selectInstructions: #(#(#block 1 #(#ret))).
	self should: [selector writtenResult = #(#(#block 1 #(#ret)))].
	self should: 
			[(selector result 
				blockAt: 1
				instructionAt: 1) class = MedRet].
	self verifySelector! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/4/2004 21:36'!
testSalConstant
	selector := self selectInstructions: #((block 1 (sal  t2 1) )).
	self should: [selector writtenResult = #((block 1 (mov t2 t3)  (sal 1 t3) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/4/2004 21:36'!
testSalRegister
	selector := self selectInstructions: #((block 1 (sal t2 t1 ) )).
	self should: [selector writtenResult = #((block 1 (mov t1 ecx) (mov t2 t3)  (sal ecx t3) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/4/2004 20:53'!
testSarConstant
	selector := self selectInstructions: #((block 1 (sar t2 1) )).
	self should: [selector writtenResult = #((block 1 (mov t2 t3)  (sar 1 t3) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/4/2004 20:54'!
testSarRegister
	selector := self selectInstructions: #((block 1 (sar t2  t1 ) )).
	self should: [selector writtenResult = #((block 1 (mov t1 ecx) (mov t2 t3)  (sar ecx t3) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/4/2005 23:23'!
testSideEffectingAdd
	selector := self selectInstructions: #((block 1 (mov (add t1 20) t1) )).
	self should: [selector writtenResult = #((block 1 (add 20 t1) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 3/6/2004 20:16'!
testSub
	"This test is here because subtracts  need their arguments reversed for x86 assembly, this is
	because med uses normal ordering and the assembly is in AT&T order with two arguments"
	
	selector := self selectInstructions: #((block 1 (sub 10 2) )).
	self should: [selector writtenResult = #((block 1  (mov 10 t1) (mov t1 t2) (sub 2 t2) ))].
	self verifySelector.! !

!InstructionSelectionTests methodsFor: 'Support' stamp: 'wbk 3/13/2003 14:15'!
verifySelector
	selector result instructionsDo:
		[:each| each name = #mov ifTrue: [self should: [each class = MedMov]]]! !

ExuperyTests subclass: #InterferenceGraphGenerationTests
	instanceVariableNames: 'allocator machine'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!InterferenceGraphGenerationTests methodsFor: 'Misc' stamp: 'wbk 8/17/2005 22:47'!
prepare: anArray
	|source |
	machine := MachineX86 new.
	source := MedMethod 
		createAssembly: anArray
		for: machine.	
	allocator := ColouringRegisterAllocator new
		initialiseSource: source 
		machine: machine
		isValidating: false.
	allocator analyseLiveness.! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 7/5/2003 15:49'!
testAddDoesntInterfereWithSelf
	"A register add shouldn't interfer with itself,"
	self prepare: #((block 1 (add 1 t1) (mov (t1) t2))).
	allocator buildInterferenceGraph.

	"Test the registers are allocated"
	(allocator interferenceNode: (machine registerNamed: #t1)).
	(allocator interferenceNode: (machine registerNamed: #t2)).
	self shouldnt:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t1)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/24/2003 11:34'!
testCall
	self prepare: #((block 1 (call 12345) )).
	allocator buildInterferenceGraph.
! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 7/5/2003 14:39'!
testCallInterference
	self prepare: #((block 1 (mov 1 t1) (mov 2 t2) (call t1) (call t2) )).
	allocator buildInterferenceGraph.

	self assert: (allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2))! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 1/11/2006 20:02'!
testCallInterferesWithMachineRegisters
	self prepare: #((block 1 
		(call 12345) 
		(add t1 t1) )).
	allocator buildInterferenceGraph.
	self assert: (allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #eax)).
	self assert: (allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #edx)).
	self assert: (allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #ecx)).

! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 2/2/2004 21:02'!
testCDQ

	self prepare: #((block 1 
				(cdq)
				(add t1 t2)
				(add t3 t4))).
	allocator buildInterferenceGraph.
	self should:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #edx)].
	self should:
		[allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #edx)].
	self should:
		[allocator
			interferes: (machine registerNamed: #t3)
			with: (machine registerNamed: #edx)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 3/26/2005 21:33'!
testCmp

	self prepare: #((block 1
					(cmp t1 t2) 
					(add t3 t4) )).
	allocator buildInterferenceGraph.
	self shouldnt:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t3)].
	self shouldnt:
		[allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t4)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 1/31/2004 14:41'!
testDivide
	"This test checks that when building the interference graph we add edges from all
	live variables in live-out to both eax and edx Eax and edx are the two registers set in 
	the divide instruction."
	self prepare: #((block 1 
				(div t1)
				(mov eax t2)
				(mov edx t3)
				(add t1 t1))).
	allocator buildInterferenceGraph.
	self should:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #eax)].
	self should:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #edx)].
	self shouldnt:
		[allocator
			interferes: (machine registerNamed: #eax)
			with: (machine registerNamed: #t2)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/28/2004 22:42'!
testDoubleRegisterInterferance
	self prepare: #((block 1 (mov 1 t2) (add 1 t2) (mov t2 1)  (mov 1 t4) (mov 1 t3) 
							(add t2 t4) (add t3 t4) (mov t4 1) )).
	allocator buildInterferenceGraph.

	self assert:
		(allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t3)).
	self assert:
		(allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t4)).
	self assert:
		(allocator
			interferes: (machine registerNamed: #t3)
			with: (machine registerNamed: #t4)).! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:23'!
testJumpInterferance
	self prepare: #((block 1 (mov 1 t3) (mov 1 t1) (mov 2 t2) (add t1 t2) (jmp block2) ) 
			(block 2 (add t3 t2) ) ).
	allocator buildInterferenceGraph.

	self should:
		[allocator
			interferes: (machine registerNamed: #t3)
			with: (machine registerNamed: #t1)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:24'!
testMachineRegisterInterferance
	"Reproduces a bug, ebp wasn't being placed in the the interference graph
	throwing it into the debugger"
	"Interestingly it is only created if ebp is an indirect argument"
	self prepare: #((block 1 (mov t1 t2) (mov (ebp) t6) )).
	allocator buildInterferenceGraph.! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:24'!
testMovFromIndirectRegisterInterferance
	"This test has no register interference but it still needs to allocate registers"
	self prepare: #((block 1 (mov 1 t1) (mov (t1) t2))).
	allocator buildInterferenceGraph.

	"Test the registers are allocated"
	(allocator interferenceNode: (machine registerNamed: #t1)).
	(allocator interferenceNode: (machine registerNamed: #t2)).
	self shouldnt:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:25'!
testMovRegisterInterferance
	self prepare: #((block 1 (mov 1 t1) (mov t1 t2) (add t1 t1))).
	allocator buildInterferenceGraph.

	self shouldnt:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:25'!
testMovToIndirectRegisterInterferance
	self prepare: #((block 1 (mov 1 t1) (mov 2 t2) (mov t1 (t2)))).
	allocator buildInterferenceGraph.

	self should:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 2/9/2004 20:17'!
testNegate

	self prepare: #((block 1
					(add t1 t1) 
					(neg t2)
					(mov t3 t4) )).
	allocator buildInterferenceGraph.
	self should:
		[allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t3)].
	self should:
		[allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t1)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 2/26/2005 18:09'!
testPic
	self prepare: #((block 1 (pic eax) )).
	allocator buildInterferenceGraph.
! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 16:09'!
testPop

	self prepare: #((block 1
					(add t1 t1) 
					(pop t2)
					(mov t3 t4) )).
	allocator buildInterferenceGraph.
	self should:
		[allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t3)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/24/2003 10:28'!
testPush
	self prepare: #((block 1 (push 1) )).
	allocator buildInterferenceGraph.
! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 7/5/2003 14:38'!
testPushInterference
	self prepare: #((block 1 (mov 1 t1) (mov 2 t2) (push t1)  (push t2) )).
	allocator buildInterferenceGraph.

	self assert: (allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2))
! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 16:27'!
testRet
	self prepare: #(#(#block 1 #(#mov 1 #eax) (mov 1 t1) #(#add #t1 #t1) #(#ret))).
	allocator buildInterferenceGraph.
	self should: 
			[allocator 
				interferes: (machine registerNamed: #t1)
				with: (machine registerNamed: #eax)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 15:18'!
testRetInterferance
	self prepare: #(#(#block 1 #(#mov 1 #t1) #(#mov 2 #t2) #(#add #t1 #t2) #(#ret))).
	allocator buildInterferenceGraph.
	self should: 
			[allocator 
				interferes: (machine registerNamed: #t1)
				with: (machine registerNamed: #t2)].
	self should: 
			[allocator 
				interferes: (machine registerNamed: #t2)
				with: (machine registerNamed: #t1)]! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 15:18'!
testReturn42Interferance
	self prepare: #(#(#block 1 #(#mov 8 't3') #(#add #ebp 't3') #(#mov #('t3') 't4') #(#mov #('t4') 't5') #(#mov 't5' 't1') #(#mov 8 't6') #(#add 't1' 't6') #(#mov #('t6') 't7') #(#mov 1 't8') #(#add 't7' 't8') #(#mov 't8' 't2') #(#mov 8 't9') #(#add 't1' 't9') #(#mov 't2' #('t9')) #(#mov 4 't10') #(#mul 't2' 't10') #(#mov 't10' 't11') #(#add 't1' 't11') #(#mov 24 't12') #(#add 't11' 't12') #(#mov 85 #('t12')) #(#ret))).
	allocator buildInterferenceGraph.
	self verifyInterferenceGraph.
	self 
		verifyDoesntInterfere: #t3
		with: #t4! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:27'!
testSimpleJumpRegisterInterferance
	self prepare: #((block 1 (jz block2) (jo block2) (jmp block2) (jg block2) (je block2) ) (block 2) ).
	allocator buildInterferenceGraph.
! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:29'!
testSingleRegisterInterferance
	self prepare: #((block 1 (mov 1 t1) (mov 2 t2) (add t1 t2))).
	allocator buildInterferenceGraph.

	self should:
		[allocator
			interferes: (machine registerNamed: #t1)
			with: (machine registerNamed: #t2)].
	self should:
		[allocator
			interferes: (machine registerNamed: #t2)
			with: (machine registerNamed: #t1)].! !

!InterferenceGraphGenerationTests methodsFor: 'Tests' stamp: 'wbk 6/23/2003 13:29'!
testSpecialRegisterInterferance
	self prepare: #((block 1 (add ebp t1) )).
	allocator buildInterferenceGraph.

	self shouldnt:
		[allocator interferenceGraph includesKey: (machine registerNamed: #ebp)].! !

!InterferenceGraphGenerationTests methodsFor: 'Verification Methods' stamp: 'wbk 3/13/2003 14:26'!
verifyDoesntInterfere: firstString with: secondString
	self shouldnt:
		[allocator
			interferes: (machine registerNamed: firstString)
			with: (machine registerNamed: secondString)].! !

!InterferenceGraphGenerationTests methodsFor: 'Verification Methods' stamp: 'wbk 3/13/2003 14:26'!
verifyInterferenceGraph
	allocator interferenceGraph do: 
		[:each| self should: [ each register isRegister]].! !

!InterferenceGraphGenerationTests methodsFor: 'Verification Methods' stamp: 'wbk 3/13/2003 14:26'!
verifyInterferes: firstString with: secondString
	self should:
		[allocator
			interferes: (machine registerNamed: firstString)
			with: (machine registerNamed: secondString)].! !

ExuperyTests subclass: #IntermediateCopierTests
	instanceVariableNames: 'machine source result emitter mockEmitter isMockTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

IntermediateCopierTests subclass: #BlockFinderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!BlockFinderTests methodsFor: 'Misc' stamp: 'wbk 1/3/2006 20:15'!
operationClass
	^ BlockFinder! !

!BlockFinderTests methodsFor: 'Tests' stamp: 'wbk 1/18/2006 23:15'!
testFindBasicBlock
	source := MedMethod
		createIntermediate: #((block 1 (mov t1 t1)) (block 2 (createBlockContext 0)))
		for: machine.

	self simplify.

	self assert: (source blockNumbered: 1) isBlockElement not.
	self assert: (source blockNumbered: 2) isBlockElement.! !

!BlockFinderTests methodsFor: 'Tests' stamp: 'wbk 1/18/2006 23:16'!
testFollowConditionalJump
	source := MedMethod
		createIntermediate: 
			#((block 1 
				(createBlockContext 0) 
				(jz block2)) 
			  (block 2 
				))
		for: machine.

	self simplify.

	self assert: (source blockNumbered: 1) isBlockElement.
	self assert: (source blockNumbered: 2) isBlockElement.! !

!BlockFinderTests methodsFor: 'Tests' stamp: 'wbk 1/18/2006 23:16'!
testFollowDoubleJump
	source := MedMethod
		createIntermediate: 
			#((block 1 
				(createBlockContext 0) 
				(jmp block2)) 
			  (block 2 (jmp block3))
			  (block 3 ))
		for: machine.

	self simplify.

	self assert: (source blockNumbered: 1) isBlockElement.
	self assert: (source blockNumbered: 2) isBlockElement.! !

!BlockFinderTests methodsFor: 'Tests' stamp: 'wbk 1/18/2006 23:16'!
testFollowJump
	source := MedMethod
		createIntermediate: 
			#((block 1 
				(createBlockContext 0) 
				(jmp block2)) 
			  (block 2 ))
		for: machine.

	self simplify.

	self assert: (source blockNumbered: 1) isBlockElement.
	self assert: (source blockNumbered: 2) isBlockElement.! !

!BlockFinderTests methodsFor: 'Tests' stamp: 'wbk 1/18/2006 23:16'!
testFollowWithOtherInstrcutions
	source := MedMethod
		createIntermediate: 
			#((block 1 
				(createBlockContext 0) 
				(jmp block2)) 
			  (block 2 
				(add 1 2) ))
		for: machine.

	self simplify.

	self assert: (source blockNumbered: 1) isBlockElement.
	self assert: (source blockNumbered: 2) isBlockElement.! !

!IntermediateCopierTests methodsFor: 'Misc' stamp: 'wbk 12/8/2005 20:21'!
setUp
	machine := MachineX86 new.
	mockEmitter := MockIntermediateEmitter newWith: machine.
	isMockTest := false.! !

!IntermediateCopierTests methodsFor: 'Misc' stamp: 'wbk 12/8/2005 20:52'!
simplify
	| simplifer |
	emitter := IntermediateEmitter 
				machine: machine
				jumpTargets: #()
				result: (MedMethod from: source)
				inlining: #().
	simplifer := self operationClass
				from: source
				emitter: emitter.
	result := simplifer runBasic! !

!IntermediateCopierTests methodsFor: 'Misc' stamp: 'wbk 12/8/2005 20:21'!
simplifyFullyMocked
	| simplifier |
	isMockTest := true.
	machine := MachineX86 new.
	simplifier := self operationClass
				from: source
				emitter: mockEmitter.
	result := simplifier runBasic! !

!IntermediateCopierTests methodsFor: 'Misc' stamp: 'wbk 2/8/2006 21:43'!
verify
	| expressions |
	"Verify that the new result is not accidentally sharing nodes from the source. This
	can be a very fertile source of bugs."
	self assert: source ~= result.
	expressions := Set new.
	source expressionsDo: [:each| expressions add: each].
	result ifNotNil: 
		[result expressionsDo: [:each| self assert: (expressions includes: each) not]].
	isMockTest ifTrue: [mockEmitter verify]! !

IntermediateCopierTests subclass: #IntermediateSimplifierTests
	instanceVariableNames: 'simplifier medBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!IntermediateSimplifierTests methodsFor: 'Misc' stamp: 'wbk 2/8/2006 22:34'!
createEmitterMocked
	source := MedMethod new.
	self makeEmitterMocked.! !

!IntermediateSimplifierTests methodsFor: 'Misc' stamp: 'wbk 2/8/2006 21:28'!
createFullyMocked
	source := MedMethod new.
	self makeFullyMocked.! !

!IntermediateSimplifierTests methodsFor: 'Misc' stamp: 'wbk 2/8/2006 22:11'!
createMocked
	source := MedMethod new.
	self makeMocked.! !

!IntermediateSimplifierTests methodsFor: 'Misc' stamp: 'wbk 2/11/2006 10:58'!
createSimplifer
	machine := MachineX86 new.
	source := MedMethod new.
	emitter := IntermediateEmitter 
				machine: machine
				jumpTargets: #()
				inlining: #()..
	simplifier := IntermediateSimplifier 
				from: source
				emitter: emitter.
	medBlock := MedBlock number: 1.
	simplifier prepareBlockFrom: medBlock.! !

!IntermediateSimplifierTests methodsFor: 'Misc' stamp: 'wbk 2/8/2006 22:43'!
createUnmocked
	source := MedMethod new.
	machine := MachineX86 new.
	emitter := IntermediateEmitter 
				machine: machine
				jumpTargets: #()
				inlining: #().
	simplifier := IntermediateSimplifier 
				from: source
				emitter: emitter! !

!IntermediateSimplifierTests methodsFor: 'Misc' stamp: 'wbk 2/8/2006 22:33'!
makeEmitterMocked
	machine := MachineX86 new.
	simplifier := IntermediateSimplifier 
				from: source
				emitter: mockEmitter! !

!IntermediateSimplifierTests methodsFor: 'Misc' stamp: 'wbk 1/27/2006 22:34'!
makeFullyMocked
	isMockTest := true.
	machine := MachineX86 new.
	simplifier := self operationClass 
				from: source
				emitter: mockEmitter.
	simplifier simplifier: mockEmitter.
	^simplifier! !

!IntermediateSimplifierTests methodsFor: 'Misc' stamp: 'wbk 2/8/2006 22:10'!
makeMocked
	machine := MachineX86 new.
	emitter := IntermediateEmitter 
				machine: machine
				jumpTargets: #()
				inlining: #().
	emitter emitter: mockEmitter.
	simplifier := IntermediateSimplifier 
				from: source
				emitter: emitter! !

!IntermediateSimplifierTests methodsFor: 'Misc' stamp: 'wbk 12/21/2004 12:43'!
operationClass
	^ IntermediateSimplifier! !

!IntermediateSimplifierTests methodsFor: 'Misc' stamp: 'wbk 2/8/2006 21:06'!
result
	^ emitter result intermediateForm! !

!IntermediateSimplifierTests methodsFor: 'Misc' stamp: 'wbk 1/27/2006 22:31'!
simplifyFullyMocked
	simplifier := self makeFullyMocked.
	result := simplifier runBasic! !

!IntermediateSimplifierTests methodsFor: 'Misc' stamp: 'wbk 2/8/2006 22:10'!
simplifyMocked
	self makeMocked.
	result := simplifier runBasic! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:31'!
testAdd
	source := MedMethod 
				createIntermediate: #(#(#block 1 #(#add #(#mov 1 1) #(#mov 2 2))))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 #(#add #(#mov 1 1) #(#mov 2 2)))).
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests - Primitives' stamp: 'wbk 11/6/2005 20:18'!
testAtPrimitive
	source := MedMethod 
				createIntermediate: 
					#((block 1  (primitive at: Array block2 receiver arg1) ))
				for: machine.			
	mockEmitter expectEmission:
		#((block1 
				(mov arg1 t1) "Index"
				(mov receiver t2)	"receiver"
				(addressOfIndexedElement t2 t1 block2))
			(block2)).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Primitives' stamp: 'wbk 11/6/2005 20:30'!
testAtPrimitiveWithInstVars
	source := MedMethod 
				createIntermediate: 
					#((block 1  (primitive at: ExuperyArrayInstVars block2 receiver arg1) ))
				for: machine.			
	mockEmitter expectEmission:
		#((block1 
				(mov (add 12 arg1) t1) "Index"
				(mov receiver t2)	"receiver"
				(addressOfIndexedElement t2 t1 block2))
			(block2)).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Primitives' stamp: 'wbk 11/6/2005 20:19'!
testAtPutPrimitive
	source := MedMethod 
				createIntermediate: 
					#((block 1  (primitive at:put: Array block2 receiver index value) ))
				for: machine.			
	mockEmitter expectEmission:
		#((block1 
				(mov value t3) "value"
				(mov index t1)	"index"
				(mov receiver t2)	"receiver"
				(mov t3 (addressOfIndexedElement t2 t1 block2))
				(emitBeRootIfNeeded t2 t3))
			(block2)).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Primitives' stamp: 'wbk 11/6/2005 20:31'!
testAtPutPrimitiveWithInstVars
	source := MedMethod 
				createIntermediate: 
					#((block 1  (primitive at:put: ExuperyArrayInstVars block2 
									receiver index value) ))
				for: machine.			
	mockEmitter expectEmission:
		#((block1 
				(mov value t3) "value"
				(mov (add 12 index) t1)	"index"
				(mov receiver t2)	"receiver"
				(mov t3 (addressOfIndexedElement t2 t1 block2))
				(emitBeRootIfNeeded t2 t3))
			(block2)).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 3/27/2005 22:13'!
testBitShift
	source := MedMethod 
				createIntermediate: #(#(#block 1 (bitShift 13 5 block2)))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(	(block 1 
				(mov 13 t2)
				(mov (sar 5 1) t3)
				(jl block3 (cmp t3 0)) 
				(jl block2 (cmp 31 t3))
				(mov (sal t2 t3) t1) 
				(jnz block2 (cmp t2 (sar t1 t3))) 
				(jmp block4))
			(block 2) "The failure block"
			(block 3 
				(jl block2 (cmp t3 -31))
				(mov (sar  t2  (neg t3)) t1) 
				(jmp block4)) 
			#(#block 4)).	"t2 is the remander".
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 3/27/2005 22:13'!
testBitShiftNested
	source := MedMethod 
				createIntermediate: #(#(#block 1 (bitShift (add 13 13) (sub 5 5) block2)))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(	(block 1 
				(mov (add 13 13) t2)
				(mov (sar (sub 5 5) 1) t3)
				(jl block3 (cmp t3 0)) 
				(jl block2 (cmp 31 t3))
				(mov (sal t2 t3) t1) 
				(jnz block2 (cmp t2 (sar t1 t3))) 
				(jmp block4))
			(block 2) "The failure block"
			(block 3 
				(jl block2 (cmp t3 -31))
				(mov (sar  t2  (neg t3)) t1) 
				(jmp block4)) 
			#(#block 4)).	"t2 is the remander".
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests - Blocks' stamp: 'wbk 3/28/2006 21:53'!
testBlockCreation
	"machine := MockExuperyPlugin."
	source := MedMethod
		createIntermediate:
			#((block 1 (mov (createBlock 1 byteCodeAddress block3) s1)))
		for: machine.
	mockEmitter expectEmission:
		#((block1 
			(mov 
				(saveRegistersAround (callFunction createExuperyBlock 1 
					(blockAddress byteCodeAddress block3 1) 0)) s1))).

	self simplifyFullyMocked.

	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Blocks' stamp: 'wbk 3/28/2006 21:55'!
testBlockCreationInBlock
	"machine := MockExuperyPlugin."
	source := MedMethod
		createIntermediate:
			#((block 1 (mov (createBlock 1 byteCodeAddress block3) s1)))
		for: machine.
	(source blockAt: 1) makeBlockElement.
	mockEmitter expectEmission:
		#((block1 
			(mov 
				(saveRegistersAround (callFunction createExuperyBlock 1 
					(blockAddress byteCodeAddress block3 1) 1)) s1))).

	self simplifyFullyMocked.

	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Blocks' stamp: 'wbk 12/24/2005 15:04'!
testBlockReturn
	source := MedMethod 
		createIntermediate: #((block 1 (blockReturn (add 1 1)) ))
		for: machine.
	mockEmitter expectEmission:
		#((block1 
			(expandedBlockReturn (add 1 1)))).
				
	self simplifyFullyMocked.
	
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 2/11/2006 11:43'!
testBytecodePrimNewWithArg
	| answer |
	self createFullyMocked.
	mockEmitter expectEmission: #(
				#(
					#block1
					#(#emitRestoreContext 2 4 5 )
					#(
						#mov
						#(#address 2 #block3 )
						#(#mem #(#add #(#currentContextAddress ) 20 ) )
					)
					#(#mov #(#emitClass 4 ) #eax )
					#(#mov #picEntry #ecx )
					#(#mov #literalAddress #edx )
					#(#restoreSendersFrame )
					#(#pic #eax )
					#(
						#mov
						#(
							#callFunction
							#exuperySetupMessageSend
							#edx
							1
							#ecx
						)
						#eax
					)
					#(#jz #block2 #(#cmp #eax 0 ) )
					#(#jmp #eax )
				)
				#(
					#block2
					#(#mov 1 #eax )
					#(#ret )
					#(#alignedLabel )
					#(#preamble )
					#(reloadStack #t1 )
				)
			).	"Call compiled method"	"Return to Interpreter"
	"A real block begins here"
	mockEmitter 
		expectRegisterEntryPointPC: 5
		blockNumbered: #block3.	"An encoded SmallInteger"
	mockEmitter newBlock. "To account for the first block"
	answer := simplifier 
				expandedSendSelector: (MedLiteral literal: #literalAddress)
				arguments: #(4 5 )
				pc: 1
				stack: #().
	self assert: (answer isKindOf: MedLanguage).	"This is inadiquate. What I really should do is check
												  that the answer is a reasonable type/object"
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:31'!
testCall
	source := MedMethod 
				createIntermediate: #(#(#block 1 (call (add 1 1))))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 (call (add 1 1)))).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:59'!
testConvertBoolean
	source _ MedMethod 
				createIntermediate: #(#(#block 1 #(#convertBoolean #jg #anExpression)))
				for: machine.
	mockEmitter expectEmission: #(#(#block1 #(#jg #block2 #anExpression) #(#mov #(#trueAddress) #t1) #(#jmp #block3)) #(#block2 #(#mov #(#falseAddress) #t1) #(#jmp #block3)) #(#block3)).
	self simplifyMocked.
	self verify.
	mockEmitter verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 10/5/2005 22:40'!
testCopyNeedsLargeContext
	source := MedMethod new.
	source needsLargeContext: 42.
	
	self simplify.
	
	self assert: result needsLargeContext = 42.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 3/13/2005 20:49'!
testCopyNumberOfArguments
	source := MedMethod new.
	source numberOfArguments: 42.
	
	self simplify.
	
	self assert: result numberOfArguments = 42.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 9/22/2004 20:17'!
testCopyNumberOfTemporaries
	source := MedMethod new.
	source numberOfTemporaries: 42.
	
	self simplify.
	
	self assert: result numberOfTemporaries = 42.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Blocks' stamp: 'wbk 2/11/2006 11:44'!
testCreateBlockContext
	"machine := MockExuperyPlugin."
	source := MedMethod
		createIntermediate:
			#((block 1 (createBlockContext 0)))
		for: machine.
	mockEmitter expectEmission:
		#((block1 
			(preamble)
			(reloadStack ) )).
	machine compiledMethodNumber: 0.

	self simplifyFullyMocked.

	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Blocks' stamp: 'wbk 2/11/2006 11:44'!
testCreateBlockContextWith2Args
	"machine := MockExuperyPlugin."
	source := MedMethod
		createIntermediate:
			#((block 1 (createBlockContext 2)))
		for: machine.
	mockEmitter expectEmission:
		#((block1 
			(preamble)
			(reloadStack s1 s2) )).
	machine compiledMethodNumber: 0.

	self simplifyFullyMocked.

	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Blocks' stamp: 'wbk 2/11/2006 11:44'!
testCreateBlockContextWithArg
	"machine := MockExuperyPlugin."
	source := MedMethod
		createIntermediate:
			#((block 1 (createBlockContext 1)))
		for: machine.
	mockEmitter expectEmission:
		#((block1 
			(preamble)
			(reloadStack s1) )).
	machine compiledMethodNumber: 0.

	self simplifyFullyMocked.

	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 1/14/2006 18:55'!
testCreateContext
	source := MedMethod 
		createIntermediate: #(#(#block 1 (createContext)))
		for: machine.
	machine compiledMethodNumber: 0.
	source numberOfArguments: #numArgs.
	source numberOfTemporaries: #numTemps.
	source needsLargeContext: #needsLarge.
	mockEmitter expectEmission: 
		#((block1 
				(callFunction exuperyCreateContext numArgs numTemps needsLarge)
				"Load current context into a register"
				(loadCurrentContext)
				(mov (emitFetchAddress 0 (mem methodArray))
					(initialCompiledMethodAddress)))).
				
	self simplifyFullyMocked.

	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 2/8/2006 21:47'!
testDeconvertBoolean
	source := MedMethod 
				createIntermediate: 
					#((block 1  (deconvertBoolean falseObj anExpression block2 1 0) )
						(block 2 ))
				for: machine.
	mockEmitter expectEmission:
		#( 	(block1			
				#(#conditionalJumpTo 'block2' #falseObj #anExpression 1)) ).
	
	self simplifyFullyMocked.

	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 2/8/2006 21:50'!
testDeconvertBooleanWithStack
	| target |
	self createFullyMocked.
	source := MedMethod 
				createIntermediate: 
					#((block 1  (deconvertBoolean falseObj anExpression block2 1 0) )
						(block 2 ))
				for: machine.
	mockEmitter expectEmission:
		#( 	(block1			
				(je block2 (cmp anExpression (mem falseObj) ))
				(jne block3 (cmp anExpression (mem trueObj)))
				(jmp block4))
			(block2) 
			(block3 
				(emitExpandedSend (emitSpecialObject 25) anExpression stack 10 20)
				(jmp block4))
			(block4) ).
	(source blockAt: 1) initialStackHeight: 2.	

	mockEmitter newBlock. "To account for the first block"
	target := mockEmitter newBlock.
	simplifier 
		conditionalJumpTo: target
		onBoolean: (MedLiteral literal: #anExpression)
		ifBooleanIs: #falseObj
		pc: #programCounter
		stack: #(10 20).

	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:31'!
testDivide
	source := MedMethod 
		createIntermediate: 
			#(#(#block 1 #(#div#(#mov 1 1) #(#mov 2 2) (mov 3 3))))
		for: machine.
		
	self simplify.
	
	self assert: result intermediateForm = 
		#(#(#block 1 #(#div #(#mov 1 1) #(#mov 2 2) (mov 3 3)))).
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 2/8/2006 21:42'!
testEmitExpandedJumpIfFalseTo
	| target |
	self createFullyMocked.
	mockEmitter expectEmission: 
		#(#(#block1 
			#(#je #block2 #(cmp #anExpression #(#mem #falseObj))) 
			#(#jne #block3 #(cmp #anExpression #(#mem #trueObj))) 
			#(#jmp #block4)) 
		#(#block2) 
		#(#block3 
			#(#emitExpandedSend 
				#(#emitSpecialObject 25) #anExpression stack) 
			#(#jmp #block4)) 
		#(#block4)).
	mockEmitter newBlock. "To account for the first block"
	target := mockEmitter newBlock.
	simplifier 
		conditionalJumpTo: target
		onBoolean: (MedLiteral literal: #anExpression)
		ifBooleanIs: #falseObj
		pc: #programCounter
		stack: #().
	self verify.
	self assert: mockEmitter currentBlock = #block4! !

!IntermediateSimplifierTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 2/8/2006 21:44'!
testEmitExpandedJumpIfTrueTo
	| target |
	self createFullyMocked.
	mockEmitter expectEmission: 
		#(#(#block1 
			#(#je #block2 #(#cmp #anExpression #(#mem #trueObj))) 
			#(#jne #block3 #(#cmp #anExpression #(#mem #falseObj))) 
			#(#jmp #block4)) 
		#(#block2) 
		#(#block3 
			#(#emitExpandedSend #(#emitSpecialObject 25) #anExpression stack) 
			#(#jmp #block4)) 
		#(#block4)).
	mockEmitter newBlock. "To create teh first block"
	target := mockEmitter newBlock.
	simplifier 
		conditionalJumpTo: target
		onBoolean: (MedLiteral literal: #anExpression)
		ifBooleanIs: #trueObj
		pc: #programCounter
		stack: #().
	self verify.
	self assert: mockEmitter currentBlock = #block4! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 9/19/2004 16:24'!
testEntryPointsCopying
	source := MedMethod 
				createAssembly: #(#(#block 1 ))
				for: machine.
	source 
		registerEntryPointWithPC: 10
		label: source newBlock.
	source 
		registerEntryPointWithPC: 20
		label: source newBlock.
				
	self simplify.
	
	self assert: result entryPoints size = 2.
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 9/19/2004 17:47'!
testGenerateProlog
	| simplifier |
	source := MedMethod 
				createAssembly: #(#(#block 1 ))
				for: machine.
	
	machine := MachineX86 new.
	simplifier := IntermediateSimplifier 
				from: source
				emitter: mockEmitter.
	result := simplifier run.
	
	self assert: mockEmitter hasCreatedProlog.
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 1/14/2006 23:05'!
testHomeContextInBlock
	source := MedMethod 
				createIntermediate: #(#(#block 1 #(add (homeContext) 5)))
				for: machine.
	(source blockAt: 1) makeBlockElement.
				
	mockEmitter expectEmission:
		#(	(block1 
				#(add (simplifiedHomeContext) 5))).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.
! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 1/14/2006 23:05'!
testHomeContextInMethod
	source := MedMethod 
				createIntermediate: #(#(#block 1 #(add (homeContext) 5)))
				for: machine.
				
	mockEmitter expectEmission:
		#(	(block1 
				#(add (simplifiedHomeContext) 5))).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.
! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 1/27/2006 21:55'!
testInstanceVariableAddress
	source := MedMethod 
				createIntermediate: 
					#((block 1  (mov (instanceVariableAddress 5) t1) ))
				for: machine.
	mockEmitter expectEmission:
		#( 	(block1			
				(mov #(#emitFetchAddress 5 #(simplifiedReceiverAddress)) t1)) ).
	
	self simplifyFullyMocked.

	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 10/17/2004 22:37'!
testIntegerValueOf
	source := MedMethod 
				createIntermediate: 
					#((block 1  (integerValueOf 42 block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitExpandedIntegerValueOf block2 42)) 
			(block2) ).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 8/30/2004 16:31'!
testJump
	source := MedMethod 
				createAssembly: #(#(#block 1 #(jmp block2)) (block 2))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 #(jmp block2)) (block 2)).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 2/4/2005 20:42'!
testJumpComputed
	source := MedMethod 
				createAssembly: #(#(#block 1 #(jmp (add 10 20))) (block 2))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 #(jmp (add 10 20))) (block 2)).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 8/30/2004 16:31'!
testJumpNested
	source := MedMethod 
				createAssembly: #(#(#block 1 #(jz block2 (mov 10 20))) (block 2))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 #(jz block2 (mov 10 20))) (block 2)).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Labels and Type Checks' stamp: 'wbk 12/11/2004 19:56'!
testLabel
	source := MedMethod 
				createIntermediate: 
					#((block 1  (label () () codeExpression failureExpression block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(mov codeExpression t1)
				(jmp block3))
			(block2 
				(mov failureExpression t1)
				(jmp block3)) 
			(block3)).
			
	self simplifyFullyMocked.
	
	"The label should return t1"
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Labels and Type Checks' stamp: 'wbk 12/11/2004 19:54'!
testLabelWithArguments
	source := MedMethod 
				createIntermediate: 
					#((block 1  (label (arg1 arg2) (t1 t2) 
						(add t1 t2) 
						(sub t1 t2) 
						block2 ) ))
				for: machine.	
	mockEmitter initialiseMachine: machine.		
	mockEmitter expectEmission:
		#(	(block1 
				(mov arg1 t1)
				(mov arg2 t2)
				(mov (add t1 t2) t3)
				(jmp block3))
			(block2 
				(mov (sub t1 t2) t3)
				(jmp block3)) 
			(block3)).
			
	self simplifyFullyMocked.
	
	"The label should return t3"
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Labels and Type Checks' stamp: 'wbk 12/12/2004 23:35'!
testLabelWithArgumentsNested
	source := MedMethod 
				createIntermediate: 
					#((block 1  (label ((add 1 1) arg2) (t1 t2) 
						(add t1 t2) 
						(sub t1 t2) 
						block2 ) ))
				for: machine.	
	mockEmitter initialiseMachine: machine.		
	mockEmitter expectEmission:
		#(	(block1 
				(mov (add 1 1) t1)
				(mov arg2 t2)
				(mov (add t1 t2) t3)
				(jmp block3))
			(block2 
				(mov (sub t1 t2) t3)
				(jmp block3)) 
			(block3)).
			
	self simplifyFullyMocked.
	
	"The label should return t3"
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Labels and Type Checks' stamp: 'wbk 10/25/2005 22:52'!
testLabelWithBooleanDeconversion
	source := MedMethod 
				createIntermediate: 
					#((block 1  
						(label () () codeExpression (deconvertBoolean falseObj failureExpression block2 1)  block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(mov codeExpression t1)
				(jmp block3))
			(block2 
				(conditionalJumpTo block2 falseObj failureExpression 1)
				(jmp block3)) 
			(block3)).
			
	self simplifyFullyMocked.
	
	"The label should return t1"
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Labels and Type Checks' stamp: 'wbk 10/25/2005 23:17'!
testLabelWithSendArgument
	source := MedMethod 
				createIntermediate: 
					#((block 1  (label ((add 1 1) (send selector pc arg3)) (t1 t2) 
						(add t1 t2) 
						(sub t1 t2) 
						block2 ) ))
				for: machine.	
	mockEmitter initialiseMachine: machine.		
	mockEmitter expectEmission:
		#(	(block1 
				(mov (add 1 1) t1)
				(mov (emitExpandedSend selector arg3 stack t1) t2)
				(mov (add t1 t2) t3)
				(jmp block3))
			(block2 
				(mov (sub t1 t2) t3)
				(jmp block3)) 
			(block3)).
			
	self simplifyFullyMocked.
	
	"The label should return t3"
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Labels and Type Checks' stamp: 'wbk 10/25/2005 23:20'!
testLabelWithWrappedSend
	source := MedMethod 
				createIntermediate: 
					#((block 1  (label ((add 1 1) (send selector pc arg2 arg3)) (t1 t2) 
						(add t1 t2)
						(send selector pc arg4)
						block2 ) ))
				for: machine.	
	mockEmitter initialiseMachine: machine.		
	mockEmitter expectEmission:
		#(	(block1 
				(mov (add 1 1) t1)
				(mov (emitExpandedSend selector arg2 arg3 stack t1) t2)
				(mov (add t1 t2) t3)
				(jmp block3))
			(block2 
				(mov (emitExpandedSend selector arg4 stack) t3)
				(jmp block3)) 
			(block3)).
			
	self simplifyFullyMocked.
	
	"The label should return t3"
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 10/2/2004 10:26'!
testMachineRegister
	source := MedMethod 
				createIntermediate: #((block 1  (add eax ebx)))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #((block 1 (add eax ebx))).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/12/2004 18:05'!
testMidDiv
	source := MedMethod 
				createIntermediate: 
					#((block 1  (midDiv 13 5 block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitExpandedDiv 13 5 block2)) 
			(block2) ).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/12/2004 19:29'!
testMidDivide
	source := MedMethod 
				createIntermediate: 
					#((block 1  (midDivide 13 5 block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitExpandedDivide 13 5 block2)) 
			(block2) ).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/12/2004 19:29'!
testMidDivideNested
	source := MedMethod 
				createIntermediate: 
					#((block 1  (midDivide (add 13 13) (sub 5 5) block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitExpandedDivide (add 13 13) (sub 5 5) block2)) 
			(block2) ).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/12/2004 18:14'!
testMidDivNested
	source := MedMethod 
				createIntermediate: 
					#((block 1  (midDiv (add 13 13) (sub 5 5) block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitExpandedDiv (add 13 13) (sub 5 5) block2)) 
			(block2) ).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 12/17/2004 23:03'!
testMidMod
	source := MedMethod 
				createIntermediate: 
					#((block 1  (midMod 13 5 block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitExpandedMod 13 5 block2)) 
			(block2) ).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 10/2/2004 10:26'!
testMove
	source := MedMethod 
				createAssembly: #((block 1 (mov 1 t1)))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #((block 1 (mov 1 t1))).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:32'!
testMoveIndirect
	source := MedMethod 
				createAssembly: #(#(#block 1 #(#mov 1 (mem #t1))))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 #(#mov 1 (mem #t1)))).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:29'!
testMoveNested
	source := MedMethod 
				createAssembly: #(#(#block 1 #(#mov (mov 1 1) (mov 2 2))))
				for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 #(#mov (mov 1 1) (mov 2 2)))).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:34'!
testMultipleBlocks
	source := MedMethod 
		createIntermediate: #(#(#block 1 (add 10 10)) (block 2 (add 20 20)) (block 3 (add 30 30)))
		for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 (add 10 10)) (block 2 (add 20 20)) (block 3 (add 30 30))).
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:35'!
testNeg
	source := MedMethod 
		createIntermediate: #((block 1 (neg (mov 1 1)) ))
		for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #((block 1 (neg (mov 1 1)) )).
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 10/25/2005 23:20'!
testNestedSends
	source := MedMethod 
				createIntermediate: 
					#((block 1  
						(send selector pc arg1 
							(send selector pc arg2 arg3)) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				#(#emitExpandedSend selector  arg1 
					(emitExpandedSend selector arg2 arg3 stack arg1) stack )). 
			).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 10/25/2005 23:18'!
testNestedSendsWithComplexArguments
	source := MedMethod 
				createIntermediate: 
					#((block 1  
						(send selector pc (add 10 20)
							(send selector pc arg2 arg3)) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(mov (add 10 20) t1)
				#(#emitExpandedSend selector  t1 
					(emitExpandedSend selector arg2 arg3 stack t1) stack )). 
			).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Primitives' stamp: 'wbk 5/30/2005 17:47'!
testPrimitiveReturn
	source := MedMethod 
				createIntermediate: 
					#((block 1  (primitiveReturn 2 (add 1 1)) ))
				for: machine.			
	mockEmitter expectEmission:
		#((block1 
				(expandedPrimitiveReturn (add 1 1) 2))).
			
	self simplifyFullyMocked.
	
	"The label should return t1"
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 8/30/2004 16:35'!
testPush
	source := MedMethod 
		createIntermediate: #(#(#block 1 (push (add 1 1))))
		for: machine.
				
	self simplify.
	
	self assert: result intermediateForm = #(#(#block 1 (push (add 1 1)))).
	self verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 1/27/2006 22:42'!
testReceiverAddress
	source := MedMethod 
				createIntermediate: 
					#((block 1  (mov (receiverAddress) t1) ))
				for: machine.
	mockEmitter expectEmission:
		#( 	(block1			
				(mov #(#mem #(#add (simplifiedHomeContext) 24)) t1) )).
	
	self simplifyFullyMocked.

	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 2/11/2006 11:38'!
testReloadStack
	self createSimplifer.
	simplifier reloadStack: { (machine registerNamed: #t1) }.
	self should: 
			[self result = #(
						#(
							#block
							1
							#(#mov #currentContext #t2 )
							#(#mov #(#mem #(#add #t2 28 ) ) #t1 )
						)
					)]! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 2/11/2006 11:38'!
testReloadStack2
	self createSimplifer.
	simplifier reloadStack: {
				(machine registerNamed: #t1).
				(machine registerNamed: #t2).
				(machine registerNamed: #t3)
			}.
	self should: 
			[self result = #(
						#(
							#block
							1
							#(#mov #currentContext #t4 )
							#(#mov #(#mem #(#add #t4 28 ) ) #t1 )
							#(#mov #(#mem #(#add #t4 32 ) ) #t2 )
							#(#mov #(#mem #(#add #t4 36 ) ) #t3 )
						)
					)]! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 2/11/2006 11:38'!
testReloadStackWithTemps
	self createSimplifer.
	emitter numberOfTemporaries: 1.
	simplifier reloadStack: {
				(machine registerNamed: #t1).
				(machine registerNamed: #t2).
				(machine registerNamed: #t3)
			}.
	self should: 
			[self result = #(
						#(
							#block
							1
							#(#mov #currentContext #t4 )
							#(#mov #(#mem #(#add #t4 32 ) ) #t1 )
							#(#mov #(#mem #(#add #t4 36 ) ) #t2 )
							#(#mov #(#mem #(#add #t4 40 ) ) #t3 )
						)
					)]! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 2/11/2006 11:38'!
testReloadStackWithTempsInBlock
	self createSimplifer.
	medBlock makeBlockElement.
	emitter numberOfTemporaries: 1.
	simplifier reloadStack: {
				(machine registerNamed: #t1).
				(machine registerNamed: #t2).
				(machine registerNamed: #t3)
			}.
	self should: 
			[self result = #(
						#(
							#block
							1
							#(#mov #currentContext #t4 )
							#(#mov #(#mem #(#add #t4 28 ) ) #t1 )
							#(#mov #(#mem #(#add #t4 32 ) ) #t2 )
							#(#mov #(#mem #(#add #t4 36 ) ) #t3 )
						)
					)]! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 2/8/2006 21:12'!
testRestoreContext
	self createSimplifer.
	result := simplifier 
				restoreContextWithPC: 1
				stack: #().
	self should: 
		[self result = 
			#(#(#block 1 
				#(#mov 3 #(#mem #(#add #currentContext 8))) 
				#(#mov 1 #(#mem #(#add #currentContext 12))) 
				#(#mov #currentContext #t1)))	"not needed for this test but all sends will need
															to save at least the receiver so it should 															always be needed in practice"]! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 3/28/2006 22:52'!
testRestoreContextWithStack
	self createSimplifer.
	result := simplifier 
				restoreContextWithPC: 0
				stack: ({ 
						MedLiteral literal: #abc}).
	self should: 
		[self result = 
			#(#(#block 1 
				#(#mov 1 #(#mem #(#add #currentContext 8))) 
				#(#mov 3 #(#mem #(#add #currentContext 12)))
				#(#mov #currentContext #t1) 
				#(#mov #abc #(#mem #(#add #t1 28)))))]! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 3/28/2006 22:53'!
testRestoreContextWithStack2
	self createSimplifer.
	result := simplifier 
				restoreContextWithPC: 0
				stack: ({ 
						MedLiteral literal: #abc.
						MedLiteral literal: #def}).
	self should: 
		[self result = 
			#(#(#block 1 
				#(#mov 1 #(#mem #(#add #currentContext 8))) 
				#(#mov 5 #(#mem #(#add #currentContext 12))) 
				#(#mov #currentContext #t1) 
				#(#mov #abc #(#mem #(#add #t1 28))) 
				#(#mov #def #(#mem #(#add #t1 32)))))]! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 2/8/2006 21:12'!
testRestoreContextWithTemporaries
	self createSimplifer.
	emitter numberOfTemporaries: 1.
	result := simplifier 
				restoreContextWithPC: 0
				stack: ({ 
						MedLiteral literal: #abc}).
	self should: 
			[self result = 
				#(#(#block 1 
					#(#mov 1 #(#mem #(#add #currentContext 8))) 
					#(#mov 5 #(#mem #(#add #currentContext 12))) 
					#(#mov #currentContext #t1) 
					#(#mov #abc #(#mem #(#add #t1 32)))))]! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 3/4/2005 15:19'!
testRet
	source := MedMethod 
				createAssembly: #(#(#block 1 #(#ret)))
				for: machine.
	self simplify.
	self assert: result intermediateForm = #(#(#block 1 #(#ret))).
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 10/2/2004 10:42'!
testReturn
	source := MedMethod 
		createIntermediate: #((block 1 (return (add 1 1)) ))
		for: machine.
	mockEmitter expectEmission:
		#((block1 
			(expandedReturn (add 1 1)))).
				
	self simplifyFullyMocked.
	
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests - Blocks' stamp: 'wbk 1/5/2006 19:53'!
testReturnFromBlock
	source := MedMethod 
		createIntermediate: #((block 1 (return (add 1 1)) ))
		for: machine.
	(source blockAt: 1) makeBlockElement.
	mockEmitter expectEmission:
		#((block1 
			(expandedNonlocalReturn (add 1 1)))).
				
	self simplifyFullyMocked.
	
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 4/9/2006 13:24'!
testSaveRegistersAround
	| answer |
	mockEmitter expectEmission:
		#((block1
				(convertStackToRegisters)
				(saveStackPointerIntoContext)			
				(saveStackToContext)
				(mov anExpression t1)
				(loadCurrentContext)
				(reloadStack))).
	
	source := MedMethod new.
	simplifier := self makeFullyMocked.
	answer := simplifier saveRegistersAround: [#anExpression].
	
	self assert: answer intermediateForm = #t1.
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 10/25/2005 23:19'!
testSend
	source := MedMethod 
				createIntermediate: 
					#((block 1  (send selector pc arg1 arg2) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				#(#emitExpandedSend selector arg1 arg2 stack )). 
			).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 2/11/2006 11:45'!
testSendMessage
	| answer |
	self createFullyMocked.
	mockEmitter expectEmission: #(
				#(
					#block1
					#(
						#emitRestoreContext
						13
						#receiver
						#arg1
						#arg2
					)
					#(
						#mov
						#(#address 13 #block3 )
						#(#mem #(#add #(#currentContextAddress ) 20 ) )
					)
					#(#mov #(#emitClass #receiver ) #eax )
					#(#mov #picEntry #ecx )
					#(#mov #literalAddress #edx )
					#(#restoreSendersFrame )
					#(#pic #eax )
					#(
						#mov
						#(
							#callFunction
							#exuperySetupMessageSend
							#edx
							2
							#ecx
						)
						#eax
					)
					#(#jz #block2 #(#cmp #eax 0 ) )
					#(#jmp #eax )
				)
				#(
					#block2
					#(#mov 1 #eax )
					#(#ret )
					#(#alignedLabel )
					#(#preamble )
					#(reloadStack #t1 )
				)
			).	"Call compiled method"	"Return to interpreter"
	mockEmitter 
		expectRegisterEntryPointPC: 27
		blockNumbered: #block3.
	mockEmitter newBlock. "To account for the first block"
	answer := simplifier 
				expandedSendSelector: (MedLiteral literal: #literalAddress)
				arguments: #(#receiver #arg1 #arg2 )
				pc: 12
				stack: #().
	self assert: (answer isKindOf: MedMachineRegister).	"This is inadiquate. What I really should do is check
												  that the answer is a reasonable type/object"
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 2/11/2006 10:59'!
testSendMessageCheckingPicEntry
	| picEntry |
	self createUnmocked.
	simplifier prepareBlockFrom: (MedBlock number: 1).
	simplifier 
		expandedSendSelector: (MedLiteral literal: #literalAddress)
		arguments: #(#receiver #arg1 #arg2 )
		pc: 12
		stack: #().
	picEntry := ((emitter result blockAt: 6) expressionAt: 10) picEntry class.
	self assert: picEntry = MedPicEntry.
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 10/25/2005 23:19'!
testSendWithComplexArguments
	source := MedMethod 
				createIntermediate: 
					#((block 1  (send selector pc (add 1 1) (add 2 2)) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				#(#emitExpandedSend selector (add 1 1) (add 2 2) stack)). 
			).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 10/30/2005 21:17'!
testSendWithDeconvertBooleanAndStackVariableArguments
	source := MedMethod 
		createIntermediate: 
			#((block 1  
				(deconvertBoolean falseObj s2 block2 1 0)
				(send selector pc arg3) 
			))
		for: machine.
	(source blockAt: 1) initialStackHeight: 2.			
	mockEmitter expectEmission:
		#((block1			
				(#conditionalJumpTo block2 #falseObj #s2 1)
				(emitExpandedSend selector arg3 stack s1	)) ).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 2/11/2006 11:45'!
testSendWithStack
	| answer |
	self createFullyMocked.
	mockEmitter expectEmission: #(
				#(
					#block1
					#(
						#emitRestoreContext
						11
						#s3
						#s4
						#arg4
						#arg5
					)
					#(
						#mov
						#(#address 11#block3 )
						#(#mem #(#add #(#currentContextAddress ) 20 ) )
					)
					#(#mov #(#emitClass #arg4 ) #eax )
					#(#mov #picEntry #ecx )
					#(#mov #literalAddress #edx )
					#(#restoreSendersFrame )
					#(#pic #eax )
					#(
						#mov
						#(
							#callFunction
							#exuperySetupMessageSend
							#edx
							1
							#ecx
						)
						#eax
					)
					#(#jz #block2 #(#cmp #eax 0 ) )
					#(#jmp #eax )
				)
				#(
					#block2
					#(#mov 1 #eax )
					#(#ret )
					#(#alignedLabel )
					#(#preamble )
					#(reloadStack #s3 #s4 #t1 )
				)
			).
	"A real block begins here"
	mockEmitter 
		expectRegisterEntryPointPC: 23
		blockNumbered: #block3.	"An encoded SmallInteger"
	mockEmitter newBlock. "To account for the first block"
	answer := simplifier 
				expandedSendSelector: (MedLiteral literal: #literalAddress)
				arguments: #(#arg4 #arg5 )
				pc: 10
				stack: #(#s3 #s4 ).
	self assert: (answer isKindOf: MedLanguage).	"This is inadiquate. What I really should do is check
												  that the answer is a reasonable type/object"
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 2/11/2006 11:45'!
testSendWithStack2
	| answer |
	self createFullyMocked.
	mockEmitter expectEmission: #(
				#(
					#block1
					#(
						#emitRestoreContext
						11
						#s1
						#s2
						#s3
						#arg4
						#arg5
						#arg6
					)
					#(
						#mov
						#(#address 11 #block3 )
						#(#mem #(#add #(#currentContextAddress ) 20 ) )
					)
					#(#mov #(#emitClass #arg4 ) #eax )
					#(#mov #picEntry #ecx )
					#(#mov #literalAddress #edx )
					#(#restoreSendersFrame )
					#(#pic #eax )
					#(
						#mov
						#(
							#callFunction
							#exuperySetupMessageSend
							#edx
							2
							#ecx
						)
						#eax
					)
					#(#jz #block2 #(#cmp #eax 0 ) )
					#(#jmp #eax )
				)
				#(
					#block2
					#(#mov 1 #eax )
					#(#ret )
					#(#alignedLabel )
					#(#preamble )
					#(reloadStack #s1 #s2 #s3 #t1 )
				)
			).
	"A real block begins here"
	mockEmitter 
		expectRegisterEntryPointPC: 23
		blockNumbered: #block3.	"An encoded SmallInteger"
	mockEmitter newBlock. "To account for the first block"
	answer := simplifier 
				expandedSendSelector: (MedLiteral literal: #literalAddress)
				arguments: #(#arg4 #arg5 #arg6 )
				pc: 10
				stack: #(#s1 #s2 #s3 ).
	self assert: (answer isKindOf: MedLanguage).	"This is inadiquate. What I really should do is check
												  that the answer is a reasonable type/object"
	self verify! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 2/8/2006 22:41'!
testSendWithStackAndStackVariableArguments
	source := MedMethod 
		createIntermediate: 
			#((block 1  
				(send selector pc s2 arg2)
				(send selector pc arg3) 
			))
		for: machine.
	(source blockAt: 1) initialStackHeight: 2.			
	mockEmitter expectEmission:
		#((block1 
			(emitExpandedSend selector s2 arg2 stack s1)
			(emitExpandedSend selector arg3 stack s1) )).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Sends and Returns' stamp: 'wbk 10/31/2005 22:10'!
testSendWithStackPush
	source := MedMethod 
		createIntermediate: 
			#((block 1  
				(stackPush value1 s1)
				(send selector pc arg1 arg2) ))
		for: machine.
	(source blockAt: 1) initialStackHeight: 0.			
	mockEmitter expectEmission:
		#(	(block1 
				(mov value1 s1)
				(emitExpandedSend selector arg1 arg2 stack s1)). 
			).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 3/27/2005 14:03'!
testSideEffectingLabel
	source := MedMethod 
				createIntermediate: 
					#((block 1  (sideEffectsLabel () () (add t1 t1) (sub t2 t2) block2 ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(add t1 t1)
				(jmp block3))
			(block2 
				(sub t2 t2)
				(jmp block3)) 
			(block3)).
			
	self simplifyFullyMocked.
	
	"The label should return t1"
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 2/8/2006 21:27'!
testSimplifyReceiverAddress
	result := #().
	mockEmitter addExpectedEmission:
		#(#mem #(#add (simplifiedHomeContext) 24)).
	
	self createFullyMocked.
  	simplifier simplifiedReceiverAddress.

	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 1/27/2006 22:11'!
testStoreInReceiver
	"Just a hack to get this working."

	mockEmitter initialiseMachine: machine.
	source := MedMethod 
		createIntermediate: 
			#(#(#block 1 
				#(#mov #(#storeInReceiver 5 #theValue) #answer)))
		for: machine.
	mockEmitter 
		expectEmission: 
			#(#(#block1 
				#(#mov #theValue #t1) 
				#(#emitBeRootIfNeeded 
				#(#simplifiedReceiverAddress) #t1) 
				#(#mov #t1 #(simplifiedInstanceVariableAddress 5)) 
				#(#mov #t1 #answer))).
	self simplifyFullyMocked.
	self verify.
	mockEmitter verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 1/27/2006 22:16'!
testStoreInReceiverNested
	"Just a hack to get this working."

	mockEmitter initialiseMachine: machine.
	source := MedMethod 
		createIntermediate: 
			#(#(#block 1 #(#storeInReceiver 5 #(#mov 1 1))))
		for: machine.
	mockEmitter expectEmission: 
		#(#(#block1 
			#(#mov #(#mov 1 1) #t1) 
			#(#emitBeRootIfNeeded 
			#(simplifiedReceiverAddress) #t1) 
			#(#mov #t1 #(#simplifiedInstanceVariableAddress 5)))).
	self simplifyFullyMocked.
	self verify.
	mockEmitter verify! !

!IntermediateSimplifierTests methodsFor: 'Tests' stamp: 'wbk 1/14/2006 22:19'!
testStoreInTemp
	"Just a hack to get this working."
	mockEmitter initialiseMachine: machine.
	
	source := MedMethod 
				createIntermediate: 
					#((block 1  (storeInTemp 42 anExpression ) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(mov anExpression t1)
				(mov t1 (simplifiedTemporaryAddress 42)) )).
			
	self simplifyMocked.
	
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 6/13/2005 22:26'!
testTypeSwitch
	| |
	Exupery initialiseExupery.
	source := MedMethod 
		createIntermediate: 
			#((block 1 
				(add checkingReturnValue (typeSwitch (receiver) (t1) block2
					((ExuperyTests (add primitive primitive)) )
					(add sendMessage onFailure) ) )))
		for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(mov receiver t1)
				(jne block2 (cmp (emitFetchAddress 0 (mem methodArray)) (emitClass t1) ))
				(mov (add primitive primitive) t2)
				(jmp block3))
			(block2 
				(mov (add sendMessage onFailure) t2)
				(jmp block3) ) 
			(block3
				(add checkingReturnValue t2))).
			
	self simplifyFullyMocked.
	
	"The label should return t1"
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 6/16/2005 21:49'!
testTypeSwitchCompactClass
	| |
	Exupery initialiseExupery.
	source := MedMethod 
		createIntermediate: 
			#((block 1 
				(add checkingReturnValue (typeSwitch (receiver) (t1) block2
					((Array (add primitive primitive)) )
					(add sendMessage onFailure) ) )))
		for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(mov receiver t1)
				(emitCheckIsNotInteger t1 block2)
				(jne block2 (cmp  12288 (and (mem t1) 126976) )) "mask out the section and 
																		compare with shifted
																		compact class number"
				(mov (add primitive primitive) t2)
				(jmp block3))
			(block2 
				(mov (add sendMessage onFailure) t2)
				(jmp block3) ) 
			(block3
				(add checkingReturnValue t2))).
			
	self simplifyFullyMocked.
	
	"The label should return t1"
	self verify. 
	mockEmitter verify.! !

!IntermediateSimplifierTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 6/13/2005 22:36'!
testTypeSwitchTwoArgs
	| |
	Exupery initialiseExupery.
	source := MedMethod 
		createIntermediate: 
			#((block 1 
				(add checkingReturnValue (typeSwitch (receiver arg1) (t1 t2) block2
					((ExuperyTests (add t1 t2)) )
					(add t1 t2) ) )))
		for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(mov receiver t1)
				(mov arg1 t2)
				(jne block2 (cmp (emitFetchAddress 0 (mem methodArray)) (emitClass t1) ))
				(mov (add t1 t2) t3)
				(jmp block3))
			(block2 
				(mov (add t1 t2) t3)
				(jmp block3) ) 
			(block3
				(add checkingReturnValue t3))).
			
	self simplifyFullyMocked.
	
	"The label should return t1"
	self verify. 
	mockEmitter verify.! !

IntermediateCopierTests subclass: #LowLevelOptimiserTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 2/3/2006 21:32'!
testAddress
	| optimiser |
	source := MedMethod 
				createIntermediate: 
					#((block 1  (mov (addressOf byteCodeAddress block1) t1) ))
				for: machine.	
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.	
	self assert: result intermediateForm = #((block 1  (mov (addressOf byteCodeAddress block1) t1) )).! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 3/26/2005 16:45'!
testCmp
	| optimiser |
	source := MedMethod 
				createIntermediate: 
					#((block 1 (cmp eax ebx) ))
				for: machine.	
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.	
	self assert: result intermediateForm = #((block 1  (cmp eax ebx) )).! !

!LowLevelOptimiserTests methodsFor: 'Tests - Copying' stamp: 'wbk 1/22/2005 15:49'!
testCopyAlignedFlag
	| optimiser | 
	machine := MachineX86 new.
	source := MedMethod
		createIntermediate: #((block 1) (block 2))
		for: machine.
	(source blockAt: 2) makeAligned.
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.	
	self assert: (result blockAt: 1) isAligned not.
	self assert: (result blockAt: 2) isAligned.! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 1/22/2005 16:07'!
testDontRemoveAfterConditionalJumps
	| optimiser |
	source := MedMethod 
				createIntermediate: 
					#((block 1 (jz block1 (sub 1 1) ) (jmp block2) ))
				for: machine.	
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.	
	self assert: result intermediateForm = #((block 1  (jz block1 (sub 1 1) ) (jmp block2) ) (block 2)).! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 2/26/2005 09:57'!
testPic
	| optimiser |
	source := MedMethod 
				createIntermediate: 
					#((block 1 (pic t1) ))
				for: machine.	
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.	
	self assert: result intermediateForm = #((block 1  (pic t1) )).! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 15:36'!
testPop
	| optimiser |
	source := MedMethod 
				createIntermediate: 
					#((block 1 (pop eax) ))
				for: machine.	
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.	
	self assert: result intermediateForm = #((block 1  (pop eax) )).! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 4/9/2005 23:01'!
testRemoveArithmaticTagging
	| optimiser |
	source := MedMethod 
				createIntermediate: #(#(#block 1 (or 1 (jo block2 (add (sub t1 1) 42))) ))
				for: machine.
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.
	self assert: result intermediateForm = #((block 1 (jo block2 (add t1 42))) (block 2) )! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 4/9/2005 23:01'!
testRemoveArithmaticTagging2
	| optimiser |
	source := MedMethod 
				createIntermediate: #(#(#block 1 (or 1 (jo block2 (sub (sub t1 1) 42))) ))
				for: machine.
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.
	self assert: result intermediateForm = #((block 1 (jo block2 (sub t1 42))) (block 2) )! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 4/8/2005 23:09'!
testRemoveArithmaticTagging3
	| optimiser |
	source := MedMethod 
				createIntermediate: #(#(#block 1 (or 1 (jo block2 (add (sub t1 1) (sub t2 1)))) ))
				for: machine.
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.
	self assert: result intermediateForm = #((block 1 (jo block2 (add t1 (sub t2 1)))) (block 2) )! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 4/9/2005 23:08'!
testRemoveArithmaticTaggingMul
	| optimiser |
	"This optimisation only works for additions and subtractions."
	source := MedMethod 
				createIntermediate: #(#(#block 1 (or 1 (jo block2 (mul (sub t1 1) 42))) ))
				for: machine.
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.
	self assert: result intermediateForm = #((block 1 (or 1 (jo block2 (mul (sub t1 1) 42)))) (block 2) )! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 4/8/2005 21:32'!
testRemoveCmpTagging
	| optimiser |
	source := MedMethod 
				createIntermediate: #(#(#block 1 (cmp (sub t1 1) (sub t2 1))))
				for: machine.
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.
	self assert: result intermediateForm = #(#(#block 1 #(cmp t1 t2)) )! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 1/22/2005 16:08'!
testRemoveRedundantJumps
	| optimiser |
	source := MedMethod 
				createIntermediate: 
					#((block 1 (jmp block1) (jmp block2) ))
				for: machine.	
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.	
	self assert: result intermediateForm = #((block 1  (jmp block1) ) (block 2)).! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 3/4/2005 15:11'!
testRemoveRedundantJumpsAfterRet
	| optimiser |
	source := MedMethod 
				createIntermediate: #(#(#block 1 #(#ret) #(#jmp #block2)))
				for: machine.
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.
	self assert: result intermediateForm = #(#(#block 1 #(#ret)) #(#block 2))! !

!LowLevelOptimiserTests methodsFor: 'Tests' stamp: 'wbk 1/22/2005 16:18'!
testResetJumpRemovalOnNextBlock
	| optimiser |
	source := MedMethod 
				createIntermediate: 
					#((block 1 (jmp block1)) (block 2 (jmp block2) ))
				for: machine.	
	optimiser := LowLevelOptimiser 
				from: source
				machine: machine.
	result := optimiser run.	
	self assert: result intermediateForm = #((block 1  (jmp block1) ) (block 2 (jmp block2))).! !

IntermediateCopierTests subclass: #TreeOptimiserTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!TreeOptimiserTests methodsFor: 'Misc' stamp: 'wbk 12/21/2004 12:43'!
operationClass
	^ TreeOptimiser! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/27/2004 10:46'!
testAtElementAddress
	source := MedMethod 
				createIntermediate: 
					#((block 1  (atElementAddress 42 1 block2 0 ) ))
				for: machine.				
	mockEmitter expectEmission:
		#((block1 
		 	(emitAtElementAddress 42 1 block2 0 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/27/2004 10:47'!
testAtPut
	source := MedMethod 
				createIntermediate: 
					#((block 1  (atPut receiver location value block2 0) ))
				for: machine.				
	mockEmitter expectEmission:
		#((block1 
		 	(atPut receiver location value block2) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/22/2004 21:24'!
testBitShift
	source := MedMethod 
				createIntermediate: #(#(#block 1 (bitShift 13 5 block2)))
				for: machine.					
	mockEmitter expectEmission:
		#((block1 
		 	(bitShift block2 13 5 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 2/1/2006 21:16'!
testBlockCreation
	source := MedMethod 
				createIntermediate: 
					#((block 1  (blockCopy 1 #byteCodeAddress (activeContext) block2) ))
				for: machine.									
	"mockEmitter expectEmission:
		#((block1 (createBlock block2) ))."
				
	self simplify.
	self assert: result intermediateForm = 
		#((block 1 
			(createBlock 1 #byteCodeAddress block2) ) 
      	  (block 2)).
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/8/2005 22:54'!
testBlockReturn
	source := MedMethod 
				createIntermediate: 
					#((block 1  (blockReturn (add 10 20)) ))
				for: machine.									
	"mockEmitter expectEmission:
		#((block1 (createBlock block2) ))."
				
	self simplify.
	self assert: result intermediateForm = #((block 1 (blockReturn (add 10 20)) )).
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/21/2004 17:11'!
testConvertBoolean
	source := MedMethod 
				createIntermediate: 
					#((block 1  (convertBoolean jg anExpression ) ))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(emitConvertComparisionToBoolean jg anExpression ))).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests - Copying' stamp: 'wbk 10/26/2005 20:51'!
testCopyInitialStackHeight
	| optimiser | 
	machine := MachineX86 new.
	source := MedMethod
		createIntermediate: #((block 1) (block 2))
		for: machine.
	(source blockAt: 1) initialStackHeight: 10.
	(source blockAt: 2) initialStackHeight: 20.
	optimiser := TreeOptimiser 
				from: source
				machine: machine.
	result := optimiser run.	
	self assert: (result blockAt: 1) initialStackHeight = 10.
	self assert: (result blockAt: 2) initialStackHeight = 20.! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 1/18/2006 23:10'!
testCreateBlockContext
	source := MedMethod 
				createIntermediate: 
					#((block 1  (createBlockContext 0) ))
				for: machine.									
	"mockEmitter expectEmission:
		#((block1 (createBlock block2) ))."
				
	self simplify.
	self assert: result intermediateForm = #((block 1 (createBlockContext 0) )).
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/8/2005 21:27'!
testCreateContext
	source := MedMethod 
		createIntermediate: #((block 1 (createContext) ))
		for: machine.
	"mockEmitter expectEmission:
		#((block1 
			(createContext)))."
				
	self simplify.

	self assert: result intermediateForm = #((block 1 (createContext))).
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 10/25/2005 22:53'!
testDeconvertBoolean
	source := MedMethod 
				createIntermediate: 
					#((block 1  (deconvertBoolean falseObj anExpression block2 1 0) )
						(block 2 ))
				for: machine.
	mockEmitter expectEmission:
		#((block1 
			(deconvertBoolean falseObj anExpression block2 1) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 1/14/2006 17:22'!
testHomeContext
	source := MedMethod 
		createIntermediate: #((block 1 (homeContext) ))
		for: machine.
	"mockEmitter expectEmission:
		#((block1 
			(createContext)))."
				
	self simplify.

	self assert: result intermediateForm = #((block 1 (homeContext))).
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 1/27/2006 22:03'!
testInstanceVariableAddress
	source := MedMethod 
		createIntermediate: #((block 1 (mov (instanceVariableAddress 5) t1) ))
		for: machine.
	"mockEmitter expectEmission:
		#((block1 
			(createContext)))."
				
	self simplify.

	self assert: result intermediateForm = #((block 1 (mov (instanceVariableAddress 5) t1))).
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/25/2004 17:34'!
testIntegerValueOf
	source := MedMethod 
				createIntermediate: 
					#((block 1  (integerValueOf arg block2 ) ))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(emitIntegerValueOf block2 arg))).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests - Jump Removal' stamp: 'wbk 1/5/2006 21:10'!
testJumpRemoval
	source := MedMethod 
				createIntermediate: 
					#((block 1  
						(jmp block2) 
						(jmp block2) ))
				for: machine.									
	mockEmitter expectEmission:
		#((block1 (jmp block2) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests - Jump Removal' stamp: 'wbk 1/5/2006 22:01'!
testJumpRemovalBlockReturn
	source := MedMethod 
				createIntermediate: 
					#((block 1  
						(blockReturn 85) 
						(jmp block2) ))
				for: machine.									
	mockEmitter expectEmission:
		#((block1 (blockReturn 85) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests - Jump Removal' stamp: 'wbk 1/5/2006 22:25'!
testJumpRemovalBlockReturnWithNestedJump
	source := MedMethod 
				createIntermediate: 
					#((block 1  
						(blockReturn (jo block2 85)) 
						(jmp block2) ))
				for: machine.									
	mockEmitter expectEmission:
		#((block1 (blockReturn (jo block2 85)) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests - Jump Removal' stamp: 'wbk 1/5/2006 22:04'!
testJumpRemovalReturn
	source := MedMethod 
				createIntermediate: 
					#((block 1  
						(return 85) 
						(jmp block2) ))
				for: machine.									
	mockEmitter expectEmission:
		#((block1 (emitReturnValue 85) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests - Jump Removal' stamp: 'wbk 1/5/2006 22:17'!
testJumpRemovalReturnWithNestedJump
	source := MedMethod 
				createIntermediate: 
					#((block 1  
						(return (jo block2 85)) 
						(jmp block2) ))
				for: machine.									
	mockEmitter expectEmission:
		#((block1 (emitReturnValue (jo block2 85)) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests - Jump Removal' stamp: 'wbk 1/5/2006 21:19'!
testJumpRemovalTwoBlocks
	source := MedMethod 
				createIntermediate: 
					#((block 1  
							(jmp block2) 
							(jmp block2)) 
					   	(block 2 (jmp block3)) )
				for: machine.									
	mockEmitter expectEmission:
		#((block1 (jmp block2) )
			(block2 (jmp block3))).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/21/2004 15:40'!
testLabelWithArguments
	source := MedMethod 
				createIntermediate: 
					#((block 1  (label (arg1 arg2) (t1 t2) 
						(add t1 t2) 
						(sub t1 t2) 
						block2 ) ))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(label1 block2 arg1 arg2 t1 t2 
						(add t1 t2) 
						(sub t1 t2) 
						 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/22/2004 21:33'!
testMidDiv
	source := MedMethod 
				createIntermediate: 
					#((block 1  (midDiv 13 5 block2 ) ))
				for: machine.							
	mockEmitter expectEmission:
		#((block1 (emitDiv block2 13 5  ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/22/2004 21:35'!
testMidDivide
	source := MedMethod 
				createIntermediate: 
					#((block 1  (midDivide 13 5 block2 ) ))
				for: machine.									
	mockEmitter expectEmission:
		#((block1 (emitDivide block2 13 5  ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/22/2004 21:38'!
testMidMod
	source := MedMethod 
				createIntermediate: 
					#((block 1  (midMod 13 5 block2 ) ))
				for: machine.									
	mockEmitter expectEmission:
		#((block1 (emitMod block2 13 5  ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 10/25/2005 22:54'!
testOptimiseBooleanConversion
	source := MedMethod 
				createIntermediate: 
					#((block 1  
						(deconvertBoolean falseObj
							(label (arg1 arg2) (t1 t2) 
								(convertBoolean jg (add t1 t2))
								(sub t1 t2) 
								block2 )
							block3 1 0) 
							)
					(block 2)
					(block 3))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(sideEffectsLabel1 block2 arg1 arg2 t1 t2 
						(jg block3 (add t1 t2) )
						(deconvertBoolean falseObj (sub t1 t2) block3 1)
						 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 10/25/2005 22:54'!
testOptimiseBooleanConversion2
	source := MedMethod 
				createIntermediate: 
					#((block 1  
						(deconvertBoolean trueObj
							(label (arg1 arg2) (t1 t2) 
								(convertBoolean jg (add t1 t2))
								(sub t1 t2) 
								block2 )
							block3 1 0) 
							)
					(block 2)
					(block 3))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(sideEffectsLabel1 block2 arg1 arg2 t1 t2 
						(jle block3 (add t1 t2) )
						(deconvertBoolean trueObj (sub t1 t2) block3 1)
						 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 10/25/2005 22:54'!
testOptimiseBooleanConversion3
	source := MedMethod 
				createIntermediate: 
					#((block 1  
						(deconvertBoolean trueObj
							(label (arg1 arg2) (t1 t2) 
								(convertBoolean jne (add t1 t2))
								(sub t1 t2) 
								block2 )
							block3 1 0) 
							)
					(block 2)
					(block 3))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(sideEffectsLabel1 block2 arg1 arg2 t1 t2 
						(je block3 (add t1 t2) )
						(deconvertBoolean trueObj (sub t1 t2) block3 1)
						 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 10/25/2005 22:55'!
testOptimiseBooleanConversionWithSideEffectingLabel
	source := MedMethod 
				createIntermediate: 
					#((block 1  
						(deconvertBoolean falseObj
							(sideEffectsLabel (arg1 arg2) (t1 t2) 
								(convertBoolean jg (add t1 t2))
								(sub t1 t2) 
								block2 )
							block3 1 0) 
							)
					(block 2)
					(block 3))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(sideEffectsLabel1 block2 arg1 arg2 t1 t2 
						(jg block3 (add t1 t2) )
						(deconvertBoolean falseObj (sub t1 t2) block3 1)
						 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 3/27/2005 21:23'!
testOptimiseConstantIntegerValueOf
	source := MedMethod 
				createIntermediate: 
					#((block 1  (mov (integerValueOf 11 block2 ) t1)))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(mov 10 t1))).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/25/2004 12:47'!
testOptimiseConstantLabel
	source := MedMethod 
				createIntermediate: 
					#((block 1  (label (11 arg2) (t1 t2) 
						(add t1 t2) 
						(sub t1 t2) 
						block2 ) ))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(label1 block2  arg2 t2 
						(add 11 t2) 
						(sub 11 t2) 
						 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 5/30/2005 17:33'!
testPrimitiveReturn
	source := MedMethod 
		createIntermediate: #((block 1 (primitiveReturn 2 (add 1 1)) ))
		for: machine.
	mockEmitter expectEmission:
		#((block1 
			(primitiveReturn (add 1 1) 2))).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 1/27/2006 20:37'!
testReceiverAddress
	source := MedMethod 
		createIntermediate: #((block 1 (receiverAddress) ))
		for: machine.
	"mockEmitter expectEmission:
		#((block1 
			(createContext)))."
				
	self simplify.

	self assert: result intermediateForm = #((block 1 (receiverAddress))).
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/21/2004 13:52'!
testReturn
	source := MedMethod 
		createIntermediate: #((block 1 (return (add 1 1)) ))
		for: machine.
	mockEmitter expectEmission:
		#((block1 
			(emitReturnValue (add 1 1)))).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 10/25/2005 23:14'!
testSend
	source := MedMethod  
				createIntermediate: 
					#((block 1  (send selector pc arg1 arg2) ))
				for: machine.			
	mockEmitter expectEmission:
		#(	(block1 
				(emitSend selector pc arg1 arg2)). 
			).
			
	self simplifyFullyMocked.
	
	self verify. 
	mockEmitter verify.! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 3/27/2005 14:39'!
testSideEffectingLabelWithArguments
	source := MedMethod 
				createIntermediate: 
					#((block 1  (sideEffectsLabel (arg1 arg2) (t1 t2) 
						(add t1 t2) 
						(sub t1 t2) 
						block2 ) ))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(sideEffectsLabel1 block2 arg1 arg2 t1 t2 
						(add t1 t2) 
						(sub t1 t2) 
						 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 10/31/2005 22:05'!
testStackPush
	source := MedMethod 
				createIntermediate: 
					#((block 1  (stackPush 13 s1 ) ))
				for: machine.									
	mockEmitter expectEmission:
		#((block1 (stackPush 13 s1 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 11/30/2005 22:38'!
testStackPush2
	source := MedMethod 
				createIntermediate: 
					#((block 1  (stackPush (add 10 20) s1 ) ))
				for: machine.									
	mockEmitter expectEmission:
		#((block1 (stackPush (add 10 20) s1 ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/22/2004 20:56'!
testStoreInReceiver
	source := MedMethod 
				createIntermediate: 
					#((block 1  (mov (storeInReceiver 5 theValue ) answer) ))
				for: machine.						
	mockEmitter expectEmission:
		#((block1 
		 	(mov (storeInReceiver 5 theValue ) answer) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 12/22/2004 20:19'!
testStoreInTemp
	source := MedMethod 
				createIntermediate: 
					#((block 1  (storeInTemp 42 anExpression ) ))
				for: machine.	
	mockEmitter expectEmission:
		#((block1 
			(storeInTemp 42 anExpression ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

!TreeOptimiserTests methodsFor: 'Tests' stamp: 'wbk 11/6/2005 20:19'!
testTypeSwitch
	source := MedMethod 
		createIntermediate: 
			#((block 1 (typeSwitch (receiver) (t1) block2
				((ExuperyTests (primitive at: Array block2 receiver arg1))) 
				(send at:  42 2 receiver arg1) ) ))
			for: machine.	
	mockEmitter expectEmission:
		#((block1 (typeSwitch receiver t1 block2
			ExuperyTests (primitive at: block2 receiver arg1) 
			(emitSend at: 42 2 receiver arg1) ) )).
				
	self simplifyFullyMocked.
	
	self verify! !

ExuperyTests subclass: #IntermediateEmissionTests
	instanceVariableNames: 'machine generator emitter result mockEmitter state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!IntermediateEmissionTests methodsFor: 'Misc' stamp: 'wbk 8/8/2004 13:02'!
result
	^ generator result intermediateForm! !

!IntermediateEmissionTests methodsFor: 'Misc' stamp: 'wbk 5/28/2005 22:29'!
setUp
	machine := MockExuperyPlugin new.
	generator := IntermediateGenerator for: machine.
	emitter := IntermediateEmitter 
				machine: machine
				jumpTargets: #()
				inlining: #().
	state := ExuperyStack 
				newPC: 10
				emitter: emitter.
	emitter state: state.
	generator emitter: emitter! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 10/2/2004 12:09'!
testAddLiteralToCurrentBlock
	emitter addExpression: (MedLiteral literal: 42).
	self assert: self result = #((block 1))! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 10/2/2004 11:54'!
testAddRegisterToCurrentBlock
	emitter addExpression: emitter createTemporaryRegister.
	self assert: self result = #((block 1))! !

!IntermediateEmissionTests methodsFor: 'Tests - Object Access' stamp: 'wbk 5/8/2005 20:58'!
testAddressOfArrayElement
 	mockEmitter := MockIntermediateEmitter newWith: emitter machine.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#((block1 
				"check argument"
				(emitCheckIsInteger index block2)
				(jg block2 (cmp 3 index) )
				"Get size and range check"
				(jge block2 (cmp (sar index 1) (sizeOfObject receiver))) )).
	mockEmitter addExpectedEmission: #(mem (add receiver (sal (sub index 1) 1)) ).
	result := emitter 
		addressOfIndexedElementIn: #receiver 
		at: #index 
		failTo: #block2.
	self verify.
	self assert: result =  #(mem (add receiver (sal (sub index 1) 1)) ).! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/27/2004 23:04'!
testBasicStack
	| stack |
	mockEmitter := MockIntermediateEmitter newWith: MachineX86 new.
	mockEmitter expectEmission: 
		#( (block1
				(mov firstValue s1)
				(mov secondValue s2))).
	stack := ExuperyStack 
		newPC: 1
		emitter: mockEmitter.
		
	stack push: #firstValue.
	stack push: #secondValue.

	self assert: stack pop name = #s2.
	self assert: stack pop name = #s1.
	mockEmitter verify.
	! !

!IntermediateEmissionTests methodsFor: 'Tests - Object Access' stamp: 'wbk 8/19/2005 22:05'!
testClass
	mockEmitter := MockIntermediateEmitter newWith: emitter machine.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#(#(#block1 
			(mov theReceiver t1)
			#(#emitCheckIsInteger t1 #block2) 
			#(#mov #(#emitSpecialObject 5) #t2) 
			#(#jmp #block4)) 
		#(#block2 
			#(#mov #(#and 31 #(#sar #(#mem t1) 12)) #t3) 
			#(#je #block3 #(cmp 0 #t3)) 
			#(#mov #(#emitFetchVariableAddress #(#sub #t3 1) 
			#(#emitSpecialObject 28)) #t2) 
			#(#jmp #block4)) 
		#(#block3 
			#(#mov #(#and 4294967292 #(#mem #(#sub t1 4))) #t2) 
			#(#jmp #block4)) 
		#(#block4)).
	result := emitter classOf: (MedLiteral literal: #theReceiver).
	self verify.
	self assert: result name = #t2.
	self assert: mockEmitter currentBlock = #block4! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 3/27/2005 18:04'!
testConditionalByteCode
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter addExpectedEmission: 
		#(emitWithFailTo 3 5 #t1 #t2 
			#(#emitConvertComparisionToBoolean #jge 
				#(#cmp 
					#(#emitIntegerValueOf #block2 #t1) 
					#(#emitIntegerValueOf #block2 #t2))) 2).
	result := emitter 
				conditionalBytecodeArg1: (MedLiteral smallInteger: 1)
				arg2: (MedLiteral smallInteger: 2)
				withJump: #jge
				failureSelector: 2.
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 8/8/2003 20:35'!
testEmitAdd
	result := emitter 
		emit: (MedLiteral literal: 10)
		add: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(add 10 20)! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/1/2006 23:00'!
testEmitAddressOf
	result := emitter 
		addressOf: emitter newBlock
		byteCodeAddress: #byteCodeAddress.
	self should: [result intermediateForm = #(addressOf byteCodeAddress block2)]! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/4/2004 23:38'!
testEmitAnd
	result := emitter 
		emit: (MedLiteral literal: 10)
		and: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(and 10 20)! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 3/27/2005 18:16'!
testEmitBeRootIfNessisary
	mockEmitter := MockIntermediateEmitter newWith: emitter machine.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#(#(#block1 
			#(#emitCheckIsNotInteger #pointedTo #block2) 
			#(#jl #block2 #(cmp #pointedTo #(#mem #(#youngStartAddress)))) 
			#(#jge #block2 #(cmp #root #(#mem #(#youngStartAddress)))) 
			#(#mov #(#mem #root) #t1) 
			#(#jnz #block2 #(#and #t1 1073741824)) 
			#(#mov #(#add 1 #(#mem #(#rootTableCountAddress))) #t2) 
			#(#mov #t2 #(#mem #(#rootTableCountAddress))) 
			#(#mov #root #(#mem #(#add #(#rootTableAddress) #(#sal #t2 2)))) 
			#(#mov #(#or #t1 1073741824) 
			#(#mem #root)) 
			#(#jmp #block2))).
	"An old object is receiving a pointer to a young object"
	" Now record the object as a new root"
	result := emitter 
				beRoot: #root
				ifNeededBy: #pointedTo.
	self assert: mockEmitter currentBlock = #block2.
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 12/12/2004 16:41'!
testEmitBitShift
	result := emitter 
				emit: (MedLiteral literal: 13)
				bitShift: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: generator result intermediateForm = 
		#(	(block 1)
			(block 2) "The failure block").
	self assert: result intermediateForm = #(bitShift 13 5 block2).
	self assert: emitter currentBlock blockName = #block1! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/4/2006 19:36'!
testEmitBlockAddressOf
	result := emitter 
		addressOf: emitter newBlock
		byteCodeAddress: #byteCodeAddress
		argumentCount: #argumentCount.
	self should: [result intermediateForm = #(blockAddress byteCodeAddress block2 argumentCount)]! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 3/30/2005 20:55'!
testEmitCheckIsNotInteger
	| failureBlock |
	failureBlock := emitter result newBlock.
	result := emitter 
				checkIsNotInteger: (MedLiteral literal: 10)
				failTo: failureBlock.
	self assert: generator result intermediateForm = #(#(#block 1 #(#jc #block2 #(bitTest 10 0))) #(#block 2))! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 3/26/2005 15:39'!
testEmitCmp
	result := emitter 
		emit: (MedLiteral literal: 10)
		cmp: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(cmp 10 20)! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 3/27/2005 18:27'!
testEmitConvertComparisionToBoolean
	result := emitter 
				convertComparisionToBoolean: (MedArithmatic 
						operator: #sub
						arg1: (MedLiteral literal: 2)
						arg2: (MedLiteral literal: 1))
				jumpType: #jg.
	self should: [result intermediateForm = #(#convertBoolean #jg #(sub 2 1))].
	self should: [emitter currentBlock blockName = #block1]! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 3/27/2005 22:45'!
testEmitConvertToSmallInteger
	result := emitter 
				convertToSmallInteger: (MedLiteral literal: 42)
				failTo: emitter newBlock.
	self should: [generator result intermediateForm = #(#(#block 1) #(#block 2))].
	self should: [result intermediateForm = #(#or 1 #(#jo #block2  42))].
	self should: [emitter currentBlock blockName = #block1]! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 12/22/2004 21:45'!
testEmitDiv
	result := emitter 
				emit: (MedLiteral literal: 13)
				div: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: generator result intermediateForm = #(#(#block 1) #(#block 2)).
	self assert: result intermediateForm = #(#midDiv 13 5 #block2).
	self assert: emitter currentBlock blockName = #block1! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 12/22/2004 21:46'!
testEmitDivide
	result := emitter 
				emit: (MedLiteral literal: 13)
				divide: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: generator result intermediateForm = #(#(#block 1) #(#block 2)).
	self assert: result intermediateForm = #(#midDivide 13 5 #block2)! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 3/27/2005 22:09'!
testEmitExpandedBitShift
	result := emitter 
				expanded: (MedLiteral literal: 13)
				bitShift: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: generator result intermediateForm = 
		#(#(#block 1 
			#(#mov 13 #t2) 
			#(#mov (sar 5 1) #t3) 
			#(#jl #block3 #(#cmp #t3 0)) 
			#(#jl #block2 #(#cmp 31 #t3)) 
			#(#mov #(#sal #t2 #t3) #t1) 
			#(#jnz #block2 #(#cmp #t2 #(#sar #t1 #t3))) 
			#(#jmp #block4)) 
		#(#block 2) 
		#(#block 3 
			#(#jl #block2 #(#cmp #t3 -31)) 
			#(#mov #(#sar #t2 #(#neg #t3)) #t1) 
			#(#jmp #block4)) 
		#(#block 4)).	"The failure block"	"t2 is the remander"
	self assert: result intermediateForm = #t1.
	self assert: emitter currentBlock blockName = #block4! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 4/1/2006 17:29'!
testEmitExpandedDiv
	result := emitter 
				expanded: (MedLiteral literal: 13)
				div: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: generator result intermediateForm = 
		#(#(#block 1 
			#(#je #block2 #(cmp 0 5)) 
			#(#mov (jo block2 (sal #(#div (sar 13 1) (sar 5 1) #t2) 1)) #t1) 
			#(#jl #block4 #(cmp 5 0)) 
			#(#jge #block3 #(cmp t2 0)) 
			#(#mov #(#sub #t1 1) #t1) 
			#(#jmp #block3)) 
		#(#block 2) 
		(block 3
			)
		#(#block 4
			(jle block3 (cmp t2 0))
			(mov (sub t1 1) t1)
			(jmp block3))).	"t2 is the remander"
	self assert: result intermediateForm = #t1.
	self assert: emitter currentBlock blockName = #block3! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 3/28/2005 13:23'!
testEmitExpandedDivide
	result := emitter 
				expanded: (MedLiteral literal: 13)
				divide: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: generator result intermediateForm = 
		#(#(#block 1 
			#(#je #block2 #(cmp 0 5)) 
			#(#mov (jo block2 (sal #(#div (sar 13 1) (sar 5 1) #t2) 1)) #t1) 
			#(#jne #block2 
			#(#sub 0 #t2))) 
		#(#block 2)).	"t2 is the remander"
	self assert: result intermediateForm = #t1! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 3/30/2005 20:39'!
testEmitExpandedIntegerValueOf
	result := emitter 
				expandedIntegerValueOf: (MedLiteral literal: 42)
				failTo: emitter newBlock.
	self should: 
		[self result = 
			#(#(#block 1 
				#(#mov 42 #t1) 
				#(#jnc #block2 #(bitTest #t1 0))) #(#block 2))].
	self should: [result intermediateForm = #(sub t1 1)].
	self should: [emitter currentBlock blockName = #block1]! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 4/1/2006 17:10'!
testEmitExtendedMod
	result := emitter 
				expanded: (MedLiteral literal: 13)
				mod: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: self result = 
		#(#(#block 1 
			#(#je #block2 #(cmp 0 5)) 
			#(#mov (sal #(#div 13 5 #t2) 1) #t1) 
			#(#jl #block4 #(cmp 5 0)) 
			#(#jge #block3 #(cmp t2 0)) 
			#(#mov #(#add #t2 5) #t2) 
			#(#jmp #block3))
		#(#block 2) 
		(block 3)
		#(#block 4
			(jle block3 (cmp t2 0))
			(mov (add t2 5) t2)
			(jmp block3))).	"t2 is the remander"
	self assert: result intermediateForm = #t2.
	self assert: emitter currentBlock blockName = #block3! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:53'!
testEmitFalseAddress
	result _ emitter falseAddress.
	self should: [result intermediateForm = #(#mem #falseObj)]! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:22'!
testEmitIntegerValueOf
	result _ emitter 
				integerValueOf: (MedLiteral literal: 42)
				failTo: emitter newBlock.
	self should: [self result = #(#(#block 1) #(#block 2))].
	self should: [result intermediateForm = #(#integerValueOf 42 #block2)].
	self should: [emitter currentBlock blockName = #block1]! !

!IntermediateEmissionTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 10/25/2005 22:51'!
testEmitJumpIfFalseTo
	| target |
	target := emitter newBlock.
	emitter exuperyStack pc: 10.
	emitter exuperyStack heightTo: 2.
	result := emitter 
				jumpIfFalseTo: target
				onBoolean: (MedLiteral literal: #anExpression).
	self assert: self result = 
		#(#(#block 1 #(#deconvertBoolean #falseObj #anExpression #block2 10)) 
		#(#block 2)).
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 10/25/2005 22:51'!
testEmitJumpIfTrueTo
	| target |
	target := emitter newBlock.
	emitter exuperyStack pc: 10.
	emitter exuperyStack heightTo: 2.
	result := emitter 
				jumpIfTrueTo: target
				onBoolean: (MedLiteral literal: #anExpression).
	self assert: self result = 
		#(#(#block 1 #(#deconvertBoolean #trueObj #anExpression #block2 10)) 
		#(#block 2)).
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 2/13/2005 12:46'!
testEmitJumpTarget
	| targetBlock |
	targetBlock _ emitter newBlock.
	emitter jumpTo: targetBlock.
	self should: [self result = #(#(#block 1 #(#jmp #block2)) #(#block 2))]! !

!IntermediateEmissionTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 8/8/2004 13:17'!
testEmitJumpTo
	| failureBlock |
	failureBlock := emitter result newBlock.
	result := emitter 
		jumpType: #jumpType
		to: failureBlock
		dependingOn: (MedLiteral literal: #instruction).
	self assert: result intermediateForm = #(jumpType block2 instruction) ! !

!IntermediateEmissionTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 2/13/2005 12:47'!
testEmitLabel
	| oldBlock answer |
	oldBlock _ emitter currentBlock.
	answer _ emitter label.
	self assert: oldBlock ~= emitter currentBlock.
	self assert: self result = #(#(#block 1 #(#jmp #block2)) #(#block 2)).
	self assert: (answer isKindOf: MedLanguage)! !

!IntermediateEmissionTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 5/28/2005 22:30'!
testEmitLabelForByteCode
	emitter := IntermediateEmitter 
				machine: machine
				jumpTargets: #(5 10 )
				inlining: #().
	generator emitter: emitter.
	result := emitter labelForByteCode: 10.
	self should: [result class = MedBlock].
	self should: [result blockName = #block3]! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/13/2005 12:03'!
testEmitMem
	result _ emitter mem: (MedLiteral literal: #address).
	self assert: result intermediateForm = #(#mem #address)! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 12/22/2004 21:47'!
testEmitMod
	result := emitter 
				emit: (MedLiteral literal: 13)
				mod: (MedLiteral literal: 5)
				failingTo: emitter newBlock.
	self assert: generator result intermediateForm = #(#(#block 1) #(#block 2)).
	self assert: result intermediateForm = #(#midMod 13 5 #block2).
	self assert: emitter currentBlock blockName = #block1! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/13/2005 12:44'!
testEmitMove
	result _ emitter 
				moveFrom: (MedLiteral literal: 1)
				to: (MedLiteral literal: 2).
	self assert: self result = #(#(#block 1 #(#mov 1 2)))! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/13/2005 12:43'!
testEmitMoveToTemp
	result _ emitter moveToTemp: (MedLiteral literal: 10).
	self assert: self result = #(#(#block 1 #(#mov 10 #t1))).
	self assert: result intermediateForm = #t1! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 3/27/2005 23:10'!
testEmitMultiply
	result := emitter 
				emit: (MedLiteral literal: 10)
				multiply: (MedLiteral literal: 20)
				failingTo: emitter newBlock.
	self assert: result intermediateForm =  #(#mul (sar 10 1) 20)! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:54'!
testEmitNilAddress
	result _ emitter nilAddress.
	self should: [result intermediateForm = #(#mem #nilObj)]! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 11/21/2003 00:02'!
testEmitOr
	result := emitter 
		emit: (MedLiteral literal: 10)
		or: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(or 10 20)! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/14/2006 22:54'!
testEmitPopIntoTemp
	mockEmitter := MockIntermediateEmitter newWith: machine.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: #(
				#(
					#block1
					#(#mov 3 #t1 )
					#(#mov #t1 #(#simplifiedTemporaryAddress 0 ) )
				)
			).
	result := emitter 
				expandedPopIntoTemp: (MedLiteral smallInteger: 1)
				slot: 0
				isInBlock: nil.
	"self should: 
			[emitter result intermediateForm = 
				#(#(#block 1 #(#mov 3 #t1) #(#mov #t1 #(#mem #(#add (homeContext) 28)))))].
	self should: [generator result numberOfBlocks = 1]."
	self assert: result name = #t1.
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/14/2006 22:54'!
testEmitPopIntoTemp2
	mockEmitter := MockIntermediateEmitter newWith: machine.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: #(
				#(
					#block1
					#(#mov 3 #t1 )
					#(#mov #t1 #(#simplifiedTemporaryAddress 2 ) )
				)
			).
	result := emitter 
				expandedPopIntoTemp: (MedLiteral smallInteger: 1)
				slot: 2
				isInBlock: nil.
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:30'!
testEmitRootTableAddress
	result _ emitter rootTableAddress.
	self should: [result intermediateForm = #rootTable]! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:30'!
testEmitRootTableCountAddress
	result _ emitter rootTableCountAddress.
	self should: [result intermediateForm = #rootTableCount]! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 11/21/2003 00:00'!
testEmitSal
	result := emitter 
		emit: (MedLiteral literal: 10)
		sal: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(sal 10 20)! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 3/7/2004 23:33'!
testEmitSar
	result := emitter 
				emit: (MedLiteral literal: 10)
				sar: (MedLiteral literal: 20).
	self assert: result intermediateForm = #(#sar 10 20)! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 1/27/2006 20:36'!
testEmitSelfAddress
	result := emitter receiverAddress.
	self assert: result intermediateForm = #(receiverAddress)! !

!IntermediateEmissionTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 3/27/2005 13:49'!
testEmitSideEffectsWithFailTo
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#(#(#block1 
			#(#sideEffectsLabel1 #block2 #arg1 #arg2 #t1 #t2 
				#(#aMethod #block2) 
				#(#emitSend #(#emitSpecialSelector 100) #t1 #t2))) 
		#(#block2)).
	result := emitter 
				sideEffectsWithFailTo: 
					[:arguments :failureBlock | 
					self assert: (arguments collect: [:each | each intermediateForm]) = #(#t1 #t2).
					mockEmitter check: ({ 
								#aMethod.
								failureBlock blockName})]
				failureSpecialSelector: 100
				arguments: #(#arg1 #arg2).

	self should: [mockEmitter currentBlock = #block1]! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 3/27/2005 19:20'!
testEmitSpecialSelector
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter addExpectedEmission: 
		#(#emitFetchAddress 10 #(#emitFetchAddress 23 #(#mem #specialObjectsOop))).
	result := emitter specialSelector: 5.
	self assert: result = #(#emitFetchAddress 10 #(#emitFetchAddress 23 #(#mem #specialObjectsOop))).
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Basic' stamp: 'wbk 2/7/2004 19:27'!
testEmitSubtract
	result := emitter 
		emit: (MedLiteral literal: 1)
		minus: (MedLiteral literal: 2).
	self should: [result intermediateForm = #(#sub 1 2)]! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:59'!
testEmitTrueAddress
	result _ emitter trueAddress.
	self should: [result intermediateForm = #(#mem #trueObj)]! !

!IntermediateEmissionTests methodsFor: 'Tests - Control Flow' stamp: 'wbk 3/27/2005 12:47'!
testEmitWithFailTo
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#(#(#block1 
			#(#label1 #block2 #arg1 #arg2 #t1 #t2 
				#(#aMethod #block2) 
				#(#emitSend #(#emitSpecialSelector 100) #t1 #t2))) 
		#(#block2)).
	result := emitter 
				withFailTo: 
					[:arguments :failureBlock | 
					self assert: (arguments collect: [:each | each intermediateForm]) = #(#t1 #t2).
					mockEmitter check: ({ 
								#aMethod.
								failureBlock blockName})]
				failureSpecialSelector: 100
				arguments: #(#arg1 #arg2).
	self should: 
			[result = 
				#(#label1 #block2 #arg1 #arg2 #t1 #t2 
					#(#aMethod #block2) 
					#(#emitSend #(#emitSpecialSelector 100) #t1 #t2))].
	self should: [mockEmitter currentBlock = #block1]! !

!IntermediateEmissionTests methodsFor: 'Tests - Addresses' stamp: 'wbk 2/13/2005 12:30'!
testEmitYoungStartAddress
	result _ emitter youngStartAddress.
	self should: [result intermediateForm = #youngStart]! !

!IntermediateEmissionTests methodsFor: 'Tests - Return' stamp: 'wbk 2/18/2006 18:07'!
testExpandedBlockReturn
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	"emitter newBlock. "	"Use the first block"
	mockEmitter expectEmission: 
		#(#(#block1 
			#(#mov #(#mem #(#add #currentContext 4)) #t1) 
			(mov (nilAddress) (mem (add currentContext 4)))
			#(#mov #(#add #(#mem #(#add #t1 12)) 2) #t2) 
			#(#mov #t2 #(#mem #(#add #t1 12))) 
			#(#mov #theValue #(#mem #(#add #(#add #t1 #(#sal #t2 1)) 22))) 
			(mov (nilAddress) (mem (add currentContext 8))) " Clear the interpreted IP and SP"
			#(#mov #t1 #(#currentContextAddress)) 
			#(#mov #(#nilAddress) #(#mem #(#add #currentContext 20))) 
			#(#beRootIfNessisary #(#currentContextAddress) #block2)) 
		#(#block2 
			#(#emitCheckIsNotInteger #(#mem #(#add #(#currentContextAddress) 16)) #block3) 
			#(#mov #(#mem #(#add #(#currentContextAddress) 20)) #t3) 
			#(#emitCheckIsInteger #t3 #block3) 
			#(#returnToCompiledMethod #(#sub #t3 1))) 
		#(#block3 
			#(#emitMoveToEax 1) 
			#(#returnSequence))).	
	result := emitter expandedBlockReturnValue: (MedLiteral literal: #theValue).
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Return' stamp: 'wbk 1/7/2006 18:05'!
testExtendedNonlocalReturn
	mockEmitter := MockIntermediateEmitter newWith: machine.
	emitter emitter: mockEmitter.
	"emitter newBlock. "	"Use the first block"
	mockEmitter expectEmission: 
		#(
		(block1
			(mov (callFunction exuperyNonlocalReturn returnValue) t1)
			(je block2 (cmp t1 0)) 
			(returnToCompiledMethod (sub t1 1))) 
		(block2
			(emitMoveToEax 1) 
			(returnSequence))).
	result := emitter expandedNonlocalReturnValue: (MedLiteral literal: #returnValue).
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Return' stamp: 'wbk 2/18/2006 18:04'!
testExtendedReturn
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	"emitter newBlock. "	"Use the first block"
	mockEmitter expectEmission: 
		#(#(#block1 
			#(#mov #(#mem #(#add #currentContext 4)) #t1) 
			#(#mov #(#add #(#mem #(#add #t1 12)) 2) #t2) 
			#(#mov #t2 #(#mem #(#add #t1 12))) 
			#(#mov #theValue #(#mem #(#add #(#add #t1 #(#sal #t2 1)) 22))) 
			#(#recycleContextIfPossible #currentContext) 
			(mov (nilAddress) (mem (add currentContext 8))) " Clear the interpreted IP and SP"
			#(#mov #t1 #(#currentContextAddress)) 
			#(#mov #(#nilAddress) #(#mem #(#add #currentContext 20))) 
			#(#beRootIfNessisary #(#currentContextAddress) #block2)) 
		#(#block2 
			#(#emitCheckIsNotInteger #(#mem #(#add #(#currentContextAddress) 16)) #block3) 
			#(#mov #(#mem #(#add #(#currentContextAddress) 20)) #t3) 
			#(#emitCheckIsInteger #t3 #block3) 
			#(#returnToCompiledMethod #(#sub #t3 1))) 
		#(#block3 
			#(#emitMoveToEax 1) 
			#(#returnSequence))).
	result := emitter expandedReturnValue: (MedLiteral literal: #theValue).
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 2/13/2005 12:29'!
testFetchVariableAddress
	result _ emitter 
				fetchVariableAddress: (MedLiteral literal: #index)
				ofObject: (MedLiteral literal: #object).
	self assert: result intermediateForm = #(#mem #(#add #object #(#add #(#sal #index 2) 4)))! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 9/28/2004 22:50'!
testHeightToStack
	| stack answer |
	stack := ExuperyStack 
		newPC: 1
		emitter: emitter.
	stack heightTo: 3.
	answer := stack pop: 3.
	self assert: (answer at: 1) intermediateForm = #s1.
	self assert: (answer at: 2) intermediateForm = #s2.
	self assert: (answer at: 3) intermediateForm = #s3.! !

!IntermediateEmissionTests methodsFor: 'Tests - Inlining' stamp: 'wbk 10/25/2005 23:14'!
testInlinedAt
	| answer |
	emitter setInlinedSends: #(#(42 #ExuperyTests ) ).
	answer := emitter 
				sendSelector: #at:
				arguments: #(#receiver #arg1 )
				pc: 42
				selectorName: #at:.
	self assert: answer intermediateForm = #(
						#typeSwitch
						#(#receiver #arg1 )
						#(#t1 #t2 )
						#block2
						#(
							#(
								#ExuperyTests
								#(
									#primitive
									#at:
									#block2
									#t1
									#t2
								)
							)
						)
						#(#send #at: #(#t1 #t2 ) 42 )
					).
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Object Access' stamp: 'wbk 1/27/2006 21:59'!
testInstanceVariableAddress
	"mockEmitter := MockIntermediateEmitter newWith: emitter machine.
	emitter emitter: mockEmitter.
	mockEmitter addExpectedEmission: #(instanceVariableAddress 5)."
	result := emitter instanceVariableAddress: 5.
	self assert: result intermediateForm = #(instanceVariableAddress 5).
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 9/23/2004 22:48'!
testLabelsAreStackable
	| stack |
	mockEmitter := MockIntermediateEmitter newWith: MachineX86 new.
	mockEmitter expectEmission: 
		#( (block1 (mov firstValue s1))).
		
	stack := ExuperyStack 
		newPC: 1
		emitter: mockEmitter.
		
	stack push: #firstValue.
	stack push: MedLabel new.

	self assert: stack pop class = MedLabel.
	self assert: stack pop name = #s1.
	mockEmitter verify.
	! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 9/25/2004 08:39'!
testLabelsAreStackableMultiplePop
	| stack answer |
	mockEmitter := MockIntermediateEmitter newWith: MachineX86 new.
	mockEmitter expectEmission: 
		#( (block1 (mov firstValue s1))).
		
	stack := ExuperyStack 
		newPC: 1
		emitter: mockEmitter.
		
	stack push: #firstValue.
	stack push: MedLabel new.
	
	answer := stack pop: 2.

	self assert: (answer at: 1) name = #s1.
	self assert: (answer at: 2) class = MedLabel.
	
	mockEmitter verify.
	! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/4/2004 21:42'!
testLabelsAreStackablePeek
	| stack |
	mockEmitter := MockIntermediateEmitter newWith: MachineX86 new.
	mockEmitter expectEmission: 
		#( (block1 )).
		
	stack := ExuperyStack 
		newPC: 1
		emitter: mockEmitter.
		
	stack push: MedLabel new.

	self assert: stack peek class = MedLabel.
	mockEmitter verify.
	! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/27/2004 23:04'!
testMultiplePop
	| stack answer |
	mockEmitter := MockIntermediateEmitter newWith: MachineX86 new.
	mockEmitter expectEmission: 
		#( (block1
				(mov firstValue s1)
				(mov secondValue s2))).
	stack := ExuperyStack 
		newPC: 1
		emitter: mockEmitter.
		
	stack push: #firstValue.
	stack push: #secondValue.

	answer := stack pop: 2.
	self assert: (answer at: 1) name = #s1.
	self assert: (answer at: 2) name = #s2.
	mockEmitter verify.
	! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 2/27/2005 13:37'!
testPic
	result _ emitter 
				picLocatedAt: (MedLiteral literal: 20)
				picEntry: 'nil'.
	self assert: emitter result intermediateForm = #(#(#block 1 #(#pic 20)))! !

!IntermediateEmissionTests methodsFor: 'Tests - Return' stamp: 'wbk 3/4/2005 15:07'!
testPop
	result := emitter pop: (machine registerNamed: #eax).
	self assert: emitter result intermediateForm = #((block 1 (pop eax))).! !

!IntermediateEmissionTests methodsFor: 'Tests - Object Access' stamp: 'wbk 5/5/2005 20:56'!
testPrimitiveArgument
	result := emitter primitiveArgument: 42.
	self assert: result intermediateForm = 
		#(mem 
			(add 
				(mem activeContext) 
				(add (sal (mem (add (mem activeContext)  12)) 1) -146) "42 + 20 (arguments in context)")).
	"Need to grab the stack pointer, this is a primitive so we need to work inside the senders context"
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Object Access' stamp: 'wbk 5/5/2005 21:03'!
testPrimitiveArgument2
	result := emitter primitiveArgument: 4.
	self assert: result intermediateForm = 
		#(mem 
			(add 
				(mem activeContext) 
				(add (sal (mem (add (mem activeContext) 12)) 1) 6) "42 + 20 (arguments in context)")).
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Object Access' stamp: 'wbk 5/30/2005 17:12'!
testPrimitiveReturn
	mockEmitter := MockIntermediateEmitter newWith: emitter machine.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#(#(#block1 
				"load the number of argument"
				(mov (sub (mem (add (currentContextAddress) 12)) 8) t1)
				"Pop the arguments"
				(mov t1 (mem (add (currentContextAddress) 12)))
				"Store the result"
				(stackForAtPut (currentContextAddress) t1 theAnswer)
				"return"
				(return) )).
	result := emitter 
		expandedPrimitiveReturn: (MedLiteral literal: #theAnswer)
		popping: 5.
	self verify.
	self assert: mockEmitter currentBlock = #block1! !

!IntermediateEmissionTests methodsFor: 'Tests - Return' stamp: 'wbk 3/27/2005 18:57'!
testRecycleContextIfPossible
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#(#(#block1 
			#(#jle #block2 #(cmp #(#mem #reclaimableContextCount) 0)) 
			#(#mov 
				#(#sub #(#mem #reclaimableContextCount) 1) 
				#(#mem #reclaimableContextCount)) 
			#(#jl #block2 #(cmp #theContext #(#mem #(#youngStartAddress)))) 
			#(#mov #(#mem #freeContexts) #(#emitFetchAddress 0 #theContext)) 
			#(#mov #theContext #(#mem #freeContexts)) 
		#(#jmp #block2))).	"Check there is a context to recycle"	"Decrement count"	"Check the context is young"
	"We're only dealing with small method context headers for now. The compiler doesn't
			deal with blocks. Large emthod contexts should be identical except the large list is used"
	result := emitter recycleContextIfPossible: (MedLiteral literal: #theContext).
	self assert: emitter currentBlock blockName = #block2.
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 4/22/2005 23:35'!
testRegisterEntryPoint
	| block |

	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission:  
		#((block1
						"The call preamble, this used to be done using a preassembled prolog"
						(push ebp)
						(mov esp ebp)
						(push ebx)
						(push esi)
						(push edi)
						(mov (sub esp 16r40) esp) 
						(jmp block1) ) ).

	block := emitter newBlock.
	emitter numberOfArguments: #numArgs.
	emitter 
		registerEntryPointWithPC: (MedLiteral literal: 5)
		label: block.
	emitter createProlog.
	
	self verify.! !

!IntermediateEmissionTests methodsFor: 'Tests - Return' stamp: 'wbk 3/5/2005 00:03'!
testRestoreSendersFrame
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#(#(#block1 
			(mov (add esp 64) esp)
			(pop edi)
			(pop esi)
			(pop ebx)
			(mov ebp esp)
			(pop ebp) )).
	result := emitter restoreSendersFrame.
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Return' stamp: 'wbk 3/4/2005 15:05'!
testReturn
	result := emitter ret.
	self assert: emitter result intermediateForm = #((block 1 (ret))).! !

!IntermediateEmissionTests methodsFor: 'Tests - Return' stamp: 'wbk 3/4/2005 20:28'!
testReturnSequence
	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#(#(#block1 
			(restoreSendersFrame)
			(ret) )).
	result := emitter returnSequence.
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Return' stamp: 'wbk 3/4/2005 20:18'!
testReturnToCompiledMethod

	mockEmitter := MockIntermediateEmitter new.
	emitter emitter: mockEmitter.
	"emitter newBlock. ""Use the first block"
	mockEmitter expectEmission: 
		#((block1 

			(restoreSendersFrame)
			(jmp theValue))).

	result := emitter returnToCompiledMethod: (MedLiteral literal: #theValue).

	self verify			! !

!IntermediateEmissionTests methodsFor: 'Tests' stamp: 'wbk 8/8/2004 13:17'!
testSetCurrentBlock
	| block |
	block := emitter result newBlock.
	emitter currentBlock: block.
	self assert: emitter currentBlock = block.
	self assert: self result = #((block 1) (block 2))! !

!IntermediateEmissionTests methodsFor: 'Tests - Sends' stamp: 'wbk 3/27/2005 19:23'!
testSetUpMessageSend
	result := emitter 
				callFunctionNamed: #exuperySetupMessageSend
				with: ({ 
						MedLiteral literal: #receiver.
						MedLiteral literal: 1}).
	self assert: emitter result intermediateForm = 
		#(#(#block 1 
			#(#push 1) 
			#(#push #receiver) 
			#(#mov #exuperySetupMessageSend #t1) 
			#(#call #t1) 
			#(#mov #eax #t2) 
			#(#mov #(#add 8 #esp) #esp))).
	self assert: result intermediateForm = #t2! !

!IntermediateEmissionTests methodsFor: 'Tests - Object Access' stamp: 'wbk 1/14/2006 23:02'!
testSimplifiedTemporaryAddress
	mockEmitter := MockIntermediateEmitter newWith: machine.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: #(
				#(
					#block1
					#(#mov #(#mem #(#add #(simplifiedHomeContext ) 28 ) ) 42 )
				)
			).
	result := mockEmitter 
				moveFrom: (emitter 
						simplifiedTemporaryAddress: 0
						isInBlock: nil)
				to: (MedLiteral literal: 42).
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Object Access' stamp: 'wbk 5/2/2005 13:13'!
testSizeOfObject
	mockEmitter := MockIntermediateEmitter newWith: emitter machine.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission: 
		#(#(#block1 
				(mov (mem theReceiver) t2)
				(jz block2 (and t2 3))
				(mov (sar (and t2 252) 2) t1)
				(jmp block3))
			(block2 
				(mov 
					(sar (mem (sub theReceiver 8)) 2) 
					t1)
				(jmp block3))
			(block3)
		).
	result := emitter sizeOfObject: (MedLiteral literal: #theReceiver).
	self verify.
	self assert: result name = #t1.
	self assert: mockEmitter currentBlock = #block3! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/31/2005 20:25'!
testStackMaterialise
	| stack |
	stack :=  emitter exuperyStack.
		
	stack push: (MedLiteral literal: 'value1').
	stack push: (MedLiteral literal: 'value2').
	
	emitter materialiseStack.
	
	self assert: (self result = 
		#( (block 1
			(stackPush value1 s1)
			(stackPush value2 s2)))).
			
	self assert: stack pop name = #s2.
	self assert: stack pop name = #s1.
	
	self verify.! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/31/2005 20:25'!
testStackMaterialiseTwice
	| stack |
	stack :=  emitter exuperyStack.
		
	stack push: (MedLiteral literal: 'value1').
	stack push: (MedLiteral literal: 'value2').
	
	emitter materialiseStack.
	emitter materialiseStack.
	
	self assert: (self result = 
		#( (block 1
			(stackPush value1 s1)
			(stackPush value2 s2)))).
			
	self assert: stack pop name = #s2.
	self assert: stack pop name = #s1.
	
	self verify.! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 6/27/2004 23:05'!
testStackPeek
	| stack |
	mockEmitter := MockIntermediateEmitter newWith: MachineX86 new.
	mockEmitter expectEmission: 
		#( (block1
				(mov firstValue s1)
				(mov secondValue s2))).
	stack := ExuperyStack 
		newPC: 1
		emitter: mockEmitter.
		
	stack push: #firstValue.
	stack push: #secondValue.

	self assert: stack peek name = #s2.
	self assert: stack peek name = #s2.
	mockEmitter verify.
	! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/29/2004 20:11'!
testStackRegister
	| variable |
	variable := emitter stackRegister: 1.
	self assert: variable name = #s1.
	self assert: (variable isKindOf: MedTemporaryRegister).
	variable := emitter stackRegister: 2.
	self assert: variable name = #s2.! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 5/3/2004 15:06'!
testStackRegisterSameSlot
	| s1a s1b |
	s1a := emitter stackRegister: 1.
	s1b := emitter stackRegister: 1.
	self assert: s1a = s1b.! !

!IntermediateEmissionTests methodsFor: 'Tests - Stack' stamp: 'wbk 4/29/2004 20:40'!
testStackRegisterWithTemps
	| variable |
	variable := emitter stackRegister: 1.
	variable := emitter stackRegister: 2.
	self assert: emitter createTemporaryRegister name = #t1.! !

!IntermediateEmissionTests methodsFor: 'Tests - Object Access' stamp: 'wbk 1/14/2006 22:08'!
testTemporaryAddress
	mockEmitter := MockIntermediateEmitter newWith: machine.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission:
		#(#(#block1 (mov #(#mem #(#add (homeContext) 28)) 42) )).

	result := mockEmitter 
		moveFrom: (emitter temporaryAddress: 0)
		to: (MedLiteral literal: 42).
	
	self verify! !

!IntermediateEmissionTests methodsFor: 'Tests - Object Access' stamp: 'wbk 1/14/2006 22:07'!
testTemporaryAddress2
	mockEmitter := MockIntermediateEmitter newWith: machine.
	emitter emitter: mockEmitter.
	mockEmitter expectEmission:
		#(#(#block1 (mov #(#mem #(#add (homeContext) 36)) 42) )).

	result := mockEmitter 
		moveFrom: (emitter temporaryAddress: 2)
		to: (MedLiteral literal: 42).
	
	self verify! !

!IntermediateEmissionTests methodsFor: 'Misc' stamp: 'wbk 7/16/2003 15:26'!
verify
	mockEmitter ifNotNil: [mockEmitter verify].! !

ExuperyTests subclass: #IntermediateGenerationTests
	instanceVariableNames: 'generator emitter result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!IntermediateGenerationTests methodsFor: 'Misc' stamp: 'wbk 3/1/2004 20:30'!
checkIsMed: anObject
	(anObject isKindOf: MedLanguage) ifTrue: [^ true].
	anObject isSequenceable ifTrue:
		[^ self assert: (#(emitSend emitWithFailTo emitConvertComparisionToBoolean emitClass) includes: (anObject at: 1))].
	self assert: (anObject isKindOf: MedLanguage).	"This is inadiquate. What I really should do is check
												  that the answer is a reasonable type/object"! !

!IntermediateGenerationTests methodsFor: 'Misc' stamp: 'wbk 10/4/2004 21:56'!
checkIsRegister: anObject 
	anObject isCollection ifTrue: 
		[(anObject at: 1) = #emitConvertLessOrEqualToBoolean ifTrue: [^ self].
		(anObject at: 1) = #emitMoveToTemp ifTrue: [^ self].
		(anObject at: 1) = #emitSend ifTrue: [^ self].
		(anObject at: 1) = #emitWithFailTo ifTrue: [^ self].
		(anObject at: 1) = #emitConditionalBytecode ifTrue: [^ self].
		(anObject at: 1) = #emitClass ifTrue: [^ self].
		(anObject at: 1) = #emitTemporaryAddress ifTrue: [^ self]].
	^ self assert: (anObject isKindOf: MedTemporaryRegister)! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 12/11/2004 21:46'!
expectIntegerWrappedCallTo: aSymbol failingTo: anInteger
	emitter addExpectedEmission: 
		{#emitWithFailTo. 5. 3. #t1. #t2.
			{#emitConvertToSmallInteger. #block2.
				{aSymbol.
					#(emitIntegerValueOf block2 t1).
					#(emitIntegerValueOf block2 t2) }}. anInteger}.! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 12/11/2004 22:43'!
expectWrappedCallWithFailBlockTo: aSymbol failingTo: anInteger
	emitter addExpectedEmission: 
		{#emitWithFailTo. 5. 3. #t1. #t2.
			{#emitConvertToSmallInteger. #block2.
				{aSymbol. #block2.
					#(emitIntegerValueOf block2 t1).
					#(emitIntegerValueOf block2 t2) }}. anInteger}.! !

!IntermediateGenerationTests methodsFor: 'Misc' stamp: 'wbk 4/30/2005 14:52'!
setUp
	| machine |
	machine := MachineX86 new.
	emitter := MockIntermediateEmitter newWith: machine.
	generator := IntermediateGenerator for: machine.
	generator emitter: emitter.! !

!IntermediateGenerationTests methodsFor: 'Tests - Primitives' stamp: 'wbk 5/30/2005 18:18'!
testAtPrimitive
	emitter expectEmission: 
		#((block1 
			(primitiveReturn 
				(primitive at: block2 (primitiveArgument 1) (primitiveArgument 0)) 2))
			(block2)).
	result := generator setPrimitive: 60.
	self assert: emitter currentBlock = #block2.
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Primitives' stamp: 'wbk 6/3/2005 16:43'!
testAtPutPrimitive
	emitter expectEmission: 
		#((block1 
			(primitiveReturn 
				(primitive at:put: block2 (primitiveArgument 2) (primitiveArgument 1)
 					(primitiveArgument 0)) 3))
			(block2)).
	result := generator setPrimitive: 61.
	self assert: emitter currentBlock = #block2.
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 19:28'!
testBitAnd
	self
		expectIntegerWrappedCallTo: #and
		failingTo: 14.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				bitAnd: (MedLiteral smallInteger: 1).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 19:28'!
testBitOr
	self
		expectIntegerWrappedCallTo: #or
		failingTo: 15.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				bitOr: (MedLiteral smallInteger: 1).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/9/2004 21:44'!
testBitShifts
	self
		expectWrappedCallWithFailBlockTo: #bitShift
		failingTo: 12.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				bitShift: (MedLiteral smallInteger: 1).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 15:44'!
testBytecodePrimNewWithArg
	| answer |
	emitter anyOrder.
	emitter addExpectedEmission: #(#emitSend #(#emitSpecialSelector 29) 4 5).
	answer := generator 
				generateBinarySelector: 29
				receiver: 4
				argument: 5.
	self checkIsMed: answer.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 3/1/2004 20:22'!
testClass
	emitter addExpectedEmission: #(#emitClass #abc).
	result := generator generateClass: #abc.
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Misc' stamp: 'wbk 4/21/2005 22:17'!
testCreateContext
	
	| answer |
	generator := IntermediateGenerator for: MachineX86 new.
	answer := generator createContext.
	self assert: answer class = MedCreateContext.
	self assert: generator emitter result intermediateForm = #((block 1 (createContext)))! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 8/8/2004 13:11'!
testDiv
	self
		expectWrappedCallWithFailBlockTo: #emitDiv
		failingTo: 13.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				div: (MedLiteral smallInteger: 1).
	self should: [generator result numberOfBlocks = 2].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 8/8/2004 13:11'!
testDivide
	self
		expectWrappedCallWithFailBlockTo: #emitDivide
		failingTo: 9.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				divide: (MedLiteral smallInteger: 1).
	self should: [generator result numberOfBlocks = 2].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/28/2004 16:56'!
testEquivilent
	| answer |
	emitter addExpectedEmission: #(#emitConvertComparisionToBoolean jne (sub arg1 arg2) ).
	answer := generator 
				generate: #arg1
				equivilent: #arg2.
	self checkIsMed: answer.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 12/11/2004 22:44'!
testGenerateAddByteCode2
	emitter addExpectedEmission: 
		#(#emitWithFailTo 3 5 t1 t2
			#(#emitConvertToSmallInteger #block2 
				#(#add 
					#(#emitIntegerValueOf #block2 t1) 
					#(#emitIntegerValueOf #block2 t2))) 0).
	result := generator 
				generate: (MedLiteral smallInteger: 1)
				add: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:42'!
testGenerateEquals
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 5 #jne 6).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				equals: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/12/2004 20:38'!
testGenerateGreaterThan
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 5 #jle 3).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				greaterThan: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:23'!
testGenerateGreaterThanEqual
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 7 #jl 5).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				greaterThanEqual: (MedLiteral smallInteger: 3).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Jump' stamp: 'wbk 10/2/2004 23:20'!
testGenerateJumpIfFalse
	emitter addExpectedEmission: #(materialiseStack).
	emitter addExpectedEmission: #(#emitJumpIfFalse #(#emitLabelForByteCode 42) #anExpression).
	generator 
		jumpIfFalse: #anExpression
		to: 42.
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Jump' stamp: 'wbk 10/2/2004 23:19'!
testGenerateJumpIfTrue
	emitter addExpectedEmission: #(materialiseStack).
	emitter addExpectedEmission: #(#emitJumpIfTrue #(#emitLabelForByteCode 42) #anExpression).
	generator 
		jumpIfTrue: #anExpression
		to: 42.
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 8/8/2004 13:12'!
testGenerateMinusByteCode
	self
		expectIntegerWrappedCallTo: #sub
		failingTo: 1.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				subtract: (MedLiteral smallInteger: 1).
	self should: [generator result numberOfBlocks = 2].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/17/2004 19:14'!
testGenerateNotEquals
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 5 #je 7).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				notEquals: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 10/23/2004 18:58'!
testGeneratePopIntoTemp
	generator := IntermediateGenerator for: MachineX86 new.
	result := generator
		popIntoTemp: (MedLiteral smallInteger: 1)
		slot: 0.
	self should: 
		[result intermediateForm = #(storeInTemp 0 3)].
	self should: [generator result numberOfBlocks = 1].
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 10/23/2004 18:59'!
testGeneratePopIntoTemp2
	generator := IntermediateGenerator for: MachineX86 new.
	result := generator
		popIntoTemp: (MedLiteral smallInteger: 10)
		slot: 2.
	self should: 
		[result intermediateForm = #(storeInTemp 2 21)].
	self should: [generator result numberOfBlocks = 1].
	self verify.! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 10/4/2004 21:55'!
testGeneratePushTemp
	emitter addExpectedEmission: #(#emitTemporaryAddress 0).
	result := generator pushTempAt: 0.
	self should: [generator result numberOfBlocks = 1].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Return' stamp: 'wbk 2/13/2005 12:53'!
testGenerateReturnFalse
	emitter addExpectedEmission: #(#emitReturnValue #(#falseAddress)).
	generator returnFalse.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Return' stamp: 'wbk 2/13/2005 12:54'!
testGenerateReturnNil
	emitter addExpectedEmission: #(#emitReturnValue #(#nilAddress)).
	generator returnNil.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Return' stamp: 'wbk 2/13/2005 12:58'!
testGenerateReturnSelf
	emitter addExpectedEmission: #(#emitReturnValue #(#receiverAddress)).
	generator returnSelf.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Return' stamp: 'wbk 1/20/2006 23:13'!
testGenerateReturnTop
	| method |
	method := ByteCodeReaderTests compiledMethodAt: #return4.
	generator := IntermediateGenerator for: MachineX86 new.
	ByteCodeReader 
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().
	self assert: generator intermediateString = #(
						#(
							#block
							1
							#(#createContext )
							#(#return 9 )
						)
					).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Return' stamp: 'wbk 2/13/2005 12:59'!
testGenerateReturnTrue
	emitter addExpectedEmission: #(#emitReturnValue #(#trueAddress)).
	generator returnTrue.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/17/2004 22:13'!
testGenerateSendLessOrEqual
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 5 #jg 4).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				lessThanEquals: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/17/2004 20:55'!
testGenerateSendLessThan
	emitter addExpectedEmission: #(#emitConditionalBytecode 3 5 #jge 2).
	result := generator 
				prim: (MedLiteral smallInteger: 1)
				lessThan: (MedLiteral smallInteger: 2).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 8/8/2004 13:13'!
testGenerateSendMultiply
	self
		expectWrappedCallWithFailBlockTo: #emitMultiply
		failingTo: 8.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				multiply: (MedLiteral smallInteger: 1).
	self should: [generator result numberOfBlocks = 2].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Jump' stamp: 'wbk 2/13/2005 12:46'!
testGenerateUnconditionalJump
	emitter addExpectedEmission: #(#materialiseStack).
	emitter addExpectedEmission: #(#jmp #(#emitLabelForByteCode 42)).
	generator jumpTo: 42.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Inlining' stamp: 'wbk 5/26/2005 22:34'!
testInlinSendAt
	"Explicit send and inlined operation must use the same register"

	emitter addExpectedEmission: #(#emitSend #(#emitSpecialSelector 16) arg1 arg2).
	result := generator 
				sendAtTo: #arg1
				with: #arg2.
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Misc' stamp: 'wbk 1/20/2006 23:13'!
testIntermediateForReturnString
	| method |
	method := ByteCodeReaderTests compiledMethodAt: #returnString.
	generator := IntermediateGenerator for: MachineX86 new.
	ByteCodeReader 
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().
	self should: 
			[generator intermediateString = #(
						#(
							#block
							1
							#(#createContext )
							#(
								#return
								#(
									#mem
									#(
										#add
										#(
											#mem
											#(
												#add
												#(#homeContext )
												16
											)
										)
										8
									)
								)
							)
						)
					)].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/13/2004 20:38'!
testMakePoint
	| answer |
	emitter anyOrder.
	emitter addExpectedEmission: #(#emitSend #(#emitSpecialSelector 11) 4 5).
	answer := generator 
				generate: 4
				makePoint: 5.
	self checkIsMed: answer.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 8/8/2004 13:13'!
testMod
	self
		expectWrappedCallWithFailBlockTo: #emitMod
		failingTo: 10.
	result := generator 
				generate: (MedLiteral smallInteger: 2)
				mod: (MedLiteral smallInteger: 1).
	self should: [generator result numberOfBlocks = 2].
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 7/31/2003 17:12'!
testPopStack
	generator popStack: 5.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 12/19/2004 14:45'!
testPopStackMove
	| move |
	"emitter addExpectedEmission: #(mov 10 t2)."
	generator := IntermediateGenerator for: MachineX86 new.
	move := IntermediateCreator 
		createExpression: #(mov 10 t2)
		for: MachineX86 new.
	generator popStack: move.
	self assert: generator result intermediateForm = #((block 1 (mov 10 t2))).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 8/24/2005 18:18'!
testPushFalse
	emitter addExpectedEmission: #(#falseAddress).
	result := generator pushFalse.
	self verify.
	self assert: result = #(#falseAddress)! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 11/3/2004 22:57'!
testPushInstanceVariable
	emitter addExpectedEmission: #(#instanceVariableAddress 5 ).
	result := generator pushInstanceVariable: 5.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 8/22/2005 21:39'!
testPushLiteralVariable
	emitter addExpectedEmission: #(#emitFetchAddress 1 #(#emitLiteralAddress 5)).
	result := generator 
				pushLiteralVariable: #aName
				slot: 5.
	self assert: result = #(#emitFetchAddress 1 #(#emitLiteralAddress 5)) .
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 8/24/2005 18:19'!
testPushNil
	emitter addExpectedEmission: #(#nilAddress).
	result := generator pushNil.
	self assert: result = #(#nilAddress).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 8/22/2005 21:41'!
testPushSelf
	emitter addExpectedEmission: #(#receiverAddress).
	result := generator pushSelf.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 8/24/2005 18:19'!
testPushTrue
	emitter addExpectedEmission: #(#trueAddress).
	result := generator pushTrue.
	self assert: result = #(#trueAddress).
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/17/2005 17:13'!
testSendAt
	"Explicit send and inlined operation must use the same register"

	emitter addExpectedEmission: #(#emitSend #(#emitSpecialSelector 16) arg1 arg2).
	result := generator 
				sendAtTo: #arg1
				with: #arg2.
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 4/17/2005 17:14'!
testSendAtPut
	" The emitMov is really coded as part of the block that is wrapped by emitWithFailTo, but
	the mock system can't yet encode this so I've told the emitter to expect it first.
	The problem is that the mock framework doesn't handle block additions that well, it does handle
	code that is built up as an expression."


	emitter addExpectedEmission: #(#emitSend #(#emitSpecialSelector 17) receiver index value).
	result := generator 
				sendAtPutTo: #receiver
				location: #index
				value: #value.
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Send Generation' stamp: 'wbk 1/10/2004 15:14'!
testSendMessage
	emitter anyOrder.
	emitter addExpectedEmission: #(#emitSend #(#emitLiteralAddress 3)).
	result := generator 
				sendSelector: #basicTarget
				inSlot: 3
				arguments: #().
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Send Generation' stamp: 'wbk 1/10/2004 15:14'!
testSendMessageWithStackValues
	emitter anyOrder.
	emitter addExpectedEmission: #(#emitSend #(#emitLiteralAddress 3) #abc #def).
	result := generator 
				sendSelector: #basicTarget
				inSlot: 3
				arguments: #(#abc #def).
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Send Generation' stamp: 'wbk 1/10/2004 15:14'!
testSendMessageWithStackValues2
	"Tests real stack values as well as arguments"

	emitter anyOrder.
	emitter addExpectedEmission: #(#emitSend #(#emitLiteralAddress 3) #abc #def).
	result := generator 
				sendSelector: #basicTarget
				inSlot: 3
				arguments: #(#abc #def).
	self checkIsMed: result.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Stack Generation' stamp: 'wbk 11/1/2004 20:53'!
testStoreAndPopInstanceVariable
	emitter addExpectedEmission: #(storeInReceiver 5 theValue).
	generator 
		storeAndPopReceiverVariableIndex: 5
		value: #theValue.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 14:04'!
testUnarySelector
	| answer |
	emitter addExpectedEmission: #(#emitSend #(#emitSpecialSelector 16) 4).
	answer := generator 
		generateUnarySelector: 16
		receiver: 4.
	self checkIsMed: answer.
	self verify! !

!IntermediateGenerationTests methodsFor: 'Misc' stamp: 'wbk 10/22/2004 23:09'!
verify
	emitter verify.
	"Its no longer required that bytecodes return registers, they are supposed
	to return mid level intermediate now"
	"result ifNotNil: [self checkIsRegister: result]"! !

ExuperyTests subclass: #JumpRemoverTests
	instanceVariableNames: 'result machine source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!JumpRemoverTests methodsFor: 'Support' stamp: 'wbk 4/1/2005 21:52'!
removeJumpsFrom: anArray
	machine := MachineX86 new.
	source := MedMethod 
				createAssembly: anArray
				for: machine.
	result := JumpRemover 
				removeJumpsFrom: source
				machine: machine! !

!JumpRemoverTests methodsFor: 'Tests - Removal' stamp: 'wbk 4/1/2005 21:59'!
testAddressingMode
	self 
		removeJumpsFrom: #(
				#(
					#block
					1
					#(#add #t1 (10 #t1) )
				)
			).
	self assert: result intermediateForm = #(
						#(
							#block
							1
							#(#add #t1 (10 #t1) )
						)
					)! !

!JumpRemoverTests methodsFor: 'Tests - Removal' stamp: 'wbk 2/3/2006 21:33'!
testAddressOf
	self 
		removeJumpsFrom: #(
				#(
					#block
					1
					#(#mov (addressOf byteCodeAddress block1) #t2 )
				)
			).
	self assert: result intermediateForm = #(
						#(
							#block
							1
							#(#mov (addressOf byteCodeAddress block1) #t2 )
						)
					)! !

!JumpRemoverTests methodsFor: 'Tests - Removal' stamp: 'wbk 4/1/2005 21:51'!
testBasic
	self 
		removeJumpsFrom: #(#(#block 1 ) ).
	self assert: result intermediateForm = #(#(#block 1 ) )! !

!JumpRemoverTests methodsFor: 'Tests - Removal' stamp: 'wbk 4/1/2005 22:38'!
testBasicJumpRemoval
	self removeJumpsFrom: 
			#(#(#block 1 
					(jmp block2)) 
				(block 2)).
	self assert: result intermediateForm = 
		#(#(#block 1 ) 
			(block 2) )! !

!JumpRemoverTests methodsFor: 'Tests - Removal' stamp: 'wbk 4/5/2005 21:38'!
testBasicJumpReordering
	self removeJumpsFrom: 
			#(#(#block 1
					(add eax eax)
					(jmp block3)) 
				(block 2 
					(ret))
				(block 3
					(add edx edx)
					(jmp block2) )).
	self assert: result intermediateForm = 
		#(#(#block 1 
				(add eax eax))
			(block 3
				(add edx edx))
			(block 2
				(ret) ))! !

!JumpRemoverTests methodsFor: 'Tests - Removal' stamp: 'wbk 4/1/2005 22:20'!
testDivision
	self 
		removeJumpsFrom: #(
				#(
					#block
					1
					(cdq)
					(div eax)
				)
			). 
	self assert: result intermediateForm = #(
						#(
							#block
							1
							(cdq)
							(div eax)
						)
					)! !

!JumpRemoverTests methodsFor: 'Tests - Removal' stamp: 'wbk 4/5/2005 22:09'!
testJumpToRegister
	self removeJumpsFrom: 
			#(#(#block 1
					(add eax eax)
					(jmp block3)) 
				(block 2 
					(jmp eax))
				(block 3
					(add edx edx)
					(jmp block2) )).
	self assert: result intermediateForm = 
		#(#(#block 1 
				(add eax eax))
			(block 3
				(add edx edx))
			(block 2
				(jmp eax) ))! !

!JumpRemoverTests methodsFor: 'Tests - Removal' stamp: 'wbk 4/1/2005 21:51'!
testWithSomeInstructions
	self 
		removeJumpsFrom: #(
				#(
					#block
					1
					#(#add #t1 #t1 )
					#(#or #t2 #t2 )
					#(#jmp #t3 )
				)
			).
	self assert: result intermediateForm = #(
						#(
							#block
							1
							#(#add #t1 #t1 )
							#(#or #t2 #t2 )
							#(#jmp #t3 )
						)
					)! !

!JumpRemoverTests methodsFor: 'Tests - Removal' stamp: 'wbk 4/1/2005 21:59'!
testWithSomeMoreInstructions
	self 
		removeJumpsFrom: #(
				#(
					#block
					1
					#(#mov #t1 #t2 )
					#(#call #t2 )
				)
			).
	self assert: result intermediateForm = #(
						#(
							#block
							1
							#(#mov #t1 #t2 )
							#(#call #t2 )
						)
					)! !

ExuperyTests subclass: #JumpTargetTests
	instanceVariableNames: 'generator method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!JumpTargetTests methodsFor: 'Misc' stamp: 'wbk 1/20/2006 23:13'!
checkNoTargetsForMethod: methodName in: className 
	method := className compiledMethodAt: methodName.
	generator := JumpTargetRecorder new.
	ByteCodeReader 
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #().
	self should: [generator targets size = 0]! !

!JumpTargetTests methodsFor: 'Misc' stamp: 'wbk 1/20/2006 23:13'!
findTargetsFor: aSymbol inClass: aClass 
	method := aClass compiledMethodAt: aSymbol.
	generator := JumpTargetRecorder new.
	ByteCodeReader 
		newMethod: method
		using: generator
		jumpTargets: #()
		stackHeights: #()! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:44'!
testBenchFibStackTracing
	self
		findTargetsFor: #benchFib
		inClass: Integer.
	self should: [generator stackTrace asArray = #(0 1)]! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/4/2004 20:17'!
testBitAnd
	self
		checkNoTargetsForMethod: #bitAnd
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/5/2004 20:40'!
testBitOr
	self
		checkNoTargetsForMethod: #bitOr
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/8/2004 18:56'!
testBitShift
	self
		checkNoTargetsForMethod: #bitShift
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 3/1/2004 19:06'!
testClass
	self
		checkNoTargetsForMethod: #sendClass
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/5/2004 22:03'!
testDiv
	self
		checkNoTargetsForMethod: #div
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 1/18/2004 17:21'!
testDivide
	self
		checkNoTargetsForMethod: #divide
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 1/16/2006 19:34'!
testDo
	self
		checkNoTargetsForMethod: #sendDo
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:33'!
testEquals
	self
		checkNoTargetsForMethod: #equals
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/27/2004 21:22'!
testEquivilent
	self
		checkNoTargetsForMethod: #sendEquivilent
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:46'!
testFindEmptyStackTracing
	self
		findTargetsFor: #return4
		inClass: ByteCodeReaderTests.
	self should: [generator stackTrace asArray = #()]! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:47'!
testFindJumpTargets
	self
		findTargetsFor: #ifTrueIfFalse
		inClass: ByteCodeReaderTests.
	method := ByteCodeReaderTests compiledMethodAt: #ifTrueIfFalse.
	self should: [generator targets asArray = #(11)]! !

!JumpTargetTests methodsFor: 'Tests - Sends' stamp: 'wbk 1/24/2004 15:30'!
testFindJumpTargetsForBytecodePrimSendWithArg
	self
		checkNoTargetsForMethod: #bytecodePrimSendWithArg
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 7/9/2004 20:50'!
testFindJumpTargetsForIterativeFactorial
	self
		findTargetsFor: #iterativeFactorial:
		inClass: ByteCodeReaderTests.
	self should: [generator targets asArray = #(24 9)]! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/24/2004 15:31'!
testFindJumpTargetsForPushFalse
	self
		checkNoTargetsForMethod: #popStack
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/24/2004 15:31'!
testFindJumpTargetsForPushMinusOne
	self
		checkNoTargetsForMethod: #pushMinusOne
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/24/2004 15:31'!
testFindJumpTargetsForPushNil
	self
		checkNoTargetsForMethod: #pushNil
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 7/9/2004 20:52'!
testFindJumpTargetsForReturnAddSmallInt
	self
		checkNoTargetsForMethod: #returnAddSmallInt
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 1/24/2004 15:32'!
testFindJumpTargetsForSendAtPut
	self
		checkNoTargetsForMethod: #atPutSend
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/24/2004 15:31'!
testFindJumpTargetsForStoreAndPopReceiverVariables
	self
		checkNoTargetsForMethod: #storeAndPopReceiverVariable
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 7/9/2004 20:49'!
testFindJumpTargetsFoSimpleMinus
	self
		checkNoTargetsForMethod: #simpleMinus
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:47'!
testFindNestedStackTracing
	self
		findTargetsFor: #nestedIfTrueIfFalse
		inClass: ByteCodeReaderTests.
	self should: [generator stackTrace asArray = #(0 1)]! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 6/11/2004 22:01'!
testFindStackTracing
	self
		findTargetsFor: #recursivefTrueIfFalse
		inClass: ByteCodeReaderTests.
	self assert: generator stackTrace asArray = #(0 1 0 1).
	self assert: generator targets asArray = #(21 26 25 26).! !

!JumpTargetTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/12/2004 21:47'!
testGreaterThan
	self
		checkNoTargetsForMethod: #greaterThan
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/14/2004 21:15'!
testGreaterThanEqual
	self
		checkNoTargetsForMethod: #greaterThanEqual
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/12/2003 22:31'!
testJumpTargetsInPushInstanceVariable
	self 
		checkNoTargetsForMethod: #a
		in: ExuperyInstanceVariables! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/29/2005 20:50'!
testJumpTargetsInPushLiteralVariable
	self
		checkNoTargetsForMethod: #pushLiteralVariable
		in: ExuperyStoryTests! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 10/29/2005 20:50'!
testJumpTargetsInPushSelf
	self
		checkNoTargetsForMethod:  #returnSelf
		in: ExuperyStoryTests! !

!JumpTargetTests methodsFor: 'Tests - Stack' stamp: 'wbk 1/24/2004 15:31'!
testJumpTargetsInPushTrue
	self
		checkNoTargetsForMethod: #pushConstantTrue
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 1/24/2004 15:32'!
testJumpTargetsInSendAt
	self
		checkNoTargetsForMethod: #atSend
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Sends' stamp: 'wbk 10/29/2005 20:49'!
testJumpTargetsInSendLiteralSelector
	self
		checkNoTargetsForMethod: #basicSend
		in: ExuperyStoryTests! !

!JumpTargetTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/6/2004 22:37'!
testLessThan
	self
		checkNoTargetsForMethod: #lessThan
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:48'!
testLongJumpIfTrue
	self
		findTargetsFor: #longJumpIfTrue
		inClass: ByteCodeReaderTests.
	self should: [generator targets asArray = #(16)]! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/14/2004 15:11'!
testMakePoint
	self
		checkNoTargetsForMethod: #makePoint
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Arithmatic' stamp: 'wbk 2/7/2004 20:32'!
testMod
	self
		checkNoTargetsForMethod: #mod
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/14/2004 15:11'!
testNew
	self
		checkNoTargetsForMethod: #sendNew
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 15:06'!
testNext
	self
		checkNoTargetsForMethod: #sendNext
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Comparision' stamp: 'wbk 1/17/2004 18:58'!
testNotEquals
	self
		checkNoTargetsForMethod: #notEquals
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Primitives' stamp: 'wbk 4/20/2005 21:50'!
testPrimitive
	self
		checkNoTargetsForMethod: #simpleMethod
		in: CompilerToys! !

!JumpTargetTests methodsFor: 'Tests - Return' stamp: 'wbk 1/17/2004 22:04'!
testReturnFalse
	self
		checkNoTargetsForMethod: #returnFalse
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Return' stamp: 'wbk 1/17/2004 22:04'!
testReturnNil
	self
		checkNoTargetsForMethod: #returnNil
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Return' stamp: 'wbk 1/17/2004 22:04'!
testReturnTrue
	self
		checkNoTargetsForMethod: #returnTrue
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 5/30/2004 23:49'!
testShortUnconditionalJump
	self
		findTargetsFor: #shortUnconditionalJump
		inClass: ByteCodeReaderTests.
	self should: [generator targets asArray = #(17 19)]! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 2/22/2004 13:15'!
testSize
	self
		checkNoTargetsForMethod: #sendSize
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Jumps' stamp: 'wbk 6/6/2004 16:42'!
testStackTracingForBenchmark
	self
		findTargetsFor: #benchmark
		inClass: Integer.
	self should: [generator stackTrace asArray = #(0 0 0 0 0 0 0)]! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 5/15/2005 19:43'!
testValue
	self
		checkNoTargetsForMethod: #sendValue
		in: ByteCodeReaderTests! !

!JumpTargetTests methodsFor: 'Tests - Common Sends' stamp: 'wbk 5/15/2005 21:02'!
testValueWithArg
	self
		checkNoTargetsForMethod: #sendValueWithArg
		in: ByteCodeReaderTests! !

ExuperyTests subclass: #LatticeTests
	instanceVariableNames: 'machine interferenceGraph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!LatticeTests methodsFor: 'Misc' stamp: 'wbk 7/8/2004 21:50'!
newLattice
	^NodeLattice new! !

!LatticeTests methodsFor: 'Misc' stamp: 'wbk 7/8/2004 19:47'!
newNode: aSymbol 
	| register answer |
	register := machine registerNamed: aSymbol.
	answer := InterferenceNode 
				for: register
				with: machine
				interferenceGraph: #().
	interferenceGraph 
		at: register
		put: answer.
	^answer! !

!LatticeTests methodsFor: 'Misc' stamp: 'wbk 7/1/2004 20:43'!
setUp
	machine := MachineX86 new.
	interferenceGraph := Dictionary new.! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 7/1/2004 21:31'!
testAdd
	| lattice node1 node2 lattice2 answer |
	lattice := self newLattice.
	lattice2 := self newLattice.
	node1 := self newNode: #t1.
	node2 := self newNode: #t2.
	lattice addNode: node1.
	lattice2 addNode: node2.
	
	answer := lattice + lattice2.
		
	self assert: (answer asSet includes: node1).
	self assert: (answer asSet includes: node2).
	self assert: answer asSet size = 2.! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/27/2004 21:51'!
testAddNode
	| lattice node1 |
	lattice := self newLattice.
	node1 := self newNode: #t1.
	self assert: (lattice includesNode: node1) not.
	lattice addNode: node1.
	self assert: (lattice includesNode: node1)! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/28/2004 23:05'!
testAddNodeTwice
	| lattice node1 |
	lattice := self newLattice.
	node1 := self newNode: #t1.
	self assert: (lattice includesNode: node1) not.
	lattice addNode: node1.
	self assert: (lattice includesNode: node1).
	lattice addNode: node1.
	self assert: (lattice includesNode: node1).! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/27/2004 22:20'!
testAddTwoNode2
	| lattice node1 node2 |
	lattice := self newLattice.
	node1 := self newNode: #t1.
	node2 := self newNode: #t2.
	self assert: (lattice includesNode: node1) not.
	lattice addNode: node1.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2) not.
	lattice addNode: node2.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2).! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/28/2004 22:22'!
testAsSet
	| lattice |
	lattice := self newLattice.	
	self assert: lattice asSet class = Set.
	self assert: lattice asSet isEmpty.! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/28/2004 23:12'!
testAsSet2
	| lattice node1 node2 |
	lattice := self newLattice.
	node1 := self newNode: #t1.
	node2 := self newNode: #t2.
	lattice addNode: node1.
	lattice addNode: node2.
		
	self assert: (lattice asSet includes: node1).
	self assert: (lattice asSet includes: node2).
	self assert: lattice asSet size = 2.! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/27/2004 22:43'!
testCreatingStackRegisters
	| lattice node1 node2 |
	lattice := self newLattice.
	node1 := machine stackRegister: 1.
	node2 := machine stackRegister: 2.
	self assert: (lattice includesNode: node1) not.
	lattice addNode: node1.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2) not.
	lattice addNode: node2.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2).! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 6/27/2004 22:41'!
testCreatingTemporaries
	| lattice node1 node2 |
	lattice := self newLattice.
	node1 := machine createTemporaryRegister.
	node2 := machine createTemporaryRegister.
	self assert: (lattice includesNode: node1) not.
	lattice addNode: node1.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2) not.
	lattice addNode: node2.
	self assert: (lattice includesNode: node1).
	self assert: (lattice includesNode: node2).! !

!LatticeTests methodsFor: 'Basic Tests' stamp: 'wbk 7/1/2004 20:48'!
testNodesDo
	| lattice node1 node2 answer |
	lattice := self newLattice.
	node1 := machine createTemporaryRegister.
	node2 := machine createTemporaryRegister.
	interferenceGraph
		at: node1
		put: node1.
	interferenceGraph
		at: node2
		put: node2.
	answer := OrderedCollection new.

	lattice addNode: node1.
	lattice addNode: node2.
	
	lattice nodesDo: [:each| answer add: each].	
	self assert: (answer includes: node1).
	self assert: (answer includes: node2).! !

ExuperyTests subclass: #LivenessAnalysisTests
	instanceVariableNames: 'source analyser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!LivenessAnalysisTests methodsFor: 'Support' stamp: 'wbk 8/17/2005 22:39'!
analyse
	analyser := LivenessAnalyser 
		on: source
		isValidating: false! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:39'!
testBasicLivenessAnalysis
	source := MedMethod 
				createAssembly: #(#(#block 1 #(#add #esp #t1 ) ) )
				for: MachineX86 new.
	self analyse.
	self should: 
			[analyser 
				isLive: #(#esp #t1 )
				at: 1]! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:41'!
testCall
	source := MedMethod 
		createAssembly: #((block 1 (call 1234)))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #()
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:41'!
testCallKillsEax
	source := MedMethod 
		createAssembly: #((block 1 (call 1234) (add eax eax) ))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #()
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:41'!
testCallRegister
	source := MedMethod 
		createAssembly: #((block 1 (call t1)))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #(t1)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:41'!
testCdq
	source := MedMethod 
		createAssembly: 
			#((block 1 
				(cdq)
				(add edx edx)
				))
		for: MachineX86 new.
	self analyse.
	self assert: 
		(analyser 
			isLive: #(eax)
			at: 1).! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:41'!
testCmp
	source := MedMethod 
		createAssembly: #((block 1 (cmp t1 t2) ))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #(t1 t2)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:41'!
testDivide
	source := MedMethod 
		createAssembly: 
			#((block 1 
				(mov 12 eax)
				(mov 0 edx)
				(div t1)
				(mov eax t2)
				(mov edx t3)
				(add t2 t3)))
		for: MachineX86 new.
	self analyse.
	self assert: 
		(analyser 
			isLive: #(t1)
			at: 1).
	self assert:
		(analyser
			isLive: #(eax edx t1)
			at: 3).! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:41'!
testIndirectAddress2LivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (mov (t1) (t2))))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #(t1 t2)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:41'!
testIndirectAddressLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (mov t1 (t2))))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #(t1 t2)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:41'!
testIndirectAddressWithArithmaticExpressionLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (add (t1) (t2))))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #(t1 t2)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:42'!
testJumpCalculated
	source := MedMethod 
		createAssembly: #((block 1 (jmp t1)))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #(t1)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:42'!
testJumpLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (mov 1 t1) (mov 1 t2) (mov 1 t3) (jo block2) (add t1 t3) )
			(block 2 (add t2 t3) ))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			at: 4].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:42'!
testJumpLoopLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (add t1 t3) (add t2 t3) (mov 1 t1) (mov 1 t2) (mov 1 t3) (jo block1)  )
			(block 2 ))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			at: 6].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:42'!
testMovInstructionLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (mov t1 t2)))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #(t1)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:42'!
testMultipleStatementLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (add esp t1) (add t2 t3) ))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #(esp t1 t2 t3)
			at: 1].
	self should: 
		[analyser 
			isLive: #( t2 t3)
			at: 2].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:42'!
testMultipleStatementMovLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 (mov t1 t2) (add t2 t3) ))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #(t1 t3)
			at: 1].
	self should: 
		[analyser 
			isLive: #( t2 t3)
			at: 2].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:42'!
testNeg
	source := MedMethod 
		createAssembly: 
			#((block 1
				(add t2 t2) 
				(neg t2)
				(mov t3 t4)
				))
		for: MachineX86 new.
	self analyse.
	self assert: 
		(analyser 
			isLive: #(t2 t3)
			at: 2).! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:42'!
testNestedLoopLivenessAnalysis
	source := MedMethod 
		createAssembly: #(  (block 1 (mov 1 t6) (add t4 t6) (add t5 t6) (jmp block2) )
							(block 2 (add t1 t3) (add t2 t3) (mov 1 t1) (mov 1 t2) (mov 1 t3) 
								(jo block2)  )
							(block 3 (mov 1 t4)  (mov 1 t5) (jmp block1) ))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #(t1 t2 t3 t4 t5)
			block: 1
			at: 1].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			block: 1
			at: 4].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			block: 2
			at: 6].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			block: 2
			at: 1].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3)
			block: 3
			at: 1].
	self should: 
		[analyser 
			isLive: #(t1 t2 t3 t4 t5)
			block: 3
			at: 3].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:42'!
testPic
	source := MedMethod 
		createAssembly: #((block 1 (pic t1) ))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #(t1)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:42'!
testPop
	source := MedMethod 
		createAssembly: #((block 1 (pop eax) (add eax eax)))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #()
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:42'!
testPush
	source := MedMethod 
		createAssembly: #((block 1 (push t1)))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #(t1)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:42'!
testRet
	source := MedMethod 
		createAssembly: #((block 1 (ret)))
		for: MachineX86 new.
	self analyse.
	self should: 
		[analyser 
			isLive: #(eax)
			at: 1].! !

!LivenessAnalysisTests methodsFor: 'Tests' stamp: 'wbk 8/17/2005 22:43'!
testSingeBlockLivenessAnalysis
	source := MedMethod 
		createAssembly: #((block 1 
			(mov 5 t1)
			(add 6 t1)
			(mov 7 t2)
			(add t2 t1)
			(mov 10 t3)
			(add 11 t3) ))
		for: MachineX86 new.
	self analyse.

	self should: 
		[analyser 
			isLive: #()
			at: 1].
	self should:
		[analyser
			isLive: #()
			at: 5].! !

!LivenessAnalysisTests methodsFor: 'Support' stamp: 'wbk 4/11/2003 09:47'!
verify
	source instructionsDo: 
		[:each| each in do: [:eachRegister| self assert: eachRegister isRegister ].
		each out do: [:eachRegister| self assert: eachRegister isRegister]]! !

ExuperyTests subclass: #TestEndToEnd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Programmer Tests'!

!TestEndToEnd methodsFor: 'Sample Methods' stamp: 'wbk 7/2/2003 12:20'!
stringConcatentate
	^ 'abc', 'def'! !

!TestEndToEnd methodsFor: 'Tests' stamp: 'wbk 11/6/2005 18:47'!
testBenchFib
	"This method was causing a register allocator bug. It failed to compile."

	Exupery 
		compileMethod: (Integer compiledMethodAt: #benchFib)
		inlining: #()
		receiver: nil! !

!TestEndToEnd methodsFor: 'Tests' stamp: 'wbk 11/6/2005 18:47'!
testStringConcatenate
	"An end to end test to make sure all the compiler stages hang together"

	Exupery 
		compileMethod: (TestEndToEnd compiledMethodAt: #stringConcatentate)
		inlining: #()
		receiver: nil! !

!Interpreter class methodsFor: '*Exupery-override' stamp: 'wbk 4/12/2004 00:11'!
initializeCompilerHooks
	"Interpreter initializeCompilerHooks"

	"compilerHooks[] indices:
	1	void compilerTranslateMethodHook(void)
	2	void compilerFlushCacheHook(CompiledMethod *oldMethod)
	3	void compilerPreGCHook(int fullGCFlag)
	4	void compilerMapHook(int memStart, int memEnd)
	5	void compilerPostGCHook(void)
	6	void compilerProcessChangeHook(void)
	7	void compilerPreSnapshotHook(void)
	8	void compilerPostSnapshotHook(void)
	9	void compilerMarkHook(void)
	10	void compilerActivateMethodHook(void)
	11	void compilerNewActiveContextHook(int sendFlag)
	12	void compilerGetInstructionPointerHook(void)
	13	void compilerSetInstructionPointerHook(void)
	14	void compilerCreateActualMessageHook(void)"

	"Added a few more compiler hooks for Exupery's use"
	CompilerHooksSize _ 25.! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 1/29/2005 21:58'!
exuperyActiveContextAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^  self addressOf: activeContext! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 12/26/2004 22:05'!
exuperyAtCacheAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self addressOf: atCache! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 2/18/2006 16:14'!
exuperyBlock: block Value: anInteger
	| blockEntry answer |
	self export: true.
	self storeContextRegisters: activeContext.

	self transfer: anInteger + 1
				fromIndex: self stackPointerIndex - anInteger + 1
				ofObject: activeContext
				toIndex: TempFrameStart
				ofObject: block.
	self 
		storeWord: StackPointerIndex 
		ofObject: activeContext
		withValue: (self fetchPointer: StackPointerIndex ofObject: activeContext) - 
			((anInteger + 1) * 2).

	self storePointerUnchecked: SenderIndex ofObject: block withValue: activeContext.
	blockEntry := (self fetchPointer: 5 "IP" ofObject: block) - 1.
	activeContext := block.
	"Set the interpreter's stack pointer so the primitive code will set the block's
	stack pointer correctly"
	stackPointer := activeContext + BaseHeaderSize + (TempFrameStart * 4).
	newNativeMethod isNil
		ifTrue:
			[answer := self cCode: '( (int (*)())blockEntry)()'.
			self exuperyCompiledReturn: answer.]
		ifFalse: 
			[newNativeMethod := blockEntry].! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 3/28/2006 22:10'!
exuperyCallMethod
	"Could move into compiled return sequence.
											It depends on how message sends end up working."

	| answer activeCntxt nativeMethod |
	self inline: false.
	activeCntxt := activeContext.
	nativeMethod := newNativeMethod.
	"Exupery only uses the active context, the rest it will get directly from the MethodContext object."
	self storeContextRegisters: activeContext.
	answer := self cCode: '( (int (*)(int))nativeMethod)(activeCntxt)'.
	self exuperyCompiledReturn: answer.
	^nil! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 2/7/2005 21:39'!
exuperyCallMethodHook
	self inline: true.
	newNativeMethod = nil ifTrue: [^false].
	self exuperyCallMethod.
	^true! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 12/26/2004 22:28'!
exuperyCheckRootTableFor: object
	| flag |
	self inline: false.
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	flag := false.
	1 
		to: rootTableCount
		do:
			[:each| (rootTable at: each) = object ifTrue: [flag := true]].
	^ flag! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 1/21/2006 20:07'!
exuperyCompiledReturnAddress
	^self exuperyCompiledReturnAddressFor: activeContext! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 1/21/2006 20:07'!
exuperyCompiledReturnAddressFor: ctx
	^ self cCode: 'compilerHooks [18] (ctx)'! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 1/21/2006 20:03'!
exuperyCompiledReturn: answer 
	| aFunction ctx |
	self 
		var: #aFunction
		declareC: 'int (*aFunction) (int)'.
	aFunction := self exuperyCompiledReturnAddress.
	[self cCode: '(aFunction) !!= 0'] whileTrue: 
		[ctx := activeContext.
		self cCode: 'aFunction (ctx)'.
		aFunction := self exuperyCompiledReturnAddress].
	self fetchContextRegisters: activeContext.! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 2/18/2005 21:32'!
exuperyCreateContextAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^ self cCode: '& exuperyCreateContext'! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 12/21/2005 17:22'!
exuperyCreateExuperyBlockAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^ self cCode: '& exuperyCreateExuperyBlock'! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 4/10/2006 21:44'!
exuperyCreate: blockArgCount Exupery: block Block: isInBlock
	| newContext |
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	reclaimableContextCount := 0.
	self fetchContextRegisters: activeContext. "A GC needs the IP and SP set so it can resave them"
	newContext := self 
		instantiateContext: (self 
			fetchPointer: 14
			ofObject: (self splObj: 28 "Current index, FIX") )
		sizeInBytes: SmallContextSize.

	self storePointerUnchecked: SenderIndex ofObject: newContext withValue: nilObj.
	self storePointerUnchecked: 1 "IP" ofObject: newContext withValue: nilObj. 
	self storeStackPointerValue: 0 inContext: newContext.
	self 
		storePointerUnchecked: 3 "Home Context" 
		ofObject: newContext 
		withValue: (self exuperyHomeContext: isInBlock).
	self storePointerUnchecked: 4 "Compiled IP" ofObject: newContext withValue: nilObj.
	self storePointerUnchecked: 5 "Initial Compiled Block" ofObject: newContext withValue: block.
	^ newContext ! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 1/21/2006 20:31'!
exuperyExecuteNewMethod
	"execute a method not found in the mCache - which means that 
	primitiveIndex must be manually set. Used by primitiveClosureValue & primitiveExecuteMethod, where no lookup is previously done"
	primitiveIndex > 0
		ifTrue: 
			[newNativeMethod := self exuperyCompiledReturnAddress.
			self exuperyPrimitiveResponse.
			successFlag ifTrue: [^ nil].
			newNativeMethod := nil].
	"if not primitive, or primitive failed, activate the method"
	self activateNewMethod.
	"check for possible interrupts at each real send"
	self quickCheckForInterrupts! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:26'!
exuperyFalseObjAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self addressOf: falseObj! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 1/30/2005 19:22'!
exuperyFreeContexts
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self addressOf: freeContexts! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 3/11/2005 23:29'!
exuperyFullGCHook
	self inline: true.
	(self cCode: 'compilerHooks[20] !!= nullCompilerHook') ifTrue: [^self cCode: 'compilerHooks[20]()']! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 2/5/2006 15:58'!
exuperyHomeContext: aBoolean
	aBoolean
			ifTrue: 
				[^ self
					fetchPointer: 3 "Home Context"
					ofObject: activeContext]
	  		ifFalse:
				[^ activeContext]! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 4/9/2006 20:42'!
exuperyInternalCannotReturn: localVal 
	self exuperyPush: activeContext.
	self exuperyPush: localVal.
	^self 
		exuperySetup: (self splObj: SelectorCannotReturn)
		Message: 1
		Send: nil! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 4/16/2005 23:27'!
exuperyLookupMethod
	| meth selector class |
	meth := newMethod.
	selector := messageSelector.
	class := lkupClass.
	^newNativeMethod := self cCode: 'compilerHooks[15](selector, class)'! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 2/7/2005 21:21'!
exuperyLookupMethodHook
	self inline: true.
	(self cCode: 'compilerHooks[15] !!= nullCompilerHook') ifTrue: [^self exuperyLookupMethod].
	^ nil! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/12/2004 00:15'!
exuperyMarkAndTrace
	^ self cCode: 'compilerHooks[19]()'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/12/2004 00:15'!
exuperyMarkAndTraceHook
	self inline: true.
	(self cCode: 'compilerHooks[19] !!= nullCompilerHook') ifTrue: [^ self exuperyMarkAndTrace] ! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:27'!
exuperyNilObjAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self addressOf: nilObj! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 1/7/2006 19:38'!
exuperyNonlocalReturnAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^ self cCode: '& exuperyNonlocalReturn'! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 4/10/2006 23:27'!
exuperyNonlocalReturn: anObject 
	| nilOop thisCntx localCntx localVal unwindMarked contextOfCaller returnAddress |
	self export: true.
	self inline: false.
	nilOop := nilObj.	"keep in a register"
	thisCntx := activeContext.
	localCntx := self 
				fetchPointer: SenderIndex
				ofObject: (self 
						fetchPointer: 3
						ofObject: activeContext).
	localVal := anObject.

	"make sure we can return to the given context"
	(localCntx = nilOop or: 
			[(self 
				fetchPointer: InstructionPointerIndex
				ofObject: localCntx) = nilOop]) ifTrue: 
			["error: sender's instruction pointer or context is nil; cannot return"

			"^self internalCannotReturn: localVal"

			^self exuperyInternalCannotReturn: localVal].

	"If this return is not to our immediate predecessor (i.e. from a method to its sender, or from a block to its caller), scan the stack for the first unwind marked context and inform this context and let it deal with it. This provides a chance for ensure unwinding to occur."
	thisCntx := self 
				fetchPointer: SenderIndex
				ofObject: activeContext.

	"Just possibly a faster test would be to compare the homeContext and activeContext - they are of course different for blocks. Thus we might be able to optimise a touch by having a different returnTo for the blockreteurn (since we know that must return to caller) and then if active ~= home we must be doing a non-local return. I think. Maybe."
	[thisCntx = localCntx] whileFalse: 
			[thisCntx = nilOop ifTrue: 
					["error: sender's instruction pointer or context is nil; cannot return"

					^self exuperyInternalCannotReturn: localVal].
			"Climb up stack towards localCntx. Break out to a send of #aboutToReturn:through: if an unwind marked context is found"
			unwindMarked := self isUnwindMarked: thisCntx.
			unwindMarked ifTrue: 
					["context is marked; break out"

					self exuperyPush: activeContext.
					self exuperyPush: localVal.
					self exuperyPush: thisCntx.
					^self 
						exuperySetup: (self splObj: SelectorAboutToReturn)
						Message: 2
						Send: nil
					"^self internalAboutToReturn: localVal through: thisCntx"].
			thisCntx := self 
						fetchPointer: SenderIndex
						ofObject: thisCntx].

	"If we get here there is no unwind to worry about. Simply terminate the stack up to the localCntx - often just the sender of the method"
	thisCntx := activeContext.
	[thisCntx = localCntx] whileFalse: 
			["climb up stack to localCntx"

			contextOfCaller := self 
						fetchPointer: SenderIndex
						ofObject: thisCntx.

			"zap exited contexts so any future attempted use will be caught"
			self 
				storePointerUnchecked: SenderIndex
				ofObject: thisCntx
				withValue: nilOop.
			self 
				storePointerUnchecked: InstructionPointerIndex
				ofObject: thisCntx
				withValue: nilOop.
			reclaimableContextCount > 0 ifTrue: 
					["try to recycle this context"

					reclaimableContextCount := reclaimableContextCount - 1.
					self recycleContextIfPossible: thisCntx].
			thisCntx := contextOfCaller].
	activeContext := thisCntx.
	thisCntx < youngStart ifTrue: [self beRootIfOld: thisCntx].

	"self internalFetchContextRegisters: thisCntx. "	"updates local IP and SP"
	"self fetchNextBytecode."
	self exuperyPush: localVal.
	returnAddress := self 
				fetchPointer: 4
				ofObject: activeContext.
	(self isIntegerObject: returnAddress) 
		ifTrue: [^returnAddress]
		ifFalse: 
			[^0

			"Returns into a compiled method, if the method is compiled"
			"self externalizeIPandSP.
	self exuperyReturnHook ifTrue: 
		[self internalizeIPandSP. 
		self fetchNextBytecode.
		self externalizeIPandSP]. 
	self internalizeIPandSP."]! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 3/12/2005 23:22'!
exuperyPopulatePic: picDescriptor with: compiledMethod receiver: aClass
	| picPosition entry entryPosition|
	self inline: false. 
	aClass >= youngStart ifTrue: [^ nil].
	picPosition := 0. "just so it generates"
	picPosition := self cCode: '*(int *) picDescriptor'.
	entry := self cCode: '*(int *) (picDescriptor + 8)'.
	entry == 3 ifTrue: [entry := 0].
	self cCode: '*(int *) (picDescriptor + 8) = entry + 1'.

	entryPosition := picPosition + (entry * 11).
	self cCode: '*(char *) entryPosition = 0x3D'.
	self cCode: '*(int *) (entryPosition + 1) = aClass'.
	self cCode: '*(char *) (entryPosition + 5) = 0x0f'.
	self cCode: '*(char *) (entryPosition + 6) = 0x84'.
	self cCode: '*(int *) (entryPosition + 7) = compiledMethod - (entryPosition + 11)'.! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 9/5/2005 20:44'!
exuperyPrimitiveResponse
	"NB: tpr removed the timer checks here and moved them to the primitiveExternalCall method.
	We make the possibly unwarranted assumption that numbered prims are quick and external prims are slow."

	| delta primIdx nArgs |
	DoBalanceChecks ifTrue:["check stack balance"
		nArgs := argumentCount.
		delta := stackPointer - activeContext.
	].
	primIdx := primitiveIndex.
	successFlag := true.
	"self dispatchOn: primitiveIndex in: primitiveTable."
	self dispatchFunctionPointer: primitiveFunctionPointer. 
	"replace with fetch entry primitiveIndex from table and branch there"
	DoBalanceChecks ifTrue:[
		(self balancedStack: delta afterPrimitive: primIdx withArgs: nArgs) 
			ifFalse:[self printUnbalancedStack: primIdx].
	].
	^ successFlag

! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 1/25/2006 23:15'!
exuperyPush: localVal 
	| sp |
	sp := self 
				fetchPointer: StackPointerIndex
				ofObject: activeContext.
	sp := sp + 2.
	self 
		storeWord: StackPointerIndex
		ofObject: activeContext
		withValue: sp.
	self 
		storeWord: ReceiverIndex + (sp / 2)
		ofObject: activeContext
		withValue: localVal! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 1/30/2005 19:22'!
exuperyReclaimableContextCount
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self addressOf: reclaimableContextCount! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:26'!
exuperyRegisterCallMethod: aFunction 
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self cCode: 'compilerHooks[17] = aFunction'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 3/11/2005 22:59'!
exuperyRegisterFullGCHook: aFunction 
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self cCode: 'compilerHooks[20] = aFunction'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:25'!
exuperyRegisterLookupMethod: aFunction 
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self cCode: 'compilerHooks[15] = aFunction'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:27'!
exuperyRegisterMarkObjects: aFunction
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^  self cCode: 'compilerHooks[19] = aFunction'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:26'!
exuperyRegisterRemapObjects: aFunction 
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self cCode: 'compilerHooks[16] = aFunction'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:26'!
exuperyRegisterReturnMethod: aFunction 
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self cCode: 'compilerHooks[18] = aFunction'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/18/2004 20:58'!
exuperyRemapObjects
	^self cCode: 'compilerHooks[16]()'! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'wbk 4/18/2004 20:58'!
exuperyRemapObjectsHook
	self inline: true.
	(self cCode: 'compilerHooks[16] !!= nullCompilerHook') ifTrue: [^self exuperyRemapObjects]! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 12/27/2004 13:04'!
exuperyReturnHook
	| function ctx |
	self inline: true.

	" Return if active context isn't a compiled method."
	(self cCode: 'compilerHooks[18] !!= nullCompilerHook') ifFalse: [^ false].

	ctx := activeContext.
	(self cCode: '(function = compilerHooks [18] (ctx)) !!= 0') ifTrue: 
		[self exuperyReturn: function.
		^ true].
	^ false! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 10/7/2005 20:39'!
exuperyReturn: aFunction
	| answer activeCntxt |
	self inline: false.
	self var: #aFunction
		declareC: 'int (*aFunction) (int)'.
	activeCntxt := activeContext.
	answer := self cCode: 'aFunction (activeCntxt)'.
	self exuperyCompiledReturn: answer.
! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:27'!
exuperyRootTableAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^  self addressOf: rootTable! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:27'!
exuperyRootTableCountAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^  self addressOf: rootTableCount! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'ar 12/18/2004 18:26'!
exuperySetupMessageSendAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^ self cCode: '& exuperySetupMessageSend'! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 3/28/2006 22:27'!
exuperySetup: selector Message: argumentsInteger Send: picPosition
	|rcvr|
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	self inline: false. 
	" Reload the context here, the interpreter code below depends on it."
	self fetchContextRegisters: activeContext.

	"The send bytecode"
	messageSelector := selector.
	argumentCount := argumentsInteger.

	"normalSend"
	rcvr := self stackValue: argumentCount.
	lkupClass := self fetchClassOf: rcvr.
	receiverClass := lkupClass.
	self findNewMethodInClass: lkupClass.
	newNativeMethod = nil 
		ifTrue:
			[self exuperyExecuteNewMethod. 
			"executeNewMethod fetches the new context registers"
		 	"Load the stackPointer into the active context, it might have changed, e.g. if a primitive
			has been executed"
			self
				storeWord:  StackPointerIndex	
				ofObject: activeContext
				withValue: (self integerObjectOf: (stackPointer - activeContext) / 4 - TempFrameStart)]
		ifFalse:
			[self 
				exuperyPopulatePic: picPosition
				with: newNativeMethod
				receiver: receiverClass].
	"fetchNextBytecode must be done inside the interpreter loop/function"

	^ newNativeMethod  ! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:26'!
exuperySpecialObjectsOopAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^  self addressOf: specialObjectsOop! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:26'!
exuperyTrueObjAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^self addressOf: trueObj! !

!Interpreter methodsFor: '*Exupery-Compiler Support' stamp: 'ar 12/18/2004 18:27'!
exuperyYoungStartAddress
	self export: true. "allow lookup from elsewhere, e.g., plugin"
	^ self addressOf: youngStart! !

!Interpreter methodsFor: '*Exupery-Sends and Returns' stamp: 'wbk 10/7/2005 20:38'!
exupery: argCnt Create: tmpCnt Context: isLargeContext
	| newContext  nilOop where tmp | 
	self export: true.	"allow lookup from elsewhere, e.g., plugin"
	
	"self fetchContextRegisters: activeContext."

	tmp := self quickFetchInteger: StackPointerIndex ofObject: activeContext.
	stackPointer := activeContext + BaseHeaderSize + (TempFrameStart + tmp - 1 * 4). "Because a compiled method may have changed these"
	newContext := self allocateOrRecycleContext: isLargeContext.	"Assume: newContext will be recorded as a root if necessary by the
	 call to newActiveContext: below, so we can use unchecked stores."
	where := newContext + BaseHeaderSize.
	self 
		longAt: where + (SenderIndex << 2)
		put: activeContext.
	self  "REMOVE, now redundant"
		longAt: where + (MethodIndex << 2)
		put: newMethod.	"Copy the reciever and arguments..."
	0 
		to: argCnt
		do: 
			[:i | 
			self 
				longAt: where + (ReceiverIndex + i << 2)
				put: (self stackValue: argCnt - i)].	"clear remaining temps to nil in case it has been recycled"
	nilOop := nilObj.
	argCnt + 1 + ReceiverIndex 
		to: tmpCnt + ReceiverIndex
		do: 
			[:i | 
			self 
				longAt: where + (i << 2)
				put: nilOop].
	self pop: argCnt + 1.
	reclaimableContextCount := reclaimableContextCount + 1.

	"self storeContextRegisters: activeContext."
	self storeWord: StackPointerIndex ofObject: activeContext
		withValue: (self integerObjectOf: (self stackPointerIndex - TempFrameStart + 1)).

	newContext < youngStart ifTrue: [self beRootIfOld: newContext].
	activeContext := newContext.
	"self fetchContextRegisters: newContext"

	self
		storeWord: StackPointerIndex
		ofObject: newContext
		withValue: 1.
	self
		storeWord: InstructionPointerIndex
		ofObject: newContext
		withValue: 43.! !

!MethodContext methodsFor: '*Exupery-return address' stamp: 'wbk 9/8/2005 23:11'!
clearExuperyReturnAddress
	receiverMap := nil! !

MethodDictionary variableSubclass: #ExuperyMethodDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Plugin'!

!ExuperyMethodDictionary methodsFor: 'Overridden methods' stamp: 'wbk 5/12/2005 23:00'!
at: key put: value
	"Set the value at key to be value."
	| index |
	index := self findElementOrNil: key.
	"The order of the #basicAt:put: and the array #at:put: is importaint. The machine
	code location must be stored before the key is placed in the array for the VM to
	find. Otherwise it may try to execute a nil."
	array at: index put: value.
	(self basicAt: index) == nil
		ifTrue: 
			[tally := tally + 1.
			self basicAt: index put: key].
	self fullCheck.
	^ value! !

!Array class methodsFor: '*Exupery-Unit Tests' stamp: 'wbk 6/4/2005 10:49'!
expressionsDo: aBlockContext 
! !

!Array methodsFor: '*Exupery-Additions' stamp: 'wbk 10/24/2004 17:33'!
expressionsDo: aBlock
	aBlock value: self.! !

!Array methodsFor: '*Exupery-Additions' stamp: 'wbk 8/22/2005 22:19'!
isMedLiteral
	^ false! !

!Array methodsFor: '*Exupery-Additions' stamp: 'wbk 8/22/2005 22:04'!
isRegister
	^ false! !

!Array methodsFor: '*Exupery-Additions' stamp: 'wbk 8/22/2005 22:05'!
visitWith: aVisitor
	^ self! !

Array variableSubclass: #ExuperyArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

!ExuperyArray methodsFor: 'accessing' stamp: 'wbk 5/6/2005 23:42'!
at: index 
	"Primitive. Assumes receiver is indexable. Answer the value of an 
	indexable element in the receiver. Fail if the argument index is not an 
	Integer or is out of bounds. Essential. See Object documentation 
	whatIsAPrimitive."

	<primitive: 60>
	Error signal.! !

Array variableSubclass: #ExuperyArrayInstVars
	instanceVariableNames: 'a b c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Customer Tests'!

PasteUpMorph subclass: #ExuperyMethodInspector
	instanceVariableNames: 'blocks edges method drawing text isAnimating'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Exupery-Tools'!

!ExuperyMethodInspector class methodsFor: 'instance creation' stamp: 'wbk 7/11/2004 11:35'!
inspect: aMethod
	self new inspect: aMethod! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 3/19/2006 22:03'!
aMouseEnter: block node: event block: node 
	| stream |
	stream := WriteStream on: String new.
	block printOn: stream.
	text setText: stream contents! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 8/7/2004 21:19'!
colorNodes
	"Color the switch node and the first node"

	(blocks at: (method blockAt: 1) blockName) backgroundColor: Color green.
	(blocks at: (method blockAt: 2) blockName) backgroundColor: Color green.
	method blocksDo: 
			[:eachBlock | 
			eachBlock instructionsDo: 
					[:eachExpression | 
					eachExpression isReturn ifTrue: [(blocks at: eachBlock blockName) backgroundColor: Color red]]]! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 4/7/2005 21:52'!
createEdgeFrom: from to: to 
	| connection |
	connection := NCAAConnectorMorph 
				fromMorph: from
				toMorph: to.
	connection line makeForwardArrow.
	drawing addMorph: connection.
	(edges at: from) add: to.
	^(edges at: to) add: from! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 8/11/2005 18:58'!
createEdges
	| to from toBlock lastExpression |
	method blocksDo: 
			[:eachBlock | 
			eachBlock instructionsDo: 
					[:eachExpression | 
					eachExpression isJump ifTrue: 
							[from := blocks at: eachBlock blockName.
							toBlock := eachExpression target.
							toBlock isMedBlock ifTrue: 
									[to := blocks at: toBlock blockName.
									eachBlock = (method blockAt: 1) 
										ifTrue: [to backgroundColor: Color green]
										ifFalse: 
											["Not to an entry point"

											self 
												createEdgeFrom: from
												to: to]]]]].
	 1
		to: method numberOfBlocks - 1
		do: 
			[:each | 
			(method  blockAt: each) isEmpty ifFalse:
				[lastExpression := (method blockAt: each) lastExpression.
				lastExpression isUnconditionalJump not & lastExpression isReturn not ifTrue: 
					[self
						createEdgeFrom: (blocks at: (method blockAt: each) blockName)
						to: (blocks at: (method blockAt: each + 1) blockName)]]]! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 2/15/2006 23:01'!
createNodes
	method blocksDo: [:each | each isEmpty ifFalse: [self createNode: each]]! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 2/15/2006 22:53'!
createNode: each 
	| blockMorph exuperyBlockMorph |
	exuperyBlockMorph := NCTextRectangleMorph new.
	blockMorph := exuperyBlockMorph 
				setTextAt: 1
				to: each blockNumber asString.
	blockMorph 
		on: #mouseEnter
		send: #aMouseEnter:node:block:
		to: self
		withValue: each.
	blockMorph borderWidth: 2.
	drawing addMorph: blockMorph.
	blockMorph position: drawing center.
	blockMorph extent: 20 @ 20.
	blocks 
		at: each blockName
		put: blockMorph.
	^edges 
		at: blockMorph
		put: OrderedCollection new! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 2/15/2006 21:15'!
createWindow
	| window |
	window := SystemWindow new.
	drawing := self.
	window 
		addMorph: drawing
		frame: (0 @ 0 corner: 0.85 @ 1).
	text := PluggableTextMorph new.
	text setText: ''.
	window 
		addMorph: text
		frame: (0.85 @ 0.05 corner: 1 @ 1).
		
	"Add the buttons"
	window
		addMorph: (SimpleButtonMorph new
			target: self;
			label: 'Graph';
			actionSelector: #layout)
		frame: (0.85@0 corner: 0.90@0.05).
	window
		addMorph: (SimpleButtonMorph new
			target: self;
			label: 'Start';
			actionSelector: #start)
		frame: (0.90@0 corner: 0.95@0.05).
	window
		addMorph: (SimpleButtonMorph new
			target: self;
			label: 'Stop';
			actionSelector: #stop)
		frame: (0.95@0 corner: 1@0.05).
		
	window openInWorld.
	self stopStepping.! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 7/11/2004 20:54'!
drawGraph
	blocks := Dictionary new.
	edges := Dictionary new.
	self createNodes.
	self createEdges.
	self colorNodes.! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 2/18/2006 18:10'!
inspect: aMethod 
	isAnimating := false.
	self createWindow.
	method := aMethod.
	self drawGraph.
	self layout.! !

!ExuperyMethodInspector methodsFor: 'Graph Layout' stamp: 'wbk 2/18/2006 18:14'!
layout
	| graph nodes node graphHeight xScale yScale |
	graph := GraphViz new.
	nodes := Dictionary new.
	edges keysDo: 
		[:each| graph add: each text asString.
		nodes 
			at: each text asString
			put: each].
	edges keysAndValuesDo:
		[:from :toNodes| 
			toNodes do: [:to| graph add: from text asString -> to text asString]].
	graph doLayout.
	graphHeight := drawing extent y.
	xScale := drawing extent x / graph extent x.
	yScale := drawing extent y / graph extent y.
	graph allNodesDo:
		[:each| node := nodes at: each id. 
		node center: (each x * xScale) + drawing bounds origin x @ 
						(graphHeight - (each y * yScale) + drawing bounds origin y)].
	! !

!ExuperyMethodInspector methodsFor: 'Animation' stamp: 'wbk 7/11/2004 16:56'!
repulsiveMove
	| blockPosition delta edgePosition distance unitDistance |
	blocks do:
		[:eachBlock| 
		blockPosition := eachBlock position.
		delta := 0@0.
		blocks do:
			[:eachOther| 
			edgePosition := eachOther position.
			distance := blockPosition dist: edgePosition.
			distance = 0
				ifTrue: 
					[unitDistance := Point
						r: 1
						degrees: 360 atRandom]
				ifFalse: [unitDistance := (blockPosition - edgePosition) / distance].
			"delta := delta + unitDistance /10."
			distance < 150 ifTrue: [delta := delta + unitDistance].
			distance < 100 ifTrue: [delta := delta + (unitDistance * 3)].
			distance < 40 ifTrue: [delta := delta + (unitDistance * 10)]].
		eachBlock position: blockPosition + delta].! !

!ExuperyMethodInspector methodsFor: 'Animation' stamp: 'wbk 7/11/2004 16:58'!
springsMove
	| blockPosition delta edgePosition distance unitDistance |
	blocks do:
		[:eachBlock| 
		blockPosition := eachBlock position.
		delta := 0@0.
		(edges at: eachBlock) do:
			[:eachEdge| 
			edgePosition := eachEdge position.
			distance := blockPosition dist: edgePosition.
			distance = 0
				ifTrue: 
					[unitDistance := Point
						r: 1
						degrees: 360 atRandom]
				ifFalse: [unitDistance := (blockPosition - edgePosition) / distance].
			distance > 70
				ifTrue: [delta := delta - (unitDistance)].
			distance > 150
				ifTrue: [delta := delta - (unitDistance * 2)].
			distance > 300
				ifTrue: [delta := delta - (unitDistance * 4)]].
		eachBlock position: blockPosition + delta].! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 8/1/2004 11:47'!
start
	isAnimating := true.
	drawing startStepping.
	! !

!ExuperyMethodInspector methodsFor: 'Animation' stamp: 'wbk 7/11/2004 11:07'!
stayInsideWalls
	blocks do:
		[:each| 
		each left < drawing left ifTrue: [each left: drawing left + 20].
		each top < drawing top ifTrue: [each top: drawing top + 20].
		each right > drawing right ifTrue: [each right: drawing right - 20].
		each bottom > drawing bottom ifTrue: [each bottom: drawing bottom -20] ]! !

!ExuperyMethodInspector methodsFor: 'Animation' stamp: 'wbk 8/1/2004 11:46'!
step
	"blocks do:
		[:eachBlock| eachBlock position: eachBlock position + ((3 atRandom - 2) @ (3 atRandom - 2))]."
	isAnimating ifFalse: [^self stopStepping].
	self springsMove.
	self repulsiveMove.
	self stayInsideWalls.
	
			
! !

!ExuperyMethodInspector methodsFor: 'Animation' stamp: 'wbk 7/11/2004 11:04'!
stepTime
	^ 200
! !

!ExuperyMethodInspector methodsFor: 'Misc' stamp: 'wbk 8/1/2004 11:47'!
stop
	isAnimating := false.
	drawing stopStepping.! !

!Behavior methodsFor: '*Exupery' stamp: 'wbk 12/26/2005 17:08'!
becomeCompactAt: anInteger
	"Here are the restrictions on compact classes in order for export segments to work:  A compact class index may not be reused.  If a class was compact in a release of Squeak, no other class may use that index.  The class might not be compact later, and there should be nil in its place in the array."
	| cct index |

	self isWeak ifTrue:[^ self halt: 'You must not make a weak class compact'].
	cct := self environment compactClassesArray.
	(self indexIfCompact > 0 or: [cct includes: self])
		ifTrue: [^ self halt: self name , 'is already compact'].
	index := anInteger.
	(cct at: index) isNil ifFalse: [self halt: 'The compact class index is already used'].
	"Install this class in the compact class table"
	cct at: index put: self.
	"Update instspec so future instances will be compact"
	format := format + (index bitShift: 11).
	"Make up new instances and become old ones into them"
	self updateInstancesFrom: self.
	"Purge any old instances"
	Smalltalk garbageCollect.! !
ExuperyBlockContext initialize!
InterferenceNode initialize!
